# Matplotlib 基础

在使用**Numpy**之前，需要了解一些画图的基础。

**Matplotlib**是一个类似**Matlab**的工具包，主页地址为

[http://matplotlib.org](http://matplotlib.org)

导入 `matplotlib` 和 `numpy`：

In [1]:

```py
%pylab

```

```py
Using matplotlib backend: Qt4Agg
Populating the interactive namespace from numpy and matplotlib

```

## plot 二维图

```py
plot(y)
plot(x, y)
plot(x, y, format_string)

```

只给定 `y` 值，默认以下标为 `x` 轴：

In [2]:

```py
%matplotlib inline
x = linspace(0, 2 * pi, 50)
plot(sin(x))

```

Out[2]:

```py
[<matplotlib.lines.Line2D at 0xa086fd0>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

给定 `x` 和 `y` 值：

In [3]:

```py
plot(x, sin(x))

```

Out[3]:

```py
[<matplotlib.lines.Line2D at 0xa241898>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

多条数据线：

In [4]:

```py
plot(x, sin(x),
    x, sin(2 * x))

```

Out[4]:

```py
[<matplotlib.lines.Line2D at 0xa508b00>,
 <matplotlib.lines.Line2D at 0xa508d30>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

使用字符串，给定线条参数：

In [5]:

```py
plot(x, sin(x), 'r-^')

```

Out[5]:

```py
[<matplotlib.lines.Line2D at 0xba6ea20>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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=
)

多线条：

In [9]:

```py
plot(x, sin(x), 'b-o',
    x, sin(2 * x), 'r-^')

```

Out[9]:

```py
[<matplotlib.lines.Line2D at 0xbcf1710>,
 <matplotlib.lines.Line2D at 0xbcf1940>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

更多参数设置，请查阅帮助。事实上，字符串使用的格式与**Matlab**相同。

## scatter 散点图

```py
scatter(x, y)
scatter(x, y, size)
scatter(x, y, size, color)

```

假设我们想画二维散点图：

In [10]:

```py
plot(x, sin(x), 'bo')

```

Out[10]:

```py
[<matplotlib.lines.Line2D at 0xbd6c0b8>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

可以使用 `scatter` 达到同样的效果：

In [11]:

```py
scatter(x, sin(x))

```

Out[11]:

```py
<matplotlib.collections.PathCollection at 0xbd996d8>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

事实上，scatter函数与**Matlab**的用法相同，还可以指定它的大小，颜色等参数：

In [12]:

```py
x = rand(200)
y = rand(200)
size = rand(200) * 30
color = rand(200)
scatter(x, y, size, color)
# 显示颜色条
colorbar()

```

Out[12]:

```py
<matplotlib.colorbar.Colorbar instance at 0x000000000C31F448>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAWMAAAEACAYAAABmohcVAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 多图

使用figure()命令产生新的图像：

In [13]:

```py
t = linspace(0, 2*pi, 50)
x = sin(t)
y = cos(t)
figure()
plot(x)
figure()
plot(y)

```

Out[13]:

```py
[<matplotlib.lines.Line2D at 0xc680cf8>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

或者使用 `subplot` 在一幅图中画多幅子图：

```py
subplot(row, column, index)
```

In [15]:

```py
subplot(1, 2, 1)
plot(x)
subplot(1, 2, 2)
plot(y)

```

Out[15]:

```py
[<matplotlib.lines.Line2D at 0xcd47518>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 向图中添加数据

默认多次 `plot` 会叠加：

In [16]:

```py
plot(x)
plot(y)

```

Out[16]:

```py
[<matplotlib.lines.Line2D at 0xcbcfd30>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

可以跟**Matlab**类似用 hold(False)关掉，这样新图会将原图覆盖：

In [17]:

```py
plot(x)
hold(False)
plot(y)
# 恢复原来设定
hold(True)

```

Out[17]:

```py
[<matplotlib.lines.Line2D at 0xcf4b9b0>]
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 标签

可以在 `plot` 中加入 `label` ，使用 `legend` 加上图例：

In [19]:

```py
plot(x, label='sin')
plot(y, label='cos')
legend()

```

Out[19]:

```py
<matplotlib.legend.Legend at 0xd2089b0>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

或者直接在 `legend`中加入：

In [21]:

```py
plot(x)
plot(y)
legend(['sin', 'cos'])

```

Out[21]:

```py
<matplotlib.legend.Legend at 0xd51fb00>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX0AAAEACAYAAABfxaZOAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 坐标轴，标题，网格

可以设置坐标轴的标签和标题：

In [22]:

```py
plot(x, sin(x))
xlabel('radians')
# 可以设置字体大小
ylabel('amplitude', fontsize='large')
title('Sin(x)')

```

Out[22]:

```py
<matplotlib.text.Text at 0xd727dd8>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAZAAAAEZCAYAAAC5AHPcAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

用 'grid()' 来显示网格：

In [23]:

```py
plot(x, sin(x))
xlabel('radians')
ylabel('amplitude', fontsize='large')
title('Sin(x)')
grid()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAZAAAAEZCAYAAAC5AHPcAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 清除、关闭图像

清除已有的图像使用：

```py
clf() 
```

关闭当前图像：

```py
close() 
```

关闭所有图像：

```py
close('all')
```

## imshow 显示图片

灰度图片可以看成二维数组：

In [25]:

```py
# 导入lena图片
from scipy.misc import lena
img = lena()
img

```

Out[25]:

```py
array([[162, 162, 162, ..., 170, 155, 128],
       [162, 162, 162, ..., 170, 155, 128],
       [162, 162, 162, ..., 170, 155, 128],
       ..., 
       [ 43,  43,  50, ..., 104, 100,  98],
       [ 44,  44,  55, ..., 104, 105, 108],
       [ 44,  44,  55, ..., 104, 105, 108]])
```

我们可以用 `imshow()` 来显示图片数据：

In [26]:

```py
imshow(img,
       # 设置坐标范围
      extent = [-25, 25, -25, 25],
       # 设置colormap
      cmap = cm.bone)
colorbar()

```

Out[26]:

```py
<matplotlib.colorbar.Colorbar instance at 0x000000000DECFD88>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAATYAAAD7CAYAAADgvbh3AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

更多参数和用法可以参阅帮助。

这里 `cm` 表示 `colormap`，可以看它的种类：

In [28]:

```py
dir(cm)

```

Out[28]:

```py
[u'Accent',
 u'Accent_r',
 u'Blues',
 u'Blues_r',
 u'BrBG',
 u'BrBG_r',
 u'BuGn',
 u'BuGn_r',
 u'BuPu',
 u'BuPu_r',
 u'CMRmap',
 u'CMRmap_r',
 u'Dark2',
 u'Dark2_r',
 u'GnBu',
 u'GnBu_r',
 u'Greens',
 u'Greens_r',
 u'Greys',
 u'Greys_r',
 'LUTSIZE',
 u'OrRd',
 u'OrRd_r',
 u'Oranges',
 u'Oranges_r',
 u'PRGn',
 u'PRGn_r',
 u'Paired',
 u'Paired_r',
 u'Pastel1',
 u'Pastel1_r',
 u'Pastel2',
 u'Pastel2_r',
 u'PiYG',
 u'PiYG_r',
 u'PuBu',
 u'PuBuGn',
 u'PuBuGn_r',
 u'PuBu_r',
 u'PuOr',
 u'PuOr_r',
 u'PuRd',
 u'PuRd_r',
 u'Purples',
 u'Purples_r',
 u'RdBu',
 u'RdBu_r',
 u'RdGy',
 u'RdGy_r',
 u'RdPu',
 u'RdPu_r',
 u'RdYlBu',
 u'RdYlBu_r',
 u'RdYlGn',
 u'RdYlGn_r',
 u'Reds',
 u'Reds_r',
 'ScalarMappable',
 u'Set1',
 u'Set1_r',
 u'Set2',
 u'Set2_r',
 u'Set3',
 u'Set3_r',
 u'Spectral',
 u'Spectral_r',
 u'Wistia',
 u'Wistia_r',
 u'YlGn',
 u'YlGnBu',
 u'YlGnBu_r',
 u'YlGn_r',
 u'YlOrBr',
 u'YlOrBr_r',
 u'YlOrRd',
 u'YlOrRd_r',
 '__builtins__',
 '__doc__',
 '__file__',
 '__name__',
 '__package__',
 '_generate_cmap',
 '_reverse_cmap_spec',
 '_reverser',
 'absolute_import',
 u'afmhot',
 u'afmhot_r',
 u'autumn',
 u'autumn_r',
 u'binary',
 u'binary_r',
 u'bone',
 u'bone_r',
 u'brg',
 u'brg_r',
 u'bwr',
 u'bwr_r',
 'cbook',
 'cmap_d',
 'cmapname',
 'colors',
 u'cool',
 u'cool_r',
 u'coolwarm',
 u'coolwarm_r',
 u'copper',
 u'copper_r',
 'cubehelix',
 u'cubehelix_r',
 'datad',
 'division',
 u'flag',
 u'flag_r',
 'get_cmap',
 u'gist_earth',
 u'gist_earth_r',
 u'gist_gray',
 u'gist_gray_r',
 u'gist_heat',
 u'gist_heat_r',
 u'gist_ncar',
 u'gist_ncar_r',
 u'gist_rainbow',
 u'gist_rainbow_r',
 u'gist_stern',
 u'gist_stern_r',
 u'gist_yarg',
 u'gist_yarg_r',
 u'gnuplot',
 u'gnuplot2',
 u'gnuplot2_r',
 u'gnuplot_r',
 u'gray',
 u'gray_r',
 u'hot',
 u'hot_r',
 u'hsv',
 u'hsv_r',
 u'jet',
 u'jet_r',
 'ma',
 'mpl',
 u'nipy_spectral',
 u'nipy_spectral_r',
 'np',
 u'ocean',
 u'ocean_r',
 'os',
 u'pink',
 u'pink_r',
 'print_function',
 u'prism',
 u'prism_r',
 u'rainbow',
 u'rainbow_r',
 'register_cmap',
 'revcmap',
 u'seismic',
 u'seismic_r',
 'six',
 'spec',
 'spec_reversed',
 u'spectral',
 u'spectral_r',
 u'spring',
 u'spring_r',
 u'summer',
 u'summer_r',
 u'terrain',
 u'terrain_r',
 'unicode_literals',
 u'winter',
 u'winter_r']
```

使用不同的 `colormap` 会有不同的显示效果。

In [29]:

```py
imshow(img, cmap=cm.RdGy_r)

```

Out[29]:

```py
<matplotlib.image.AxesImage at 0xe0883c8>
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAQcAAAEACAYAAAC+rrMfAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 从脚本中运行

在脚本中使用 `plot` 时，通常图像是不会直接显示的，需要增加 `show()` 选项，只有在遇到 `show()` 命令之后，图像才会显示。

## 直方图

从高斯分布随机生成1000个点得到的直方图：

In [30]:

```py
hist(randn(1000))

```

Out[30]:

```py
(array([   2.,    7.,   37.,  119.,  216.,  270.,  223.,   82.,   31.,   13.]),
 array([-3.65594649, -2.98847032, -2.32099415, -1.65351798, -0.98604181,
        -0.31856564,  0.34891053,  1.0163867 ,  1.68386287,  2.35133904,
         3.01881521]),
 <a list of 10 Patch objects>)
```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXUAAAEACAYAAABMEua6AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

更多例子请参考下列网站：

[http://matplotlib.org/gallery.html](http://matplotlib.org/gallery.html)