# 不要迷信默认设置

导入相关的包：

In [1]:

```py
import numpy as np
import matplotlib.pyplot as plt

```

生成三角函数：

In [2]:

```py
x = np.linspace(-np.pi, np.pi)
c, s = np.cos(x), np.sin(x)

```

## 默认绘图

In [3]:

```py
%matplotlib inline

# 画图
p = plt.plot(x,c)
p = plt.plot(x,s)

# 在脚本中需要加上这句才会显示图像
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXoAAAEACAYAAAC9Gb03AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz
AAALEgAACxIB0t1+/AAAIABJREFUeJzt3Xd0VVXax/HvpkPo0osC0gkloQgoGqyIdKXX0BUEHId5
bSOOM6OIFRCQEgi9CBIRhYCY0KUm1IQQOog0KdJJst8/TnAQ02/Z997zfNZiLW5y7j0/QvJk312V
1hohhBC+K5vpAEIIIVxLCr0QQvg4KfRCCOHjpNALIYSPk0IvhBA+Tgq9EEL4OIcLvVJqulLqjFJq
TxrXjFNKHVRK7VJKBTh6TyGEEBnnjBb9DKBFap9USrUEKmutqwADgUlOuKcQQogMcrjQa63XAxfT
uKQNMDP52i1AYaVUSUfvK4QQImPc0UdfFjhxz+OTQDk33FcIIQTuG4xV9z2WfReEEMJNcrjhHqeA
8vc8Lpf8sT9RSknxF0KILNBa39+Y/hN3tOiXAb0AlFKNgUta6zMpXai19vg/o0aNMp7BFzJ6Qs5r
1zTDh2sKFtS0bq2ZM0dz5Ur6OW/f1qxcqQkO1hQpYj33xAnv/XruO7uPwd8NpsjoInRb0o3NJzaT
lJSU7vOu3rpKeHw4A5cNpMTHJfhq21ckJCZ4/P+7q7+e7v6TEc6YXjkf2ARUU0qdUEr1VUoNUkoN
Si7ePwCHlVLxwGTgFUfvKYSjNm2CunXh/Hk4dAiWLYPu3aFAgfSfmzMnPPccTJ8Op09Dw4YQGAgz
Z0IGf+48QmJSIqMiRvHkzCcplb8U+17Zx9wOc2lcrjFKpdlABMAvlx/PPvwsk1tPZlWPVczZM4dG
0xqx+cRmN6QXmeFw143WumsGrhnq6H2EcIabN+Gf/4Q5c2DiRGjf3rHXy53ber3WraF3b1iyBKZM
gVKlnJPXVc5cPUP3b7qTpJOIHhxNqfyOBa5bqi7r+qxj/t75vPT1SzxT6Rk+fuZjivsVd1Ji4QhZ
GZtJQUFBpiOkyxsygvtz7thhtbyPHIHduzNe5DOSs1492LYN6tSx3iksXOhY1qzI6Ndz3bF11J9S
n6blm7K652qHi/xdSim61e5G7JBYCucpTNPpTTl66WiWc5rmLTkzQmW0j8fVlFLaU7II37NmDXTt
CmPHQpcukIGeiSzbts26x+DBMHKk6+6TWUk6iTEbx/DFz18Q2i6UFpVTXefoFF9u/ZKPNn7Eiu4r
8C/h79J72ZlSCp3OYKw7Zt0IYdTdIr94MTz+uOvv17AhrF0LzZtbjz2h2GutGbBsAPvP72fbgG2U
L1Q+/Sc5aGijoRTNW5SnZj1FWOcwmpRv4vJ7ipRJoRc+zd1F/q5y5SAiwjOKvdaakatHsv/8fn7s
+SN+ufzcdu9utbtRJE8R2ixow+z2s13+LkKkTProhc8yVeTvulvsp0yBjz92//3vGr1hNOGHwvm+
2/duLfJ3PV/leb7t8i29w3qzYO8Ct99fSIte+CjTRf4u0y37ydsnMy1qGuuD11M0b1H33vweTcs3
ZU2vNTw16ynKFCjD4w8Z/E+xIWnRC5+zbZtnFPm77m3ZT57svvsu3LuQ99e9z6oeqyhToIz7bpwK
/xL+zG4/m86LO3Ps0jHTcWxFZt0In3LhAtSvD59/7vgceWc7eBCaNoUffrAGbF0pPD6cXmG9WN1z
NXVK1nHtzTLps82fMWf3HDb03UC+nPlMx/F6GZl1I4Ve+IykJGvhUo0a8MknptOkbMkS+PvfrTn9
RV3Uk3Lk4hEaTWtEWOcwHn3wUdfcxAFaa3qF9SIhKYF5HeZlaBWuSF1GCr103QifMXo0XL4MH35o
OknqXnzReqfRu7f1i8nZ7iTeods33XjzsTc9ssiDVZimtJpC/G/xjNk4xnQcW5BCL3xCRASMH2+t
SM2Z03SatH30kdXFNMYFNe5fa/9FodyFGNF4hPNf3Iny5szL0s5LGbd1HD8c/MF0HJ8nXTfC6/3y
CzRoALNmwdNPm06TMSdOWP30CxaAs1baRx6NpNuSbkQNiqJkfu84xG3TiU20W9COLf23ULFIRdNx
vJJ03Qifl5BgbTfw8sveU+QBype3fjF1727tgOmoC9cv0HNpT6a3ne41RR6saZcjm46k/3f9M7zl
rsg8KfTCq73/PuTLB2+/bTpJ5j37LAwcCD17Ora9sdaafsv60almJ69cefpak9f4/dbvTNs5zXQU
nyVdN8Jr7d1rLUTavRtKlzadJmsSE+GRR2DoUOjTJ2uvMWnbJKbunMrmfpvJnSO3U/O5y96ze2k+
szlRg6IoV1COlM4MmV4pfFZSEjRrZrWGBw82ncYxO3fC889bv7iKZ3L79rgLcTw6/VE2BG+gWrFq
rgnoJu+vfZ8tp7awvOtymXKZCdJHL3zW1KlWd8fAgaaTOC4w0Oqr//vfM/c8rTWvrniVNx970+uL
PMAbj73BySsnmbtnrukoPkda9MLrnD5tHe7x00/g7yPbnF+9CrVqWccTPvVUxp6zZP8SRkWOImpQ
FDmze/ic0gza8csOWs5rya7Bu5x2IIqvkxa98EmvvQb9+/tOkQfInx8mTLC6oW7eTP/6a7ev8Vr4
a0xoOcFnijxA/TL16RfQj6E/yOmjziSFXniVFSusTcv++U/TSZyvVSvrncp//5v+tf9Z9x8ef+hx
nqjwhOuDudm7T7zLvnP7WLJ/iekoPkO6boTXuHbNasVPmQLPPGM6jWv88otV7NeuhZo1U74m9nws
zWY0Y/fg3ZQu4KXTjdKx9uhaeof1JnZoLHly5DEdx6NJ143wKf/6Fzz6qO8WeYAyZax/56BBKe+F
c3cA9p1m7/hskQd4osITBJQOYOzPY01H8QlS6IVXiI+3Bio/+8x0EtcbPBhu3YJFi/76ucX7F3Pm
6hmGNBri/mBu9tHTH/Hxpo85d+2c6SheT7puhFfo0gXq1IG33jKdxD0iI6FfP4iJgVy5rI9dvX2V
GhNqMK/DPJo91MxoPncZvmI4CUkJTHhhgukoHksWTAmfsG0btGsHcXHg5/4jT41p2dJaSPXqq9bj
t9e8zYkrJ5jVfpbZYG504foFqk+ozro+66hRvIbpOB5JCr3welpb88q7dPGNxVGZsWsXPPec9Qvu
erZfqTWxFtGDoilfqLzpaG716aZPiTwWyXddvzMdxSNJoRdeLzwchg2Dffsghw2Psu/VCypWhIuN
h5FdZefzFp+bjuR2txJuUWNCDaa1mcaTFZ80HcfjSKEXXi0pydoe4N13oUMH02nMOHoU6gUdI9vg
QGJfjaGEXwnTkYxYtG8RH274kO0DtpM9W3bTcTyKTK8UXm3+fMiTx/MO+XanChWgXPf3qfTbK7Yt
8gAda3Ykb468zN4923QUrySFXnikW7fgnXesY/fsvJHhgfMH+LXgMg7PeZ2DB02nMUcpxafPfso/
I/7JzYQM7BEh/kQKvfBIX31lbfL1hO+t8M+UUZGj+Pujr/P3oYV55x3TacxqUr4JdUvWZUbUDNNR
vI700QuPc+UKVKkCP/4ItWubTmNO9K/RtJzbkoOvHoQ7flStCmFh1lmzdrXl5BY6ft2R+GHx5Mqe
y3QcjyB99MIrjR9vHbNn5yIP8M5P7/BWs7fwy+WHn5+1kdt775lOZdYj5R6hZvGahEaHmo7iVaRF
LzzKtWtQqZK1MrSGjdfHbDqxiW5LunFg6IE/jge8eRMefhiWL4eAAMMBDbr7tTn46kGf2qI5q6RF
L7zOlCnWEYF2LvJgteZHPTHqT2fA5skDr78OH3xgMJgHaFq+KZWLVpYZOJkgLXrhMW7dslrz0mLd
RI9vehD3ahw5sv15ldi1a9YCqrVr7f3LcP2x9fT5tg8Hhh74y9fIbqRFL7xKaKi1F7udizzARxs/
YmTTkSkWMD8/a6Xw6NEGgnmQZg8148FCDzJvzzzTUbyCtOiFR0hIgKpVYfZsa895u9p3dh9PzXqK
I8OPkDdn3hSvuXTJ6qvfscNaUGVXEUciGLR8EDFDYmy9WlZa9MJrLFgADz5o7yIPMGbTGIY/MjzV
Ig9QuLB1MMmYMW4M5oGCKgRRMn9JFu5baDqKx5MWvTAuKcmaSvn559a0Srs6dukYgVMCOTTsEIXz
FE7z2nPnoFo1a7O30r570FS6Vh9azfCVw9nz8h7btuqlRS+8QlgY5Mvn20cEZsRnmz+jX0C/dIs8
QPHi1s6Wn37qhmAe7OlKT1MoTyGWxi41HcWjSYteGKU1NGhgLQZq1850GnPOXz9P1fFV2fvKXsoU
KJOh55w8aQ1ex8XBAw+4OKAH+ybmGz7e9DGb+202HcUIadELjxcebk2rbNPGdBKzvtz6JS/VfCnD
RR6gXDl48UUYa/Pzs9tWa8vZa2fZfMKehT4jpEUvjGreHPr3h+7dTScx5+rtq1QaW4mNfTdS5YEq
mXruoUPwyCNw7Ji9jlm83/gt41l7bC2LOy02HcXtpEUvPFp0NBw8CJ06mU5i1rSd0wiqEJTpIg/W
NMvHH4dZ9jlGNkXBAcGsPbaWwxcPm47ikaTQC2PGjoUhQyCnjbcruZ14m083f8r/Pfp/WX6NESOs
r2VSkhODeZn8ufLTP6A/Y3+2eT9WKqTQCyN+/dWabWO3A7/vt2jfIqo9UI36Zepn+TWaNbO6bVau
dGIwLzS00VBm757NxRsXTUfxOA4XeqVUC6VUrFLqoFLqL80SpVSQUuqyUioq+Y/Nj08QYB0s0rmz
vWeLaK0Zu2UsIxqPcOh1lLJa9V984aRgXqpswbK0qtqKKTummI7icRwajFVKZQcOAE8Dp4BtQFet
dcw91wQBf9NapzmvQgZj7ePmTWvpfkSEvTfm2nxiMz2X9iTu1TiyKcfaXLduWZudrVoF/v5OCuiF
on+NptW8Vhweftg2B5O4YzC2ERCvtT6qtb4DLADappTFwfsIH7JggbVxmZ2LPMC4reMY2miow0Ue
IHduePllmWpZr1Q9qhWrxqJ9i0xH8SiOfoeVBU7c8/hk8sfupYGmSqldSqkflFI1Hbyn8GJaW1sd
jHCst8LrnbpyivD4cILrBTvtNQcPhsWLre0R7Oz1Jq/z6eZPkR6C/3F0I+eMfCV3AuW11teVUs8D
YUDVlC58755z0oKCgggKCnIwnvA0kZFw546997QB+Gr7V3Sv3Z1CeQo57TWLF7cWUE2ejK0PEm9R
uQWvr3qdyKORNK/Y3HQcp4uMjCQyMjJTz3G0j74x8J7WukXy4zeBJK31R2k85whQX2v9230flz56
G2jbFl54wd6zbW4m3OShLx5iXZ91VCtWzamvvWcPPPccHD0KuezRRZ2iqTum8l3cdyzrusx0FJdz
Rx/9dqCKUqqCUioX0Bn401dWKVVSKaWS/94I65fLb399KeHr4uNh82bo0cN0ErMW7F1AYOlApxd5
sHYBrVULFtp8597udbqz8cRGjl46ajqKR3Co0GutE4ChQDiwH1iotY5RSg1SSg1KvuwlYI9SKhr4
AujiyD2F9xo3DgYMsHaqtCutNeO2jGNYo2Euu8eIEdY4iJ3fIOfLmY9edXoxeftk01E8gux1I9zi
yhVrSuWePVD2/uF6G9lwfAP9lvUjZkiMU2bbpCQpyZrRNG2atZjKruIuxPHY9Mc4/tpx8uTIYzqO
y8heN8JjzJ4NTz9t7yIPMHbLWF5t9KrLijxAtmzWVMtJk1x2C69Q9YGq1CtVj8X77bfR2f2k0AuX
09oqOi+/bDqJWccvH2fN4TX0rtvb5ffq3Rt++AHOnnX5rTzakIZDmLBtgukYxkmhFy63YQMkJoLd
Z8tO2jaJXnV7USB3AZffq0gR6NABpk93+a082gtVX+DUlVPsPL3TdBSjpNALl5s0yVrMo2y8Pvp2
4m2mR0/n5Qbue1vz8svWnPrERLfd0uPkyJaDwQ0GM3HbRNNRjJJCL1zq7FlYscLqSrCzpTFL8S/h
75Iplalp2NDaNC483G239Ej9A/uzJGaJrXe1lEIvXGr6dKsLoXD65137tK92fMWg+oPSv9DJZFAW
SviVoGWVloRGh5qOYowUeuEyiYlW14HdB2Fjz8cScy6GdtXdf/p5ly6waZN11KCdDWk4hInbJ5Kk
7Xk6ixR64TLh4db+Kw0amE5i1pQdU+gb0NfItrl+ftCzJ0yx+RbtTco1wS+nH6sPrTYdxQgp9MJl
Jk6U1vyNOzeYtWsWAwIHGMsweDCEhMDt28YiGKeU+qNVb0dS6IVLHD0KP/9snSJlZ4v3L6Zh2YZU
LFLRWIbq1aFmTVi61FgEj9CtdjfWH1vPicsn0r/Yx0ihFy4xZYrVZWDnfW3AGoQdXH+w6RgyKAv4
5fKjq39XpkfZb3GBFHrhdLdvW7NtBpuvb0btObOHY5eO8ULVF0xHoV07iIuD/ftNJzFrQP0BhESF
kJhkr8UFUuiF0y1dam2VW819U8Y90uQdk+kf2J8c2Rw938dxOXNCv37WLCg7q1eqHiXzlyT8kL0W
F0ihF043daq9DxYBuHr7KvP2zKN/YH/TUf7Qrx/MnWsdzm5nAwIHMHXnVNMx3EoKvXCqw4dh1y6r
q8DOFuxdQLOHmlGuYDnTUf5QoQLUrw/ffGM6iVld/bsSeTSS07+fNh3FbaTQC6eaPt0ahM2d23QS
sybvmOwRg7D3GzDA2qfezgrkLsBLNV6y1UpZKfTCaRISYMYMq4vAzqJOR3H22lmefdjzTkBv0wb2
7bOOdbSzAfUHMC1qmm1WykqhF06zYgU89JA1EGtnIVEhBNcLJnu27Kaj/EWuXNY7rpAQ00nMalim
Iflz5eenIz+ZjuIWUuiF00ybBv09Z+zRiBt3bjB/73yC6wWbjpKqfv0gNBTu3DGdxByllK0GZaXQ
C6f45RdYvx46dTKdxKylsUtpUKYBDxV+yHSUVNWoAQ8/bJ1AZWfda3cnPD6cc9fOmY7iclLohVPM
nAkdO0L+/KaTmBUSFUK/AM8fpJBBWSiStwhtq7dl1q5ZpqO4nBR64bCkJOm2ATj02yF2n9lN22pt
TUdJ10svwcaNcPKk6SRm3e2+0VqbjuJSUuiFwyIjrZa83bcjnhE9gx61e5A7h+fPLfXzszacCw01
ncSsR8s/SjaVjfXH15uO4lJS6IXD7rbm7XwmbEJSAqHRofQL9Pxum7v697dm3yTZY4ZhipRS9Avo
5/MbnUmhFw65cMEa1Ove3XQSs8LjwylbsCz+JfxNR8mwwEDriMef7DHDMFU96vQgLDaMK7eumI7i
MlLohUPmzIFWraBoUdNJzAqJCqF/gHcNUihlDcpOtccMw1SVzF+S5hWbs2jfItNRXEYKvcgyra23
/nZfCXvm6hkijkbQ2d/7Tlnp1s068vH8edNJzOpbry8zomeYjuEyUuhFlu3YAVevwhNPmE5i1qxd
s2hXvR0Fcxc0HSXTCheGF16AefNMJzHr+SrPc/jiYWLPx5qO4hJS6EWWzZgBffpANht/F2mtvbLb
5l7Bwdb/pZ3lyJaDXnV6MSPKN78QNv4RFY64eRMWLIDevU0nMWvTiU0ANC3f1HCSrHvySfjtN4iO
Np3ErOCAYGbtnsWdRN/bG0IKvciSb7+1Zm085Lkr/d1ietR0+gb0RXnx3NJs2ax3ZnZv1VcvVp1K
RSqxMn6l6ShOJ4VeZMn06dZbfju7dvsa38R+Q886PU1HcVifPlY//a1bppOY1bdeX6ZH+96cein0
ItNOnIBt26B9e9NJzFoSs4RHyz9K6QKlTUdxWMWK4O8P331nOolZnWp1IuJIBGevnTUdxamk0ItM
mzXLWj6fN6/pJGbNiJ7h0dsRZ1bfvtJ9UyB3AdpVb8ec3XNMR3EqKfQiU7S2ioHdu20OXzzM3rN7
aV2ttekoTvPii7BpE5w6ZTqJWX0D+hISFeJTG51JoReZsn69dR5sw4amk5g1M3omXf27kit7LtNR
nCZfPmtXy9mzTScxq9mDzbideJttv2wzHcVppNCLTLnbmvfiSSYOS9JJzNw106e6be66O6fehxqz
maaUIrheMCE7fee8RSn0IsN+/x2WLrXOHLWziCMRFM5TmIDSAaajOF2TJtYv8U2bTCcxq1fdXny9
/2tu3LlhOopTSKEXGfb119Z2ByVLmk5iVuiuUJ9szYNV5GWlLJQrWI5GZRsRFhtmOopTSKEXGSaD
sHD55mW+O/Ad3ev47r7MPXvCkiVw7ZrpJGb1qdeH0F2hpmM4hRR6kSEHD0JcnLUBlp0t2reIpyo9
RbF8xUxHcZkyZaBpU1i82HQSs9pWa8v2X7Zz4vIJ01EcJoVeZMjMmdbhIjlzmk5ilq/NnU9NcLD1
f25neXPmpWPNjsze7f3TkKTQi3QlJlqLpPr0MZ3ErNjzsRy5dIQWlVuYjuJyrVvD7t1w9KjpJGYF
1wsmNDrU6+fUS6EX6YqIgGLFoE4d00nMCo0OpWednuTIlsN0FJfLnRu6dLF+wdtZo7KNyJ4tO5tP
bjYdxSFS6EW6QkNlEDYxKZHZu2fTp14f01HcJjjY+r+3++Hhfer28fp96qXQizRdvgzLl0PXrqaT
mLX68GrKFSxHzeI1TUdxm8BA8POzVkPbWc+6PVkSs4Trd66bjpJlUuhFmhYtgqeesrpu7Cw0OpQ+
dfuYjuFWSlnjMqGhppOYVaZAGRqXa8zSmKWmo2SZw4VeKdVCKRWrlDqolPq/VK4Zl/z5XUop31tO
6MNCQ2UQ9uKNi6yMX0kX/y6mo7hd9+7WauirV00nMcvb59Q7VOiVUtmBL4EWQE2gq1Kqxn3XtAQq
a62rAAOBSY7cU7hPXBwcOgQtfH+SSZoW7lvIc5Wfo0jeIqajuF2pUtCsmbWAys7aVGtD1Okojl8+
bjpKljjaom8ExGutj2qt7wALgLb3XdMGmAmgtd4CFFZK2XwRvXeQufMWO3bb3Eu6byBPjjx0rtWZ
Wbu8cxqSo4W+LHDvsrGTyR9L75pyDt7XZbTWhMeHk5CUYDqKUXfnztv98O+YczEcv3ycZx5+xnQU
Y1q1gj174MgR00nM6lOvj9fOqXd0QnBG/8X3b2qb4vPee++9P/4eFBREUFBQlkI5QinFqMhRJOpE
WlZp6fb7e4qffoISJWTu/MxdM20zdz41uXNbs65mzYJRo0ynMadBmQY0Ld+U89fPU9yvuLEckZGR
REZGZuo5ypHfTkqpxsB7WusWyY/fBJK01h/dc81XQKTWekHy41jgCa31mfteS3vKb8qvtn/FT0d+
YlHHRaajGNOtm7XfydChppOYk5iUyINfPMjqnqttNa0yJTt3WidQHToE2WSunkdRSqG1TvOECEf/
y7YDVZRSFZRSuYDOwLL7rlkG9EoO1Bi4dH+R9zSda3Um/FA4v934zXQUIy5dgu+/l7nzdpw7n5qA
AChQANatM51EZIVDhV5rnQAMBcKB/cBCrXWMUmqQUmpQ8jU/AIeVUvHAZOAVBzO7XJG8RXi+8vMs
2LvAdBQjFi2Cp5+GBx4wncSs0Gjf3Xc+s+7Oqbf7PvXeyqGuG2fypK4bgPD4cP4Z8U+2DthqOorb
NW0Kb71lDcLZ1cUbF6k4tiJHhh+x5bTKlJw5A9WqwcmTkD+/6TTiLnd03fispys9zanfT7Hv7D7T
UdwqNtaaXWH3ufML9i6gReUWUuTvUbKkdcLY11+bTiIySwp9KrJny06vOr0IjQ41HcWtZs6EHj0g
h30nmQDWcYF22sAso2ROvXeSQp+GPvX6MGfPHNvMqZd95y0x52I4eeUkz1Sy79z51LzwAsTEWLNv
hPeQQp+GasWqUbFwRcLjw01HcYvVq6FsWahVy3QSs2ZEz6BnnZ5kz5bddBSPkyuXNfXW7qdPeRsp
9Onw9s2MMkMO/4aEpARm754ts23ScPeYQTvvU+9tpNCno1OtTqw+tJoL1y+YjuJSFy9CeLh1qpCd
rYxfScXCFalWrJrpKB6rbl0oWtQ6eUx4Byn06SicpzAtq7Rk/t75pqO41Pz51kybIjafZGKXw78d
FRwsc+q9iRT6DLh7QLAvk33n4fz186w5vIbO/p1NR/F43bpZJ49dvmw6icgIKfQZ8GTFJzlz7Qx7
zuwxHcUl9u2DU6fgGZtPMpm7ey6tq7WmYO6CpqN4vGLFrJPHFtl3OyivIoU+A+7OqZ8R7ZvvVUND
oVcvyG7zSSbSbZM5Mqfee0ihz6DggGDm7pnL7cTbpqM41Z07MGeOdNtEnY7i0s1LBFUIMh3Fa7Ro
Yc2nP3DAdBKRHin0GVS5aGWqF6vO93Hfm47iVOHhULGitYeJnYVGh9K7bm+yKfmRyKicOa1V1DKn
3vPJd3Um9K3Xl+nR003HcCqZOw+3E28zb+882fIgC/r0sVZTJyaaTiLSIoU+E16q+RIbjm/g9O+n
TUdxinPnYM0a6NTJdBKzvjvwHf4l/KlYpKLpKF7H3x/KlIFVq0wnEWmRQp8Jfrn8eLHGi8zePdt0
FKeYMwfatoVChUwnMUsGYR3Trx9M9603uj5HCn0m9Q3oy/So6V55QPC9tIaQEOjb13QSs07/fppN
JzbxYo0XTUfxWl26WPsknTtnOolIjRT6TGpSrgkAm09uNpzEMdu2wa1b8PjjppOYNXv3bDrU6IBf
Lj/TUbxWoULQpg3MnWs6iUiNFPpMUkr90ar3ZiEh1iCsSvNcGt+mtSYkKoS+ATZ/W+MEffta31Ne
/kbXZ0mhz4KedXqyJGYJV29fNR0lS65ft04J6t3bdBKzNhzfQHaV/Y93aSLrnngCbtyw3ikKzyOF
PgtKFyhNswebsXj/YtNRsmTxYmjSxNp73s5CokLoF9APZee3NU6ilPUOUQZlPZMU+iwKrhfstd03
06dbMyXs7PLNy4TFhtGzbk/TUXxG797W3jfXr5tOIu4nhT6LXqj6AgcuHODghYOmo2RKfLx1FFyr
VqaTmLVg7wKervQ0JfxKmI7iM8qVg8aNYckS00nE/aTQZ1Gu7LnoUbuH121fPGOGtWw9Vy7TScy6
220jnKtfP2tQVngWKfQO6BvQl9BdoV5zeHhCgrXboN3nzu8+s5vTV0/z7MPPmo7ic1q3hv37rXeO
wnNIoXd2f20jAAAXzElEQVRArRK1eLDQg/xw8AfTUTJk1SooX14O/w7ZGUKfun3k8G8XyJXLesco
p095Fin0DhoYOJCpO6eajpEhshIWbiXcYt7eeTJ33oX69rXeOSZ4xxtdW5BC76BOtTqx8fhGTl45
aTpKmu5uYGb3w7/DYsOoW7KubGDmQv7+1sBseLjpJOIuKfQO8svlR+danZkR5dnvVWfOhHbtoKDN
T8mTQVj36N8fpk0znULcpTxlcy6llPaULJm18/ROOizswKFhhzyy31dr62CRmTOthVJ2dfTSURpM
acDJv50kT448puP4tN9/hwcftM4jLlPGdBrfppRCa53mqj9p0TtBYOlAiuUrxurDq01HSVFkJOTO
bc1xtrMZUTPoVrubFHk3KFDAOudAVsp6Bin0TjIgcIDHDspOngyDBtl7A7OEpARmRM+Qbhs3GjQI
pk6V06c8gRR6J+lauys/HfmJM1fPmI7yJ+fOwcqV1pQ3O1txcAVlC5albqm6pqPYRmAgFC8up095
Ain0TlIwd0E6VO/gcStlZ86E9u2hcGHTScz6asdXDKo/yHQM2xk0CKZMMZ1CyGCsE205uYXu33Qn
7tU4sinzv0NlENZy7NIx6k+pz/HXjpMvZz7TcWxFBmVdTwZj3axR2Ubky5mPyKORpqMAMgh719Sd
U+lRp4cUeQNkUNYzSKF3IqWURw3KTpkig7B3Eu8QEhUi3TYGDRpkzamXQVlzpNA7WY86PVhxcAXn
r583mkMGYS3LDiyj6gNVqVG8hukothUYCMWKyaCsSVLonaxI3iK0rd7W+ErZuythZRD2KwbXH2w6
hu3JoKxZMhjrAltObqHrkq7ED4s3Migrg7CW+N/iaRrSlBOvnSB3jtym49iaDMq6jgzGGtKobCOK
5i3KyviVRu4vg7CWKTum0KdeHynyHkAGZc2SQu8CSileafgKE7dNNHL/r76SQdhbCbcIjQ5lYP2B
pqOIZHdXysr2xe4nhd5Fuvh3YcupLRy5eMSt9z11Clavhl693Hpbj7MkZgn1StWjctHKpqOIZIGB
ULYsLF9uOon9SKF3kXw589G7bm8mbZ/k1vtOngzdusl2xJN3TJYplR5o6FAYP950CvuRwVgXiv8t
niYhTTg+4jh5c+Z1+f1u3YKHHrL66KtXd/ntPNa+s/t4ZvYzHBtxjJzZc5qOI+5x+7b1PbpmDdSs
aTqNb5DBWMMqF61MgzINWLRvkVvut3gx1K5t7yIPMH7reAbVHyRF3gPlygUDB8KECaaT2IsUehd7
pcErTNzunkHZL7+03hrb2cUbF1m4byGDGki3jacaNAjmz4fLl00nsQ8p9C7WskpLzlw9w/Zftrv0
Ptu3w+nT0KqVS2/j8UKiQmhdtTWl8pcyHUWkokwZePZZa52HcI8sF3qlVFGl1GqlVJxSapVSKsU1
mEqpo0qp3UqpKKXU1qxH9U7Zs2VncIPBLp9q+eWX8MorkN3zTjJ0m8SkRL7c+iWvNnrVdBSRjqFD
re6bpCTTSezBkRb9G8BqrXVVYE3y45RoIEhrHaC1buTA/bxWv4B+fBPzDReuX3DJ6587B99+C/1s
fnjSsgPLKFOgDA3LNjQdRaTj0Uchb1748UfTSezBkULfBrj75msm0C6Na228dAeK+xWndbXWzIh2
zf43ISHQoQM88IBLXt5rjNs6jmGPDDMdQ2SAUvDqqzLV0l2yPL1SKXVRa10k+e8K+O3u4/uuOwxc
BhKByVrrFPfw9cXplffadmobHb/uSPyweHJky+G0101IgEqVICzMWpBiV7vP7Kbl3JYcGX5EZtt4
ievXrf1vtm61vodF1mRkemWaFUcptRpIaVTr7XsfaK21Uiq1Kv2o1vq0Uqo4sFopFau1Xp/She+9
994ffw8KCiIoKCiteF6lYdmGlC9UniX7l9DZv7PTXve776B8eXsXeYDxW8bzcoOXpch7kXz5IDgY
Jk2Cjz82ncZ7REZGEhkZmannONKij8Xqe/9VKVUaiNBapzmDWyk1Criqtf40hc/5dIseICw2jA/W
f8CW/ltQTtqI5sknrXnJXbo45eW80vnr56kyvgpxQ+Mo7lfcdByRCUeOQMOGcPy4VfhF5rl6wdQy
oHfy33sDYSkEyKeUKpD8dz/gWWCPA/f0aq2rtubizYtsPLHRKa8XFQVxcVb/vJ1N2zmNdtXbSZH3
QhUrwmOPQWio6SS+zZFCPxp4RikVBzyZ/BilVBml1PfJ15QC1iulooEtwHKttW3PmcmeLTsjHhnB
p5v/8oYmSz75BIYPt1Yb2lVCUgITtk1gWCMZhPVWI0fCZ5/JUYOuJHvduNm129eoMLYCm/ttdmhn
xWPHrH75w4ehUCEnBvQyi/cvZtyWcawLXmc6inBA06bwt7/BSy+ZTuJ9ZK8bD+SXy4+BgQP54ucv
HHqdL76Avn3tXeS11ny86WNGNB5hOopw0MiRMGaMdTqacD4p9AYMbTSUuXvm8tuN37L0/IsXreXj
w4c7OZiXWXtsLZdvXqZd9bSWcAhv0KYNXLoE6+SNmUtIoTegdIHStK3WlsnbJ2fp+ZMmQevWUK6c
k4N5mdEbRvOPR/9h5Fxe4VzZs8Pf/y7TLF1F+ugN2X1mN8/PfZ4jw4+QK3vGR1Nv3rRmKqxaZW1J
bFdRp6NoPb81h4YdkjNhfcTNm1ChAvz0k+xVnxnSR+/B6pSsQ63itZi/Z36mnjdnDtSrZ+8iD/DR
xo94rfFrUuR9SJ481mZnn3xiOonvkRa9QSvjV/KP1f9g1+BdGVpAlZRktXQmTrQWStlV/G/xNJ7W
mCPDj1AgdwHTcYQTXbgAVarA3r3WdsYifdKi93DPPfwc2VQ2lsdl7LTk5cvBzw+aN3dxMA/3yaZP
eLnBy1LkfdADD0CPHjBunOkkvkVa9IYt2b+E0RtHs7X/1nRb9c2awZAh9t7u4Nerv1JjQg0ODD1A
Cb8SpuMIF7i7LcLhw3LIfUZIi94LtK/RnpsJN1kZvzLN6zZtgpMnZUHJ2J/H0r12dynyPqxiRXjm
GZgyxXQS3yEteg+waN8iPtv8GZv7bU61Vf/cc9aeNoNsfBTq5ZuXqTSuEtsHbKdikYqm4wgX2r3b
+p6Pj7e6K0XqpEXvJV6s8SJXbl3hx8MpH7ezYQMcOGBt6WpnX23/iucrPy9F3gbq1LG6Kie69gRO
25AWvYeYt2ceE7dNZH3w+r+06p96Crp1s/dRgdduX6Py+MqE9winTsk6puMIN9i3z5pdFh8PBWTc
PVXSovcinWt15tz1c0QcjfjTx9euhaNHoVcvM7k8xZdbv6TZg82kyNtIrVpWof/yS9NJvJ+06D3I
rF2zmB41ncg+kYC1wVNQkLV5We/eaT7Vp126eYkq46uwPng91YulebaN8DGxsfD441arXmbgpExa
9F6mW+1unLxykrVH1wIQEQGnT0P37oaDGfbppk9pVbWVFHkbql7dGpSVefWOkRa9h5keNZ15e+ax
uuePNGsGgwdbC0js6uy1s9SYUIMdA3dQoXAF03GEAQcPWvvVHzwIhQubTuN5pEXvhXrW6cmhi4f4
fMkGzp+Hrl1NJzJr9IbRdPPvJkXexqpUgRdesM5gEFkjLXoPNDN6FkNnTmJKo0107eqcQ8S90YnL
J6g3uR77XtlHqfylTMcRBh06BI88YrXqixQxncazSIveSxX7pQcJ+hbUWmQ6ilH/XvdvBgQOkCIv
ePhhaNfOOltWZJ606D1MYiLUrw/tX4sg9FJfYobEkCdHHtOx3O7ghYM0CWlC3KtxFM1b1HQc4QGO
HoUGDaxVs7Kz5f9Ii94LhYRY08je7dWc2iVqM37LeNORjHhv7XuMaDxCirz4Q4UK0L8/vPWW6STe
R1r0HuTSJWs62YoVEBAAsedjaTajGTFDYiiWr5jpeG6z69ddPDfnOQ6+elC2IhZ/8vvvUK0ahIVB
o0am03gGadF7mffftw5JDgiwHlcvVp3OtTrz/tr3zQZzI601Q34YwntB70mRF39RoAB88AEMG2Yd
xCMyRgq9h4iJgdmz4T//+fPHRz0xinl75hF3Ic5MMDebvXs2txJvMSBwgOkowkP16mUV+blzTSfx
HtJ14wG0hueft1YAvvbaXz8/ZuMYNp3YRFiXMPeHc6NLNy9RY0INlnVZRsOyDU3HER5s82brbIYD
ByB/ftNpzJKuGy/xww/WjIIhQ1L+/LBHhrHrzK4/tkbwVe9GvEubqm2kyIt0NWlibXj24Yemk3gH
adEbdvs2+PvD2LFWqz41C/cu5IMNH7BtwDZyZc/lvoBuEv1rNM/NeY79r+zngXwPmI4jvMCpU9a+
9du2QaVKptOYIy16LzB+vLXEO60iD9CpVifKFSzHRxs+ck8wN0rSSQz5YQj/af4fKfIiw8qWhb/9
DUaONJ3E80mL3qCTJ6FePdi40Zoylu71V04SMDmAiN4R+Jfwd31ANwmNDmXS9kls7reZbEraHiLj
btyAmjVh0iRo0cJ0GjOkRe/BkpKsowFHjMhYkQcoV7AcHzz5AX2/7UtCUoJrA7rJxRsXeePHN5jQ
coIUeZFpefPC1KkwYABcvGg6jeeSnyxDJk2CK1fgjTcy97z+gf0pmLsgn2/+3DXB3OyNH9+gffX2
NCjTwHQU4aWefhrat099MoOQrhsj4uLg0UetLpuqVTP//CMXj9BwakM29t1ItWIZfDvggcJiw3gt
/DWiB0VTKE8h03GEF7t+HQID4V//gs6dTadxr4x03Uihd7OEBHjsMejZ07EWyLgt41i0bxHrgtd5
ZZfHySsnqT+lPmGdw2hSvonpOMIHbN0KrVtDVJS9Nj2TPnoP9NFH1qZlL7/s2OsMbTQUgAlbJzgh
lXslJiXS45seDGs0TIq8cJpGjawT2fr3txYhiv+RFr0bRUVZq1937oRy5Rx/vQPnD/DYjMdY22ct
NYvXdPwF3eS/6/7Lj0d+5MeeP5I9W3bTcYQPuXMHGjeGQYNg4EDTadxDWvQe5OZNq7vm88+dU+QB
qhWrxifPfELbBW25eMM7phxsPrGZcVvHMbv9bCnywuly5rT2jHrrLetUKmGRQu8GWlv98TVrQrdu
zn3t3vV606pKK7ou6UpiUqJzX9zJLt+8TLdvujGl1RTKFXTSbzsh7lOzJrzzDnTqBNeumU7jGaTr
xg0++AAWL4Z161yzAVNCUgIt5rQgsHQgY54Z4/wbOIHWmm7fdKNIniJMfGGi6TjCx2kNffvChQuw
dClk9+E3j9J14wHmz4fJk2H5ctftspcjWw4WvrSQJTFLmLdnnmtu4qB3I97l4IWDfPrsp6ajCBtQ
yvq5u3Yt5R1h7UYKvQutXw/Dh1tF3tXTvR7I9wBhncMYvnI4O37Z4dqbZdLnmz/n6/1fs6L7CvLm
zGs6jrCJXLlgyRJYs8baNNDOpNC7SFwcdOwIc+ZA7druuWftkrWZ3GoyHRZ14MzVM+65aTpmRs/k
iy1fsKrnKor7FTcdR9hM4cLw/ffWtOYw3z7OIU1S6F3g3Dlo2dI6LerZZ9177w41OjAwcCBBM4M4
cfmEe29+n7DYMN5Y8wareqziwUIPGs0i7KtCBfj2W2s/nG3bTKcxQwq9k/36q1XkO3a0Fm6Y8Pbj
b9M/oD+PzXiM2POxRjJEHIlg4HcDWd51uVdv0yB8Q8OGMG2adSbz9u2m07ifFHon2rULHnkEXnjB
mmlj0utNX+dfQf+i+czmbP/Fvd/Z64+tp/PizizquIj6Zeq79d5CpKZtW2szweeft2bB2YrW2iP+
WFG817ffal2smNbz55tO8mffxn6ri48prn889KPL75WYlKjHbBijS3xcQofHh7v8fkJkxc6dWpcv
r/W//611UpLpNI5Lrp1p1leZR+8greGTT+CLL+Cbb6wWvadZe3QtHb/uyPjnx9PZ3zVb+/124zf6
hPXh3PVzLHxpofTJC492+rTVwq9SBUJCIE8e04myzqXz6JVSHZVS+5RSiUqpwDSua6GUilVKHVRK
/V9W7+eJfv/d6oefOxd+/tkzizzAExWeILxHOG//9DbtF7bnyMUjTn39rae2Un9KfSoXrczaPmul
yAuPV7o0rF1r7SbbvDkcP246kWs50ke/B2gPrEvtAqVUduBLoAVQE+iqlKrhwD2Ni4yM5No1GDMG
KleGxETYsAHKlzed7H8iIyP/8rGA0gHsfWUvDcs0pMHUBrwX+R437txw6D5Xbl1h9IbRtJrXis+e
/YzPnvssUweXp5TTE0lO5/KUnHnzwoIF1gBtQAAMHQq//PK/z3tKTmfIcqHXWsdqrePSuawREK+1
Pqq1vgMsANpm9Z6m3bgBH34YycMPWyP3EREQGuq6Fa9Zldo3aJ4ceXir2VtEDYpi/7n91JxYk6Ux
S0nSSZl6/ZhzMQz9YSgVvqhA1K9RbO63mfY12jstp6eRnM7lSTmVgjffhJgYq/vG399aSfvrr56V
01E5XPz6ZYF7J3OfBDy0g+Ovrl+3vgH27rX+zJtn7SW/ahXUqWM6XdY9WOhBFnVcxJrDaxi5eiT9
v+vPEw89QfMKzXmy4pPULF4TpawuP601V25d4dz1c+w5s4eJ2yey58weBtYfyJ6X91C2YFnD/xoh
HFeihDXW9vrrMHq0tTFahQpQsqRV/GvVgqJFTafMujQLvVJqNVAqhU+9pbX+LgOv732jq1ibIa1b
B6dOWUf9+ftbf5YvtxZeeHORv9dTlZ5i56Cd/PL7L0QciSDiaASf//w51+5co1zBcpy9dpaz186S
O3tuSviV4KHCDxFcL5iONTuSO0du0/GFcLrSpa3tEkaOtMbfdu6EWbNg3z7rnbu/v7V/1QMPmE6a
OQ7PulFKRQCva613pvC5xsB7WusWyY/fBJK01h+lcK1X/lIQQgjT0pt146yum9Rush2oopSqAPwC
dAa6pnRhekGFEEJkjSPTK9srpU4AjYHvlVIrkj9eRin1PYDWOgEYCoQD+4GFWusYx2MLIYTIKI9Z
MCWEEMI1PG6vG6XU60qpJKWUR45xK6X+rZTapZSKVkqtUUp50Az6/1FKfayUiknO+o1SqpDpTCnJ
6MI7U7xhwZ9SarpS6oxSao/pLGlRSpVXSkUk/3/vVUoNM53pfkqpPEqpLck/3/uVUh+azpQWpVR2
pVSUUirNyTEeVeiTi+YzwDHTWdIwRmtdV2tdDwgDRpkOlIpVQC2tdV0gDnjTcJ7UpLvwzhQvWvA3
Ayujp7sDvKa1roXV5TvE076eWuubQPPkn+86QHOl1GOGY6VlOFa3eJpdMx5V6IHPgH+YDpEWrfXv
9zzMD5w3lSUtWuvVWv+xEmoL4JGncWdw4Z0pXrHgT2u9HrhoOkd6tNa/aq2jk/9+FYgBXHz2WuZp
ra8n/zUXkB34zWCcVCmlygEtgWmkPiEG8KBCr5RqC5zUWu82nSU9Sqn/KqWOA72B0abzZEBf4AfT
IbxQSgv+ZIWYEyTPxAvAaoR4FKVUNqVUNHAGiNBa7zedKRWfAyOBdJe2u3pl7J+ksQDrbayuhXvP
YzI23TK9hWJa67eBt5VSb2B9sYPdGjBZRha0KaXeBm5rrY2dGu6EhXemyEwFF1BK5QcWA8OTW/Ye
JfmdcL3kca1wpVSQ1jrScKw/UUq1As5qraOUUkHpXe/WQq+1fialjyul/IGKwK7kpfflgB1KqUZa
67NujAiknjMF8zDYUk4vp1KqD9Zbu6fcEigVmfh6eppTwL2D7eWxWvUii5RSOYElwByttUef4qq1
vpw8VbwBEGk4zv2aAm2UUi2BPEBBpdQsrXWvlC72iK4brfVerXVJrXVFrXVFrB+mQBNFPj1KqSr3
PGwLRJnKkhalVAust3VtkweYvIGnLZr7Y8GfUioX1oK/ZYYzeS1lteJCgP1a6y9M50mJUqqYUqpw
8t/zYk0O8bifca31W1rr8sn1sgvwU2pFHjyk0KfAk98yf6iU2pPchxcEvG44T2rGYw0Wr06efjXR
dKCUpLbwzhN4y4I/pdR8YBNQVSl1QillpCsxAx4FemDNZIlK/uNps4VKAz8l/3xvAb7TWq8xnCkj
0qyZsmBKCCF8nKe26IUQQjiJFHohhPBxUuiFEMLHSaEXQggfJ4VeCCF8nBR6IYTwcVLohRDCx0mh
F0IIH/f/QH0wXEQipAoAAAAASUVORK5CYII=
)

默认效果如图所示，我们可以修改默认的属性来得到更漂亮的结果。

# 图

图像以 `Figure #` 为窗口标题，并且数字从 1 开始，`figure()` 函数的主要参数如下：

| 参数 | 默认值 | 描述 |
| --- | --- | --- |
| `num` | `1` | 图号 |
| `figsize` | `figure.figsize` | 图大小（宽，高）（单位英寸） |
| `dpi` | `figure.dpi` | 分辨率（每英寸所打印的点数） |
| `facecolor` | `figure.facecolor` | 背景颜色 |
| `edgecolor` | `figure.edgecolor` | 边界颜色 |
| `frameon` | `True` | 是否显示图框架 |

In [ ]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图
p = plt.plot(x,c)
p = plt.plot(x,s)

# 在脚本中需要加上这句才会显示图像
plt.show()

```

### 设置线条颜色，粗细，类型

首先，我们使用 figure() 函数来创建一幅新图像，并且指定它的大小，使得长宽比更合适。

然后，我们使用 `color, linewidth, linestyle` 参数，指定曲线的颜色，粗细，类型：

In [4]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
p = plt.plot(x, c, color="blue", linewidth=2.5, linestyle="-")
p = plt.plot(x, s, color="red",  linewidth=2.5, linestyle="-")

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAlkAAAFwCAYAAACLs24kAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

也可以像 **Matlab** 中一样使用格式字符来修改参数：

表示颜色的字符参数有：

| 字符 | 颜色 |
| --- | --- |
| `‘b’` | 蓝色，blue |
| `‘g’` | 绿色，green |
| `‘r’` | 红色，red |
| `‘c’` | 青色，cyan |
| `‘m’` | 品红，magenta |
| `‘y’` | 黄色，yellow |
| `‘k’` | 黑色，black |
| `‘w’` | 白色，white |

表示类型的字符参数有：

| 字符 | 类型 | 字符 | 类型 |
| --- | --- | --- | --- |
| `'-'` | 实线 | `'--'` | 虚线 |
| `'-.'` | 虚点线 | `':'` | 点线 |
| `'.'` | 点 | `','` | 像素点 |
| `'o'` | 圆点 | `'v'` | 下三角点 |
| `'^'` | 上三角点 | `'<'` | 左三角点 |
| `'>'` | 右三角点 | `'1'` | 下三叉点 |
| `'2'` | 上三叉点 | `'3'` | 左三叉点 |
| `'4'` | 右三叉点 | `'s'` | 正方点 |
| `'p'` | 五角点 | `'*'` | 星形点 |
| `'h'` | 六边形点1 | `'H'` | 六边形点2 |
| `'+'` | 加号点 | `'x'` | 乘号点 |
| `'D'` | 实心菱形点 | `'d'` | 瘦菱形点 |
| `'_'` | 横线点 |  |  |

In [5]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
p = plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAlkAAAFwCAYAAACLs24kAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

### 设置横轴纵轴的显示区域

我们希望将坐标轴的显示区域放大一些，这样可以看到所有的点，可以使用 `plt` 中的 `xlim` 和 `ylim` 来设置：

In [6]:

```py
# 设置图像大小
p = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
p = plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

########################################################################

# 设置显示范围
p = plt.xlim(x.min() * 1.1, x.max() * 1.1)
p = plt.ylim(c.min() * 1.1, c.max() * 1.1)

########################################################################

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAlYAAAFrCAYAAAATqcfxAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

### 设置刻度

对于三教函数来说，我们希望将 `x` 轴的刻度设为与 $\pi$ 有关的点，可以使用 `plt` 中的 `xticks` 和 `yticks` 函数，将需要的刻度传入：

In [7]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
p = plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

###########################################################################

# 设置刻度
p = plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi])
p = plt.yticks([-1, 0, 1])

###########################################################################

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAk0AAAFrCAYAAADM573uAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz
AAALEgAACxIB0t1+/AAAIABJREFUeJzs3Xd4VNUWBfA1CV26IEXxoSiCgIoUKSIgqIgiKiKCKEUE
RATpIF1670hRkCbNAtKkiHQQ6U26SO+EkhDS5v2x3rwblBKSmXtm5q7f9/lxbuSR7QvJ7Dlnn71d
brcbIiIiInJnIaYDEBEREQkESppEREREEkBJk4iIiEgCKGkSERERSQAlTSIiIiIJoKRJREREJAGS
+foTuFwu9TQQERGRgOF2u123+rgtO01ut9un/3Tt2tXnn0P/+Oc/+to79x997Z37j772zv3Hjq/9
neh4TkRERCQBlDSJiIiIJEBQJE3lypUzHYIYoq+9c+lr71z62juX6a+9627nd0n+BC6X29efQ0RE
RMQbXC4X3CYLwUVEREQCnZImERERkQRQ0iQiIiKSAEqaRERERBIgyUmTy+Wa4HK5zrhcrp3eCEhE
RETEH3ljp2kigEpe+HNERERE/FaSkya3270awCUvxCIiIiLit3w+sFdEJCmiovhPQqRKBSTTT7Xg
FBcHXL0KXL4MhIXx19hYIH9+IFs209GJQ+jHi4j4lQsXgDVrgNWrgVWrgC1b+NqYEKlTAyVKAC+8
wH9KlADSpPFtvOIlN24AK1YACxcCR45YiVFYGP+5cgW4XaPkbNmAp57iP08/zV/z5wdSpLDzv0Ac
wCsdwV0uV24A89xud6Fb/Dt3165d//9crlw5423QRcR/nDzJ5MiTJO3a5b0/O1kyoGhRJlBlygCl
SwOZMnnvz5ckOncOWLAAmDcPWLIEuHbNe392smRMnDyJ1GuvAU8+6b0/X4LGihUrsGLFiv8/d+/e
/bYdwW1JmjRGRUQ83G5g2TJg+nQmSYcO3fr3hYYy4Xn+eSB79oT9uYcP88/cs+fWv8fl4mto2bJA
/fp8LRUbud3A7t1MkubNAzZs+PfuUbJkTG4yZQIyZAAyZrz9r7GxzLK3bwd27OAXPjr69p+/fHng
00+BqlV1jiu3dacxKklOmlwu13QAZQHcD+AsgC5ut3tivH+vpElEEBcHzJ0L9O4NbNr073+fKhWP
08qUsY7W0qZN3Oc6f55HfJ4drC1b+Pn/6fXXgS++AEqWTNznkQQ6eBAYMYKJ0l9//fvfZ84MVK4M
VKkCvPIKk6LEiIoC9u1jAuVJpLZvB06fvvn3PfQQ0KgR8PHHqoeSf/Fp0pSAT66kScTBYmKAGTOA
Pn1u3gFKk4Y7Pp6js6JFgZQpfRPDlSvA+vXWEeDatTcnUeXLM3mqUIG7UeIlp08DPXoA48bxL0J8
TzwBvPEGE6WSJX2783PwIDBmDPDNN6yP8kieHKhenbtPJUvqiy8AlDSJiAE3bgDffgv063fz5kKm
TECzZsBnnwH3328mtsOHgf79gYkTb76ZV7w4k6cqVYAQzUtIvCtXgAEDgMGDgYgI6+Nly1qJ0uOP
2x9XRATPhUeOBLZtu/nfFS7M5KlmTd0ecDglTSJim/BwYOxYYNAgFnl7ZMsGtGoFNG4MpEtnLr74
Tp5knGPG3PzaXrAg0KED8O67Kn25JzduAF99BfTsyWuQHq+8wq3GwoXNxRaf2w2sWweMGgV8//3N
dVBZswLDhwM1amjnyaGUNImIz0VHMwEZOPDm18v//Ado2xaoV48tAfzR+fN8nRwx4ubTmzx5gO7d
gVq19Pp5R7GxwLRpQJcuwN9/Wx8vVgzo2xd48UVzsd3N6dPA+PHM9E+csD7+xhtMAHPmNBebGKGk
SUR86sAB4P33gT/+sD6WLx93a2rWZOlIILhyha+TgwcDZ89aH69WjWU5mTObi80vud3sq9S+/c29
IvLmBXr14v9xgZJtRkfz6K5VK2bRAAvSBw3iVctA+e+QJFPSJCI+4XYDX38NfP65dbxVoAB3Z958
k20DAtH168CECaxhPnOGH3vwQWDSJBaLC5hVfvghsHix9bEcOYCuXZlkBEqm/E/nzvEv9HffWR+r
UIFZ86OPmotLbKOkSUS87vx53tieM8f6WKtW3GDw1S04u507x//GuXOtjwXbf2OirFnDmh9P0VqG
DEC7dkDz5sFTRD1vHvDJJ9aRXZo0/MJ/9lngvhuQBFHSJCJetWQJUKeO1f4mZ07uwlSsaDYuX7jV
btrTT7OEp0ABs7HZzu3m2WW7dtZsm1q1WBBm6iqkL12+DLRpw5onj5Il2bogf35zcYlP3Slp0qVa
EUmwyEgmD6+8YiVM1aqxh2AwJkwAS1k+/hjYupW9pAD2SyxalDfXHfOeMCwMePttoHVrJkwpUrAA
bOrU4EyYAO6gjRsH/PqrdTS3fj3wzDPcdbpT93EJStppEpEE2bmTmwqeet+0abnBULeuc2pko6OB
bt14e97zY+3VV1n/lJBRLwFr61bgnXfY4AoAcufmVf0iRYyGZauICKBzZ2DoUKsz6ksv8f+H9OnN
xiZepeM5EUm0uDgmR+3bsw0PADz3HI+n8uQxG5spq1cDtWsDR4/yOWtWnthUqWI2Lq9zu3k01ayZ
9cWvUoVnsU6dfPz77yx097S3f+opDh1+6CGzcYnX6HhORBIlOpoXpFq04GtmSAhb8axe7dyECeDY
l+3bufMGsGD8jTfY/TxohIezcK1RI37xQ0P5HzhnjnMTJoDvGDZu5Bcc4Nl0iRL8CyFBTztNInJL
EREcy7VwIZ8feYTlK6VKmY3L33z3HS9ZXbnC5zZtmFsE9JHl3r08jtu9m885cnCA4AsvmI3Ln8TG
ssBv5Eg+p0vHo7qXXzYblySZjudE5J6EhfEUZs0aPhcvzuQpWOt9k2r3br5Wem7g16/PBtMBOYJl
+XKgalXg2jU+ly/Ppo/ZspmNyx+53cCQIexDAXA3btw4/gWQgKXjORFJsNOngXLlrISpQgVg2TIl
THdSoACwdi3w2GN8njCBc+siI83Gdc+WLAFee81KmDp2BJYuVcJ0Oy4X0LIlMHs2G3fFxgIffcSC
cW0WBCXtNInI//31Fy8EHTrE52rVWPDt6EaO9+DMGaBSJWDbNj6/+CJLgPxlQPEdLVjAlgJRUdwx
mToVeO8901EFjnXrWOfkGbxYuzZvB6RIYTYuuWc6nhORu9q1i0dMp07x+aOPeMSk5sf35vJlHm2u
Xs3nokWBRYuALFnMxnVHc+eygC06mmeKM2cygZJ7c+AAe1B43nWULw/8+COQMaPZuOSe6HhORO5o
wwbW+HoSprZtedNcCdO9y5AB+OUXnnIBwKZNvG137JjZuG7r++9Z9B0dzV2RH39UwpRYjz/O5pcl
SvD5t9+A0qWBv/82G5d4jZImEYdbsoR1S5cu8blfvyC4/WVYmjTATz/xhAbgZbTSpYF9+8zG9S8z
ZvAILiaGZ7Bz5gRhsymbZc3KYvpq1fi8Zw/w/PNWUy8JaEqaRBxs9mzg9dfZXiAkhLtLbduajio4
JE/OHpCffcbnY8e447Rli9m4/m/KFOD991m8nDo1MH8+j5Yk6VKnBmbNYoMzADh+nMWCZ8+ajUuS
TEmTiEN98w0H1XtOZWbNAho0MB1VcAkJAYYNA7p35/O5c7yZ6Kl3MmbCBDaujIsD7ruP/SSCdXig
KSEhwKBB7OUEAPv3Myn1NPSSgKRCcBEH+vFHlrG43XzNnDNHr5m+NnKkteuUPj1bOhQqZCCQsWOB
xo25TpuWVerPP28gEIeIi2PfpkmT+Fy2LP8/T53abFxyW7o9JyL/t3YtE6TISCZMv/7KyRDie5Mm
ccAxADz4IAvwbR1ZNmIE58gBzNwWL7aKlsV3YmJY4/Tzz3yuUgX44Qee4Yrf0e05EQHAQuQ33mDC
FBrKi1NKmOxTp441n+7ECZ7WhIXZ9MlHjbISpowZmS0rYbKHp41DuXJ8njePPT3i4oyGJfdOSZOI
Q5w+zcaLFy/y+euv+Sz2atMGaNqU6127gLfe4jxcn5o/30qY7r+ft7uKFvXxJ5WbpErFflhFivB5
yhR2E9dJTEBR0iTiAFevApUrA0eO8PnLL61jIrGXywUMHcpkCQBWrODXwmebDtu3s61AXBx7ISxe
DBQu7KNPJneUPj3rmZ54gs/DhgE9e5qNSe6JkiaRIBcdzWbPW7fy+eOPgU6dzMbkdKGhHE9TujSf
Z8wA2rXzwSc6dYo9JcLDma1Nm2btdIgZWbNynl+uXHzu0oW3BCQgKGkSCWJuN5OkxYv5/PrrwOjR
alzpD1Kn5mmNZ9Nh4EBg+HAvfoLwcBYcHz/O5wEDgDff9OInkETLlYuJk2e2zmefAd99ZzYmSRDd
nhMJYp07W7v/xYuzlOW++8zGJDc7cgQoWZI1Zy4XG456mkknWlwce0r89BOfGzYExoxRtuxvNm/m
fLqrV1ksPncuz9HFKLUcEHGg+O148uThEPYHHjAbk9za1q2c/XftGqeZLF3K7uGJ1q4d0L8/1xUr
snmlrrf7p5UrgVde4W2AVKnY+VRF+kYpaRJxmHnzeBITF8cSinXrgMceMx2V3MmSJRzyGxMDZMrE
flr58yfiD/rmG6u1e758HCCbMaNXYxUv+/lnDkmOjeXR3ebN/MYVI9SnScRBfv+d41E8l6Xmz1fC
FAhefpltIAAOT65UCTh58h7/kOXLre3FLFmABQuUMAWCN95gURvAIYU1azJ7Fr+jpEkkiPz9N4u9
r1/n6KuZM1nLJIGhTh2rBu3oUe48RUQk8H+8dy+LoWJiOExwzhzg0Ud9Fqt4WfPmTJYANh7t2NFs
PHJLSppEgsSNG2wtcP48n8eMYQIlgeWLL4BGjbjets1qhHlH58/zi+1pLz5xotXPQAKDywWMH28N
JOzfn7cCxK8oaRIJEq1bA3/8wXWzZmw1IIHH5WLbnrJl+TxxIjBhwh3+BzdusFPmoUN87tYNqFXL
12GKL9x3H288eo5U69UD9uwxG5PcRIXgIkFg5kw2fQY4S27VKp7QSOA6dYqNu8+c4aWqDRuAp5/+
x29yu9lOfPJkPteqBUydqtYCgW7hQu4cut1A3rzAxo1Ahgymo3IMFYKLBLF9+6zLUpkzA7NmKWEK
BjlyANOnszYtMpJHr1eu/OM3ff21lTCVKsWbc0qYAl/lytwxBID9+1nspuG+fkFJk0gAi4hgD8Nr
1/g8dSrw8MNmYxLvKV8e6NGD6wMHgI8+ijffddcuawhvzpw81kmVykic4gOdOllFiXPnAn36mI1H
AChpEglYbjfQpAlfOwFetnn1VbMxife1b281if7+e2DECDBbrlGDW1AhIZwpp86lwSUkBJgyxeoX
0rkz8MsvZmMS1TSJBKr4PQzLl2cX6dBQszGJb1y4ADz7LNsQJE8OHK/UAA/M+4b/smtX6yhHgs+u
XSxUjIhg19NNm9RKwsfUEVwkyGzbxnllkZFA9uwcw5E9u+moxJd+/52jVapFT8d0/O92XNmy7Omj
bDm4xb/p8fTTbPGfJo3ZmIKYCsFFgsjly6xj8pzMzJihhMkJnnsOGN/uIMahIQDgcvIsiJsyTQmT
E9SoAbRqxfX27RzArM0II5Q0iQQQtxuoX99qydO7t9XPR4LcjRv4cGENpAOr/mtGT0KfyQ8aDkps
07cvUK4c19OmAaNHGw3HqXQ8JxJAhg4FWrTg+vXXeakmRG99nOHzz4FhwwAA32RshQZhAxESAixb
xpo2cYCzZ4EiRYDjx3lTcsuWRE51ljtRTZNIEFi/HnjhBY4W+89/+PMyc2bTUYktfv4ZqFqV6+LF
sXP0ahR/PgUiI4Fs2VjTliOH2RDFJqtXc3vZ7ebtgPXr1ZjNy1TTJBLgzp8H3n3XmsU6e7YSJsc4
dozjNAAgfXpg+nQUKpLi/6czZ86wRjgmxlyIYqMyZYC2bbnesgX48kuz8TiMkiYRP+d2s7XA8eN8
HjwYKFbMbExik5gYoGZN4OJFPn/99f+vm9erZ+VSq1YBvXoZilHs1727NVOnTx/ephNb6HhOxM9N
nswpCgBHacycqUkZjtGpk5UNNWoEjBlz07+OiOCtul27gGTJ2Jbg2WcNxCn227ULKFqUA5sffZR9
SNKlMx1VUFBNk0iAOn4cKFiQbQayZwd279axnGMsWwa8/DK3GgsVYkaUOvW/ftvWrUDx4tyUKlAA
2LwZSJnSQLxivyFDgJYtuW7QABg/3mw8QUI1TSIByO3mrLHLl/k8frwSJsc4cwaoXZt/CdKk4fbi
LRImAChcmBM2ACbVag7uIM2bW1cnv/6aFwbEp7TTJOKnxo4FGjfmul49YMIEs/GITdxudi/98Uc+
T5hgFS/dRnQ0O8Rv3swWFGvW8Fkc4OhR4Kmn+O4qa1Ye22kOYZLoeE4kwBw+zJ+D4eFArlzAzp1A
hgymoxJbzJrFDtAAk6dZsxJUxLZ7N+uZoqKAxx9niYsmbTjEtGncmQSAKlXYwE2Fj4mm4zmRABIX
x42F8HA+T5ighMkxzp0DPv2U6yxZgFGjEvziV6AA0LMn1wcOAF984aMYxf/UqmUl2vPmcZq3+IR2
mkT8TPyu302a8HVTHKJGDe4sARwq6HkhTKDYWDZA9dxAX75c3cId4+JFXhg4eRK47z7OqMuTx3RU
AUnHcyIBYt8+4JlnOIw3Tx4esaRNazoqscUPP/A4DgDeeovPiThiOXCALXyuXwdy5wZ27NBNdMdY
upQ3LgEWta1axV4Uck90PCcSAGJi2I8pMpKvld9+q4TJMc6f57YiwCuSo0cnuibl8ceB/v25PnIE
aN3aOyFKAHjpJeCzz7hevx7o189sPEFISZOInxgwgK14ALZeef55s/GIjZo35zBWABg+nE25kqBJ
E+tYbtw44JdfkhifBI5+/YB8+bju1o1XKsVrdDwn4gd27GBz3+ho/rzbsuW2bXkk2MydC7z5Jtdv
vAHMmeOVm09HjvAG5tWrQM6cvImeKVOS/1gJBJs3AyVKcPs6Xz6e86vjaYLpeE7Ej0VFAR9+yIQp
NBSYNEkJk2NcvGg148qYkWNSvHRVPHduNowGWBvcrJlX/lgJBEWKWF1O9+7lfDrxCiVNIob17MmL
LgDQvj1HYohDtGgBnD7N9dChQI4cXv3j69cHKlfmeupU4KefvPrHiz9r29Ya6tu7N/Dnn2bjCRI6
nhMx6I8/eMklNpZHKX/8AaRIYToqscWCBcDrr3NduTIwf75PGhKePMn5hZcusWH07t38VRzgjz84
0dntZpHkypVsGS93pOM5ET8UFQXUrcuEKXlyYPJkJUyOERYGNGzIdfr0nJnjow7OOXMCI0dyfe4c
0LSpTz6N+KNixaxz2TVrOJ9OkkRJk4ghAwYAe/Zw3aWLtZMuDtCyJbeAABYePfSQTz9dzZrA229z
PWsWsGiRTz+d+JMePTiLCeCR3alTZuMJcDqeEzHg0CEemURGcvzF1q3cbRIH+OUX4NVXuX7lFWYw
NswJO3kSyJ8fuHKFReK7d2s2nWPMm8ebmQBQvbrVdV5uScdzIn7E7WYfnchIPo8dq4TJMS5fBj7+
mOt06dhEyabBqjlzAr16cX3kiDWnThygShUmSwAwezaTKEkU7TSJ2GzmTOC997hu0AAYP95sPGKj
xo2ZJQP81VPXZJPYWLbv2bSJ0zW2beNOpzjAqVPcarx8mcd1u3drvs5taPaciJ8IC+PPrdOneYNp
715OzRAH2LABKFWKW40VKnBOmE27TPFt2cL64Lg4XahynHHjgEaNuG7enG0u5F90PCfiJzp2tNry
DBqkhMkxYmN5Jut2szOzF5tY3qtnn735QtXEiUbCEBMaNLDmMw0fDmzcaDaeAKSdJhGbbNzIoxG3
m3PBfv3V2Oum2G3kSGuQapcuQPfuRsO5epU7nidOMHHfu1e9mxzjzz95VTc6mr/+8YeKKv9BO00i
hsXEcFfc7WYvpq++UsLkGKdPc4sRAB59lG3fDUuXjhsNACe5tGljNh6xUf78wBdfcL19uzVrRxJE
SZOIDUaMYNEtwNfMJ54wG4/YqHVr3vMHuOPkJ4MF33rLakg+aRKwYoXRcMROHTpYP4S6dWMPFEkQ
Hc+J+NixY3xzFx4OPPYYsHMnkCqV6ajEFr/9Brz4Itdvvw388IPZeP7hyBHgySeB69f5Grp9O0uu
xAFWrQLKluX6pZeAxYu1/f0/Op4TMahZMyZMAI/llDA5RFQUi78BdpH0w5tKuXNzowEA9u0D+vc3
GY3Y6oUXrJ5hS5cC06aZjSdAaKdJxId+/hmoWpXrWrX0c8lR+vblMQgA9OvHERZ+KDoaKFKEO6Ap
UwK7dnFHVBzg0iVug585A2TJwiLxLFlMR2Wc+jSJGBAezqOPo0eBDBn4Tj5bNtNRiS3+/ptf/IgI
/rp1q19PY163Dihdmmud1DjMrFlAjRpcN2rEdhgOp+M5EQO6dWPCBHDTQQmTg3z+ORMmABg92q8T
JoA9N+Of1MyYYTYesVH16pyBCLD55ZYtZuPxc9ppEvGB7dt55OEZW7F2rbouO8b8+Zz1BQAffABM
nmw2ngS6eBHIlw84d44J/t69QMaMpqMSW+zdCxQqxN4opUqx66mDtxq10yRio7g4jhiLjQVCQzli
TAmTQ0REWE0sM2QABgwwG889yJwZGDyY6zNnrFY+4gD58nF3FOBZrYovb0s/ykW8bOJEjhkDgBYt
gKeeMhuP2KhPH97jB4BevQLuTPb9960OCWPGcLCvOETnzkD27Fy3bcu28fIvOp4T8aLLl4G8eYGz
Z4EHH+Sud9q0pqMSW+zbxww5KooD3jZu5FZjgNm3jyc10dE6qXGcyZOBOnW4btPGsT0odDwnYpMe
PZgwATyZUcLkEG430LQpEyaXiw25AjBhAtjksnlzrtetA6ZPNxuP2Kh2baBkSa6HDmUGLTfRTpOI
l+zbBxQsyFrK0qWB1av1Dt0xguza9pUrwOOPWzum+/YB991nOiqxxZYtQNGifCPwyivAokWO+0Gm
nSYRG7RsyYTJ5eIwVIf9nHGua9dYvAawMWDv3mbj8YL06VmeBQAnTrBlhjjEs89a/ScWLwbmzTMb
j59R0iTiBQsX8h8A+Ogj/twRh+jTBzh5kuv+/XkNLQjUrcu2GQCPmj317eIAPXta/SZatAAiI83G
40eUNIkkUVSUtdGQPj0vTYlDHDkCDBrEdbFiVhFtEAgJ4Y4pANy4AbRubTYesVHWrCzQBIDDh62/
46KkSSSpRowA9u/numtX4IEHzMYjNmrblhkFwMLZIGvIVaoUZyYCwA8/AL/9ZjYesVHjxrxGCfDI
+dgxs/H4CRWCiyTBmTNsMXDlCm8d7djh9xMzxFtWr+akeACoWRP47juz8fjI8eP8ux0RwdfQLVuA
ZMlMRyW2WLkSKFeO63ffBWbONBqOXVQILuIjHTsyYQKAIUOUMDlGXJzVQTl16qCulH7oIaBDB653
7gTGjzcbj9iobFnrVuisWcCKFUbD8QfaaRJJpM2bWcbidgOVKwMLFpiOSGwzcSJQvz7XXboA3bub
jcfHrl8HnnySJVz338/j6CCpd5e7OXaMY1YctNWonSYRL3O72QDQ7ebPjyFDTEcktrl61RrM9uCD
rGsKcqlTAwMHcn3hAtCtm9FwxE65cll/33fuZONWB1PSJJIIM2YAa9dy3bw565rEIfr0AU6f5rpv
X8d0fXz7baB8ea5HjwZ27zYbj9ioVSvg0Ue57tIFOHfObDwG6XhO5B6Fh7Mw9sQJ3pTbv58D7cUB
/voLyJ+fN+aKFwfWrw+6G3N3smMHULgwS7oqVgSWLFETV8eYNw944w2uP/4YGDfObDw+pOM5ES/q
148JE8BNByVMDhK/xcCwYY5KmADOI27cmOtly4CffzYbj9jo9deBSpW4/uYbYNcus/EYop0mkXtw
5Ag3GiIj2S1540bHvW4616pVvE0EsHnRtGlm4zHkwgXOpbt0iSc2u3cDqVKZjkpssWcPM+fYWM6l
++UX0xH5hHaaRLykTRtrosDw4UqYHCM21jEtBu7m/vuBL7/k+vBh9vQUh3jyyZvn0i1ebDYeA7TT
JJJAK1ZYhbAO3mhwpgkTOFQQYNt3h18fi4kBnnmGu0z33ce6vpw5TUcltjh7FnjsMd4iLVgQ2LYN
CA01HZVXaadJJIni4qz5cmnSsK5JHCJ+i4GHHnJEi4G7SZaMJV0AL0Z06mQ2HrHRAw9Y3U537eIb
CgdR0iSSAFOn8g0VALRrx9dOcYjevTkvB+CxXJo0ZuPxExUqWJepvv2WN+vEIT7/HHj4Ya47d+Yb
C4fQ8ZzIXVy/zj5Mx48DOXIABw44pjWP/PUXuyFHRQElSgDr1umOfTx79/KEJjYWePllR5a4ONe0
aUDt2lx36gT06GE2Hi/S8ZxIEgwdyoQJAHr2VMLkKG3aMGEC+BdBCdNN8uUDGjXieskSJU2OUrMm
ULQo14MGWT8kg5x2mkTuIH7NY6FCwNatQVfzKLcTv8VA7drAlClm4/FT+h5xsNWrgRde4PrDD4FJ
k8zG4yXaaRJJpC+/tI7rBwzQi4FjxMVxdATAFgN9+piNx4898ADQvj3XO3cGzeumJESZMsBbb3E9
eTKH+QY57TSJ3Ma+fUCBAqzXeOklHj+IQ8yYweMHgIWunsZEcksRERwtdPw4Ww/s369jbMc4cID9
m2JigHLlgOXLA/4YWztNIonQrh0TJpeLu0ziEDduWC0GsmZlXZPcUZo0rPcDgJMngcGDzcYjNnr8
ceDTT7lesYIz6oKYdppEbiF+OUvdusDEiUbDETsNHWo15Ro1CmjSxGw8ASI2lnXB27Zxl+ngQSB7
dtNRiS0uXgTy5AHCwnjVeNcuIHly01ElmnaaRO5BXBzQujXXqVMH1U1auZuwMOsLnjevNTJC7io0
1NqRDQ93fNN0Z8mcmcfYAM9mx4wxG48PKWkS+YdZs4A//uC6ZUs1snSUPn34rhlgI8sAfrdsQsWK
wKuvcj1+POe7ikN8+iknOANA9+58AxKEdDwnEk9kJHvP/P03bwUdPAikS2c6KrHF0aPcXbpxAyhd
mtepA7w/1kQzAAAgAElEQVSg1YRdu4Cnn+aO7WuvAfPnm45IbPPDD8A773DdunXAFoPqeE4kgUaO
ZMIE8M2SEiYH6dSJCRPAH/ZKmBKlYEGgfn2uFyzgZSpxiLffBp5/nuvhw9lRP8hop0nkfy5cYJO+
sDDuNu3cycGk4gBbtwJFigBuN1CtGvD996YjCminTvF7KSICKFwY2LQJCNFbdGfYuBF47jmu330X
mDnTbDyJoJ0mkQTo2dM6hu/fXwmTY7jdQNu2/DVZMjWy9IIcOaxODVu3At99ZzYesVHx4laPs1mz
gN9/NxuPl2mnSQTAoUNA/vxAdDRbDfz2m05nHGPxYqBSJa6bNgVGjDAbT5C4do0tfE6fBnLlYrPY
1KlNRyW2OHKE3U6jogLyB6p2mkTuokMHJkwAMHBgQH1/S1LExnKXCWABm+fatCRZ2rRW94Zjx4Bh
w8zGIzbKndtqeLlyJbBokdFwvEk7TeJ469cDpUpxXasWMG2a2XjERt9+C9Srx3XPnkDHjkbDCTax
sbxJt3s3kD49b6NmzWo6KrHF+fNseHnlSsBNctZOk8htuN1WI8uUKYFevczGIza6fp035gAOTPN0
ARevid/w8soV3kgVh8iS5eZJzkHyblRJkzja3LnAunVcN2vGXWVxiKFDgRMnuO7RgwPUxOsqVWLT
SwAYO5a7TeIQzZvzVgDAo+/ISLPxeIGO58SxYmKAp54C/vwTyJSJxeCZMpmOSmxx7hyPDq5eZWOh
bdsC5uggEG3Zwo4OAPDee8D06WbjERuNHw80bMj1wIFAq1Zm40kAHc+J3MKkSUyYABaCK2FykJ49
mTAB7C+hhMmnnn2WyRIAzJgBbN5sNh6xUb16bHwHsP4hwMeraKdJHOn6dV6HPnGCs+X279d1aMc4
eJD9JWJigBdfBJYt03VJGxw6xNfOmBjgpZeAJUtMRyS2mTMHeOstrtu141xHP6adJpF/GDHCKmfp
3l0Jk6N88QVfuQHuMilhskWePECjRlwvXcpcVRyialXrivKwYcDx42bjSQLtNInjXLrEYdxhYcCT
TwLbt6v7t2Ns2gQUK8a1+kvY7swZJk/h4axx2rhR41UcY80aoEwZrj/6CPj6a7Px3IF2mkTi6dvX
Olbv3VsJk6N4rkAnT866JrFVtmxWHfDmzcDs2WbjERs9/zzwxhtcT5wI7NljNp5E0k6TOMrx46xl
iozkbvGaNTqdcYylS4GXX+b6s884hV1sd+UKh/meO8df9+xhDisOsGcPG13GxTGBmjvXdES3pJ0m
kf/p1s1qFdKvnxImx4iLs3aZ0qa1mlqK7dKnt6bVHDzo16c04m1PPml14P/5Z75rDTDaaRLH+PNP
tuSJiwOqVOH3rDjEzJnWnfeuXZk9izFRUbxJ99dfPLI7eJC5rDhA/O3+kiWBtWv97t2rdppEwEtT
cXEsPO3d23Q0YpvoaGtnKWvWgGiuF+xSpLBKys6cYXN2cYiHHmKncICDP/30iO52tNMkjrBuHVC6
NNd167IOURziq6+AJk24HjaM83LEuLg43qDbtg1Il459nDTM1yHCwniF+dIlbjnu3OlXN3K00ySO
5nZb5SwpU2poqKOEhwNffsl17txWoyAxLiTE6nF49ap2fx0lY0agY0eu9+4NqHexSpok6C1YAKxe
zXXTpsDDD5uNR2w0bBhw+jTXX37JrFn8xssvA+XLcz16NHDkiNFwxE6ffmr9MO7aFYiIMBtPAilp
kqAWG8u5cgCQIYO1Fge4cIFXJAFec65Vy2w88i8ul/UliooCunQxG4/YKFUqoEcPrk+d4hucAKCk
SYLa1KnArl1ct2sH3H+/2XjERn36sCmQZ62hvH6pWDHgnXe4njoV2LHDbDxio/ff5xsagCONLl0y
G08CqBBcglZkJPDEE8DRo0COHLzWnCaN6ajEFkePAnnzAjducHTDypV+d61ZLPv3s4VPbCxQuTKP
1MUh5s9nDxjAb4b5qhBcHGn0aL52Aiz+VsLkIN26MWEC1MU0AOTNC3z8MdcLFzLHFYd47TXravOw
YdYkdT+lnSYJSpcv80brxYvcbdq1y69utIovxR/VULUqMGeO6YgkAU6d4liViAjguefYwke5rkPE
H+bbqBEwZozRcLTTJI4zYAATJkBDeR1HXUwDUo4cQIsWXP/+O/DTT2bjERs9/zx3nADO1TlwwGw8
d6CdJgk6p08DefLwHWvx4sCGDXrH6hjr13MSM8AZVxMmmI1H7kn8HeL8+VkUrjc8DrFjB/DMM2ys
9+67HH1kiHaaxFF69rRafvTtq4TJMf7ZxVTz5QJOhgzcKAQ4K3LKFLPxiI2eespqCzJrFrB5s9l4
bkM7TRJUDh9mV/7oaOCll4AlS0xHJLZZuNDa4m/ZEhg0yGw8kijXr3Oe64kTQK5cvFmXKpXpqMQW
hw+zCDUmhp1PFy82EoZ2msQxunZlwgSonMVR4uKszqXp01vbFRJwUqe2NgmPHTNeEyx2evRRa9TR
kiXA8uVm47kF7TRJ0Ih/JF69Ond4xSGmTQNq1+a6Z09rrpUEpJgYoEAB7jJlycJhvunTm45KbOEH
RanaaRJH6NiRCVNoqNWdXxwgKgro3JnrbNmAzz83G48kWbJkQK9eXJ8/DwwebDYesVH27NY1yo0b
/a5liJImCQpr17KxLADUr89jcXGIr78G/vqL6y5dgPvuMxuPeEW1akCRIlwPGgScPWs2HrFRmzZA
5sxcd+zIrUc/oaRJAl78S1OpUmnop6OEhwNffsn1I48ADRqYjUe8xuWyJmpcu6YaRUeJP13dz65R
KmmSgLdoERvKAkDTpsBDD5mNR2w0bBhw5gzXPXoAKVKYjUe8qmJF4MUXuf7qK+DIEaPhiJ0+/RR4
8EGuu3blMFE/kOSkyeVyVXK5XHtdLtcBl8vVzhtBiSTUPy9NeXacxAEuXuRkdIA9XmrWNBuP+ESf
Pvw1Kkqttxzln9cov/rKaDgeSUqaXC5XKICRACoBeBJATZfLld8bgYkkxIwZvDUHAG3bAvffbzYe
sVG/fmwhDfDsJkQb58GoeHHg7be5njIF2L3bbDxio7p1Oc0Z4M2AK1eMhgMkfaepOICDbrf7iNvt
jgYwA0DVpIclcnf/vDTVvLnZeMRGJ04Aw4dzXbo0ULmy2XjEp3r2ZE4cFwd06mQ6GrFN/GuUFy74
RcPapCZNDwI4Fu/5+P8+Zh+3mw2w1AvKcb7+mg1kASZPadOajUds9OWXVo2DZuUEvfz5uekA8Ab6
hg1GwxE7VasGFC3KtR9co0xq0mQ2U9m/HyhZEqhQgSMUxDHCw61eTI88Anz8sdl4xEb79wPffMP1
a69xQroEva5drTr/9u31Ptkx4l+jDA+3dp4MSer86BMAcsV7zgXuNt2kW7zqvXLlyqFcuXJJ/LT/
kyULsHcv1x06AK++qroGhxg+nI1jAW466NKUg3TpAsTG8oep7qE7xsMP80LVkCHAypWcsvHKK6aj
EltUqMCrlMuWAePHs0A8Uyav/fErVqzAihUrEvR7kzRGxeVyJQOwD0AFACcBbARQ0+12/xnv9/h2
jEqfPtacqalTgfff993nEr9w8SJHFF2+DBQqBGzdyi7g4gBbtlgdD2vV4vgUcYxz5zhh4+pVoHBh
YNMmvU92jE2beFu2Rw+fdy/22RgVt9sdA6ApgMUA9gCYGT9hskWzZmy7DrCwJSrK1k8v9vvnpSkl
TA7ieYOULJnV1FIcI2tWoHVrrrduBWbPNhuP2KhoUQ4UNTzuITgG9n71FdCkCdcjRrDDoQSlEyeA
xx5jDXDp0sDq1aoBdowVK4Dy5blu0gQYNcpoOGLG1avcbTp3jj8L9uwBkic3HZUEk+Af2NugAb+L
AG7dXbtmNh7xGV2acii32+pimiaN7p07WLp01pf/4EFgwgSz8YizBEfSlDy5dZXq7Flg6FCz8YhP
xL80VbmyLk05ys8/W/fMmzcHcuQwG48Y1agR8J//cN29OxARYTYecY7gOJ4D2PXs2WeB7ds5T+PQ
Id6uk6BRowaPtF0uYNs2Ts4QB4iN5Rd7zx7emDl8GMiY0XRUYtjkyUCdOlz37Qu00xAv8ZLgP54D
eIXCM6ToyhWrr4MEhc2bmTABvDSlhMlBpk1jwgSwQY8SJgEvShcowHXfvsClS2bjEWcInp0mgHUP
5coBq1YBKVMCBw4AuXLd9X8m/u/ll4GlS3kSu3cvWw6IA9y4wdsyf/8N5MzJ7+k0aUxHJX7i55+B
qv8b3NWund4ri3c4Y6cJ4LmNZ7fpxg0edkvA+/VXJkwAaxmUMDnI2LFMmAC2hFbCJPFUqQKUKsX1
sGG8XSviS8G10+RRtSrfgoSEcCR2vnz2fn7xGrebU843bQLuu4+latmymY5KbKG75ZIAq1cDL7zA
dcOGzLNFksI5O00evXpx10kjsQPejz8yYQKAli2VMDnKoEFMmAB+TythklsoU4YjCAHert2/32w8
EtyCc6cJ4LWKyZO53rgRKFbM/hgkSWJigIIFgX37gPvv5y5ThgymoxJbnD3LXaZr1zg2ZeNGzcuQ
29qxA3jmGe5Mv/suMHOm6YgkkDlvpwlgPZPnnamnKZ4ElG+/ZcIEcHqGEiYH6dnTalLbt68SJrmj
p57irVqAt2w3bzYbjwSv4N1pAtgEb/hwrpcu5ZRkCQjXrwOPP87Czly5uOWeKpXpqMQWhw+zDjE6
mt+znlsAIncQ/6/NSy8BS5aYjkgClTN3mgCgY0dWDwPs72IqeZN7NnKkdROme3clTI7SpQtf+QDr
NqzIXTz6KG/XAsyzf/3VbDwSnIJ7pwngNWXPNPTZs4F33jEXiyRIWBh/AF66BDz5JOsVQkNNRyW2
2L4dKFyYb3CqV7c6mookwJkzLIULDweKFmUpnOZTyr1y7k4TALRqxSpigDtPMTFm45G76t/f6u7b
q5cSJkfp0IEJU2go65pE7kG2bLxlC/DW7Y8/mo1Hgk/wJ03p0zNZAlgYM3Gi2Xjkjk6dsuYtlyhh
dfsVB1i5Eli0iOsGDYC8ec3GIwGpdWu9TxbfCf6kCQA++cQap9Ktm0Zi+7Evv2QROMBLU9padwi3
25q4mjo165pEEiH+++R9+3gLV8RbnJE0pUpljVQ5edK6USd+5cABYPx4ritVAsqWNRuP2GjOHOD3
37n+/HPOmRNJpH++T/a8ERNJquAvBPeIjQWefppjVTJkYKdEzx6u+IX33rOa0m3dymZ14gAxMUCh
QpzEnCkT745nzGg6Kglw334L1KvHdf/+QJs2RsORAOLsQnCP0FBrBPbly7rK7Ge2bLESppo1lTA5
yqRJTJgAdjFVwiRe8MEHvH0L8Md9WJjZeCQ4OGenCWDdRNmynPCYIgULw//zH9NRCXgct3gxkCwZ
Xz/z5DEdkdgifhfThx7iGa2acomXzJ0LvPkm1x06AL17m41HAoN2mjxcLqBfP66jolRs6id+/ZUJ
E8Ap5UqYHGTUKHUxFZ954w3ewgV4K9fzV00ksZy10+RRrRobeLhcwLZtHFwkRsTFcZbyli1s3n7w
IJA9u+moxBbxu5jmywfs3MmtRhEvWrXKulTSoIF12UTkdrTT9E+9e7PGye3meBUxZuZMJkwA+5Aq
YXKQ+F1Me/dWwiQ+8cILwOuvcz1hArBnj9l4JLA5c6cJ4JCiceO4Xr4cKF/ebDwOdOMGkD8/8Ndf
wAMPcJcpXTrTUYktTp4EHnuMNU0lSgDr1qkpl/jM7t08UIiL45Hd3LmmIxJ/pp2mW+nWDUiThut2
7TTM14CvvmLCBHBEoBImB1EXU7FRgQJW+4Gff+ZdIJHEcO5OEwB06sThZoCG+drs8mUWfF+4wMtT
u3cDyZObjkpssXcvULAge6e9+iqwcKHpiMQBTpzgzxptbsrdaKfpdtq0sRpcfvEFEB1tNh4H6deP
CRPAchYlTA7Svj0TJpfL6p0m4mMPPshm8wCwYYOG+UriODtpypCBu00A+8N8/bXZeBzi+HFgyBCu
n3uOlxnFIVavtgpK6tbVzVWxVbt21vvkDh30PlnunbOTJoBDinLn5rp7d+DaNaPhOEHXrkBkJNcD
BmiL3DHcbmuWRapUrGsSsVGGDEDnzlzHn3UpklBKmlKmBHr25PrMGWDwYLPxBLndu62p41WqAGXK
GA1H7PT999ZQ3hYt2AFcxGaNGwOPPMJ19+7A1atm45HA4uxCcI+4OKBIETa6TJuWw3wfeMB0VEGp
ShVg/nwgJIS9DD2zoSTIRUXxi33oEJAlC/tLZMhgOipxqOnTgVq1uO7ShcmTiIcKwe8mJMQar3Lt
mrXzJF61ciUTJgCoX18Jk6OMHcuECeCrlBImMahGDb5PBoBBg4DTp83GI4FDO00ebjfw0kschJY8
OfDnnxqC5kVuN6/5btwIpE7NjYacOU1HJbaI318iTx62ZE6RwnRU4nDLlwMVKnDduDH7xokA2mlK
mPjDfKOjrVt14hXff8+ECWA5ixImB4nfX6JPHyVM4hdefBGoVInr8eOBffvMxiOBQTtN/1SzJjBj
BtcbN3KarCRJdDSP4g4e5HXfQ4d0OuMYx44BefPyuuRzzwHr1+u6pPiNHTuAZ57hTvhbb6l3k5B2
mu5Fz55Wp8VWrTRexQvGjWPCBKicxXG6dFF/CfFbTz0FfPgh1z/9xC7hIneinaZbadnS6r744498
CyKJcuUK57KeOwc8+ihLxXQ64xDx38ZXrQrMmWM6IpF/OXqUm6E3bgClS7P/qnJ7Z9NO073q1AnI
lInrtm15XVoSZeBAJkwAx/wpYXKQtm2ZMIWGalyK+K2HHwaaNeN67VqrYb3IrShpupXMmXmsAPBc
SdcqEuXUKV7nBXi99913zcYjNlq6FFi8mOuPPwby5TMbj8gddOhgvU9u3x6IiTEbj/gvJU2306QJ
z5UAjnu4dMlsPAGoSxcgIoLr/v3ZDkscIC6Ou0wAcN99nJsj4scyZeLMdoC36DReRW5HL2O3kyKF
1YLg4kU1vLxH27cD33zDdeXKvN4rDjFtGrvrA0yesmc3G49IAjRtao0h7dIFCAszGo74KRWC34nb
DZQty8pANbxMMLcbqFiRzeNCQzkuJX9+01GJLSIjWVV77BiTpQMHOJpIJADMmsVu4QDQujUvfIrz
qBA8sVwuqygnOpqH3XJX8+czYQKATz5RwuQoI0YwYQI40EsJkwSQ6tWBUqW4Hj7cmvwj4qGdpoSo
XZtHDgCwZg3vpcotRUUBhQoB+/cDGTNaDS3FATxjUi5fZqa8YweQLJnpqETuycaN7MMKANWqcZqB
OIt2mpKqd28gVSqu1fDyjr76igkTAHTurITJUbp1Y8IEsB5QCZMEoOLFgfff5/qHH4BVq8zGI/5F
O00J9cUXnJsFANOnA++9ZzYeP3TxIi8cXrrEX3fvVl8mx9i9G3j6aSA2llX/y5apQ6AErPjTf4oU
4e6Tbv86h3aavKF9e+CBB6y1ZzSE/F/8zgwDBihhcgy3m130Y2P5yjJkiBImCWi5crEQHAA2bwam
TjUbj/gPJU0JlT49C1sB4O+/WSUo/7dvHzBqFNdly3JqhjjEwoXAkiVcf/wxB3qJBLh27YAcObju
0AEIDzcbj/gHHc/di5gYHkHs2cMk6uBBIGtW01H5hapVgZ9/5gbD5s1A4cKmIxJbREcDBQuykE3f
ExJkJk4E6tfnuls39Wl1Ch3PeUuyZFbjjitX+F0kWL6cCRMA1K2rhMlRRo2yKv+7dFHCJEHlww85
cxrgVIMTJ8zGI+Zpp+leud3Ayy+z0FWdGxEbCzz7LG+X33cfXz9z5jQdldji/Hng8cfZOlmV/xKk
VqwAypfn+sMPgUmTjIYjNtBOkze5XMDAgfw1NtaaseVQ337LhAlgDYASJgfp1s2aNTFokBImCUrl
ygFvvsn15MnApk1GwxHDtNOUWB99BEyYwPWyZUCFCmbjMeDqVW40nDkDPPQQi8HTpDEdldgifouB
ihVZCK4bcxKkDhwAChRgCV+ZMsDKlfrrHsy00+QLPXpYGcLnn7NI3GH69mXC5FkrYXIItxto0cJq
MTB4sF5BJKg9/jgH+gIcRfrjj2bjEXOUNCVWzpxseAkAu3axFbaD/P23NZavWDGgZk2z8YiNFiwA
li7lulEjzs0RCXKdOwOZM3Pdti1w44bZeMQMHc8lRWQk92wPH+agtf37HXN7qFYtNkYHNI7PUeIP
F8yQgecWDvk7LzJiBNCsGdcDBlgNMCW46HjOV1KlAoYO5TosDOjY0Ww8NtmwwUqY3n1XCZOjxG8x
0LWrEiZxlMaNgXz5uO7RAzh3zmw8Yj/tNCWV2w1Urgz88gvrOjZuBIoWNR2Vz8TFAaVKAb//DqRM
CezdC+TObToqscX582wtcPkyB3Pt3Kkbc+I4CxYAr7/OdaNGwJgxZuMR79NOky+5XMCwYUDy5Eyg
mjVjZhGkJk5kwgSwFlgJk4N07cqECVCLAXGsypWBl17ietw4tSBwGu00eUu7dmwZC7D72Ycfmo3H
By5eBJ54ghsODz0E/PknkDat6ajEFrt2scVAXBxfMRYv1o05cay9ezliMToaeO45YN06XiSV4KCd
Jjt06mRNd2zblmNWgkznzkyYAG40KGFyCE+Lgbg4vjIMGaKESRwtXz5+SwDceZ840Ww8Yh8lTd6S
Lp2103TmDKsEg8jWrdbZ/YsvAtWrm41HbDR/Phu4AqyELVDAbDwifqBzZ+DBB7lu35478RL8dDzn
TW438Pzz3KtNloyFsp6rFgEsLo7/WevX8z9rxw5Hj9tzluvXmST99Rfbahw4AGTJYjoqEb8waxZQ
owbXTZrwcqkEPh3P2cXlYiMPl4sdwps3ZyIV4CZPZsIEcEtaCZOD9OnDhAkAevZUwiQST/Xq3HkH
uBO/davZeMT3tNPkC40bA2PHcj1nDlC1qtl4kiAsjLfLz51jE/S9e3kSKQ6wfz8bWUZFAc8+y3Ya
oaGmoxLxK3/+yaLwmBigZEk2+1VReGDTTpPdevUCMmXiukULHnEEqM6drQZugwYpYXIMtxv49FMm
TC4XxwQpYRL5l/z5OX4U4I785Mlm4xHfUtLkC/ffz6MMgEcbAweajSeRtm0DRo/munx56+xeHGD2
bKv4u1EjoHhxs/GI+LEuXbgTD/DydFiY2XjEd3Q85ysxMUCRIqyaTp2a51oPP2w6qgRzu4EyZYC1
a1n8vW2bLk05xpUrvMBw6hTHpOzbZ+2cisgtTZ/OmZwA8NlnwPDhZuORxNPxnAnJkrEoHODxXIBN
dpwyhQkTwCbnSpgcpFs3JkwAp5IqYRK5q/feA8qW5XrUKGD7drPxiG9op8nXatWyptsuX85zLj93
+TI7f585A2TPzo2G9OlNRyW22LGDRd+xsewzsWqVGlmKJNCuXcAzz/Dbp3RpYPVqffsEIu00mdS/
P5AmDddNm7Kw1s917cqECWA5lhImh4iLAz75hD/xQ0NZ0Kaf+CIJVrAgd+YB7tRPmWI2HvE+JU2+
9tBDvIIGAHv28LjDj+3YAYwcyfULL1hn9OIAkyaxMSvA60CFCpmNRyQAdevGHXqAReGeGdcSHHQ8
Z4eoKBaF79oFpEzJzCRvXtNR/YvbzURpzRpuNGzbxndO4gAXLvBM9sIFzob480/1lxBJpGnTgNq1
uW7eHBg61Gw8cm90PGdaihTAuHE86rhxg1e4/TCRnDaNCRPA2x9KmBzkiy+YMAH8Ca+ESSTRatXi
G1CAO/c7d5qNR7xHO012atrUGk40YQJQr57ZeOIJC2OTttOngWzZWPydIYPpqMQWv//OVsZuN/DK
K8CiRaplEkminTuBwoWtOxUrV6pTeKDQTpO/6N3bGovdqhVw9qzZeOJp25YJE8CyKyVMDhEby+Jv
t5tHxyNHKmES8YJChfg+GeAO/vjxZuMR71DSZKf06a0q60uXOGLFD/z2m/UNXbGidRYvDvDVV9aU
0XbtgMceMxuPSBDp0QPIlYvrtm2B48fNxiNJp+M5E95+G/jpJ64XLQIqVTIWSkQEh00eOsTOCDt3
Ao8+aiwcsdPp0yz+vnKFX/Rdu9i9XkS8ZuFC4LXXuK5SBZg7V5u5/k7Hc/5mxAir0PaTT4DwcGOh
dOvGhAnguDwlTA7SqhUTJoA7oEqYRLyucmXg/fe5njcPmDXLbDySNNppMmX0aE6RBzhixUD/pk2b
gOeeY0/D4sXZokeD7B1i/ny+7QW48/nDD2bjEQli58/zos358xznuGcPkCWL6ajkdu6006SkyZS4
OF6pWL+eVyr++IPjK2wSHQ0ULcqWUcmTA1u2qMWAY4SFcZjgyZOs+N+927qgICI+MWMGULMm17Vr
q1u4P9PxnD8KCWHvpmTJmEA1bAjExNj26fv3Z8IEsEWPEiYHadmSCRMADBmihEnEBjVqAK+/zvXU
qSxnlcCjnSbTOnUCevXievBgW27U/fknh0pGRQFPPsldppQpff5pxR8sWsQiC0A9mURsdvw4f+Ze
vcpbdbt3q4+sP9LxnD+LjOT1tQMHeH1t924gd26ffbq4OKBMGdYvuVz8tUQJn3068SeXL3NL8fhx
/qTevdu6Dy0ithgzhvd/APZxGjHCbDzybzqe82epUgFjx3IdEQE0aeLTESujR1szWZs1U8LkKG3a
WI1iBg1SwiRiQMOG1oiVUaOAtWvNxiP3RjtN/qJ+fWDiRK5nzOABuJf9/Tc3Gq5d42bWzp1A2rRe
/zTij5YuBV5+meuKFYElS3QsJ2LI/v08YLhxA8iXj/1lU6UyHZV4aKcpEAwYwLuoALeAPMNTvcTt
Bho3ZsIEcHNLCZNDXL0KNGjAddq0bP+uhEnEmLx5ge7dud67lz3yJDAoafIX99/P6fIAZ9J55oF5
ybRpwC+/cF23rrXpIA7Qrh1w9CjX/fv7tGZORBKmVSsO9AWAfv2A7dvNxiMJo+M5f+J2A2+9xT77
ALuYO/oAABlqSURBVO+lelrJJsHZs2ysdvEikC0bG6tlzpzkP1YCwfLlQIUKXJcrB/z6q0ati/iJ
rVuBYsU4N7tIEWDDBnahEbN0PBcoXC72bnrgAT5/+qm1Q5AEzZoxYQI4LUMJk0Ncu2Ydy6VJA3zz
jRImET9SuDAH+QLA5s1smyb+TT9B/c0DDwBff8315ctAnTrsE5BIc+cCM2dy/eabQLVqXohRAkOH
DsBff3Hdt68GC4r4oS5dWOPkWe/fbzYeuTMdz/mrhg1ZsAvwenjLlvf8R5w8yRsaFy5wWsaePUDO
nF6OU/zTqlVA2bJclykDrFihXSYRP7V6tdWGoEgRtoVJkcJsTE6m47lANHgwkCcP1x06sD/APYiL
4yaV5xLeV18pYXKMiAi2sACA1KmBCROUMIn4sTJlOLcd4DFd585m45Hb009Sf5U2LSc6hoRw3knt
2mzqkUBDhgDLlnH9wQfWoEhxgI4dgUOHuO7VC3jsMbPxiMhd9epl3aYbMIB3NsT/6HjO33XubDXx
aNuWd1PvYutW4LnngOholrFs3QqkT+/jOMU/rFgBvPgib2KWKsVjutBQ01GJSALs3Qs8+yxw/TpP
BnbsYDcasZdmzwWy6GigZEnu2bpcwG+/WbUqtxAezjPxffv4Wrl2LRMocYBz54CnnwZOnWJ74W3b
gCeeMB2ViNyD8eNZ0grw8s6PP6oXrd1U0xTIkidnv6ZUqbh78OGHvFV3Gy1bMmECgG7dlDA5hqeI
7dQpPg8froRJJAA1aMB2fQAwZw670Ij/0E5ToBg5EvjsM67r1AG+/fZfv+Wnn4C33+a6TBluSulk
xiEGDuRAXoBzC6dP19tTkQB14QI3jU+c4F2OzZvZoFjsoeO5YBAXB7z6KgetAsD339/UdOnECbYX
uHgRyJiRLfkffthQrGKv338Hnn8eiIlREZtIkFi+nLO13W7gmWfYLTxlStNROYOO54JBSAgwcSKQ
KROfGzb8/1FMXBxP7Txdv8eOVcLkGGFhwHvvMWFKnpydTJUwiQS8F1+0uoVv2wZ88YXZeISUNAWS
nDmZEQHMkOrXB9xuDBzIdyUAUK8e8O675kIUG7ndwMcfA0eO8LlfP6BoUaMhiYj3fPklL/YAbN3n
OWgQc3Q8F4g++IDF4QCOth6OPEM/Q0wM2/Fs3coWT+IAY8YAn3zC9euvAz//rDomkSCzfz/bEISH
A9mzsw1B1qymowpuqmkKNpcvs4Dp6FFEIxnKYiX+SFYK69ZxYrY4wI4dQPHibHj64IPcv8+SxXRU
IuIDEyYAH33Etd4f+Z5qmoJNhgzAzJmICUmO5IjB93gHg9ucUsLkFOHhvCF34wZr3aZPV8IkEsTq
1QPeeYfr+fM5FkvMUNIUoL4/XgKfxo0AAOTEKTRdWZ3jViT4NW3K1sEAm3GVKWM0HBHxLZeL/Zpy
5eJzq1bArl1mY3IqHc8FoD17gBIlgKtX3ZiSogFqR03gv/jsMzY1lOA1dSpr2gBer1myRM24RBxi
5UqgfHneAcmbl91GMmY0HVXw0fFcELl4EahaFbh6FQBcyDB1lHVjasQIDvmV4LR/P9C4MddZszKB
UsIk4hhlywJdunC9fz+7jcTGmo3JaZQ0BZCYGJayHDzI5+7dgSrVUwE//GDVtDRsyCt0ElwiI/nF
Dw/n8+TJQI4cZmMSEdt16cKZdACweDHQrp3ZeJxGSVMAadMGWLaM63feATp1+t+/ePhhYMYMFgVH
RnKWiqfTpQQ+t5t1TNu28bltW6BSJbMxiYgRISF8z1SwIJ8HDeKz2EM1TQFi4kT2sgQ4k2jtWuC+
+/7xmwYMsFrIvvIKsGCBjm+CQfyva4kSwKpV7P4tIo51+DBbzFy8yPEqK1dqQLu3qE9TgFu3jsV/
UVEsZfnjD+A//7nFb3S72Q78++/53LEj0LOnrbGKl/30E2cMut28OvP77zqWExEAHMr+0kusa8qR
A9i0iYMjJGmUNAWwY8f4buLMGSBZMo5LueMN86tXuRuxZw+ff/rJOgCXwLJ5M7/Y16+zzfvatWxq
KiLyP6NG8fQe4GvFypVA6tRmYwp0uj0XoCIigLfeYsIE8Jvjri150qUDfvyRvwKc5Ltvn0/jFB84
dgyoUoUJU0gIB/EqYRKRf2jShPd/AJ5CNGzIjWnxDSVNfsrtZtv8zZv5HP8b466eeMKqDLx6lYXh
7FEggeDqVSZMp07xeehQoHJlszGJiF9yudhtxvOGeupUFoeLbyhp8lP9+vFCHACUK8fXzXvy5pus
aQJ4VFenjhp6BILYWKBmTWD7dj43bcqmpSIit5EiBUtZH36Yz23bAosWmY0pWKmmyQ/Nm8cGlm43
kDs3t1wTNVosNhZ47TU28wCARo04tEiTHv3X558Dw4Zx/eqrnMyZLJnZmEQkIGzbBpQuzdKODBl4
b+SJJ0xHFXhUCB5ArBEpbCmwfj1QqFAS/sBLl9hGdudOPnfoAPTu7ZVYxctGjwY+/ZTrQoWANWuA
9OnNxiQiAWX2bF6iBjRqJbFUCB4gzpwB3njDKj+aMiWJCRMAZMrEnaZHH+Vznz468PZHv/wCNGvG
dbZsHGWuhElE7lH16kDnzlzv388E6sYNszEFE+00+Ynz59mLyTO5unt3a8aQVxw+zH3b06f5PGEC
UK+eFz+BJNquXUCpUsyWU6XineHixU1HJSIBKi6O7d3mzOFz1arcgVJP3ITR8Zyfu3SJA+s9UzLq
1wfGj+dNc6/auRN44QUgLIx/+Pffs6eBmHP6NNv4Hj3K59mzOSNHRCQJrl3jYIh16/hcvTrw3Xcq
kUwIHc/5scuX+RfbkzDVrg2MG+eDhAngWd/ChUCaNHwr8t57wK+/+uATSYJcusTWAp6EqU8fJUwi
4hVp0/LHfbFifJ49G6hbV5eok0o7TQZdvcq5q7a/E1i8mC/W0dH8zlq+3PrOEntcuAC8/DKwZQuf
69UDvvlGNxtFxKtsO8kIItpp8kMREcxbPAnTm28C06bZtHX6yivsgOZycQ/31VeBP/+04RMLAODc
OaBCBSthqlYNGDtWCZOIeF2mTMDSpUDBgnyeMIHt37SXkThKmgyIjGRh3sqVfK5cmY0sbS3Se/dd
YMwYri9c4NTHv/+2MQCHOnOGFf+e5pU1axr44ouIk2TJAixbBuTLx+evvgJatFDilBhKmmx24wY3
FpYt43PFisAPPwApUxoIpmFDq2fTiRNMnDyD7sT7Tp5ke/fdu/n8wQfsK6HKTBHxsWzZWML62GN8
HjYMaN9eidO9UtJko+hooEYNFucB7Dk5dy5vmRvTvj3QujXXBw6wyOr8eYMBBaljx/gF37uXzx99
BEycCISGmo1LRBwjZ06WsObOzef+/YGuXY2GFHCUNNkkJgZ4/30mSQDb8syfz4tsRrlc/M6pX5/P
27YxuEOHzMYVTI4cYcJ08CCfGzfmFUklTCJis1y5mDjlysXnHj2AXr3MxhRIlDTZIDaWVz1nz+Zz
sWLcbUqb1mhYFpeLhcjvv8/nAwc4y2XDBrNxBYPDh5kw/fUXn5s147gUXV0REUMeeYSJU44cfO7U
CRg40GxMgUI/uX3s6lXWME2bxufChXnjP0MGs3H9S7JkwOTJwBdf8NnTovzHH83GFcgOHGAzUU8f
platgKFDdUtORIx77DEmTg88wOc2bYB27dTH6W7Up8mHDh/mLDlP3W/BgsBvv/Emg18bPx745BN+
97hcwODBwOefm44qsOzdy+Yop07xuUMH7oErYRIRP7JzJ39UeUpZK1dmv0C/e2NvI/VpMsDTL9KT
ML36KofW+33CBAAff8yCq7RpebWiRQugeXO9BUmoNWt4JOdJmLp2VcIkIn6pUCFWYjz5JJ8XLmR1
xv79ZuPyV0qavMztBkaOZLPnixf5sTZtgHnzAixzr1QJWL2a1y0AYPhwnjNGRJiNy5+53cCgQWwr
cPYsP9ajB9CtmxImEfFbefIA69ez4TLAjfLnngOWLDEblz/S8ZwXRUUBn34KfP01n1Om5Lp2bbNx
JcmxY9yv3bWLz8WLMwP0HIQLhYVxFIpnrHiKFEw0GzUyG5eISALFxQFduli36UJCWCD++efOet93
p+M5JU1ecvYsN2LWrOFzzpzATz8xxwh4ly9zkKynI+cjjwCLFgFPPGE2Ln+xdSv//zl8mM+5c/Oq
ZNGiRsMSEUmMmTP5HvD6dT7XrcsBEkaaMBugmiYf27aNr4+ehKl4ceCPP4IkYQJ4rrhgAVCnDp//
+gsoWRL45RezcZnmdrPfUsmSVsJUpQpnyilhEpEAVaMGX888vZy+/ZZVB54yTSdT0pREs2ezF+Sx
Y3z+8EPOlPOUAgWNFCnYwbpbNz5fusTq9rp1reItJwkPZxLZqBFn44SGAv368XguUybT0YmIJMmz
z/LNf+nSfN6wgZebNm0yG5dpSpoS6do1tt15911uYYaEsAb4228Nj0XxJZeLN8GmTAHSpePHJk3i
tQsn9XPyVElOmcLnHDl4XbJtWzWtFJGg4ZlX99FHfD5xAihThpednHqZWjVN98jt5nlvq1acvwrw
9GrmTOCVV8zGZqtjx7jLsmiR9bFq1fjdlD27ubh8bfp0tmQID+dz+fL8WLZsZuMSEfERz63wFi2s
ZOmZZ/gxz05UMFFNk5fs3MnXyJo1rYSpRAlg40aHJUwAD7sXLOBuS+bM/NgPP3DXafLk4BudvX8/
UL06UKuWlTB17AgsXaqESUSCmssFfPYZf9w98gg/tm0b8PzzLElxUq2TkqYECAvjlcvChVmvBPDG
/cSJwNq1QN68ZuMzxuViP4U9e5hQAKx1qlOHbQo840MC2alTHLD75JPA99/zY5kzM2Hs2VNDd0XE
McqXZ8Pm7t2tMpQpU3iRevBgIDrabHx20PHcHcTFcdOkXTurV2FoKNC0KeuhM2Y0Gp7/+eknoEkT
4PRpPqdNy+Loxo0Dr9bn8mWgf3/OivM09HS5ONS4d2/rWomIiAMdOQK0bMkf+x758wMjRgAVKhgL
yyvUpykRtmxhcrR+vfWxsmX5F6JQIXNx+b1Ll1jwNXGi9bFnnwWaNeM9Vn+vko+MBEaPZne3+LcC
X30V6NMHePppc7GJiPiZxYv54z3+2JXq1XkxKlDfWyppSiC3m/VJ48bxNd8Tds6c/AtQo4azuqIm
yZIlQMOGwN9/Wx+7/36gQQPuPOXObSy0W4qNBaZOZTvc+MeKxYtzt6xcOWOhiYj4s6goYMgQTo3y
lHymScORpXXrBl4Ji5Kmuzh4EJg2ja+ZBw9aH0+enLcFOnWybtjLPbh2jdnmmDHWkR3AzLNKFc6c
qVjR7NHdpUusT+rXzxoVA/CQvndv4K23lCmLiCTA8eOctTpjxs0fL16c5a81agTGBC6fJE0ul6s6
gG4A8gEo5na7t9zm9/ll0nT+PDBrFovYNmy4+d+FhACvvcaSlnz5zMQXVKKiePA9cqTVNt3j8ceZ
PNWpY1+R2P79nJ83bx7jid9wJGdOFqzVqwckS2ZPPCIiQWTFCtYCb9x488dDQzkLvnZt4I03uBvl
j3yVNOUDEAdgLIBWgZA0Xb/O18mpU9leKCbm5n9fuDDwwQfAe++xX6H4wPbtwKhR3NrzFFgD/O6p
Xp1vSZ56ioVjGTJ453PGxADr1vGL/9/27jdGrqoO4/j3KZRAW9h2BYvYQiui2EJr0TQEBbdIDZCW
SogKAf+RAC+I+AIQ+ZNIokajRhMh8MZI1QZIVCCFloSCXSVKasBut1oKLAFbQEpVKNsApTg/X5wz
7ex0ZvZuO7Mz230+yc3M3HvO3TM9vef+5p5z7l25cmjne9m0aenmlNdc07lHspnZGLJ5czrfrlgx
dKQGpHlCF12UAqhFizprInJLu+ckraVDgqYI2L49VU6tZWBgb39r2fHHpwlRl14Kc+eOSjENUrfY
8uVp0HVln2ilWbNSADV/fnqdNw9OPHHfo+u99+DNN9OMtzfeSK87dqTLiWvXwurV6e9Vmz07dRMu
XQpnnZUeFWNmZk1VKqXfrStWpB6e6ua4uzs17SecUHsZ7ZnqB23QNDiYJmqVg6ItW/Y+lbmRrq50
UeOyy9It4cfabPiDSqmUBo3feWcKcAYHG6efNCmNKty9e2+AtHNnsb8lpYfrlgOlOXM8XsnMbBTt
2pV+x65YAQ89lEZvDOeoo/YGUKeemoabttJ+B02S1gC1nolxU0Q8mNO0LWjavTvNYC+V6qeZMmVo
xHr22bBkSefPfB+XSqUU/fb3p268/v60DAzs/x3Gp0xJt2tfujTdcPOYY5pbZjMz2y+vv57uGbxu
3dCLH7t21c+zYEG6JVArNQqaGo50jYjFzSjArbfeuud9T08PPU2avj1xYuq5mTCh/mW9adN8MWHM
mDAhdZnNng3Llu1dv3Nnug1tOZgaGIDJk9Mlw66udO221mtXV7pRiLvdzMw6zrRp6VGeV1yxd12p
lG4mXW+YzSmnNL8cvb299Pb2FkrbrO656yLiqTrbO2YguJmZmVkjLXlgr6QLJW0FTgdWSXp4uDxm
ZmZmY5VvbmlmZmaWteRKk5mZmdl44qDJzMzMrAAHTWZmZmYFOGgyMzMzK8BBk5mZmVkBDprMzMzM
CnDQZGZmZlbAQRE0Fb39uR18XPfjl+t+/HLdj1/trnsHTTamue7HL9f9+OW6H7/aXfcHRdBkZmZm
1moOmszMzMwKGJVnz7X0D5iZmZk1Ub1nz7U8aDIzMzM7GLh7zszMzKwAB01mZmZmBXR00CTpu5I2
SOqT9JikmXXS/VLSNkkb62y/VlJJUnf+vFjSk5L68+uiVn4PGzlJX5D0D0n/k3Rag3Qv5npcL+mv
FevvzevWS3pB0vq8/n2S1koalHTbaHwXG56kcyVtlvScpBvqpPl53r5B0oLh8krqlrRG0rOSHpE0
dTS+ixVXoO3ukbSj4li+Ja//aMW69TnNNXlbobbD2kvS4ZLW5fP7Jkk/qJHmZElPSHpH0rU1th+S
6//BinU/lvR0bifuk9TVzHJ3dNAE/Cgi5kfEx4EHgO/USXcXcG6tDTnQWgz8s2L1dmBJRMwDvgr8
pnlFtibZCFwI/GmYdAH0RMSCiFi4Z2XExXndAuD3eQF4G7gFuK4FZbb9IOkQ4HbSMTwHuETSx6rS
nA98OCJOAq4E7iyQ99vAmoj4CPBY/mydpW7bXeGP5WM5Ir4HEBHPVBzfnwDeAu7P6Yu2HdZGEfEO
sCif3+cBiyR9uirZf4BvAD+ps5tvAptI54GyR4C5ETEfeBa4sZnl7uigKSIGKz5OAf5dJ93jwOt1
dvNT4FtV6fsi4tX8cRNwhKSJB1hca6KI2BwRzxZMXnOWA4AkAV8E7sn7fSsi/gzsOvBSWpMsBAYi
4sWI2A3cCyyrSnMB8CuAiFgHTJV07DB59+TJr59v7dewkRqm7S6re3xn5wDPR8TWvM+RtB3WRhHx
Vn57GHAI8N+q7dsj4klgd3VeSTOA84FfUPF/JCLWREQpf1wHzGhmmTs6aAKQ9H1JW0hXhH44wrzL
gJcior9BsouAp3KDa2NPAI/mbtYramw/E9gWEc/XyGed4YPA1orPL+V1RdIc1yDv9IjYlt9vA6Y3
q8A2agI4I3e1rJY0p0aai4G7R7lc1gSSJkjqIx2fayNi0wiy/wy4Hig1SHM5sPoAiriPtgdNeczB
xhrLUoCIuDkijgeWk/6Riu53EnATQ7v0VJVmLikQu+pAv4eN3HB1X9Cn8iX684CrJZ1Ztf0S3KB2
uqIB7HBXHMpp9tlfpHurOFAee/4GzMxdLbeRhmnsIekwYCnw2zaUzQ5QRJRy99wM4CxJPUXySVoC
vBYR66nTLki6GXg3Ipra/h/azJ3tj4hYXDDp3YwsYjwRmAVsSD00zACekrQwIl7Ll/buA74cES+M
YL/WJCOo+0b7+Fd+3S7pflJ3zeMAkg4ljW3wYNDO9jJQOcljJumKUaM0M3KaiTXWv5zfb5N0bES8
KukDwGtNLbW1XOUQjYh4WNIdkrojotyNcx6pp2B7e0pozRAROyStAj4J9BbIcgZwQR7reDhwlKRf
R8RXACR9jdR199lml7XtV5oakXRSxcdlwPqieSNiY0RMj4jZETGb1MCelgOmqcAq4IaIeKK5pbYW
qPdLYpKkI/P7ycDnSINAy84Bno6IV4ru09riSeAkSbPylYMvASur0qwEyg3i6cAbueutUd6VpG59
8usD2JgiaXoel4ikhaQbMleOe7mEPF6x3i5aWT7bf5KOLs9olXQEacJWvXP8kHqMiJsiYmY+t18M
/KEiYDqX1G23LA82b66I6NgF+B3pJNhHmv30/rz+OGBVRbp7gFdIg3u3Al+vsa8XgO78/hZgJ6mC
ysvR7f6+XobU14W5Lt8GXgUerq574EP5/0Yf8Hfgxqp93AVcWWPfL5JmZQwCW4CT2/19x/tCumLw
DDBQrkdSt/lVFWluz9s3kH4A1c2b13cDj5Jm0DwCTG339/SyT72X2+538/F+eWW9A1fnY7sP+Atw
ekXeyaTJQUdW7bNm2+GlsxbgVFL3ax/QD1yf11fW/7G5LneQJgxsAaZU7eczwMqKz8+RZsuXz+13
NLPcfoyKmZmZWQEd3T1nZmZm1ikcNJmZmZkV4KDJzMzMrAAHTWZmZmYFOGgyMzMzK8BBk5mZmVkB
DprMzMzMCnDQZGZmZlbA/wEMqEO0RIci1gAAAABJRU5ErkJggg==
)

### 设定 x 轴 y 轴标题

我们想让刻度的位置显示的是含有 $\pi$ 的标识而不是浮点数，可以在 `xticks` 中传入第二组参数，这组参数代表对应刻度的显示标识。这里，我们使用 `latex` 的语法来显示特殊符号（使用 `$$` 包围的部分）：

In [8]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
p = plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

# 设置刻度及其标识
p = plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi], 
               ['$-\pi$', '$-\pi/2$', '$0$', '$\pi/2$', '$\pi$'], fontsize ='xx-large')
p = plt.yticks([-1, 0, 1], 
               ['$-1$', '$0$', '$+1$'], fontsize ='xx-large')

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAlsAAAF3CAYAAACSQ46hAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

### 移动坐标轴的位置

现在坐标轴的位置是在边界上，而且有上下左右四条，我们现在想将下面和左边的两条移动到中间，并将右边和上面的两条去掉：

In [9]:

```py
# 设置图像大小
f = plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

# 得到轴的句柄
ax = plt.gca()
# ax.spines参数表示四个坐标轴线
# 将右边和上边的颜色设为透明
ax.spines['right'].set_color('none')
ax.spines['top'].set_color('none')

###################################################################################

# 将 x 轴的刻度设置在下面的坐标轴上
ax.xaxis.set_ticks_position('bottom')
# 设置位置
ax.spines['bottom'].set_position(('data',0))

# 将 y 轴的刻度设置在左边的坐标轴上
ax.yaxis.set_ticks_position('left')
# 设置位置
ax.spines['left'].set_position(('data',0))

###################################################################################

# 设置刻度及其标识
p = plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi], 
           ['$-\pi$', '$-\pi/2$', '$0$', '$\pi/2$', '$\pi$'], fontsize ='xx-large')
p = plt.yticks([-1, 0, 1], 
           ['$-1$', '$0$', '$+1$'], fontsize ='xx-large')

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAjwAAAFdCAYAAAAHT7f4AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

### 加入图例

使用 legend() 加入图例：

In [10]:

```py
# 设置图像大小
plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

# 得到画图的句柄
ax = plt.gca()

# ax.spines参数表示四个坐标轴线
# 将右边和上边的颜色设为透明
ax.spines['right'].set_color('none')
ax.spines['top'].set_color('none')

# 将 x 轴的刻度设置在下面的坐标轴上
ax.xaxis.set_ticks_position('bottom')
# 设置位置
ax.spines['bottom'].set_position(('data',0))

# 将 y 轴的刻度设置在左边的坐标轴上
ax.yaxis.set_ticks_position('left')
# 设置位置
ax.spines['left'].set_position(('data',0))

# 设置刻度及其标识
plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi], 
           ['$-\pi$', '$-\pi/2$', '$0$', '$\pi/2$', '$\pi$'], fontsize ='xx-large')
plt.yticks([-1, 0, 1], 
           ['$-1$', '$0$', '$+1$'], fontsize ='xx-large')

##################################################################################################

# 加入图例，frameon表示去掉图例周围的边框
l = plt.legend(['cosine', 'sine'], loc='upper left', frameon=False)

##################################################################################################

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAjwAAAFdCAYAAAAHT7f4AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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==
)

### 注释特殊点

我们可以使用 `anotate` 函数来注释特殊的点，假设我们要显示的点是 $2\pi/3$：

In [11]:

```py
# 设置图像大小
plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

# 得到画图的句柄
ax = plt.gca()

# ax.spines参数表示四个坐标轴线
# 将右边和上边的颜色设为透明
ax.spines['right'].set_color('none')
ax.spines['top'].set_color('none')

# 将 x 轴的刻度设置在下面的坐标轴上
ax.xaxis.set_ticks_position('bottom')
# 设置位置
ax.spines['bottom'].set_position(('data',0))

# 将 y 轴的刻度设置在左边的坐标轴上
ax.yaxis.set_ticks_position('left')
# 设置位置
ax.spines['left'].set_position(('data',0))

# 设置刻度及其标识
plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi], 
           ['$-\pi$', '$-\pi/2$', '$0$', '$\pi/2$', '$\pi$'], fontsize ='xx-large')
plt.yticks([-1, 0, 1], 
           ['$-1$', '$0$', '$+1$'], fontsize ='xx-large')

# 加入图例，frameon表示图例周围是否需要边框
l = plt.legend(['cosine', 'sine'], loc='upper left', frameon=False)

####################################################################################

# 数据点
t = 2 * np.pi / 3

# 蓝色虚线
plt.plot([t,t],[0,np.cos(t)], color ='blue', linewidth=2.5, linestyle="--")

# 该点处的 cos 值
plt.scatter([t,],[np.cos(t),], 50, color ='blue')

# 在对应的点显示文本
plt.annotate(r'$\sin(\frac{2\pi}{3})=\frac{\sqrt{3}}{2}$', # 文本
             xy=(t, np.sin(t)), # 数据点坐标位置
             xycoords='data',   # 坐标相对于数据
             xytext=(+10, +30), # 文本位置坐标
             textcoords='offset points', # 坐标相对于数据点的坐标
             fontsize=16,       # 文本大小
             arrowprops=dict(arrowstyle="->", connectionstyle="arc3,rad=.2")) # 箭头

# 红色虚线
p = plt.plot([t,t],[0,np.sin(t)], color ='red', linewidth=2.5, linestyle="--")

# 该点处的 sin 值
p = plt.scatter([t,],[np.sin(t),], 50, color ='red')

# 显示文本
p = plt.annotate(r'$\cos(\frac{2\pi}{3})=-\frac{1}{2}$',
             xy=(t, np.cos(t)), xycoords='data',
             xytext=(-90, -50), textcoords='offset points', fontsize=16,
             arrowprops=dict(arrowstyle="->", connectionstyle="arc3,rad=.2"))

#####################################################################################

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAjwAAAFrCAYAAADVbFNIAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

### 最后调整

调整刻度值的大小，并让其显示在曲线上方。

In [12]:

```py
# 设置图像大小
plt.figure(figsize=(10,6), dpi=80)

# 画图，指定颜色，线宽，类型
plt.plot(x, c, 'b-', 
         x, s, 'r-', linewidth=2.5)

# 设置显示范围
plt.xlim(x.min() * 1.1, x.max() * 1.1)
plt.ylim(c.min() * 1.1, c.max() * 1.1)

# 得到画图的句柄
ax = plt.gca()

# ax.spines参数表示四个坐标轴线
# 将右边和上边的颜色设为透明
ax.spines['right'].set_color('none')
ax.spines['top'].set_color('none')

# 将 x 轴的刻度设置在下面的坐标轴上
ax.xaxis.set_ticks_position('bottom')
# 设置位置
ax.spines['bottom'].set_position(('data',0))

# 将 y 轴的刻度设置在左边的坐标轴上
ax.yaxis.set_ticks_position('left')
# 设置位置
ax.spines['left'].set_position(('data',0))

# 设置刻度及其标识
plt.xticks([-np.pi, -np.pi/2, 0, np.pi/2, np.pi], 
           ['$-\pi$', '$-\pi/2$', '$0$', '$\pi/2$', '$\pi$'], fontsize ='xx-large')
plt.yticks([-1, 0, 1], 
           ['$-1$', '$0$', '$+1$'], fontsize ='xx-large')

# 加入图例，frameon表示图例周围是否需要边框
l = plt.legend(['cosine', 'sine'], loc='upper left', frameon=False)

# 数据点
t = 2 * np.pi / 3

# 蓝色虚线
plt.plot([t,t],[0,np.cos(t)], color ='blue', linewidth=2.5, linestyle="--")

# 该点处的 cos 值
plt.scatter([t,],[np.cos(t),], 50, color ='blue')

# 在对应的点显示文本
plt.annotate(r'$\sin(\frac{2\pi}{3})=\frac{\sqrt{3}}{2}$', # 文本
             xy=(t, np.sin(t)), # 数据点坐标位置
             xycoords='data',   # 坐标相对于数据
             xytext=(+10, +30), # 文本位置坐标
             textcoords='offset points', # 坐标相对于数据点的坐标
             fontsize=16,       # 文本大小
             arrowprops=dict(arrowstyle="->", connectionstyle="arc3,rad=.2")) # 箭头

# 红色虚线
p = plt.plot([t,t],[0,np.sin(t)], color ='red', linewidth=2.5, linestyle="--")

# 该点处的 sin 值
p = plt.scatter([t,],[np.sin(t),], 50, color ='red')

# 显示文本
p = plt.annotate(r'$\cos(\frac{2\pi}{3})=-\frac{1}{2}$',
             xy=(t, np.cos(t)), xycoords='data',
             xytext=(-90, -50), textcoords='offset points', fontsize=16,
             arrowprops=dict(arrowstyle="->", connectionstyle="arc3,rad=.2"))

#####################################################################################

for label in ax.get_xticklabels() + ax.get_yticklabels():
    label.set_fontsize(16)
    label.set_bbox(dict(facecolor='white', edgecolor='None', alpha=0.65 ))

####################################################################################

# 在脚本中需要加上这句才会显示图像
# plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAjwAAAFrCAYAAADVbFNIAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

> The devil is in the details.