# 各种绘图实例

## 简单绘图

`plot` 函数：

In [1]:

```py
%matplotlib inline

import numpy as np
import matplotlib.pyplot as plt

t = np.arange(0.0, 2.0, 0.01)
s = np.sin(2*np.pi*t)
plt.plot(t, s)

plt.xlabel('time (s)')
plt.ylabel('voltage (mV)')
plt.title('About as simple as it gets, folks')
plt.grid(True)
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAY0AAAEZCAYAAABrUHmEAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 子图

`subplot` 函数：

In [2]:

```py
import numpy as np
import matplotlib.mlab as mlab

x1 = np.linspace(0.0, 5.0)
x2 = np.linspace(0.0, 2.0)

y1 = np.cos(2 * np.pi * x1) * np.exp(-x1)
y2 = np.cos(2 * np.pi * x2)

plt.subplot(2, 1, 1)
plt.plot(x1, y1, 'yo-')
plt.title('A tale of 2 subplots')
plt.ylabel('Damped oscillation')

plt.subplot(2, 1, 2)
plt.plot(x2, y2, 'r.-')
plt.xlabel('time (s)')
plt.ylabel('Undamped')

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAY0AAAEZCAYAAABrUHmEAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz
AAALEgAACxIB0t1+/AAAIABJREFUeJztnXeYVOXVwH+HZQGBBUQUpAQEQcUERRQBC2uLoImgiEoT
CIloBPxMYonGgJpiSSKCiWKBUG0EBARswAqiIEWKAgoKFjrS+5bz/fHehWF3Znd2dmbuzOz5Pc88
O/fed+49c/fOPfc9VVQVwzAMwwiHcn4LYBiGYSQPpjQMwzCMsDGlYRiGYYSNKQ3DMAwjbExpGIZh
GGFjSsMwDMMIG1MaRsoiIkNEZGwM9nuSiEwTkd0i8nq0918COfJEpHGEn80SkX7RlslIfUxpGL7j
3cB2ikiFMMaV5EYXqySkm4HTgJqqemvBjSLSW0QWi8geEfleRJ4UkbQYyRIpShjnR0QaecrJ7hUG
YErD8BkRaQS0BrYBNxQzvKRKQCIQKRwaAl+pal6I7ScB9wCnABcDVwF/iJEs8SJW59JIMkxpGH5z
O/ABMBboHWqQiPwVuAx4TkT2icgwb/2zIvKd91S/WEQuLWIfbUTkYxHZJSLLRKR9EWPP8WY2u0Tk
cxH5pbf+UeAR4FZPjr4FP6uqL6jqfFXNUdVNwHjgkiKO9YyIbPW+wwoRae6tP2FmJSJ9RGRegY9f
LyJfi8h2EXlKRCRg7HwRGe6Z0VaLyJUhji8i8icR2eDJMVpEqnmb53p/d3vf92IROVNEPvT2u11E
Xgv13YzUw5SG4Te3A68DbwDXishpwQap6sPAPOBuVc1Q1UHepk+B84CTgQnAm8HMXCJSD3gbeExV
T8Y9+f9PRGoFGZsOTAPeAU4FBgLjRaSZqg4G/ga85skxKozv2B74PNgGEbkWpwybqmp1oCuwM/9r
U/zsqjPQCrgA6AT8KmBba2AdbsYzGJgkIjWC7KMvTmFnAo2BqsBz3rbLvL/Vve+7EHgceEdVawD1
gGHFyGikEKY0DN/wZgX1gKmquhZYBXQv7mOBC6o6XlV3qWqeqv4LqAicFeRzPYEZqvqO97kPgMXA
dUHGtgGqqOoT3mxhDk7hdAuQISxzjYj8CndD/0eIIUeBDOAcESmnql+q6pZw9u3xpKruVtXvgaEB
MgJsU9VnVTVXVd8AvgR+EWQfPYB/quoGVT0A/BG4zfNjBPueR4FGIlJPVY+q6sclkNdIckxpGH7S
G3hPVfd5y29ShInK44QnbxH5g4is8kwlu4DqQKHZA84P0dUzN+3yxl4C1Akyti7wfYF13+IUXNiI
SGfcrKSjqu4MNsZTSM8B/wa2isgIEckowWEC5fwOJ3s+GwuM/RY4Pcg+Tve2Be6nPFA7xDHvxymT
Tz3TXSETnZG6mNIwfEFETgJuAa4Ukc0ishn4PXCeiLQI8bGCCuMy4D6gq6rW8MxOewj+dPwdMFZV
Tw54ZajqU0HGbgIa5PsHPBoCP5Tg+3UAXgR+oapfFDVWVYer6oVAc6CZ950ADgBVAoYGU3A/KfA+
UFEUVHINcd+tIJuARgX2kwNsJYh5TFW3quodqloP6A/8J9LQXyP5MKVh+EVn3I3pHJxP4jzv/Tyc
nyMYW4EmAcsZ3j52iEgFEfkzUC3oJ2Ec8EsR+bmIpIlIJRHJ9HwdBVkAHATuF5F0EcnEmXXCcvh6
DufxwE2quriYsRd6zuV075iHgVxv8zLgJnF5IWcCwcKN/yAiNUSkATAI5x/K5zQRGeR9h67A2cCM
IPt4FbjXC6+tynGfTR6wHcgj4LyLSFcRqe8t7sYpllCRZEaKYUrD8IvbgZGq+oOqbvNeW3Gmmu4h
8gKeBW4Wl9MxFOeofgf4CtgAHMLNKPI55khW1R9wjuKHcOG93+FmNoWOo6rZwC+Bjrib5nNAL1X9
quB+Q/AnnEKb6UUc7ROR6SHGVsPNSHZ632EH8LS37Rmc/2ArMAqn+AoedwqwBPgM53d5JWDbQqCp
9x0eB7qo6q4gMozERa/NBb7BKa+BAKp6EPgrMN877xcDFwILRGSfd/xBqrqhiPNhpBBiTZgMI/UQ
kT5AP1W9rLixhlESbKZhGIZhhI0pDcNITcIqE2IYJcXMU4ZhGEbY2EzDMAzDCJvyfgsQDUTEpkuG
YRgRoKolKkaZMjMNVbWXKoMHD/ZdhkR52bmwc2HnouhXJKSM0jAMwzBiT1jmKXENZGoHjlfV70J/
wjAMw0hFilUaIjIQV1Z5G8fLGwD8LFZCGZGTmZnptwgJg52L49i5OI6di9JRbMitiHwNtFbVH+Mj
UskREY3UPmcYhlFWERE0Bo7w74C9kYlUNCIy0usUtrKIMcNEZK2ILBeRlrGQwzAMwwiPcHwa64E5
XsG1o946VdfwprSMAoYDY4JtFJHrgDNVtalXKO15XIMcwzAMwwfCnWl8AFTAtYHM8F6lRlXnAcGq
buZzAzDaG7sQqCEiQRvDDBp0LbNnhyokahiGYUSDYmcaqjoEIL+bmB7vshYP6nFiZ7IfgPq4UtEn
cNNN7zF+/NcAXHnl9XERzjAMo6xR7ExDRH4mIp8BXwBfiMgSEflp7EU7LkKB5ZAe7x49vmbKlOEx
FscwDKPsEo5P40Xgd+p6GeN1MXsRaBdDufLZCDQIWK5P4b7HAPz3v+7v6tVryMrKsrA6wzCMAmRl
ZZGVlVWqfYQTcrtcVc8rbl3EAog0AqapaqG8D88RPkBVrxORNsBQVS3kCBcRnTPHvZ88+Vqeffad
aIhmGIaR0kQSchtW9JSIPIJrBylAD1xLyFIjIq8C7YFaIvI9LokwHUBVR6jqDBG5TkTWAQeAvkXt
b9y4JnTvPjAaohmGYRhBCGemURN4FLjEWzUPGKLBew37goho796V6dXrNa666pd+i2MYhpEUxGSm
oao78ZrMJzIDBpzFGWek+S2GYRhGShNSaYjIs6p6j4hMC7JZVfWGGMpVYurXv5cffniGU065zm9R
DMMwUpaQ5ikRaaWqS7xoqYKoqn4YU8lKgIhobu5hFixoRIsW71O1ajwjgg3DMJKTqNaeUtUl3tvz
VTUr8AUkXA2ocuUqUrfub9m48Vm/RTEMw0hZwikj0jvIuj5RliMq1K17J9u3T+To0e1+i2IYhpGS
FGWe6gZ0By7DRUzlkwHkqupVsRcvPAJLo69Z82sqVWpEo0Z/8lkqwzCMxCYS81RRSqMhcAbwBPAA
x8t57AOWq2pOKWSNKoFKY//+laxYcS1t2mygXLkKPktmGIaRuERVaSQTBZswLV9+DbVr306dOr18
lMowDCOxiYnSEJG2wDDgHKAikAbsV9VqkQoabQoqjR9/nM7EiYP44oszETmCakU6dx5k1W8NwzAC
iFUZkeeA24A3gAuB24GzSi5e/Fi2LI+PPvqefv2OVzuxsumGYRilJ5zoKVR1LZCmqrmqOgroEFux
SseUKc/Rr1/2CeusbLphGEbpCWemcUBEKgLLReQpYAuFe1wkFCJHQmw5HFc5DMMwUo1wZhq3e+MG
AAdxPS26xFKo0qJaMcSWSnGVwzAMI9UoVmmo6gZVPaSqe1R1iKr+TlXXxUO4SOnceRDjxzc5Yd24
cU3o1Cnh6y4ahmEkNEXlaaws4nOqqi1iI1LJKRg9BTB79nT+97/HOXRoJRkZl9Gp00BzghuGYQQQ
7eS+RkV9UFU3lORAsSSY0gDIy8tm/vxTaNNmA+npNX2QzDAMI3GJashtIimFSClXLp1q1dqyZ888
atXq5Lc4hmEYSU9In4aI7BeRfSFee+MpZGmoUaM9u3cnTBV3wzCMpKaomUbVeAoSK2rUaM/ateYA
NwzDiAZFde6rpqp7vR7hhfDawCY8GRkXcejQWrKzd5OeXsNvcQzDMJKaokJuX/X+LgWWBHmVGhHp
ICJrRGStiDwQZHumiOwRkc+8V4nrnZcrV4GMjNbs2fNRNEQ2DMMo0xRlnrre+9soFgcWkTRcXaur
gY3AIhGZqqqrCwz9sLT9yGvUaM+ePR9Sq9YvSrMbwzCMMk+xyX0icqOI1AhYriEinaNw7NbAOi95
MBt4DQgW4lTqkiXmDDcMw4gO4ZQRGaKqu/MXvPdDonDsesD3Acs/eOsCUaCdiCwXkRki0jySA2Vk
XMyBA6vIydkXoaiGYRgGhFewMNiTfloUjh1O96elQANVPSgiHYG3gGbBBg4ZMuTY+8zMTDIzM48t
p6VVIiOjFXv2zOeUUxK6QK9hGEbMyMrKIisrq1T7CKcJ0yhgF/BvnAK5GzhZVfuU6sAibXCzmA7e
8h+BPFV9sojPrAdaFYzcCpURHsj69X9GNZvGjf9eGrENwzBShkgywsMxTw0EsoHXcX6HwzjFUVoW
A01FpJGIVABuBaYGDhCR2iIi3vvWOCUXUahvjRqZ7N6dVUqRDcMwyjbFmqdUdT/wAByLeKqqqgdK
e2BVzRGRAcC7OHPXK6q6WkT6e9tHADcDd4lIDq4s+22RHq9atTbs37+S3NwDpKVVKa34hmEYZZJw
zFOvAv2BXGARUB14VlWfir144RGOeQpg6dJLadRoMDVrXhMHqQzDMBKbWPUIb+5lhvcAZgIP4hzU
CaM0wiU/9DZVlcbs2dN5661hiBxBtSKdOw+ycvCGYUSVcJRGeRFJBzoD/1bVbBEJJ/Ip4ahRoz3f
fvu432KUilCKYfbs6bz66j306PH1sbHjx7v3pjgMw4gW4SiNEcAGYAUw1+uzsSd2IsWOatXasW/f
Z+TmHiIt7SS/xSkxwRTDuHFrOXp0M1OnvnzCeoAePb5m8uThpjQMw4ga4bR7Haaq9VS1o6rmAd8C
V8ZetOhTvnxVqlT5KXv3LvBblIh4661hhRRDz57ree21gRw58kWITx2OvWCGYZQZwikjUkNEnhGR
JSKyBPgHUDn2osWGZC4pInIk6Prq1S+mSpV2IT5VKXYCGYZR5ggnT2MksBfoCtwC7ANGxVKoWJJf
vDAZUa0QYkslOncexPjxTU5Y+/LL5fj5z800ZRhG9AjHp9FEVW8KWB4iIstjJVCsqV79Ur744hZy
cw+TlpZcT+Ht2tVl5MhK/OpXx01O48Y1oXv3gcf8FpMnD8eZpCrRpcv5nHzy39i//wqqVv2pP0Ib
hpFShJOnsQC4T1XnecuXAk+rats4yBcW4eZpgHMmjxnTnSpVziAtrXbShKXu3buIlSuvZ9++J5k5
83XyFUOnTgOLlH/r1lf5+uvfs3v3I7zzzlsWjmsYxjFiladxJzBGRKp7y7uA3iUVLhHIjz7q02cv
4CZLyRCWmpOzj9Wru9O06b857bSudOjQN+zP1q7djY8+Wsxbbw2kX7/cY+uT4XsbhpF4FDvTODbQ
UxqqmnDhtuHONAYNupabbnqv0PrJk6/l2WffiYVoUWHNmr5AOc4++5WIPp+s39swjNgSq5kGkJjK
oqSEij5KtLDUwAS+I0d2ct55O/jNb76KeH/J8r0Nw0h8wlYaqYBqxRBbEschHiyBb+zY+px11ocR
m5KS4XsbhpEchBNymzIEC0sdN64JnToN9EmiwgRL4OvV6wemTBke8T6Dfe+xYxsm1Pc2DCM5CDnT
EJEuuO56QpAue6o6KYZyxYTAsNTs7B84fHgLPXs+m1DO4FiYkgqG4x46tJF27WpwxRXXRbzPRKKo
elxWwNEwoktR5qlf4pTFaUA7YLa3/grgYyDplAa4G+iVV15PdvYuFiz4CZdcklgVb2NlSsr/3gB5
eUdZsuRCtm17jdq1u5Vqv34TqlDjihWL+OKLcVbA0TCiTEjzlKr2UdW+QAVcefQuqtoFONdbl9Sk
p5/MSSedyb59i/0W5QQ6dx7E2LENTlgXbRNauXIVOOusV1i37l6OHt0etf36weTJzwQt1Dht2pNB
15fGzGcYRniO8AbAloDlrcBPYiNOfMlvAVu9eqi6TfHnyiuvZ+PGnzFhQgVOOqk+UOmEjO9oUa3a
RdSu3ZN16/6P5s3HR3XfsaCgqaljx5tp2nQ1+/YFLwlTsWLwEGzVfUH3Z6YrwwiPcJTGB8C7IjIB
59+4FXg/plLFiRo1Mtm48d80bPiQ36IcIydnL2ec8Qm33LKSihXrxfRYZ5zxGIsWtWDHjrepVesX
MT1WaQhmgnrllQ/o2PEmqlZtC8wr9JmcnKpAYf/Qnj2fMnZsB7KyVtGr1/fH1qeS6coUohFLwikj
IsCNwGXeqrmqOjnWgpWEkpQRCSQ7eycLFjTkkkt2Uq5cegwkKzkbN/6b3buzOPfcN+NyvF275vDq
q11Zvfo8ypXLTcibTFHJiZ06DQzSY6QJP/1pz0I+jXHjmnDLLY8yceJgunf/Ouj+kiXZsWTNuJrQ
rduzFhxgFCImyX2qqiKyFNinqu+LSGURydD8eX4pEJEOwFAgDXhZVZ8MMmYY0BE4CPRR1c9Ke9x8
0tNrHvNrVK/ufyktVWXjxudo1uyFuB3zs88OsnDhUfr2nX1sXaI9defmbg6x5XDQQo355rzZsy8K
un769JeAwkojWZIdi+rSGCxkO78ZF1Bkd8dkVihFyR7pNiM4xSoNEbkD+A1QE2gC1AeeB64qzYFF
JA14Drga2AgsEpGpqro6YMx1wJmq2lRELvaO26Y0xy1I9ertPb+G/0pj9+7ZiJSnevXL43bMt94a
Rt++J+r/ROn4p6r88MOz7Nv3ZYgRLqIsMDIskFDrQ0WoHTy4nuzsncyb90lC3EhC3dBCKYYxY/rg
nq0Ks3fvHEaP/oi+fQ8U+tykSc8AoRUKkBDnA4KfEyha9ki2FadE46lsYqEQ87dFQjg+jbuB1sAC
AFX9SkROi+hoJ9IaWKeqGwBE5DWgE7A6YMwNwGjvuAu9hlC1VXVrFI4POL/Gpk3P07DhH6O1y4jZ
uPE56tUbgLMIxodEKjFy4kWezoUXwjnnbKN79+cZP/5vhUxN3btHFlHmkh2/LpB134jMzHMYMaIx
S5ak07v3jmPb/Jh5hWrtu2fPfA4fXhH0M5Uq1UakGvBJoW3O93MAKBwtuHfvbEaPnk/fvif+z3v0
+JoXXniEjIy9cQ1dLpnp7WsOHarGr39dWIlOnPhX8vJygyrYN9/8C1AuollZUduKUjaR3OCLmlVG
KmPgtuERBBOGozSOqOqR/BuZiJQnSLJfBNQDvg9Y/gG4OIwx9XERXFGhRo3LWbOmF3l52b76NQ4f
/o7du+dy9tlj43rcRCkxEuzHMXJkFerW/S8dOtxMhQq1g5qaIiGYSatHD7e/u+9uR+/eJ950/Zh5
hWrtO2bMi5QvX4sTAxod6en16dRpIOPHF/bxdO9+X8gny+rVryEvbxewqNC27ds/5847s09YF3g+
ov0UHOommZ29kylTngt6k3/iieAPWQcPrkAkeFbB4cOf47pXF2bfvg8ZM+YTrxr2icd6/fWHgfIl
VjZF5Q2F+gyENje++eaj5OXlBN02YcI9qObSo8eGQtvGjbsDVaVXr1Am3+IJR2l8KCIPA5VF5Brg
t8C0iI94nHAVT8ErIujnhgwZcux9ZmYmmZmZYe08Pb0mlSo18d2vsWnTC9Su3Yvy5avG9bjBnrpH
j65Fr17xLTES7Mfxq18dYPLkl7n66ptDmpoiJdT+ypcPlYJ0CIi+WSLY/tq2PZejR9cGHZ+R8VM6
dbovhGII3owrcH3B/7X73KCQCqVixXQgu9D6Q4c+Z+LEAcycOZlevTYdWx/pU/DYsWvYv/9Opk+f
EPRGOGpUP8qXD/6Ak5eXgWsueiIZGZfiAmQKB1FUrXpJyG1VqlyI6n5gWaFtOTkbycsrfD4gf8Y2
j759TzQR9ujxNY8//jceeaSw8h0zpg+qefTuvbPQtlGjOiOSE/RYhw9/ibPwF0Ykh3LlgivLbdvS
2LTpILm5QTeHRThK40GgH7AS6A/MAF6O/JDH2IjLAcmnAW4mUdSY+t66QgQqjZLi8jU+9E1p5OYe
ZvPml2nZ8qO4H7vgTSY3N4dWrVZw8cVNiv5glEkUM1momdeePUv43//u5Z13pkVkqgnXFj9y5Ies
WlWBnJzqIfZUqVjFUJSPp6jPBVMoNWtWAwrHnohUYebMt05QGOBudqNH90Ikjdtv31Fo25gxfVHN
oXfvXSds69XrO0aPfpry5YPfkmrUaOf9bwrf5GvWbML48XuDKtFQ36vobQ+GVKKVK7cqQhG1I5QJ
sGLF8gRTvpUq1fHM0TsLbatevTVQGZf1UPBYbUPKUanS2d629YW2nXFGcxo10mPRiKNHFxpSLOFE
T+WKyGhgIe4pf01E8a2FWQw0FZFGwCZc/kfBmhZTgQHAayLSBtgdTX9GPjVqtGfTphE0bPhgtHcd
Ftu3v0HVqhdQuXIzX45f8CazceMLrF7dnQsu+IRy5UKZr6LL0aOhgvHiayYLNvMaN64JN93Ul8mT
/1noZheOqSaUyWX//jT69y84uzrC5Mnt6d59UMjZBIRWDMVRUoXiZA0mx7+YMuVpgj3DVa78E1Rz
gB2FtlWqdJr3hLyr0LZq1VqEVAxQic6dBwb939xxx+NBZQ/8npFsK7myCW0CzMmpTP5sNZD09Hre
DX5loW0iGZ65cX0UFWLwbSUhnOip64EXgG+8VY1FpL+qzojoiB6qmiMiA4B3cSG3r6jqahHp720f
oaozROQ6EVmHU+Hht6wrAc6v0Tvufo38m8yBAx9ToUJTunad7nvEEkDduv3ZufMd1q//E02aPB3z
423b9ibnnvs1Y8fWo1ev4zeh0ji7I6Wop/FZs94HCmegHz26npkzRzBp0tMlsks/8USoKj5Hip0V
xIKiFFEwOULdIMuXr+PdCL8otC09vb63LZgzP7RiCMf0Fkr2or5XpLOyorYFk/+663oyfnzhvKHi
bvClkSO8be8GPS9FEU5y35fA9aq6zltuAsxQ1bNKfLQYEWlyXyCLFp1Hs2YjqF49qhG9ISkuCctv
jh7dweLF57N9+53MmjUvZqGFmzePYv36h2nRYiaffppfAj68/ufxJlSS4dixdcjJ2V0o+ghg1KgK
iGTTp0/h6/NvfzuZhx4q/MSdLEmGwSO8mtC9+7NAYdNbONvyZ2aJfB0URyj5i/pefn3nSJL7wlEa
i1T1ooBlAT4NXOc30VAaa9feQ4UKp8fNRJUMLVinTHmciRMfLdBbvHSKLdCEc+jQFs4/fyd9+syj
cuWEeQYJSVE3ySlTnubGGwvPQiZNaoNqFbp0mVVo2wsvtCwUzhp480wGIr0RJrtiSBVi1e51iYjM
AN7wlrsCi0XkJkjOvhrBcPka8fNrJIrjtyhmzfroBIUBpQs/DX7TbcjZZ6/jyisTX2kUZSoIZaoR
qe6ZXDZEZItPdCIx/RS3zUhswlEalYBtQHtvebu37pfecooojfj6NRIlP6Iooq3YgucefJsQ2efh
EupmF8qBXhpbvGEkIuFET/WJgxy+k55+CpUqNWL//qVUq1YwxzD6dOo0kFdemUO/fsfD8Pxw/BZF
tBVbUTWkkp1Iw2ANI9kIJ3qqMTAQaBQwXlX1hhjK5Qv5/TXioTRatarG2rW1mTz5XBLVNBHs6fnl
l8txww0/Ydast5kyZXhY2b433NCPBg1msX//VyGOlDizq9JgisEoC4TjCF+BS+b7HMjPu1dVDd79
xgei4QgH2L59Eps3v0SLFjOjIFXRrFrVk4yMC2nQ4P9ifqzSUNBh2bHjzXz77d/5+OOtJxS/y3eQ
Q+HImFdeKc8111xB3bq/5vXXH0pqx69hpBKxip76VFVbl0qyGBMtpXH06A4WLmzs9dcIx90TGdnZ
P7JgQRPatPmG9PSaMTtOrBg48Bq6dCmcpTpxYlvy8vK45ZaFhbblR4VZ1IxhJA6xip4aLiJDcFkg
xzyjqrq0ZOIlPh99tJAxY5TXX29NuXKnxqzc8ZYtY6lV65dJqTAAypULXnvn4MHlIQvE5fstzIRj
GMlNOErjXKAXcAXHzVN4yylDfjhonz77ya+1E4sS0KrK5s0v0qzZiKjtM96EcpBnZFwWsh5Oqvgt
DKOsE+qxMJCuwBmq2l5Vr8h/xVqweBOq1IMzpUSPPXs+ApTq1S+N6n7jiXOQn1jQcNy4JnTqNLDI
bYZhJD/hzDRWAicTxR4WiUi8ku02b36R00+/I66NlqJNaevhGIaRvISjNE4G1ojIIo77NFIu5DYe
yXbZ2TvZsWMaZ545NGr79AvL9jWMskk4SmNwzKVIAIJn9DaOarLd1q1jOeWU60lPPyVq+zQMw4gn
4WSEZ8VBDt8paHLZu3cFN9xwa9SemFWVTZtepFmz/0Rlf4ZhGH4QTkZ4W2AYcA5QEdf7Yr+qVoux
bHEn0Kyydet4tmyJoK1VCPbu/RjVXKpXvzxq+zQMw4g34URPPQd0B9biDPz9gJR/XK5Vqwv793/G
oUPfFD84DDZtepG6dZPbAW4YhhFW2rOqrhWRNFXNBUaJyDJc7/CUJS2tErVr92Lz5pdp3PhvEe9n
9uzpTJ78T/btm0tGxnfceONZ5iQ2DCNpCUdpHBCRisByEXkK2AKUicfl00+/g+XLr6BRo0cjKpde
uH9EFuPHfw9YOWzDMJKTcMxTt3vjBgAHgfpAl1gKlShUqXI2J53UjB9/nBrR5+OVMGgYhhEvwome
2iAip3rvh0TjoCJSE3gdaAhsAG5R1d1Bxm0A9gK5QLYfhRPr1u3Ppk0jOPXUkuvJZOjOZxiGURJC
zjTEMUREdgBfAV+JyA4RGSyl9+Y+CLyvqs2AWYT2jyiQqaot/aq0W6vWTRE7xLOzQykNq8NkGEZy
UpR56l7gEuAiVT1ZVU8GWnvr7i3lcW8A8uNZRwOdixjrq//kuEP8pRJ9Li/vKOedt5nRo087Yb3V
YTIMI5kJ2U/Di5C6RlW3F1h/Km6WcH7EBxXZ5SkhvFnLzvzlAuO+AfbgzFMjVDXonTta/TRCceDA
GpYty6Rt2+8oV65CWJ/ZsOFx9u5dwPbtdzF16nNY/wjDMBKNaPfTKF9QYQCo6nYRCScp8H2gTpBN
DxfYn4pIqDv+Jaq6OV9RicgaVZ0XbOCQIUOOvc/MzCQzM7M4EcOmSpWzqVz5LH78cVpYvo0DB1ax
ceMwWrWik1cnAAAgAElEQVRaSosWDbjqql9ETRbDMIxIycrKIisrq1T7KGqm8ZmqtizptrAOKrIG
56vYIiKnA3NU9exiPjMYl4n+zyDbYjrTAJg06T6mTRtJtWo/K9QTOxDVXJYuvYQ6dfpQr96dMZXJ
MAyjNEQy0yjKp9FCRPYFewE/K52oTAV6e+97A28VHCAilUUkw3tfBfg5rkx73Jk9ezozZkyid++d
3Hjjh9x003u8+uo9zJ49vdDYH34YRrlylahb9w4fJKXUTxGphJ2L49i5OI6di9IRUmmoapqqZoR4
lbaB9hPANSLyFXClt4yI1BWR/DtxHWCe51tZCLytqsFawsWct94aRs+eJ0ZPBeZbzJ49nUGDrmXg
wIt5+OH72bKlexFtT2OL/SCOY+fiOHYujmPnonSU9uYfEaq6E7g6yPpNwPXe+2+AiJ3t0SRUvsWB
A4uYNOk+ZsyYdIJSGT/+KSpWrGcOb8MwUg5/HoeTjFANmtLT6/L226OKnIUYhmGkEiEd4clEEdFX
hmEYRhGU1BGeEkrDMAzDiA9mnjIMwzDCxpSGYRiGETamNAzDMIywSWqlISIdRGSNiKwVkQf8lsdP
RGSkiGwVEV8SIBMFEWkgInNE5AsR+VxEBvktk1+ISCURWSgiy0RklYj83W+Z/EZE0kTkMxGZ5rcs
fiIiG0RkhXcuPi3RZ5PVES4iacCXuHyPjcAioJuqrvZVMJ8QkcuA/cAYVS1txn7SIiJ1gDqqukxE
qgJLgM5l+LqorKoHvXpxHwF/UNWP/JbLL0Tkd0ArIENVb/BbHr8QkfVAKy9nrkQk80yjNbBOVTeo
ajbwGtDJZ5l8wyvkuMtvOfxGVbeo6jLv/X5gNVDXX6n8Q1UPem8rAGlAiW8SqYKI1AeuA16mjLSs
LoaIzkEyK416wPcByz946wwDABFpBLTElaEpk4hIOa8Uz1ZcYdBVfsvkI88A9wF5fguSACjwgYgs
FpHflOSDyaw0ktOuZsQFzzQ1EbjHm3GUSVQ1z+t9Ux+4XEQyfRbJF0TkF8A2Vf0Mm2WAazvREugI
3O2Zt8MimZXGRqBBwHID3GzDKOOISDrwP2CcqhaqoFwWUdU9wHTgQr9l8Yl2wA2eLf9V4EoRGeOz
TL6hqpu9v9uByThzf1gks9JYDDQVkUYiUgG4FVdy3SjDeJ0gXwFWqepQv+XxExGpJSI1vPcnAdcA
n/krlT+o6kOq2kBVzwBuA2ar6u1+y+UHpW07kbRKQ1VzgAHAu8Aq4PWyGiEDICKvAh8DzUTkexHp
67dMPnEJ0BO4wgsn/ExEOvgtlE+cDswOaC8wTVVn+SxTolCWzdu1KUXbiaQNuTUMwzDiT9LONAzD
MIz4Y0rDMAzDCBtflUY4pS9EZJhXJmS5iLSMp3yGYRjGifg90xgFhHRSish1wJmq2hS4A3g+XoIZ
hmEYhfFVaYRR+uIGYLQ3diFQQ0Rqx0M2wzAMozB+zzSKI1ipkPo+yWIYhlHmKe+3AGFQMOW/UIyw
9Qg3DMOIjJL2CE/0mUbBUiH1vXWF0KZN0UGD0DZt0CpV0EsuQVu2dH87dkR37UJV7VXMa/Dgwb7L
kFSvvDx01iz0yivRhg3RM89EcU82evnlDO7VC/3gA/c655zj2y66CD161H/5k+xl12cJXjk5aLt2
6Mkno+XLo2edhd55JzphAvr992jHjhHdlBNdaUwFbgcQkTbAblXdGnTkp5/Cs8/CJ5/Ali0wZAhs
2gTz58PMmXDHHfGT2kh9VGH6dGjXDu66C3r1grVroWlTt/3CC2HKFGjcGK66yr0aNXLbmjWDChXg
rLNgxAg4csS3r2GkKN9+C1dcAV98Abt2QU4OtGgBzz8P3bpB/fowYUJEu/Y75Da/9MVZXumLX4lI
fxHpD6CqM4BvRGQdMAL4bcid1ahx/H3VqnD11XDBBW65fHn3g83OjtE3McoU110HGRlw223uYWTV
KujTB9LT3Q+xa1d4//0Tr0k4vm3hQvjoIxg71imWmjWdsunYEXbv9uUrGSnEa6/BRRfBL34Bbdu6
dRdeCC++eOK4gtdnuPg+hYrCy32NIOzapdq1q+rq1ao//7nqxRerrlsXfKyhqqpz5szxW4TEZvRo
1fR0VTfXcNdXEYR1Pi+44Pj+br45OnKmKHZ9FsGePaq9eqk2a6a6eLFbl38P3LUr6Ee8e2eJ7reJ
bp4qHTVqwBtvwNlnOxNVt27Qpg2MHu1+okYhMjMz/RYhcRk2DP70J3cNQfCntwKEdT5re1HkVatC
uXI2Iy4Cuz5D8PHHcP75ULkyLF0KrVq59fn3wEhnFUFIiYKFIqJhf48VK6B9e2dTbtnSTeWieEKN
FEQVHnsMxo93Zqfq1Z1Z6sUXo3Pt7N7t9jd0KPz6186c+sYbUKlS6fdtpD5t28KSJfCzn8GsWSW6
JkUELWH0VNlTGgCXXeZsyuBszG+8ERvBjOQnLw/uvRfmzoV33jk+K4gVR49C794umGPKFKhWLbbH
M5Kb//4X7rzzeDBFCe9nkSiN1DZPhSIjw/096SQXyWIYwcjJgb593XR/zpzYKwxwM+Bx45xJ9aqr
YMeO2B/TSE7eew8efBBae033wjCXRoOyqTTyo1iWLnU/0DFltuujEYp+/aBOHZgxA15/Pb4mzLQ0
+M9/4Jpr4Mwznfnhuusssso4zrJl0LMnTJwIU6eGjtiLAWXTPBXIqlUunnn8eBemaxiqblaxfbtb
9tOE2bgxrF/vvxxG4vDddy4/aOhQuPnmUu3KzFOR0Lw5vPkmdO8Oy5f7LY2RCDz/PBw+7N7Hacof
krPPdn9r1nSJgEbZZtcul8/z+9+XWmFEiikNgMsvh+HDXTLM998XP95IXZYscdUEsrLiOuUPyYQJ
cNNNzlT25pv+yWH4z5EjcOON8POfu+AMnzDzVCD/+IeLRvjoIwvDLYvs3u3i25980renuJB8+SVc
eqlzfra0XmRljrw86NHD5fC88YbL54kCZp4qLb//vbNnN25sJR3KGqouUur66xNPYYCrUzV8uJv9
7NnjtzRGvGnd2tU627cP9u71VRRTGoGIQK1azm74zjtW5LAsMXQobNwITz/ttyShue02Z5ro188q
GpQlli51/tZ9+9xM0+f7kimNglSp4v6mpcHDD/srixEfPvkEnnjCTfsrVvRbmqL5179cNNVzz/kt
iREPjhxxyZ7Nm7tlvwMzMJ9GYfJLOpx7rnOGzpoVNfuhkYDs2OH8GMOHww03+C1NeHzzjat/9fbb
xxO7jNTk4YddefNRo6B//+iVrvGwMiLRJDfXOR579IABA6K7byMx+M1v4H//cz/CpUuTK/hh8mS4
/XbXI6F6dRdllUzyG8Xz6afuQWb58phVIzClEW2+/BIuuQQWLHCZuUZq0bQprFvn3idj4lz9+s4P
A8kpvxGaw4ddlNyQIXDrrTE7jEVPRZuzznKlsPv0cTMPI3XYvNl1N4OEsBNHRL6du1mz5JTfCM2f
/+yq1sZQYUSKrzMNEekADAXSgJdV9ckC2zOBKcA33qr/qepfguwnNjMNcPHRmZkuqcbHhBojynTr
BnXrumTOKNuJ48bu3fDLX7rZxqpVVko9Vfj4Y+jSxbVxOPXUmB4qqcxTIpIGfAlcDWwEFgHdVHV1
wJhM4HeqWqSHMqZKA+Drr+Hii12/8bPOit1xjPjw/vvOqfj5565pTbLTpYvzbQwe7LckRmk5eNA1
U3riCVcJIMYkm3mqNbBOVTeoajbwGtApyLgSfaGY0KQJPPqoC30zM1Vyc/gw/Pa3LmQ1FRQGuByT
4cNh7Vq/JTFKy8MPu/7ecVAYkeKn0qgHBBZ6+sFbF4gC7URkuYjMEJHmcZOuIHfd5apLNmtmZaqT
mSeegPPOc//DVKFBA3joIbj7bkv6S2ZuuAH+/W/YujWh7y9+Ko1wru6lQANVPQ8YDrwVW5GKoFw5
9+P85hvXb9yyxZOPr75yP8qhQ/2WJPoMGgTbtrneH0bykZsLs2e72lKzZiX0/aV8qA0iMi1gUTnR
TKTF+RnCYCPQIGC5AW62EXiQfQHvZ4rIf0SkpqruLLizIUOGHHufmZkZmwb0p5zi/taqZdEqyYaq
exJ/6CEXqppqlC/vSrrffLOrm1a9ut8SGSXhv/+F9HT3PobRfFlZWWRlZZVqHyEd4Z4TGuBGoA4w
Dqc4ugFbVfX/SnVgkfI4R/hVwCbgUwo7wmsD21RVRaQ18IaqNgqyr9g6wvPZvdsVtfv4Y1c87MIL
Y39MIzq8+qqrXrt4sbvBpir9+7uWscOH+y2JES5797oAm1dfdR0b4xjNF5PoKRFZoqqtilsXCSLS
keMht6+o6t9FpD+Aqo4QkbuBu4Ac4CAukmpBkP3ER2nk8/LL7slg3jxX5NBIbHbvdjkNkya58hup
zM6d7ru+/bY91CQL99/vytmMHBn3Q8dKaawGfqGqX3vLjYHpqnpOxJJGmbgrjdxcF+Fw//2u8qiR
2AwYADk58MILfksSH8aMgWHDYOFCV3jTSFzWrnU94D//3DXaijOxUhodgBcBr1ExjYA7VPXdSISM
BXFXGuBmGT17wurVqRO6mYp06QLTpkH79q7zXTIm8ZUUVZe4mJHhyt9YXarEpVMn1+/7gQd8OXzM
kvtEpBKQn9W2RlWPRCBfzPBFaYBL8W/e3JKqEhVV11s7P3yxLNVnatXKFWGEsvW9k4n333eh/F98
4VtJ/pgk94lIFeA+YICqLgd+IiK/iFDG1OKpp5wZwPqKJybvvutCGCF560tFSn5V1NNPL1vfO1nI
yXFlif7xj8Tv4VKAcPI0RgFHgXbe8ibgrzGTKJlo2NCFcfo0tTSKIDfX+ZxGjHBP2u+/X7ZMNBMm
uATGQ4dcaQojsRgxwvkwOgUrgpHYhB09JSKfqWpLb91yL+EuIfDNPAVw4ACcfbZLqmrXrvjxRnwY
NcpFo8ydW7Yj3B54wEVUvfSS35IY+ezc6e4Zs2a5SrY+EqvaU0dE5KSAgzQBEsqn4StVqsDf/w73
3OMq4hr+c/AgPPKIm/qXZYUB8Mc/wtSpzm5uJAZDhrgkTJ8VRqSEozSGAO8A9UVkAjAbMHtMIN27
u94MzZtbXapEYOhQN+u7+GK/JfGfGjWc4rj/fr8lMQBuucVl7n/1VdLeJ8KNnqoFXIzLCF+gqjti
LVhJ8NU8lU/LlrBsmXtv0Sr+sW2bU94LF7rqxAYcPQrnnONMVFde6bc0ZZtateDHH937BLhPxCp6
SoD2uL4XVwKXRSZeinP66e5vgwYWreInjz3m+rqbwjhOhQrwt7/BffeZCdVPFi6E/fvd+ySO5gvH
Ef480AR4FTfTuAX4RlV/G3vxwiMhZhq7d7u8jaVLXdOmatX8lacs8tVXrqf76tXuic44jqoroTJo
kFOqRnxRdbO8G2+Ejz5KmG6RscoIXwM0V9U8b7kcsEpVz45Y0iiTEEojn9tvhzPOcE2bjPjSpQu0
bm0h0KGYO9ddn2vWWGvYePPuuy5Y5vPPE6pgZqyip9YBPwlY/om3zgjGY4+5rnBbt/otSdli/nxY
tMg9SRvBufxy14DKKuDGl7w8ePBB+OtfE0phREo4M425wEW40uWKa9O6CNhLdPpqlJqEmmmAe6JQ
ddniRuxRdYlSJ58MjRtbraWiWLPG9aBu1cr13LBzFXteew3+9S/n00iwEPBYmacyi9isqvphSQ4Y
CxJOaWzb5qJVFi1yNzEjtkyZ4sKe8zOfEyAqJaE5/XTYssW9t3MVW44eddF8L76YkJFrMStY6O28
GgGd/oJ1z/OLhFMa4Hwa69bB2LF+S5La5OY6k0ulSrBkiYtKKWslQ0rKFVdAVpY7b1lZdq5iyfPP
w1tvOZ9GAhKrkNv+IrIFWAks8V6LIxOxDPG737mb14oVfkuS2kyY4CLV3n+/bNaYioTJk6FZM7jg
AjtXseTAAXj8cVcxIoUIxzy1DmiTaAl9gSTkTAOcT+Pdd11rWCP6HD3qaviMGuX6ZRjhs2OHO3eW
BBk7/vpXWLnS+TQSlFhFT30DHIpMpKIRkQ4iskZE1opI0DhJERnmbV8uIi1jIUfM6N8fVq1yoY5G
9HnpJffEbAqj5NSq5SLN/vxnvyVJTX78EZ55xs00UoxwZhoXAP8FPsGVSAfnAC9VbKOIpAFf4jLN
N+Iisrqp6uqAMdfh+nhcJyIXA8+qaqEmzwk70wDn0/jDH9xTXZUqFq0SLQ4cgKZNXS/sCy7wW5rk
ZN8+dw7few9atPBbmtSiRQs3mzv//IT+zccqemoxMBfn08jDZYWrqo6OVFBvv22BwarawVt+ELfj
JwLGvADMUdXXveU1QHtV3VpgX4mrNHJznc3dInuiyxNPuOx7O5elY+hQV6J72jS/JUkdvv/eJfjm
5rrlBP7NR6I0wsk0SVPV30UoU1HUAwJb3v2AK4pY3Jj6QPJkzqWlufDb/MieJK03k1Ds2gX//Kcr
x2CUjjvvdGaU+fNdCRaj9Dz2mGvQ9s03KfmbD0dpzBSR/sBUAvpoRCHkNtypQUEtGPRzQ4YMOfY+
MzOTzMzMiISKCe+/78wA/fol7DQ1qXj6adfx7Kyzih9rFE2lSq7H/UMPufDbBEs+Szq+/NKF2C5a
5MrRJ0iNqXyysrLIysoq1T7CMU9tIMiNWlXPKNWBRdoAQwLMU38E8lT1yYAxLwBZqvqat5x85ql8
5s6F3r3dRVWhgt/SJC9btsC557oy9A0a+C1NapCT4xoCDR0K117rtzTJzS23OB/bgw/6LUlYxCR6
SlUbqeoZBV+Ri3mMxUBTEWkkIhWAW3GzmUCmArfDMSWzu6DCSBouv9yZqVJsqhp3/vIXp3xNYUSP
8uVdlM9DD1np9NKwZIkz86V4/bNwmzD9FGgOHCuNqapjSn1wkY7AUCANeEVV/+6ZwlDVEd6Y54AO
wAGgr6ouDbKfxJ9pAHz2mevst3YtVK3qtzTJx/r1zka8Zg2ceqrf0qQWeXlw0UXuCblrV7+lSU6u
vRY6d4a77vJbkrCJVfTUEFwTpnOB6UBH4CNVvTlCOaNO0igNgNtuc6aAhx/2W5Lko2lTl9B37rkJ
HcaYtLz7rjOvnH++hYeXlDlz4Ne/dr1cksj8HCul8TlwHrBUVc8TkdrAeFW9OnJRo0tSKY21a6Ft
W+fbOOUUv6VJHlascJVZc3LccgKHMSYtqq5S8J49btnOcXiout/0oEGucGYSEauM8EOqmgvkiEh1
YBtgBuVIadrUNQt68snixxrH+eMf3bmDlAxjTAhEXEVWcM5cO8fhMWUKHDrkrAhlgHCUxiIRORl4
Cee8/gz4OKZSpTp//jO88gps3Oi3JMlBVpab9s+ZY0UJY82MGVC/vvO92TkuntxcZ2r+29+gXDi3
0+Qn7NLoACJyBlBNVZfHTqSSk1TmqXzuv9+ZAUaM8FuSxEYVLr4Y7r0XunXzW5qyQb4Jdc0a67Ve
HKNHuxpo8+YlZY5LVH0aItKKIhLwgkUx+UVSKo2dO12xvU8+OW52MQozcaJ7ilu8uMw8ySUEd9/t
HLrPPOO3JInLkSMuwXTcOLj0Ur+liYhoK40snNI4CWgF5DeGaAEsVtW2kYsaXZJSaYArnTxypMs5
qFzZolUKkp3tIqX+/W+45hq/pSlb5CdRLl7s6igZhWnXzs3G2rRJ2t9urKKnJuEKC670ln8KPKqq
XSKWNMokrdLYvx9q1nQ3R7BolYI8/zxMmuR8GEb8GTzY1U+y7pOF2bPH5Qol+W83Vkpjlao2L26d
nySt0gCXs/H559amtCD79zuz3fTpVvrcL/JLp7/zjsvdMI7z4IPOLLVxY1L/dmMVcrtCRF4WkUwR
uUJEXgISyhGe1GRludLp99yTlBddzHjmGdfL2hSGf2RkwJ/+lDR1lOLGhg3O+f3ee2Uymi+cmcZJ
wF3AZd6qucDzqno4xrKFTVLPNMBddHfd5br8JVE2aczYvt3V6fr0U2jc2G9pyjZHj7rcjREj4Kqr
/JYmMejWzTVVGzzYb0lKTUzMU8lA0isNgOuvh6uvdqGlZZ1Bg1z44rPP+i2JAfD6664c/aefWgTb
ggVw882uokOVKn5LU2pi5dO4FBgMNOJ4/w1V1YR5BEwJpbFqFWRmumiMmjX9lsY/vv7a5WWsXm1F
CROFvDxo3Rruuw9uvdVvafxD1TWquuMO6NPHb2miQqx8Gq8A/wIuBS7yXq1LLp5RJM2buyeYxx7z
WxJ/ueYaVwG4d2/YvdtvaQxws4vatd3/5Npry+7/5c034fBhuP12vyXxlXBmGgtVtWAb1oQiJWYa
ANu2OeXx8ccu8a+sMWcOdOzokqYgacMYU5LMTPjwQ/e+LP5fDh92fraRI12ARooQq5nGHBF5WkTa
ikgr72UhLbHgtNOcCeCBB/yWJP5kZ8OAAccL5llRwsSicmX3Ny0NHnnEX1n8YPhwaNEipRRGpIQz
05gTbL2qJszZS5mZBhx/ovnvf6F9e7+liR/PPOPyAV57Dfr3T7jeymWe3budLb9xY+d3evNNvyWK
H/nRfPPnp1xf+miXEfl9gVUK7MA1YPomMhGP7bsm8DrQENgA3KKqhQylXn/yvUAukK2qQX0pKaU0
wEWrPPWUa05fFqJVtmyBn/40JX+UKcehQ242+NJLLtqvLDBggJthpWA0X7TNUxlA1YBXBq4G1UwR
KW250QeB91W1GTDLWw6GApmq2jKUwkhJbrnF5WuMG+e3JPHhgQegXz9TGMnASSfB0KEwcKDL4Uh1
Vq92/ps//9lvSRKGEudpeLOEWaraMuKDiqwB2qvqVhGpA2Sp6tlBxq0HLlTVH4vZX2rNNAA6dXLm
mssvd6aAVDXVzJ/vwjhXr3YZyEbio+r6bVx1FfzhD35LEztUXTHRihXdA02SFiUsilg5wk9AVXeW
9DNBqK2qW733W4HaoQ4HfCAii0XkN1E4bvKwZ497kvvgA2dLTkVyc93U/+mnTWEkE/mJl088AZs2
+S1N7Bg3zvlyvvkGZs5M3d9hCSlf/JATEZErgF1hjHsfqBNk08OBC6qqIhJqmnCJqm4WkVOB90Vk
jarOCzZwyJAhx95nZmaSmZlZnIiJTX60Snp6yiQSFeLFF13drTLSJjOlaNYMfvMb10wsFc2o27a5
WdR557kQ+BSJ5svKyiIrK6tU+yjKEb4yyOqTgc3A7aq6OuKDOvNUpqpuEZHTgTnBzFMFPjMY2K+q
/wyyLfXMU/nRKjfcAH/5CyxbBpUq+S1V9NixwzlUZ81ylX6N5GP/fhdVNH68M6OmEj16QN26rpXr
HXekbDRftKOnGhVYpcCPqro/IulO3PdT3r6eFJEHgRqq+mCBMZWBNFXdJyJVgPdwfTzeC7K/1FMa
gdx8syuQ9pe/+C1J9LjjDjebGjrUb0mM0vDGG66Z2JIlUL7EhovEZPp0V/9s5crjM/4UJWkKFnrO
9DeAnxAQcisidYGXVPV6EWkMTPI+Uh4Yr6p/D7G/1FYamze7afIHH7gEo2TnxhvdD7N9+9R28pcF
VKFePXdzbdYs+Z3F+/a58O+RI8tEVd+kURrRJuWVBsDLL7sp8iefuJjxZOXgQahVy8X7Q9ksSZFq
XHSRawsLyf//HDTImd1GjvRbkrgQl+gpwyf69XOF/IYN81uS0nH//cefRFPEuVjmya9GXLmy6+ee
rHzyCUycCP/4h9+SJDSmNJIFEXeD/etfYf16v6WJjLffdq9PPimTHc9SlgkT3P/zkkuSN2v6yBH3
YPbss2W7NUEYmHkq2XjqKRdx9M47TpEkC1u3uj7Tb7wBl11W/Hgj+cj/H7/+evJFUz36KHz2GUye
nFy/q1JiPo2yQE4O1Knj/AKNGyeH41HVdSa84ILUigAzCjN9Otx9twsRT/TrMp+bb4YpU9zDzKRJ
ySN3FDClUVa48EIX4gjJ4Xh87jkYM8aVDElP91saI9YMGAA//ugeaBL9qX3vXvcQVkYDM8wRXlY4
7TT3t2JFePJJf2Upji++cFP/8eNNYZQVnn4ali93//NEJi8PevZ0s3awwIwwsZlGMpKfLX7qqbB2
LcyYkZiJVYcPu37f99wDv/qV39IY8WTZMte699NP4Ywz/JYmOI884roRTpzoZkcpmvVdFGaeKmvk
5Lhqoz/7GfyzUHUV/7n3Xvj+e5fAl+hmCiP6/Otf7oY8d27iPdS8+aarLbVo0fGZexnEzFNljfLl
Xae7KVOczyCRuPpq+M9/3Kxozx6/pTH84P/+D777zs00OnZ010IisHw5/Pa3LlKqDCuMSDGlkezU
rOmUxu9/70wBicCMGW7af/SoCw+2ktJlk3LloGFD+OEHFyKeCNfBjh3QubPr+X3BBX5Lk5SY0kgF
zj3XlRnp0sXVqfKTDz5wpdwvusgtm3OxbFO9uvtbsaKr6eQn2dkuOuq226wcfykwpZEqdOrknuRu
usllt/rBvHnQrZuzY8+YYVnfxvFs8aVLYfRo94TvF7/7nSt1YrlCpcIc4alEXh40aeJiz1u1cvHm
8bphL1jgen9MmOD8GYZRkG+/dZnif/qTa+AUL/Ly3Ix3zRpX6sQqKx/DHOFlnXLlXE/jnTvdE36P
HvE57tKlTmGMGmUKwwhNw4bOx/XoozB2bHyOeeAA3HILrFvnEvhSuX1ynDClkWpUrer+NmjgylV/
9FFsj/f55y7s94UXXKkQwyiKM890DzQPPBD7zOvvvoNLL3W/ibZt3TrzsZUaUxqpRr4NecUKF4bb
pYtzkseCDh1cBEqdOnDllbE5hpF6nHOOi6bq08cpkQ4doh+OO38+tGnjMr5HjXJFFM3HFh1UNe4v
oCvwBZALXFDEuA7AGmAt8EAR49QIwZdfqjZrpjpokGp2dnT2uX69aqdOqpUqqbpyhKpdu0Zn30bZ
4aKLjl8/V1wRvf2OHKl66qmqM2ZEb58pinfvLNH926+ZxkrgRmBuqAEikgY8h1MczYFuInJOfMRL
IQkdCi0AAAalSURBVJo1g4UL4csvnU25bVtnTgrxZJeVlRV6X4cPw2OPuSn+RRcdL39tU/6QFHk+
yzr5NZ8aN3ZO6t69XXn1IijyfPbpA/Xru5Ig06a5hEIj6viiNFR1jap+Vcyw1sA6Vd2gqtnAa0Cn
2EuXgtSo4ZofpaW5KKeZM+HnP3dtLQsQ8kf59tsuH2T5cldh9+GHbcofBqY0iiDflLpkiXuoqV3b
5XIMG+ZK5ASh0PnMyXHXc/fuzrm+caNrKZyIZXVShET2adQDvg9Y/sFbZ0RC+fLHk6saN4aTT3ZP
ZT17wrvvHv+RZme7H/B778FLL7nwyHr13I+7Zk145RU3YwGnKOIZ1mukFoHXT0aGazA2dy5MneqK
cTZoAM2bw6uvOh9dfjkaVRexd++97hoeMgTatYMrrnDbbeYbU2JWRUxE3gfqBNn0kKpOC2MXlngR
bSZMcOGG+dU8t21zs4VHHnHJgbm5TnlMmOAUS6NGTkFUqwabNrlorDvuKFP9Bow4c845buZ63nmw
cqVb97vfuQeWb7911+c//uH+1q/vzFD51Qd69jzx+jZigq/JfSIyB/i9qi4Nsq0NMERVO3jLfwTy
VLVQAwkRMQVjGIYRAVrC5L5EqFccSuDFQFMRaQRsAm4FugUbWNIvbRiGYUSGLz4NEblRRL4H2gDT
RWSmt76uiEwHUNUcYADwLrAKeF1VV/shr2EYhuFIidpThmEYRnxI5OipExCRDiKyRkTWisgDIcYM
87YvF5GW8ZYxmSjufIpIpojsEZHPvNef/JAzGRCRkSKyVURWFjHGrs0wKe582rUZPiLSQETmiMgX
IvK5iAwKMS7867Ok2YB+vIA0YB3QCEgHlgHnFBhzHTDDe38xsMBvuRP1Feb5zASm+i1rMryAy4CW
wMoQ2+3ajO75tGsz/HNZBzjfe18V+LK0985kmWmEk+h3AzAaQFUXAjVEpHZ8xUwawk2ctACDMFDV
ecCuIobYtVkCwjifYNdmWKjqFlVd5r3fD6wG6hYYVqLrM1mURjiJfsHG1I+xXMlKOOdTgXbedHWG
iDSPm3Sph12b0cWuzQjwIlFbAgsLbCrR9ZkIIbfhEK63vuDTh3n5gxPOeVkKNFDVgyLSEXgLaBZb
sVIauzajh12bJUREqgITgXu8GUehIQWWQ16fyTLT2Ag0CFhugNOGRY2p760zClPs+VTVfap60Hs/
E0gXkZrxEzGlsGsziti1WTJEJB34HzBOVd8KMqRE12eyKI1jiX4iUgGX6De1wJipwO1wLJt8t6oW
XTKz7FLs+RSR2iIi3vvWuPDsnfEXNSWwazOK2LUZPt55egVYpapDQwwr0fWZFOYpVc0RkfxEvzTg
FVVdLSL9ve0jVHWGiFwnIuuAA0BfH0VOaMI5n8DNwF0ikgMcBG7zTeAER0ReBdoDtbyk1cG4qDS7
NiOguPOJXZsl4RKgJ7BCRD7z1j0E/AQiuz4tuc8wDMMIm2QxTxmGYRgJgCkNwzAMI2xMaRiGYRhh
Y0rDMAzDCBtTGoZhGEbYmNIwDMMwwsaUhmEUQESqi8hdAct1ReTNGB3rFyIypIjtLUTklVgc2zAi
wfI0DKMAXmG3aar6szgcaw5wW1EZuCKSBdyiqttiLY9hFIfNNAyjME8ATbwGP0+KSMP8hkAi0kdE
3hKR90RkvYgMEJE/iMhSEflERE72xjURkZkislhE5orIWQUPIiINgAr5CkNEuorIShFZJiIfBgyd
CXSN/dc2jOIxpWEYhXkA+FpVW6rqAxSuAHoucCNwEfBXYK+qXgB8glfDB3gRGKiqFwL3Af8JcpxL
cBVb83kE+Lmqng/8MmD9p8DlpftKhhEdkqL2lGHEmeIa/MxR1QPAARHZDUzz1q8EWohIFaAd8KZX
Vw+gQpD9/ATYHLA8HxgtIm8AkwLWb8Z1WTQM3zGlYRgl50jA+7yA5Tzcb6ocsEtVw+kFfkyrqOpd
XtXW64ElItLKq94qWP8NI0Ew85RhFGYfkBHB5wRcvwdgvYjcDK48tYi0CDL+W1wPZ7xxTVT1U1Ud
DGznePe0072xhuE7pjQMowCq+iMw33NKP4l7ys9/0g98T5D3+cs9gH4isgz4HNeHuSDzgQsClp8S
kRWe032+qq7w1rcG5pbmOxlGtLCQW8PwERGZDfRQ1c1FjMnCQm6NBMFmGobhL/8A7gy10TNrrTOF
YSQKNtMwDMMwwsZmGoZhGEbYmNIwDMMwwsaUhmEYhhE2pjQMwzCMsDGlYRiGYYSNKQ3DMAwjbP4f
Lgxre1MOTEUAAAAASUVORK5CYII=
)

## 直方图

`hist` 函数：

In [3]:

```py
import numpy as np
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt

# example data
mu = 100 # mean of distribution
sigma = 15 # standard deviation of distribution
x = mu + sigma * np.random.randn(10000)

num_bins = 50
# the histogram of the data
n, bins, patches = plt.hist(x, num_bins, normed=1, facecolor='green', alpha=0.5)
# add a 'best fit' line
y = mlab.normpdf(bins, mu, sigma)
plt.plot(bins, y, 'r--')
plt.xlabel('Smarts')
plt.ylabel('Probability')
plt.title(r'Histogram of IQ: $\mu=100$, $\sigma=15$')

# Tweak spacing to prevent clipping of ylabel
plt.subplots_adjust(left=0.15)
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAYkAAAEbCAYAAAAvc3j1AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 路径图

`matplotlib.path` 包：

In [4]:

```py
import matplotlib.path as mpath
import matplotlib.patches as mpatches
import matplotlib.pyplot as plt

fig, ax = plt.subplots()

Path = mpath.Path
path_data = [
    (Path.MOVETO, (1.58, -2.57)),
    (Path.CURVE4, (0.35, -1.1)),
    (Path.CURVE4, (-1.75, 2.0)),
    (Path.CURVE4, (0.375, 2.0)),
    (Path.LINETO, (0.85, 1.15)),
    (Path.CURVE4, (2.2, 3.2)),
    (Path.CURVE4, (3, 0.05)),
    (Path.CURVE4, (2.0, -0.5)),
    (Path.CLOSEPOLY, (1.58, -2.57)),
    ]
codes, verts = zip(*path_data)
path = mpath.Path(verts, codes)
patch = mpatches.PathPatch(path, facecolor='r', alpha=0.5)
ax.add_patch(patch)

# plot control points and connecting lines
x, y = zip(*path.vertices)
line, = ax.plot(x, y, 'go-')

ax.grid()
ax.axis('equal')
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAW0AAAEACAYAAAB4ayemAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 三维绘图

导入 `Axex3D`：

In [5]:

```py
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
from matplotlib.ticker import LinearLocator, FormatStrFormatter
import matplotlib.pyplot as plt
import numpy as np

fig = plt.figure()
ax = fig.gca(projection='3d')
X = np.arange(-5, 5, 0.25)
Y = np.arange(-5, 5, 0.25)
X, Y = np.meshgrid(X, Y)
R = np.sqrt(X**2 + Y**2)
Z = np.sin(R)
surf = ax.plot_surface(X, Y, Z, rstride=1, cstride=1, cmap=cm.coolwarm,
        linewidth=0, antialiased=False)
ax.set_zlim(-1.01, 1.01)

ax.zaxis.set_major_locator(LinearLocator(10))
ax.zaxis.set_major_formatter(FormatStrFormatter('%.02f'))

fig.colorbar(surf, shrink=0.5, aspect=5)

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAVsAAADtCAYAAAARK9YxAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 流向图

主要函数：`plt.streamplot`

In [6]:

```py
import numpy as np
import matplotlib.pyplot as plt

Y, X = np.mgrid[-3:3:100j, -3:3:100j]
U = -1 - X**2 + Y
V = 1 + X - Y**2
speed = np.sqrt(U*U + V*V)

plt.streamplot(X, Y, U, V, color=U, linewidth=2, cmap=plt.cm.autumn)
plt.colorbar()

f, (ax1, ax2) = plt.subplots(ncols=2)
ax1.streamplot(X, Y, U, V, density=[0.5, 1])

lw = 5*speed/speed.max()
ax2.streamplot(X, Y, U, V, density=0.6, color='k', linewidth=lw)

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAV4AAAEACAYAAAD7rx6dAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXAAAAEACAYAAACqOy3+AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 椭圆

`Ellipse` 对象：

In [7]:

```py
from pylab import figure, show, rand
from matplotlib.patches import Ellipse

NUM = 250

ells = [Ellipse(xy=rand(2)*10, width=rand(), height=rand(), angle=rand()*360)
        for i in range(NUM)]

fig = figure()
ax = fig.add_subplot(111, aspect='equal')
for e in ells:
    ax.add_artist(e)
    e.set_clip_box(ax.bbox)
    e.set_alpha(rand())
    e.set_facecolor(rand(3))

ax.set_xlim(0, 10)
ax.set_ylim(0, 10)

show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAQEAAAEACAYAAACzsMNYAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz
AAALEgAACxIB0t1+/AAAIABJREFUeJzsnXeYHMW19n89Oc/szM7sbM5BYZWFEgoEJQQS0eR0yTY2
mGTAxsbXNsb4mmDjC9j+zMWAMVlkUJaQUBZKq11tznk2TI7d3x+rtOxKGxRAtt7n4UHTXVVd3Vv1
1qlzTp0jSJLEGZzBGfznQvZtd+AMzuAMvl2cIYEzOIP/cJwhgTM4g/9wnCGBMziD/3CcIYEzOIP/
cJwhgTM4g/9wHJMEBEH4uyAILYIg7DnimlUQhOWCIJQKgrBMEATLye/mGZzBGZwsDCQJvAws+Ma1
h4HlkiTlASsP/D6DMziD0xTCQM5CgiBkAB9JklR44HcJMFuSpBZBEJzAGkmSCk52R8/gDM7g5GA4
OoEESZJaDvy7BUg4gf05gzM4g1OM41IMSj1ixBm/4zM4g9MYimHUaREEwSlJUrMgCIlAa3+FBEE4
Qw5ncAbfEiRJEgZbdjgk8CFwI/C7A/9feoyODKP5wcHn8/Hog09iYy6J9rxD16OxCFLEjVqpOXQt
FAmCwkC3p4WKzvf5+W/uIi0trU+bjz/+OI8//vhJ6e+evbup8e0gf0wWAOFwhF2rq7l0wbVoNJoB
avfGE7/9DV3+CrxeH9//8ZXHLBuJRLnt6t+wZtUGDAbDsPt/onCyvvEzzz3NXs8/mHtT37/rsdBS
42Ppf/tY/cWmo5Y5Vp+vvPwKghVNjErK7HNvTdlOlvzXdfzk4Z8MqU/HC0EY9PwHBjYRvgF8BeQL
glAnCMLNwJPAXEEQSoFzD/w+5Xjv3Y8RvLm9CABALlMQQ0CUxEPXlAoVsagPmyUVp+5cXv7rm4ii
+M0mTyrycvNxN4mEgiEAVCol5mQlZeX7h9zWrbfcxs4tNRTvrSIWix21nCRJvPLSR0yfNvM7QQAn
E1MmT6WhSBzywlO6tYtJ46cO+7lKlYrYUcZSotHKqhUrht32qcIxSUCSpKslSUqSJEklSVKqJEkv
S5LUIUnS+ZIk5UmSNE+SpK5T1dkj+sWm9bvJTJzS554gCMgVeiLR8KFrMkGGXICYGCEtYTSN5TLW
rVt/KruMWq2mMGciFfsaDl1zJFmpa64eclsOh4PXXn2DjrYgD9z1Rz7/aANtLZ2HJoDPG2DPzjKe
+uU/qK/y8MRvvhWePiWIxWJs37KF5ooqmrd2sfb5GkpWt9NS7SMaOTbRezrDbHrby523/XDYz8/N
z8Md9Pd7L8FkZW9R0bDbPlUYznbgW0d7eztBrwxdornf+0qFmmAsTCQWRilXASAXBCKxCAq5irzk
+bz9z38ye/bMXqLTnDlzTmq/RxSMovyLEpob23EmxWM069nvrkCSpCGLcA6Hg2efeY64uDhe+ssL
fPDW3/D5fMjlcgQEMjIyuOTiq7jssstQqVQn6Y2GjhP5jSVJYu3yFYTKqhnpcPLwZTexbtsHJDqU
uGr9NGjcpM4wY0/R9Vv3sxcbuOrSm8nOzh52n8eOHcu7r/yz33tmrZ6u7i78fj86Xd8+fFdwWpJA
VVUVOnnyMcuoVQZCIQ+iFEIpVyIBAj0TzaSPJ9ykorm5mcTExEN1TjYJKBQKzpkxn2VffoQkitid
VkAaFgkAzJgxg88+/pRkrZOZ/zWLi6+4hGg0itFoHFZ7pwIn8ht3dHTgKq1gZnYBgiAwZ9Zs6uqq
KVm1hwkLrKQooGxZN20ZPrKmxKHR9wz3gDfKR3+sQ96VxffvHFgKOFafp06dSm17M6IoIpP1FqwF
QUCpUBIKhb7TJHBanh3omTTH5i9BENBoTCDXEYxGCYugUKgP3VfL7LS29mvYOKmwWCzMn7UYd6WC
rctLyUzK7zN4BoNYLMYbr7yOr7idSyfPp6WuCZ1Oh8lk+s4SwPGgq6uLrq7DO8/Ozk4aGhowKJSH
3lcQZFxz1fVMHrGQ1a90ULXdQ4ZGj61ewZ6lLexe18qyl2t54c5yRtkv5NW/v4lerz+ufjmdTnJz
cqlsb+r3vlwmIxqNHtczTjZOS0kgLi6OiDg4VYRSoUGp6Kt9l6HF6/We6K4NCmazmQvnX4zP5xv2
CrH882VITQFmj59FMBwiEg4PXOk0hdfrZenSDwBYsGA+VquVa5ZcRTAQ5M5LLupVVqFQcN65c5k0
8SyWr/icPZ+V0NnRjScYwhOn55wll/PjPy2hsLDwhPXvBz+6m6d/+QQ5jr7SqXgahO87LUkgNTWV
QKwFUYwhk8mH1UZYaiMhYVa/98rLy3nzzTf5wQ9+gMVy8s5HDXcVKisro3jDbi6ZPB9BEOjydhOf
YD/BvfvuoLy8HKPRhFqp4t133qVgRAHmoJGJQiHvr1zDnHET+9Qxm81cftlh86koirR2drA/6CEz
s68573hwxRVXcP+P76PD58GqNx667gsFEASB+Pj4E/q8E43Tcjug1WqZcFYOFQ1bhlU/GosQEtv6
9RXo6uri9tvu4I3X32Tr1q3H29Uhobm5mZdeeonHHnuU2269jkcfeYgPPviA8BGrfCQS4bN3P+bs
3ImolEoAWlytpGQNzT5+OsHV7iLg9dJZsxd1VzlbVnyAKizn3NSZlJfX0djeNmAbMpkMpy2eFEHB
prXrTqgPi16v52eP/YzVFbt6maar2puZOmXqd357dlqSAMA1119GZ3Qz/mD3kOu2uirJzkvuV2v+
t7/9DYPWRHZGDp2dnSeiqwP3p7WV73//ViZNHMmXK39F1PN/5KetQwq8zp+e+T7jxuazceNGAL7a
8BVxUR3J9sMKzSZvO+lZGaekr6cSXq+X8ooKiktLaSjbSX6SgcL8LAyKKGI0jFJQMN40lqVfrhl0
m1mJKbjLq6moqDihff3RPfeQkpPJspLtBCIh/OEQm+v2c9+D95/Q55wMnJbbAYD4+Hguveoclr76
GRNyrhj0tiASDVLTuZIHf3R1n3tdXV288/a7nDN9Hrv37cBs7t8EeSLx+eefc8ftN3DhPDUfvpaE
2dT7T3Lr9bB+k4err7qQZ5/7f5Rt28eSMecfuu8P+nFFusnKyjrpfT2VaGhoYHNVGSpnPA2xIGqF
SKOnC5UIfq8Hv+hDFEVGWfNZX7WJbq8X8yAcogRBYExyGttXriElJQXlAWnq4L3hKGkB5HI57y19
n0cefphX/vkGEnDHnXdy/vnnD1j328ZpKwkAzJ13HmOm69le9iahSP8OG0ciEg2xs+JdFlwyjhEj
RvS5//bbbxMfl4BepycQ9JOSknIyun0I69at4847ruXZX1u47y5bHwI4iLOnGvntz+K49+67yNQn
YdAd1iWU11dRMH50r8F8uiMUCrG1opSEcaNIzMzAmZ6KqDEiN5qQ2yzEVDJq3E3IZHKyzJm4vQH2
NNYOSsQXRRGNSoMuEKGyrBIxIiEd+C8ajhEOhYe9VTCbzfzvCy/w9e5dFO8v4cnfnR5OWqc1CSgU
Cu76wS0suCKb7VV/o7J+O4GQp085UYxRUb+VbVV/YdaiFC6/4uI+ZSRJYun7H5CVlo0oinR7uk8q
CezYsYMbrr+MJx+LY8yogS0E+Tka8hL0tFTW9bpe2VFP4fgxJ6ub3wo6OjoQrCY0Wi0ABrMZU1ou
RU0Biuu7cckshDQyGrtbiFNbCPpDaDNSKKqpPGqboigSDkeJRiRkkoxUczwN5ZXIZTJkB/5TyOTI
kRMJR46r/+np6TidzuNq41TitN0OHIRMJuPSy5YwfsIYVnyxjm2b1yGFLWhkSYBEDC+BWDNjJ6Xw
wyu/T3Jy/05GVVVVuNo7mDrOQVt7KykpKb22A9FolI6ODrq6uwkGggCYLWbibbYha/mbmpq4/LJF
PHafkcnjB+fTv2tPmCVTc9i/qwhp8SUIgkB7l4uwWiQ9PX1Iz/+uo6O7G5XpsJbdYDbha+8kbdIM
wuEw6pQuSvY1Uu1qxKDQY1NayMjLpTomsq+mipHph7X/kiQRicZAFJDL5IiSSIfHjTfko3hPGaMn
TUSv1x86WyEIApzaYyXfOk57EjiIzMxMbrszk/+6LUZVVRUNDQ3IZDKMRiOJiYkkJBw79smaNWtI
sDkRBIGmlgZmz+kxH0YiEVpbW2lpaUGhVKHT67BY45AkCb/fT8n+/YwcMQLtgVVrMPj1rx5j0fkK
5pxtGlT5YFCkfK+CxaOclO8N4HK5iI+PZ3dNCVPPPXvY+9jvKr6pTTdYzNSGQsgVCrQKBdFwBHtu
CmXNVRRqRxMORwmHw5x/0SJWffY5O6vKKUzLRBAEolERGTJk8p5v1NTZTkOsDoVBTiTmo9q3j0ir
iCyqJNGaQoLdiUr73XGzPhX4tyGBg5DL5eTk5JCTkzOkemtXr8WZ0KNxd3W1M2PGDLq6uqisqkKl
UmFPSEAu7618NJvNiKJEW1v/5sb+UFFRwccfv8fSfxzb7flIlFUGSdamolMrscVFcHV0oNKqaQ67
uHz8uMG/5GkCg1ZLOHDYMmOKsxAOhQ79Vms1pOXmsGLlW1xIlJhcoKSygrFjx3L+ogvYtH49a7/e
S64pnqR4Ry9SUSuUCDEZapUcR1ICjsQe/4pIJIKrs56akgoc5iTysvO/U2cuTib+vZaQYcLv91O0
bx9ORxI+n5dgOEBCQgLllZVYbTasNlsfAjgIuVw2JEXSCy/8kUsX6TEZB+/kVLpPIMvRM1i1GvB6
POysLGLSnGlDjkVwOsBoNBLz+A791hkMRCWR0r172blpM+uWrWbX1l1ok638c98buCKd+E1aqmtq
UCgUTJ81i7MvWUK9QmRHZTntXYdPWMab4zCF49i2txJHymEiViqV2OxxpBQ4CGo72brnq15uyv/O
+LeTBIaDsrIyTAYzSqWS0ooSzpoyGVdnJ06ns5eo7fP5WLN6Ne0uFwq5nCUXX0w0GkNpGJxmXhRF
/vXGa/zrr4MPy9jtjuJp15CY2rNn9XhBUMpoCLaxeEpfM+e/A0wmE8pAiFAwSCgQYNdXW9mwchOB
oBpjfDJyhR6/mErCpLPY3fAGar2FD9/9go261Tz8/TtJTU4lOSkZ5/euoLy8nIq9+9hdUYJOpiAs
iURlcPbsSxFEkabaVsw2AzqdlhgiCqUCm8NK0Bhkb8XXTBr170m0R+IMCQD19fXoNDpEUaSqroJF
ly4gISHhEAG43W6ef/ZZ3nnzTfLirDjValoDQZa+9RZP//nPZGdmDOo5dXV1aDUCiQmDFzPLKkKk
m7KRyXpE2o7OMOUdtcz63tzv9Mm044FcLifHkcQrf3+N0pJ6FMZUUicsprW+mXiHg0g4jDIQICEj
l7n3/BKAWDRCXfEuHnrsf7jhigtZtHA+crmc/Px88vPzCYfDuN0edDodWq0GQRCIxWK4XC5qm6pp
izWhjVOi1WlQKJVIkkRUHsTr9Z4hgf8ENDQ0oFSqqaqpJM5qYeasWYcIYONXX/HQvfcyRm/gD1Nm
4Dgw8URJ4srPP0Gr0QxaKVhaWkpWxuAViAD11TJGW3vOLwRDIu1eD6NSLUyc1Ndf/t8FkUiEZctW
sWNjFbmzLkJ1YBK6uzx43R5AQqvvTYByhZK0kePpUJr5cMXXNDa2cNstNxz6O6pUKuLjbb3ryOXY
4uOxOqyIokhnZycefzdhTwgkiTzHWKxW6yl5528TZ0iAHp0AwN79u7jn/ntRKpWIosj/PPkk773x
Bt8vGMXEhN52X1ESicSi5A5BAVlaWkpG6uD7FYtJtDXLsI/vMUHWNgRpiLax4OJF/3YWgYMQRZGX
X3mNohofY8bPpSsQPEQCztQU6srKiUaj2NP6+nDI5HIUZjMJtkS2F++g4MsNzJ49s//nSBKiFEOu
lCM/EHgmMTGRRBL7LT8cRKPRHstScysBXwClSkG8Ix6n0zkka9LJxhkSoOdU4r79e5g5eyZz5swm
Go3y0I9/TMXmLTwz9WxManWv8pIksaOlhTGjRg3pj1lTXY7TPngjdJc7hl6hQ3lA+fjW2gomzztn
SH4BXV1d/O63T1BbXUmHq4NwKEQ4EkalUqHT6tAZ9FitVuKs8TiTk8nOziE7O5ucnBwUilM/PPbs
2cOmXXXkTZiLJEF3Qz1hnRaVWo1CpSQtPw9JElEcxUNSbdLT7fKQljeFt5YuY9SokYckAEmSECUJ
CRFB3hPw42Qd7qmtrWXb+u3Iw3KMKhMqpRp/LMS+4mK2SFvJG5vHiJEF34mtxhkSAC666CJMJhOW
uB77/wP33EPD9h38fMJkNN+YCD0DSeTDhjrueeI3Q3qOIyGZ2tIhVJAkZIKAJEms+rqOr6or2bvs
i2NWiUaj7Nmzh6/37qWx3UXI4+Hdd97BqFEyZUQ2BenZ5KYmoddqUMrlBEJhun1+ujxeWku/5vON
a6hsbqOty8P58xfw6yd+e8qkDkmS+PCTFcSnjjp0FiQ53k51WxuKxARkchlyhRw4umVFrdXSHWlH
odYgaZPYuHkzCxfOBySQgVwhRyY7eZNfFEW+XLOe9koXWc5sTMa+viChcIjaolqqS6s5f9F5GI3G
flo6dThDAvTsF88++2yKS0r43z/9iaqt2/jFxMmo5Yc/j4R0KM3K6vp6okYD3/ve94b0nKysLNat
GvyEUqlkeEIBvti9n3c2lXHPgw8c81BTSUkJv3/pr7g0BtQ5+WgzRtBZVUlcTg7JqiidYR+fb93K
m6tD+MIgiRJ6rQadRo1WrUYuEwhFogRCYfyBAKX79+P3+09ZpOKGhgZqm7vJmXBY1NfpdDiDRlra
27E4HDDA3JXJZMjUKiQ52JLS2LprD4svXnTKjvNu/moz3dVuxuaMO+oz1So1uWm5NLc1sfzjFcy9
8Pwet2WFAoVCQSAQQK/Xn7I+nyGBA9BoNBTt3csrf/krf5g24xABHJlkSRBk1HrcvF5dwYp164Ys
Lk+fPp17fuQlFrMil/es8A1NERqbw8RiEiqlDKNRTma6GqVCwGiQc84FEd75oIyIPI4f/vCeo7a9
b98+HnnueWyLLqOgYCQhr4eGjWtR1mzjgvOzUTWXce2ihWh1Oppau1ixo5HzLrm9J0BLIIDf7yca
jaJWq9HpdNhstlN+KKmlpQWZOq7P4Lda44i0RuloacXkiB9YMpH1fFu9KY666u5TNpmqq6upL25k
XM54BEFAFEWCwSCC0DO+XK4Oujvc+Dx+ZDIBUSZS31LPc/ufZuyksUSjUbrdHeiNGsYXTicjI+PQ
GBNFkWg0ilJ54qWYMyRwAF6vl8d/+lN+OHI0Vo3mUF4CQRAQBBmCIOAOh3h6725+89RTFBQMPQer
0+lk5MhC/vFmJVkZGoor5Kh1FtKzklBqFfhDYSorulmxvokJo2KML9SxtzjI+q0ali1fhvobuomD
6Ozs5PE/Po/jkquxZeXQWVtN86evMTZRIO+8XJQqBS7cuN3dmExG0pJsnCdJbPlyOWPvfuC4vtuJ
hM/nA1l/5lOBBIcdRUcnrU0tGBx2FMr+h64kSRCJoVQqiYSDRy13ohGLxdi6bht5KQUgSVRWV9PS
2QFKJbFojObKOgyiicykTOyGZLq93ZTXF6PRaxD9EnFWE0olZOSZaW3sprJ6P8XFe0lJTSc9LZ26
pmqihBFEOYn2FBx2x1Ed2IaKMyRwAC+98AJ5Wj2TE5MOXOmJT3wQ7nCIX+3YxkXXXM0NN944rGdI
ksQtt/6Ax//7J/zw7jFcfm0idntfUbu9zcemjRX84g8lbN7iZ+WqDaSmHt2ssHL1GmL5hdiycmgr
LaF7+WvMn5SIzX44NNo3vRrjrUa6djUO6z0GwsFzFSqValDSRFVVFa+8/DIrPvuMptYu2s+5nFET
52AwxR1RSsBmtaJSKqlvbkUdZ0ar1/fZHgS8PgyaHj8AT3cHKYmnJl9uW1sbypgShUzB7uJiwmo1
tsxMZDIZDVW1WA3pGLUWXN1edBo9XR4XGSnp6HU6ojURVn6+giXXnIsgyHDYk7HG2YhEIrS0trJs
WRG6eBWTp08kFovR3l5PR3k7uZknxrX5tCMBSZIOiUUnCrFYjBeef56HC0YdcfXw6Grz+/n1zm0s
vvZanvjd74YljkmSxGeffUJFdRG/fPIhqquKUKr6tyxo9VrM9lwyRjpwpmgG3JN/vX8/5lGT6aqr
xb3ideZPS8VkOVwnGgoidXditzsOXZPLZIQjof6aOy6UlZXx6sevU+eugyiMTR/DVRdeedSjtcXF
xVw0bz5T4uwssljxJ2jZ+OVS/vf9lzhr7pXMvvCmXt/baDSSpVLR1uGiq9uNwqBHqVIiCDLCwSCS
x4fD2UPknc1lLLmsfxPhiUZdTR0mtZmS8nIkkwmr5bDuxt3qJt2Wh1wmJ6JWU9vSgs/Xjd3R44Ng
tyZQ3rCDWDRCJChgs/QoCpVKJSnJyVjMZjZsW8fWrVFGjSrEkRhPd5ebkvIiCnJGHTcRnFQSCAQC
J9we6vf7ee3VVygcM46pU6eeEM11Q0MD0WCQTHPvlTMWi7G2oZ7/Kyvhuv+6hZ/+/OfD3o99+eWX
7CvdwfW3XopOp6VobwKfrVhFklOOPR5USgFfQKSrW6ChKUph4Vjuf2A6+4vLee31V7j3nvuPSnxa
jYaQ10P7+k+YO87RiwCkWBTX7h1MyM9FrT48WOqaXKRlDX1LcyyUlZXx5JtPEbfEQX5OIZIoUbGj
jkf/9hh3zLuVKWf1zhhVVVXFJYsWcWVqNjOSeg5gBYNBxjqScEfCPL3hEz7t7uCCa+/rfQhIrSYl
MYlQKITb4yEc9BOTROJUGsyJySiVSvzebjS4mThxwgl9x/4gSRK15bVYJTsBuRy7pbfyVqmWE4mE
kKt1KJVKVEYjLa1VRCLhnpiEKh9OSwI11XVkpIzuM6kNBgP5WSPpjrayY8dWxo6dgNliRpK6Kava
z8i80celJziptp8f3noTJSUlJ7RNvV5PUlIya1d8ymeffnxCYroHAgFURygCI5EIlS4XT2zbwqtV
FcyddyEhb4gf3PUD3vjnGwSDwSG17/V6Wbn6c5ZcPg+drocUR40ezX/dcjtZuTPxh7Np60pBpiwk
M/tsbrnlDmbOmoNKraJw3Eg0eo75HWdPmkjl26+Qq3fjcB72cAt53LRu30KuLY5RI0b2qrO3upPC
48jB1987Pv2vZ7FfkYQ9t+fknkwuI2VyKik3Z/Li8r9SVlbWq86jDzzIbHP8IQIAUKlVSGIMs0rD
I+On0r53I19++mq/z1Sr1djj40l2JpKWmEz8AWVmJByktvhLvnfpBUfVo5xIBINBooEYHW4Pxn48
DK3Jdtq6moiJPXkjdXo9glJLm6sdX7QDpVqGUqHA54liNPR/vNzpSEQZ02KxmNi1awfd3d1Y4sxE
ZL7jjoV5UiWBa0c6+c2D93DL/Q8zZ845J6zdefMX0NnhYte2TcRiMS5YdNFxObakpqaitZj5n6+3
oxGgxuOlIRjg3DlzuXXuBYeYORgMsmH1eurr67nv/vsGrZj5YtnnjByTgS0+rtd1tUZD4ZgxFHLs
yEA5+ensLy2hsLCw32xFY8aMYZQ2REqgHtfeEMhkiJ5uVLEoZ48eRWZmJkdWKa1uxi9PYNSoUZwo
bNi0gegIibj0vpNAb9NjvzSRP7/9Ar+551fo9XpaWlpY/+U6np3eOwafTJChUikJh6No5AruK5zE
I8v+xZhp87FYB97fB/xeaorWcMmCqcyYPu2Evd+xIIoigiDgD4WwHyCdaDSCXK5AEASs9nii4Qh1
tWUYlBb0WhPmODtltVvJHeUgEgGz1QJR7VFFe41GTUZyNlUNFZhMBnbt2sG4cRMxWY20dDRjMBh4
4cWXWL5q45D7f1JJYFJOGk6Lid89/STBQJAFCxeekHbVajUXX3o57771L/Z+vRWVSsX8BRcMWyTS
6XS8++GH3HzTzeji7JyfkU3hyNGolL3/IBqNhumTprF+ywbefuttrrr6qgHb7urqYtfubdxxz/BP
/GXnZvDWq1/gds/npZde4oEHHuj1riUlJcyfNoLpY5Jpb28nFosRZynAYrEgyHp/E18gxNo9HVxz
+09OmF5FkiRWfr0ax+VHD6lly4ynPM/Fug3rWDhvIStXrmR0fAJaRd8+KBVKBCAUjmBWqTgvKZV1
H/6dxTc9ctT2w6EAzXWlhDoruenKRcw8e8YpMw0KgkAoFKKyvold1WXUVTXjdvuQyyHeYSMrJ4Xx
4yZjsVnpbHfR2dWMm24iOjeC3kZSago1lS0Y9MfW/eh0OrJTc6mur0KGn+3btzF2zHhiUTlLLr2G
zcURRMeVwBtD6v9JVwymxFv42aKpPPHCMwSDAS6+5NIT0q7JZOKSy7/He++8yddbN2K3O5g4afKw
21u+fDkzzzqbsSOPvSrLZDImj5vEss+/4LLLLxtwItXU1JCSnoBWO3z3UFt8HB5PNxs3buSfb/yD
2bNnc9ZZZx26X19dRpJdh16vQ68/enCTYCjCR+vKmDz74qOGWRsOXC4X7TEXeQPE1XNOSeaLV5cx
77x5bN24iRzN0Qe9QqFEJpcTDoVZkJzOg5vXUDRmOlkFE1FrtD0xA4N+/D43rqZyCLUyb850Zs+6
6JTH93O5XLz/0TKiXekk2SeTbZyP3m4jJoZx+1so3bKLPTtf45zzZ5CVmY+YKNLpbiC+uwCDWk1b
cwcquQG1emBS1mg05GXl9ywue3dSuacBT5ePrXvbUYx/F0E29Cl9SqwDCRYTP198Nr96+SVMZjPn
nnveCWnXYrHwvauuZel777B54wZGjBx1zOO1zc3NuN1uMjIyeoldkiSxbcs2Zk08e1DP1Wq0KGQK
mpqaBowo1NzcjD1h8FmMJEmiu8uNy9VJh8tLZ5uX9tZu9uxoQCXtwdcp5+mn/sr1N7qZOHk0TqcT
tUZH1BM7Zrtub4APv6wgZ9IC5px7YsNgd3d3o7AO7MRisBtojKuluLiYYCCAfoAtnEyQodFoUKlV
XJCWSVvpGuJUHrw+Pwq5HLPJSKIzntQsHePGXczMmSfGEhCJRNiwfgMlu0oIBUPMmj+L8ePH91u2
rKyMp3+5N16bAAAgAElEQVT7DxzKxZgdWRjj7cgOfAeFXI3VmIbVmEanZxzLln7EuOmtjBw5Crkq
iklvJMmZQPHOGjxhF7n2wWVGkslkWK1Wpk85m/37K9i5aw8h0/nohkEAcApNhDajngfmn8VvnnkK
pzORkSNHDlxpEDAYDFx97fXU1dX1uypXVFTw1LP/w9IPP8AX8KEyavC3uLEl2jl72gx++egvsNls
SDFxSIc5YmJsUEonn9+LPu7YFpJoNEpTQws1VS001HQiRtQoZUbkcjUaXQJmQwIj8gQmjJvJ2rU7
Cfj0tLUIrN+4mfnzzsFosdFaG+i/nzGR3fvr2VruZdbCa5g6bfqg33GwCAQCSIP8dIaJZlZvXUM4
HMY8SHFdJsiY5Ezm/9VU8vGnH59UMd/r9fLyiy8j71AyMnUUMo3Ax699QkpKCnZ771Rv4XCYvzz/
L3LirkRttVFb1kAkHO53XMQZUxmnvZlt619AUAZwJsUTbmsm6A6SkpjB+qI1hIaYT1KtVqFUytFp
Ncgj/SdEHQxOqZ9ASryFO2eM4qlf/JQ/vPg3bDbbwJUGAblcTkZGRp/rb731Frf/6C5YlIjmt6Mx
J/f4Y2ujIrFmP8vX7+OzOdO5+dobiYmDP90XDAWJiSIOh2PAsnqdHre7vt97rvZOKsvrKdvXgkK0
YDYkkOkciVwmIxjzo1D1hMKuqqrDYU8gLs6GUqnC5+/G1VXNxNmTUGhl5I7IYftXBjbuqiQv3UGc
SUe3J0Btk4uvK9w4Msdx4w8uGjDY6nDh9/tBM7iJGZ8dz77P9hEOhZAPwbybYY6jbVcrbW1tg/ru
w0EkEuH1l1/HFrAzafzhrWV2Wzbbt+1gwcL5vcp/9ukyot3pJObnEo1GkasaiQQCqFSqfolKLqhx
qGezYd1rLLxwAvEWNfEmE/UNJZgTTDQ3trFvdxE2ixm5TI5MIcdoMWFzxGM2mfpNsKNSKVi06AJe
/NvV+MoTQDP0yNMn1UToC/Z1Rhmbmcx5aRaefvKJE5oP7pv40f33cvsjd6P69VgMN+ahSDEcTmGt
kKFIMaC7Khv9C1P5x1fvsb3oazq6BmdqKdq/j5mzZw5qRcrPL6C6ojdLd7g6WfnZZr54by8tZXpy
kmaQlzWBBEcyKqWqx2VZJiGTyYjFRMpLqsnNy0eQgUgYd6QMvS1Mbk4OsWgMk8HMf911P0HzBD75
2suf3y/ig63ddGrHsuSG+7nmhltPGgFAz4rIN5TaPpePki/28fWb26lcX0HI2zMWVHo1IXUEjV6H
Jzx4ZyWZIJAZF8+ePXtOZNd7Ydnny5CaBSYV9NYtGbQm/EfEPIQeS9En73/F6IwLgJ4cGJZ4CzIp
RtDfVyqLxkS6ul3YrE60QirdbW0k2dOJt8fRGWohGG6g8usiTB4DbftbibWHMAZVhGq7Kd28l40r
11NfX9dzkO0IRCIx0tLSWLvyE66a7uKclBVDfu+TSgIvrNx6yAf/SFw0aSTe6hJWrFh+Up77zjvv
8I8P30D3pymo8o69H5fbNGgfG0NNZwPvfPR2r+Sf34QkSZRVlhGMBfnelYM7QZiamkp3pxevt2cQ
7d5Zwmfv7CTancSI7OmkJGegUvUWH5VKFQpJQyQYY39xOTqdCa+/jb3lq9FY23CkQ2NDPWF/FIWo
Rq/V90TOSUhGb0oChQ1fQIZcoTklEXONRiPCEVneqzdWsuyJ5TRVewgIKiq3N/HFr7+gfkctAPI4
Bdl5edQFB84adSSsKjUtLS0nsuuH0NnZyfY1O5g+ckafe96AF4OptxKztrYWtZCIVn34GHCCMwFB
IyCFQwR8fg6ucRLg87oRlDGUShmqSCKxgIBBb2L9hq+QyUMsmTWHEfmJJDkcnDtxDlrBQG1tIz5f
ELvOSropifrdVRTt2nPI36CpqRmZTIHVaiU3N5eXXniOpe/271NxLJzU7UDQlsa7m/dwxbSxva7L
ZTJunTWWp/78RyZNmkxcXNxRWhjGM4NB7n7gHpQPFSAbZABQmUGJ7rFxbPnJNhLXJjF1whTstt77
P6/Py659u9FbDDzys0cHfQZcLpczdsxE1q/eTEp6Mns3d5CfOR1FP6axIxGNRKirrWHjurXMOW8K
BaMtZGWPo72tkpLKzRTvLsakN9Pa2sqqFSvYsHIVBknArjfh1OsRxShff/IFyz/6mAd/8fNjnj2I
RqNs27aNtevWUFJeRHNrI6IoMnvaeSy64CLGjh171LrQo6CVunoGZvnaMvZ+VkLB1VPRWg8nZXE3
dLL97V3EIjEEk4ysuCxecQ/NySUqiSeN1LZv206GKRONqq9yo9XfwuTs3p6HLpcLjaz3GFGplKRm
plBXUYdSiuF3dyMJMsLRCKGwD6UqBggkWrJxdzezc+dOwmI382fOQC6Xk5rmoGhHFRmJ6YzJHU0o
HKbF1UJdYz2haBCVSknZ1hJa2tqxxTuwWeOZMX3mcR8kGjYJCILwCHAdPfla9gA3S5LUS7579PH/
5oEf3EFCUQWzRmX3qp/hsDE73cr//fUlfvzQw/0+o7W1lfauNuxxjj5KmaPhvffeI5qmRjN6aPoG
VZ4FaVoiCSlOyuor2FW8G41ajVyuwB8MIMhg/sIFLF6yeMj29QsXXcQzz/6emoo2EszjEI/YBsVi
MYKhAH6/j2DQRzDqIRztJBTzsr+kmFvvvoq5c+ce2noUjh5DRd1OKutq+OjDD1n2/gc4VBqmpWaj
/YZCyhFnpay+lo+XLuWuH/6w171oNMqyZct4+/03WLV6JfoEAeckiCuQYz9bgSTCyp0v8tIVf2bN
F1+RmXl0zbXT6STaGsHX4WPvR0UUXDMNjaW3lcaUHEfuxRP5+p0tZBdkkDcjD1Eup8HjJrmfwBv9
QZQ4aceb9+8qZbSjsM91r9+DR+zuE80pEomA1HfyGfR6UrNSKSsux93pRSZTEgz6UalBJoAkM6CQ
q6lva8aeHGHhubMOpZjXatQodRIevxezwYRapSItMZW0xFSCoSD+YICMYIB9reVMv2jmoOfEQBgW
CQiCkAHcBoyQJCkkCMKbwFXAK0eWM5vN/Py3v+en996NQi5nekFGr3YWTxrJj99cRfMNN/Wx7dbV
11LZWYY53sC+xiZGMnZQL71zzy4iI3QMxyovnmVh7/ZiPn//E5qamvB4PPh8PuLj40lJSRk242q1
Wm679S7+8MzviMQ20xUsQyb0/OFlcjDH6bHE60i06VFrzdTV+Nj7dSf3/fjBPolTs7OzcbW4CXo8
fPj3fzBn7AR0x7Bq6DVaokfk1vP7/bzyj1f404tPo7AFyJwrcMn1Zoz2vpMrYwp0V3WyZcuWY5KA
Wq0mOS6J3e/sJK4guQ8BHITObiRhUjYVy/ajPV/LNTdcz6fvfsBtIwaXQCUiiScl5FksFqO5vonz
ps3tc297+XamnTetjwSSmppKQNzWp7wEuD0efPIYqlQroW4fgkxAqVcTjITweLpxuffhHCdnzvSJ
6LS9iVulkhGO9N2SatQaNGoNVnMcgXCQ9vb2E0YCw9UJuIEIoBMEQQHogIb+CqampvLrZ/7EG0UN
rN5T3uueVqVkdqaDzz75uNf1UChEZUsFSZkJmOPM2FNtVDUOLp/8nv1FKJKHlhvwIBTZJor2FSGT
yUhOTqagoICJEyeSnp5+3CKX3W7n4Yd+RuGoSXR2tWFPVjJlTg7nXjCOCVNzsNr1FBeV8+E7qwl0
KfjR3Q/0mzk5MTGRkl2lJMpVZJmtxyQAgEAoiN5oRJIk3njjDcZMLODlFb9hxmOw5HkrY5bE9UsA
AN1NYVqLosyfP7/f+0diVuFMKlZX4Jx4bO20c2Iafl8Yt9vNvfffz84uF/We7gHbFyWJik4Xo0eP
HrDsUCFJEkh905KX1ZXSpepkZj/BSlNTUwlLbUSivZWbjU1N1LS34cjMwJGSTFxyAuZUI6ZUM/HZ
DlIL05Hb/Yi6EJFo38SnKo1iQFOhWqkiEhyaOfFYGBYJSJLUAfwBqAUagS5Jko6qlkxLS+OJZ5/n
gwoXH20r6mUVmFmQyfrlvePmeb1elAbZIdbX6rQEov4eEWwA1NbXIbf32OUlevy6Y7EYsVhsQGuE
FIihP4mhtCwWC5dcfAkPPfBTbMYMirbXseyjzaz8dBule1qYNHY2jz3631x//Y39hroOh8O8+vL/
kao2kGq10NHpOubzJEmiwdNNcnoaF1+xiP9+/j7OfULN/F9ZcY48tu9CJCCy6tfd3HX73VgsAzs7
pSSloBA0KPXH9p0QBBnGdDvllRWYzWZ+/OADvFNddsw6AOWdLuLibScl+apCocAcb6al47DSsbqp
mp2tO7jxjhv6tfsrFAoKJ2ZT1XhYGgiHI9S1tGBLSUZ+KCJQFJ1Bi86oQ2vQ4fW3ILPWkz1jPLur
+g84eaxxKkkSvlAAte7EBSgd7nYgG7gXyAC6gbcFQbhWkqTXjyz3+OOPH/r3nDlzePKPf+bJX/6c
/Z9u4OZZ47EZ9TgsBjo7Xb0OxoTDYWTKb5jfDvx0u914PB40Gg0Wi6XPCp2VkUlTUwNCvgnpwMGO
g3VjkRhyufyoq3q03ktu9tByGA4HRqORBQuGfo7inbfeoq2klDGZOfiCnbhc7ccsX9PcREvQx213
38joK1Vc8vN45N/8rv3A3xnl80c7OWfcJfzkgaP76x8Jj8dDcloa/nYfBufRlaYRfxhnVhpfF+/m
aq7itjvu4OW//o1lNRXMS8/ut44kSXzRUM1N3799UH0ZDs65YA7L/rmcNFM6ncEOAroAN9594zF9
Eq66ZgmPPfhHHJ5sLEYnrW2tKIyGQwRwqP8H/i+KMSqaP+W82yeSnJ3M1pplNLY0kZRwOMx50B9F
Zzk6QQeCAbzKEOnp6cRiPeN5zZo1rFmzZtjvPtwN1iTgK0mSXACCILwHTAeOSgIH8btn/8Sbb/yT
n771OuMT40iz6FEq1cRisX73e6IksmnjJl594VVq99cSDPnRGdSEglHEqMDYsWM4b/ZCrr32Okwm
EwSjBDY1ozrHiUwp6xV4RpIJxKKxo5KAWOOlMP/Enaw7kWhsbGTDshXMzh1JaVSiqraTru4uRElE
JvQV6Nq7Ovl452bK2ou54Gkr9pzBrRzla9189Uc/t173A372yODjJzQ0NpKWm0lnY5BYXAy5uv9v
HGgPkF8wgrrPdtPW1obdbmfpp58w/5xzEZFYkN6XhJdW7adTr+Gmm28eVF+Gg4kTJ2IymairraPQ
PooRI0YMqIS02+3cevcS/vLMK4xIvJzWzgB6Z29/DJlciRjzE4kE2Ve1lNQJcrJGZiEIAsljRrJh
+y4ui++JpCxJEl53GFNK/yQajUUpaaxg9Jyxh6QTURSZM2cOc+bMOVTul7/85ZDefbgkUAI8JgiC
FggC5wNbBvVAhYJrr7+BufMXsG3bNop27uCnT9zTiwAMBgPh1iiiJPLcc0+zadsqcnKVzLs9CeMR
Pup+T5Sa4kY+3fhH/vcvz5CekktLVwWUtCN1hpDZ+hn4RxnUYiCKuKyZaz77bub3W71iJQ6Njkg0
SpzVSsn+KEqlAq/X2yesdbfXy9JtX1HWXszFf4rHnDSwWc3nirL+OTeRGgv/+n9vMG3a0I7h1jTW
Ep/sxG5Usr+8FEuBFUHe+1tHAxGkdpGksUm47DW0tLRgt9tJT0/ni9WruHzxErbv3MQ0q4OJCUm4
QyHWNlSzT4rwxepVPSR/EpGbm0tubu6h3wdjSxzchiqVyj4KwkmTJqF5RMPLf3mHoqooY2xXolTZ
EQ6Eig+Fu2ht3YlbvpWx85OZtuDcQ+M3IyebjspK9taUkJOUiccdwKKJR/kN87EkSXR0d1LVWU/2
lBHk5OX1uX88rtTDIgFJknYJgvAPYBs9JsIdwF+G0obD4eCCCy7gggsu6HPPaDRiUsSxbuV6vtq6
knMutpKRZUSt7b266IwKRpxlZcRZVvZsbuLVx9fw5OvXs/z9vXzx5C70T57VayCKMemorqqhV8pZ
cO48xow59inCbwu1VVXEG81UdTUSiUVwdbuxmo14PJ5eJNDY3kZRWyOV7TXMecQ8IAF42yLsestL
6Wchbr3pLh5+9ZFhJcQQJRGZTElKSgq+gI/6/Q0Y0o0o9T3PjwaiePa7GZMxGrVajdKopqOj41D9
9PR0vty8iWXLlvHGK6/w+tqV2G3xzF24kN8/+MBJ9Xj8JrxeLxWVldTUNxATRSSEnrVDklAplKQm
J5KUmIjNZkMQBHJyciickMHSz//Enrc/Ry5oSEnLRaYW0cYpsDjh4uvPJik9qddzZDIBZ3YWRrmS
Rn8Hu7aXUZgwmcbWph5vUVHEE/LhEf2YnHHMmH0uDoejl87gYFTj41FcD9veIknSU8BTw37yABid
X0hDbSPdZSFsceo+BPBNxKVIWBPVeLuDXHHrWezd0UDj3/ejuyUfZAJiVAJB6POxpKhI8LUKNJu8
vLjtf0/W6xw3goEADpWaLKORis4GYskaGto7aXW1k5yUTDgSYW9NJRGTnvMvXsLK4uWkTbQhSRKB
rhixqIRMJqDSyUCAuh1+KldEqNsc5porr+e1L+8jKSlp4I4cBRq1hq5ICBDIz8nH0mKmtLQMv9oH
AsgCAqNSR+Jw9ExmQSnvE6FJo9GwePFiFi9efNyr23DR2dnJuq82IVdrsdidfbao0UiEulYXZdV1
2C0mEp0J/Pa3f6aoyEtXVIlPaEA5OocOcT9atYpoZROWJh3ZYxP6kACAWqdDLoE1LoHZ8wpIcCTi
7nQjxmKolApy4rNwOp29TsceDGJyEAeJYLih9r6zgUYVCgWLFi6ipPheXn78ec6+wsyIKXHoTT2i
Uiwq4vOG8HT5aKr0su79FsxmC+Z4JZFImHt/eT5PPvQprQ9sRn1HAercuD4EEG3yEX66mEJLDm9t
XPGdTj45cuwYdi1bxYScfArsGTTo69jh2smurnJavvaDWsucBfO5+NJL8fv9BB6U+OLJZlTJCgSL
nKgo4WuP4imT6N4foiAxj+u+dxPXvXjdMROaDBZWcxzVviqgZ1A6nYnY7Q58Ph+iKGIwGHpNKJlS
fkwX7W+DAAD2lexHbTAddeuhUCqJs9rAaqO4qIhHH/0fgmEnJe3r0Tx6C87FcxE0KmJRPxq9BkGS
8H66lj//7Dnqqhq49kfX9GpPkMmoLqsjL9nJjOnTh+UReZAEhovvLAkcxP33PcSM6bN4/oVn+NPL
G9HHyVAZIKyIEAyGiIRAo1QTJ0uhuqGV157aiNmioa6ii+46H8n2BNp+XkTEqiGWrCPiVCILS8jK
fEQavNz3ox/z04cfPWEx3E8WLr70UtpaWli5YycmhQpRpaGtMUBI2UnhgnOZNGoSM8ZMR6vVUltX
y1U/uomicDG1ndVIXgmjwUjO6CRGXjaK9OR0vNUeZG1yqmqqKBxVeNzv77DZCRTv7XVNLpcfdTLF
AuEhZTbq6uqiqqqqJ9pwVtZJS41m0Ovo8LYBx9Y/eD0eXn/lfVpcGppkG7F+8DyyFCccVNIKcsRY
DIVSifGic9FMGM2H827GZrcyde4U5AoFni4PpTvLydYmMWP6OYMmAJlM1kdSOh5p4DtPAgBTp05l
6tQ3qaysZOmad4maQmz+6kvOMjoZmZBCnE7fkx3I1cb6PcXEGmJcmXcO+WcnsbG5mlLBx6R55xIO
h9m1axeiKJIwOoH09HRUKhV+v/9bzwc3ENRqNXffey9er5eqqioEQWDzdftIT07ntktuZX99KRtL
N6PcKWePZx/jb5jMNP3Rg2zYEx0EPH5W7FlLxfIqFs1ZeFzJMbOysvAtf3fQ5cMd/kFFAJIkibfe
fJMP3n6LhLg4vIEAOkscP3v88RPmMXckRhQU0NrWTktzE/FHSfAhSRKvv/Iv2lv1NMq2E//B8yjs
8YiS2LNf70eKUSY7sP79CV676VFsSSPQ6jUYzIkYLRJTx4wfkgRwcML3RwLDwWlBAgAdHR1sKdvI
lMWT0WjVNNVUkqt2YNUfnrxpNjvXzLHT3tlF3d4WulpU5IcVCM0eXnz4F9TqIxgLnMgtagKtftpe
q0cv0+Dz+bjlllu+xbcbPAwGA4WFPT7uV115DU1NjaSnppOYkEhldSV/+/DvjLhyNGq9Gperndra
OiLhMCazmezs7F5mL61RR/b0XOr21PDe8ve5bN6lw47Om5GRgSamwN3eiSl+4ANhgQ7PoEjg3Xff
YfVHH3LXxUsw6nVIksSabdv5w+9+x29///sTvm1QqVTMmTWT8vIKSisriSEgV6pQqzXI5XJEMcba
VavZu9tPtWsj5r//FIU9HjhiIkoC0JcMtFPGEpw3nZa6FhZedy0AXTV1w9qG9vfeBy0SQ8VpQQLh
cJh121fjGBmP5oCvdUpOFvV7qkkwWkCS6O7uxtXhwtXdQSAYJKSU+LChmrG2VCwjrdyaO4dPS4rY
3upC7tGiCSu45dIbWDz/QmbPnv0tv+Hw8NBDP6GxsSeLkEqlIhaJkTQ9DY1Ry0fvL8XraifNbkOj
UFJbXcmWDeuZOnMWed8wMaUWplMv1fDRqk+4dP7FwxIpBUFg5qRpbNtfzsgBSCDg9aOQ5APqIiKR
CO+9+Sa3XrAQo1536DlzJk3kuTffprGx8YTGSjwIpVLJiBEF5OXl0tXVhcvlwu3xEAyF6Xa7+XLl
bqyWKcgMlWinTjxUT0BAdiAPIkdRbCoXzmLTXz5g4XXX0tnWhlGElJSUPuUGQn/i/3ClgdOCBJqa
moiZo5ith/dpY8aP460tO7A21FFbVYUkExH0SmR6JQqLFllExOcP01jaSqKgw6A3cHviVDZ0NiCc
VcDPfv3L77weYCDI5fJeR4RLG8vQZ+n58L33yIozM3722b0Goqurm+Vr16DRqElL6+1+mzImnYrV
pVRVVZGd3b/n3kA4a+JkvnhpLbEpYw6kEO8f1btLOXvS1AFX8dbWVjRyOVZz7/25IAgYdDo8Hs+w
+jlYyOVybDZbrwhYv/rV73E6L6K8YT3Kq/uG0ZcJMqJiFEmKIetnfGnGFlBT8hSxWIzanbu5fMbw
oiKfSAno1CSeP040tjdgiO99KMhqszF90Tw+rd5LVBLRqnXoJQ3miAZb1EC61snE/JFkjM7j8sWX
sWjeBUyfMo0fz70EsbyeTZs2fUtvc3IgiiI17bXUNFRjUymZkJ/XZ6DYLGZmjR7JxnXr+m3DXpjA
2t3rhr23zM7OZnzGSEo3Hz36TyQcoXVXDfPO7Xti75tQKBRE+jnzEQqHaXe7j8uk2dXVNeQAJdXV
1axbV0Ja2izcwWYUyf1vZwShxxwr9fMdpXAEhVrF3lVrGJuYRH5+/rD6D4cVhL2fPXRyOC1IwONz
o9H03auOGTuWmVdeQoNdQ1pODpPGTWTMqDHk5xaQmppGSlIiEQ299mYKuZyFKSPYtHz1KXyDkw9B
EIiKMYqL9jA+9+greVJ8PCGfr99V1BRvpsvkoby8vJ+ag+vDDVdfh3tvI621fQNfSpLE3lVbmVl4
1qBEYIfDQUJyMpv3HLY6RGMxPlizjhmzZg/bg3DLli1cdcVdXHnpj3ju2cH7hvzrX0sxm+cgl6vw
+lpRJB7lXIEUQ6tRQyxGNBI5dHhNFCXCDc1oNGrOHzWaCxcsOK4VvT8dwL8tCZgNFoKB/lN/nTV1
CvOvu5LlHVVsr68gGjscelsQBORqGYFvnM/OjndSUVRMLHbsMN2nEwRBQCkoCHh9WAzHsHQIYNLr
8Xq9/d6Oy7PxdcXOYffDarVy320/pPzjbezftBvxwDcOBYLs+Hg9CQEd1151zQCtHOiqIHDfQz9h
a2U1r332BR+u/ZIX31uKKS2N2+68c1j9W7t2HQ/d+zRW5eXkJPyA999ZTXNz84D1fD4fq1ZtIzX1
YPgxCamf8SPx/8k77/i2yrP9f8/RXpZsyXuPeMTZe5BNICSEEVaAUKBllLdAodD5tkAHtFDKLhTK
aNmzZBAKBEjI3tt24tiO9x6yZG3pnN8fSpwYj9iOQ8L7uz4f/2HpjEdn3M/93OO6ZGQ5hEqlDnMA
qNQoBQE5GIRQCKmynjE5eUyZPHlIXHpRFE+rRgC+JzGBaEsMte2V0EswOTUtjWtvv4V1a77inaKd
jIqIIS8mCaWoQPLJ6L6lJNTgtGO0mAeda5Zlmebm5jC5pMVy1gpbvo24yDjko+D1+9Fqek45ybKM
o4+UqDHKRG17xWlV7OXl5fHXBx7htbf+zfrnV6Ax6Ql0eJk9cTrLll4/oHRYQkICz734Irt378bh
cHB1ejo5OTmDGpvdbufRh/9BYuRSIgzhpYSWUfz3v19w880/6HPfvXv3olZnolKFO/ziIvOp3VOA
ZlRXzgdJCqBSKzuVn0SFiKgQO7Myro/W8IMbhq4bUhCETo9gsPfre2EEbDYbvpIAwYxgr8wypogI
Fl9xOQ0NDezaso3XD+5EHxCJq9VRrKlFp1LjDwYpaK5hW0c9y+6/e1AXbfOWLaz+/Atc/gCyJBEV
YWLh/POZMGHCWTcGWfEZmFQWKurqyEnrue++uKoKs9WGwdgz8YpSpSQohvD3wp/fX1itVu6/+2c4
nU7sdjtWq7VPYZi+oNPpmD69OwHoQPGv194i5M4h4qRYgl6TyOGi8lPuu2HDDgyGEx2mw5LmUvGf
V5B/cMVJ911GlgJoNT3/TtfGXegrG1i8ePHp/IxuCLNSh/5vG4GIiAhyE/IpPXyItPy+SSViY2NZ
eNkluM+fx9ZPd2LJtPB1TT0+jweVRk3mBRP5/YUXDCo3u2vXLt5ZsYrMUWPJOJbeamtu5o0VqzhU
fITrr116xirZ+oMReSMYsTWfbUXbsFksWL8lkd3Y2sbOI2UsXLIEgT4eGEWYg3AoFH1NJtM5UYjV
2trKiv+sJTPmzi6fa9QRNDW29rJXGKFQiE2b9pKefoJhKSVlOpo9T9Px1nJMyy4Pb3fMC+gpK+Cv
qlUKqrMAACAASURBVKPj/sd4+fd/HFKy1OMegEKhGLQh+F4YAYCReSNp3txMeUEFSTmJfXLNhUIh
aosbWDz9MnKzc4dsDF99s56U3OGYTspvR9psmKOmsWvHVpI3bGD2Waw50Gg0XDp1MY5CF5/v2U9y
lJn4qChCkkRNcyv1TidzLrqI6OjeiTICvgDqoAqdrm/moe8bvvlmPSo5G5Wy6yytVGhw96ATcDJa
Wlrw+9VotScYlpRKDZfOe5Z3HrkeVU4GmgkjkeUAWm13D8t7qAz7tffx0P/8dEi9AFmWWbVqFXPn
zsVoNKJQKP7vFgtBOGc7Z9ocCg4VULh9P5GZFiJtFvx+H36fH1EUUWvUOFqdtJU7yIkeTs6wwadf
vo1gMEhlTQ1jsrvLp4miSEb+SD5d8yVTJk8+rfLb00V+Xj7ZRzLJuSiXmsYaapqbAIHUMWOYmZp2
yrG11beRGXfmavPPBmRZ5qP3PyPKOLfbd8GQD4MxbBjcbjft7e14vV7cjg48Djc+j5fK8gpCbW6a
yzaBqEBQqhHUOkS1njnjfsFXy36F+sYF2H5yHaL5hNcTbGzB+c4n+F/6kGd//yeuubpvrQqHw0FL
SwspKSn9qmFpaGjgw5UfkJmZ2Skz/3/aE4CwIRiVP4rEuEQOFO9nw9fbcIsBlFo1IU+IgMtPsjWB
86fP6VGW7HTPrVapCAYCqHpw5wxGEyGFipqamkEX2wwF1Go1l8+4lHc2vEfW9CxM48adeqdjkGUZ
x5E2hg+ffeYGeBZQWlpKTWUHOQndl5JeXzsRgsS65Z8TcvoxCVp0ohqNUoVBpUajikTpd5AjxmML
6AAZyScjOx1ItGMiEl/0LOyf7qHsrdU4bGaUeh2IIoHaRi5duIj7Pl5Jbm7fHml9fT1/fvlR/PoA
42PGcuM1Pzgls9HBgwdxeRyDjrUcx/fKCByH1WolJjKRieNjMUWYCYVCaDRatDodTkc7R+vqkRFI
TUkeshlNEATGjx5FUXkZ6b0sMUSFAp+v/9JaZwqxsbFcNfUKPtr0Mb5xfmxJth63q6mpYe+evRwp
LiXgD+Br8mAs1tExyUF2bhbJyckMGzaMuLi4sx70PB1s3bodNd0zCoGgG2fjASbE6RiuTsKQdOJl
8vp9HKkqo7y2nsKSoxxpK8cuFiATQpJCSHK4KhCvg1yrmnvvfI7a9iZqZDvZE/IRRZHs7Ox+x1VW
ffkJ6nE6UvOz2Lv2ALz3b25Zdkuf++zcux1R7L1Ts7/4XhoBj8dDQ6uDpKzuNzbCbMFgNFFZXYXX
V0JeTnYvRxk4Lpw/n52PP4EzNg6TuSsDrxQK4etwDqoO/DgCgQDNzc1D8tIlJiZy/ZxrWbn+E8pK
jhCVZ8MS27Wm/8Xn/4naZ8GojkJq6EBdqCNSSmbbf0r5Rt5HUOnG6W/BZDYwZfokZs+dybRp085p
3oWesHnjXiIM3RmjfIEOzP4Aw9OGY9CFDUBzeyv7ig9xsLQSsy6VaHMWM0dOQWraToR5HEpleDkl
SxJNLQX45Aoi4+CzLZu5ZNZsAq0S8fHxAxJNdTgc7K7Yy7Dz8sJLyznD2PnhHmYWF3fr8ziOQCBA
0eFC1CpNv9ig+8L30gg0NDahi4js9UVRKBQkpKRSU16GtryC9F7SZQOFzWbjR8uu45W33sEUl0Bi
WjpKpRKv201JwQEmjRk9KKssyzKbN2/h1ZffRakSeObZx4YkMm+1Wrnx0huoqKhg455NlCmLUSVo
0Rq1KJQKoiOsVO+qR+vUEd+RSqwxBcW3NO7DFNftFK6pZtsXL9AefJBJU8ZzxTWXM2vWrNN2Rc80
gsEgh4pKyLR1D8jpNFGUGxw0Kjooq63gcMVRisubiY/MY1relWjVJ4Kj2TlpHDpUhE6bSDDkIRBo
IC7WCMpM/LLMvoMHWV/wOHf88pYBq203NjaitKoQFWGvVRRFrBNjWLl2Ffdn39fjPjU1NTjcDtKS
0s+eDNnZhNvjRa3t++ETBIH4lDQOHy6kuakRlUZHIBhCALRaNTE2K5GRkQOWtRoxYgS/uPtO1nz1
NTs3rkNQKNEoFcydMpmLFiwY8G8JBAL84x+v8uUXO9FoBO6974dDYgCOQxRF0tPTSUtLo6amhoam
BppqmwkEA9w77U5WHF3OjqK9WDQ2hB7kxQVBwKi1YDwWGQ+GAtTtOcqfdj7N7xS/58YfXs+NN994
xklAB4uqqioE2YxS0f2aioICpSHIpCVz+HT1Whw1anKSpqFVamnxdKD0uFEgIiAQFWMlNeijubka
g1ZJTHwy3oCf0pYmLInxpGTP4/AhHW/9ZznpWZkD8gjtdjuCseuy1ZYWzZEdRVRVVfWoI1ldXY3L
5cJqiumkHh8svpdGIBAMIvZCaX0cHc4OjlZW43CFKKtpYsK4sZisEWEGWJ+Xw1XNeItKiI+OJGdY
1oCMQXx8PD9Ydj3XXnM1brcbg8EwaHmst99+l89WbyEpKZqrrrwMsynqtG9qTxAEgaSkpG4P5+J5
i9i9ezdP/+05tuz6iChFCgnGLMz6nuMISoWK5KhsksnG5XPw4Ytf8sa/3ubxpx9l5syZQzrmoUB1
dTVKoeeZ2etrwxSh5MjhcmIjRjN/8jRCIYlgIIDL5cLn94Wl4mUZkElPt5AhCCiVSpRKFfX1dTQY
lUQlpwCQpZhIaYuL5996h1uuuoKMjIx+jdHtdvNt3TxBEFCnaTlYdLBHI1BcUowsSqQnZNPU0Exc
wuCJWL+XRkAhigT6yIfW1zdQUdeMNS6J2HQz7a3NtLe3k5B4/AUwEx0TiyRJ1FVXsmXHbsaNyh8Q
3RWE+85Ph5+vvb2dGGsS9/70VnJzwsEku6ONlpZWYmKGnjWnN4wbN45/v/UqJSUlrF61mo/eX4Gn
MYBJjsOqSyTKEIdS0d1IGjQRjIidSaurnrtvv58nn3+UOXO6t9f2By6Xi8LCQrKzs/t1Tf1+P1u2
bKG8vJzy8nKOlhbT3m4nf+QYRo8ew5w5c7DZbLS3t0OoZ6+xpb2U3AmpVJa0MXviBQAoFCJ2ewf1
R+swWk3Ex8f3uC9AZGQUVFV3/u9wNBGdlEDssAxeev8DfnTFki4U5r1BFMUTCiUnISrNytYN27no
gu5CNSVHj2DUG4lLiCXgEXA6nYMuyvpeGgGtVo3L64MefnN7eztVDa0YLDbKyo5SV1uHz+fD1dbE
3j37GDFyBMOHD0ehVIY1B1PSaGsxsXt/AedNmfid5cf9fj8VR+vJzx3dxYvQanS4nB7of1xpyJCV
lcVP7/0pt99xO7t27WLH9p1sWLeZzYe/waC0oMGEKqTHoLGgV5tQiuFUqS/oRfao2Ltn76CNwPKP
l7Nj03Zik+O47/77eq2qc7vdPP30Uzz95N8wqENYjTIGlReTVkKthM0r1rDqXT0313kZmZ/PgkWX
gdRzibQnVEhMTBYpkaOOteVCfW0d7bXtyDJEx/Z9EywWC8pQiIDPByLU2wuZev48dEYjwvjJvPLR
f/jJ9df1KQsP4clE6KGXLSLGzGFvAc3NzdhsJzyzUChEbV01eo2BlPRENEotbU3hVOFgPMjvpRGI
slioO1oLdJ0tZRlKj1ZytLqZpuYiDAYzRqONyCgNbqMVp72BfXuK2L//IBcumI/NFt4/0mrF3tpE
dXU1KSkp38lvaGlpRSXquy0jZFlGPAvpuAMHDvDyv19l0/bNYS1ItYpAIIgtysoNt1zH8Nw8gsEg
R8vKKT5UQnVVSbizU4CYlGjuuegWLrvsskGd2+v1smPrdpZcdCkbd2zmyzVrWLhoUbft9u/fz8UL
L8Sm62DJOB/xkccNtgCc/PB7CYZkDlTs57E/F5MS9UOSY/2oTmok8/jaUOlayMxYAE4Vsgy11TX4
mr0oFUqsSVb0+r6rJkVRIDMlhcK6ahqcxSSOSEZ3zJuMiIwiOHIcr73/Iffc+qM+YyZKpRI52LNn
q0xUU1ZW1sUINDU14fa6iLXFk5KWRH1VK2qlnnZ7O1HWgWduvpdGICIigqCvpFvnVG1tDV+u24gx
KpHE1CwUKiWiECZe0KuicLY1kBabSDAQYOXyT7j2+qWd5bFxiSmUlx787oxAUzsWY/d1nN/vx2b9
7kp2165dywuvvcjRhipGL53Odff+DKMtotMjqi+uZven23nviQ9JtMbzx9/+nnt/ds+QjqG5uRm9
Vo9Wq2XCqHGs+eprLlywoMustmnTJi5edCHzh/sZmSpyqi54pUJgbIaCFgeUV7Xy+WefMW3adKKO
Re4bW/ew6Jo5DMtN4+tVhSgkLcG2IEpRiWAWsfWTxNRo0lDw+XJSZo0ge/zYLt9Fxcbisrfy3n8+
5oc3LOt1llar1Qi9aO1qo7WU15YziUmdn7W0tOD2uhmZPwqNRoPWqACfiNPeQYQ52K9xn4zvZW2o
UqnEZNDicbs7P3O73fz79bdQaC1kZOeiM+hRq9UoVUpUahUarQZjdDR2lwODwYTJFMWWzVs699do
tfj8p1Y9HgoEAgFkqbsUNkAg6MVgOPNpN1mWeeqZp/jlX39H4tJR3LL8f5mybB4RMZYu44rLTuL8
e5Zw+6cPknnzJG666xbe/+D9IR2Ly+VCeywjYjFb0CjUHDlyQqm4rq6OJZcv5uLRvmMGoP8w6kJY
9H5iTUE2bdpIh9NJSArgkfazcOF88vPz0UV2sHnzqrCCtUEiMSWpN7U6IMziVFlTwoZdy6lo3cgP
frQAjULqMWWdnJNHaXsHO3ft6vV4FosFqaNnTgCjLYLS2rIun7W2tiIjMyp/NABWWxTeYAdKQYvT
MXDKtXPWEzhVhDwh2kZZQyt6Q3i9999PP0OrM2ONsSH0sq7X6IyEPA7cAR9JiWkcLNjFiBENxMTG
4vP5UKsHli4cLEKhEEIP9tftdmEwqb6T3Ptfn3icVdu/4PrX7sEQdeqAkqhQkD9/PHHZSfz1zqcR
RZErr7hySMbi8/lQiCfudWpiKju2be8stX3gt78hN8ZDdsLA17smXZCA3EGUPsy8tHnzRnJG6Zkx
N5+MjAwqKioYFpWOOlvBhpJ3yBs2CbnKi8loQalQolAoEUQRt9uJw9lGu6uRdncdyelRLL56cmd5
etUrr1J7tJSE9O4l4ymjRrN63XpGjhjR472Niooi1N7zDG6INFDZUtrF621tbcWgNXZSkymVSiw2
I20NbhxtAyfKOec8gUf+/AhJqYlYosxMmjaRd999t8ftYmNjkb0d+Hw+qiqrOHq0mpz8Uch+D15v
z11hWr0Bl8cdNhIyWMxWqmtqAGioriStF864oYZKpUKiK3ee3+/HE3CQlNJ7NHqosH79ej78cgVX
/f2OfhmAk2FNjeWKZ2/j4acepbi4eEjGEwgEuhj89ORUCg4WAOGlwnvvvcfUYYNjz7EYIUiYJMVi
gFCwhfKGFdzxPz/EbrdzeNshdKKWzAkZPPzEr5l1cTbamAYaPDspb9vI4dovKaj4jNbAPqLSO5h+
YTq33nkVS6+/olMERRRFrl1yOe6yEpz2tm5j0JsikKOiWdsLt6PBYMCg1ON1dn9ulWolQUUQl8vV
+ZnL7cJqjiYy8kQFqNlsRhehIBj4nrMNHzx4kKeff5JRVyWgMyfSUuHk3l/fTZu9jTt+fEeXbRUK
BRmpiZTV17N79z4S4lNRKBVEWSJpa6wjJjG1W1+3QqFEkiHg96MwmjAYImhuasbe1kbIYycp6dTp
nKGAQqHAFh1Ba2Mrer0Bv99PQHKRkZU0pIVCPcHn8/G/f/wd8x68Er2556j5qWBLi2Py/1zAHx79
E2++8vppj0mn03Uq/wKYjCY8Lg8ul4v169eTFqfBoO273bc3xEcK6PW1dPgbUAgqQqovaGx2EB0d
zdr/rsXX7oNcM1OmTEWlUjF8+HCGD+/eKXoqWK1WbrjsEl7+zwqyZsxCo+0a10kZns/Kjz+guKiI
fXv3o9GoiYuPQ6c3kZ8/CtmrpGhvMUk5iZgtEV2yI6I63JNyPIU9Z/YcLrzgQr6NmNhodPqBLwfO
KU/A6/UiyzJKXZieKTojgtyLY/nzow/3uH18XBwqyUdZ6VHiYuMJev0YTRHoVAIN1Ufx+brzEgYD
QdSiAoWoQKlUUl1VSVNlMWNHDv9OKcjj4mOJSTSCwoMlWkVOXjoGw+BeyoHg66+/RptiJnNy3qk3
7gNjL5vOocojHDx48NQbnwJmsxn3Sd6bIAhYIszU1dVRUlJCpLZnfsn+QBQEpuZ24BJWYpc/ZNGk
GkQhwJ49e/D7/GRNG8bk8yYPuHK0J+Tk5HDpzOmUbN6A76Tf43a7ePPNN1m5bgNvvvYO7bUujhbV
8dXnu1i5fD33//whakpaCbUKBCQFtXXNNDQ0EgyGlwiCUuhiJOOPKSJ/G4IgDKpy85zwBCRJwh/w
M3zkcK675jree+9dokfo0Js1NJV0kJuXTzDYnVpMFEWiI824WxtRq1XIgNvZQWSkFZ3HTXN1GaJK
i9ZgRqVRIwVlAi4PAjJ11eWUFR8k2qpm2sSxZ3wG/jZEUSQmJpoB9JkMCT765GPyLplw2sdRKBVk
LxzL12u/ZsSIEad1LIvFgtvr7vKZSW+irq5uSOo2EqJErpvlOrauVpBsU1BcXMzSpUuH3PCfN306
okLBx99sIGPKdFrtbbz5xluYDZGMmzALRUU5NnMCKQYbWk3YW3B7Xewq2Ep5SRHLJv+ICHMUXo+b
+vom4uOiERRCp0E4EzjrnkAwGMQb8IIi/GD95dHHePWFfzMxbi6GpkSunX8zr77yGgEpgMfr6cac
4na7SbJF01pfhU6rxazREXC5EYIS0RYrBqWIt6WOtsoy3PWVBB1N+FtrsajAolMyZ9Z537kBOJso
OFRIypisITlWyrgstuzedtrH0ev1CKKA96Q2bINOT0tLC3FxcTj9Q3N/jgfWVKIcDkaeIc9v2pQp
XD1vNvs/X82Lzz5HYnQK6UmZKJQq7B0uDMboTgMAoNcamDF+HoZABJ99/CmSJKHV6REVGhqampFF
uYsnMNQ4q55AMBjEF/ShVJ0YhiAIzJ07l7lzu7PAyKKM1+dFq9GeuKGqMBVWQqSFurpKrPEp2CxR
yJJMMBQEgwmFLQ5RIeKwt6CLMpIYH5auOli487Raf79v8Hg8tNntmOOHphXYkmBlaz/ouk8FQRBI
TEqkpbW5896YjEZampuZf8EF3FnvJyTJKMShKaLyhYQBl4gPFBMnTOChBx7E1NSKFNlEuyTjbG9D
pzagUffM7jQ6eSLbyzexY8cOJk+ejFanp6MjSEeb64zSvZ01TyAUCuEP+bsYgFNBEAQEpYDX5+30
CCIjI3F7Xdis0cRbImiuKaPD2Y4gCqhUKlQqJaJCJBgI4GlvJSoy/ALU1lZjNhsH1Pd9piBJEn6/
/9QbDgEEYegkrESF4rQ5748jJS2V5taWzv+NBhOtLa2kpKSQn5/PgYqhOU9IkqloCDBx4sQhOV5v
KCgooLCgiEunLiRbZcBYV4+qrp7c1N6XTonWVKKaLRQdLMTv8wMyGo2O9npHZ/A0EAjg9/spKCjo
kjE4HZw1T8Af8CMqT22Dmpua+eqrr9i0bSP7C/ZTU12Dx+Ml4A2gUWtISU/BoDKSnzuO6OhYDAYj
tfV1NNhbUOkMqNQaQoEAvg47iTYrOq0u3GNevI+bfnjdOcGl19jUjNsbxGTQYLNGnTEWH61Wi1Kh
xN3uGnRm4GS0VjeReBpSYCcjJSWF9UVHO/9XqZT4fGHD+KdHHmPplYvJTQqgVZ3etSmolBiWnU16
evppHedU2L59O6kJGWg0GuKjEzCbLERZktD1QER6HFqtnlR1Jvbm3VRWVpCRkUHA5cOgNIEMSkX4
dZUkifFjxyPLMr/65S+5/5c/Py1G57PyBkiSBGLvM5IkSXy6ejWLLlvImMmjeehfD/CVcw2uyQ7i
breR+ctU8h7KIv3nSQRmeiiRivnZ/96GJEnotDoy0zLIiIslWqtEG3ATqZQZlpxCVKSVUCjErt1b
GDt+RK+sLd81PL4A5igbbr9Mm91+xs4jCAJjRo2hcs/gZMa+jbrCCvJ7IF4dDHJzc6lrqutUhQoE
gmiOCajMmTOHy69YyopdakLSwNl0j8Ptk1lfrOFPjzw2JGPuC9XV1WhVJ9x+j9eLRnXqIrC02GyU
h0UqC8oRRZHmg/VMzJ5GY2Nz5zaiKLJnzx4MWj2P/eUxbFE2vlzz5aCYhuE0jIAgCBZBED4UBKFI
EIRCQRCm9HffUChEb7T3TY1NXLR4AXc9dCc16VVk/SqdhKWxxJ0XQ0SmCbVZjVKrQFSLiFoRU4aR
uAuicbS3U3ykqPM4BoMRa5SNxPhEoqNj0Wq1eLweNm/5mtT0WC699JLB/vQzBoPRhN3pxesdfErs
VJh33myK13SVGfO5vDib7DSXN1C7v5KKrSUc3XKE8q0l1OyrwNFo75QTOw5ZlilevYdFCxYOybgi
IyNJTkuhsqYKgEDAj0Zz4iV67vl/kJA5no93qHB6Bv6we/0y/9mp5oYbb2H+/FOLoZ4uqiqrMBpO
pOu8/iBqdd8BTlmW0ai1ZBjy8W5yUrG+BHWVkulTZ9Pu6Cobl5uXS11TPX96+E+IgsjiRYtZt3bd
oJZnp+MJPA18KstyHjAKKDrF9p0ISaEe3fBgIMC1P1hKpbGC1DuSsI6ORKHueYjHpZfaCu1Uv1bP
o488iqOjnl27t+DxdE03BQIBSkqL2bz1K2bPm8p1119LfX0969dvYMOGjbS29i0+caahVikJBoMI
goDeGEFTy5nzBq5YcgVVm4up2ldKQ3ENpRsOU7uzhvYjHQQbQYOJyMh4bNZEoqIS0AoR2A+103C4
tstxCr/cTZQqgjFjxgzZ2KZOn8qR8rCX4nK7iYw6URGnVCpZvvJTLlhyGy99rWB7iYQUksN9+Kew
CbWtEv/aoGLuwqX85bHHh2y8fSEmNgaX58SLKyMjCH2/brIsIQoKRFHB/AmLuSzpCm694i6MRhP+
QPcUoVqt5mc/v4/G5kb+9e/XSE1JoeZYBexAMKiYgCAIZmCGLMs3hgcvB4H2/u4vy3KPCjgdHS72
7z9A9i8yOrXceoKv1Ufr/nb8BX4isPDG828wf/58PB4Pa9euY/03XyAIis4orMfrIn9EHrf/+GYS
ExP59NPPKCo8ilZrQpYl9u4t4KabrjtrSjkatQrfsToIlUqF1y3g8XiGPCLs9/tpbW1j8ZzFfPXQ
Si781bXExCaj7KNnQqVWIQgCTucJd9TV6uSbvy7n1SdfGtL4xfjx41nx8Qqqa6upbaxj1riu3AR6
vZ6/Pv4EN970Q3548w28vO4wI5P8ZMWJWE0C4rFnJhiScbihySGxr0ZPQ7vI4397ih/ceGOf53c6
nezbt4+2tjbUajXDhw8nKSlpUL/xvPPO49OVn/V7++PvhCAIeANe0lLTGTU6TBcfCoWQ+1gGGY1G
rrzqKt56/x2+2DFwte3BBgbTgSZBEF4DRgO7gJ/Ksuzue7cweruolkgLP7vnZ7zw9+fRZ+ohMgRK
ATkoIQQVYBfw1nkRgyILFyzk8r8s4fw553dWe+l0OhYuvIgFCy6ko6ODjo4OAoEACQkJqFSqY4ot
n1JypIbU1OzOcdTWVnLwYAFTp/Z7RTOkMOh1uFo74JgwiEZnoK3dOWRGIBAIUF5eQU1VPVqtkWXX
/YjmNhcHlm9j+i198yKGAkHamhuJHxsOALpanXx494vcuOT6IfUCIKygdOvtt/LsU8+iUikZP358
j9uNGDGCbdt3s3z5clYu/4iPv1xDc0sb0ZE63N4gTpePaFskqSnJ3P2rH7Ns2bI+r6UkSTz97LM8
8+KL6FOT0URFIfn9tBQeQi0InDd1Kj9ctoyZM2f22yDMmTMHu6OV5rYmbJHRiIKAJEmnqE0QcPlc
NLbWM3HCieyFJEkolH3XNKxcvZL1tbsw5g+ckUoYTDBBEIQJwBZgmizLOwRBeApwyLL8wEnbyL0d
2+f3IYu9q6jW1taydcsWSstK8fp86LU6dHo9aamp5OblkZaWFhZhDIbQKDX9LvooLi5mxfI1pKV1
VSZqa2shPsHE4sVDs74dKGRZpqK6DqPZ2nlNHPYWkuOjB81deBzNzc0UFhSj1ZiItsV0Xiuvz8eT
zzxFlbueGT9ZhN7SPW/ubu/A3tZE1DArloQoKveU8MUf32Pp/CXcc/c9ZyyL0dzcjEajGZBn1tHR
QVlZGZGRkSQkJAyoEOjdd9/ld/94gbEP/x5L5gleQFmWcdXVU7thI9Uf/IdYjZZHHniAWf2Umnvr
rbf4/QN/4Ir51+F0u1CoI7sUCZ0MWQ4vbbYd2My0mZO45dYTmgPt7Xb06iA5uT0XeVVXVfGHVx4n
dfFIqtYe4qVfPoEsy/2+OYM1AnHAFlmW04/9fx7wK1mWLz5pG/nBBx/s3Gf27NnMnj0bCLulkthz
//VAIIUk1Ap1v2/466+/TSioxWjsWl9dX1/LqNFpzJp19ogyW9vacPmFzlZTl8uFRX96whLV1TUc
KS4nIS4Zna57ZFqSJT786ENW/HcVsSNSSJ2Wi0qjZN/ydbQ3NoJOYtiFE9GZDRR+vB1VB9x9251c
eumlgx7TuYilN91E83mTybi4O5vRcciSRNXadRQ+9gQ3LrmC3/361/0SFv35z3/O2i++YdaE83EF
RMymnglcg6EQu4u2IQkBXnjhBTTaE0HE+vpqcocl9Kr3cM8vfsa28r2o9RpC1S42r904ICMwqGlG
luV6QRCqBEHIlmW5GDgfKPj2dg899FCP+ysUCoLB4CldnH6Mo9+GxOVy0dTYSnJyd31Cv99Naup3
wyjUGyJMJtprG+GYEVCr1XS4XYM2Ak6nkyOHj5KSnNlrc4woiFx95dUsumgRW7ZuZeUHK9mzfR3z
Z4eYPkbGH5DY8vYBDpeJXH759Tzy6mPfSZPTUEOWZdasWYNCoWDevHndvh+dl8eKsvI+jyGIEDT3
WgAAIABJREFUIinz5hIzdiwfP/AHNl9+GSvee/+UlYePPPIItzffzsq1H5KVOobhuWaUYtf70dre
wq7CbWTnDePXv/pVFwMgSRJS0Nsr+WpraysefYhLfr2Msi8PcOtPrmXKlIEtawflCQAIgjAaeBlQ
A6XAzbIst5/0fa/LAQCP14OoOr0yBSkQrgvoC83NzXg84Y6ujz5cTWJiV5fK6XQgSQ5uunnZabve
p4um5ha8IQV6vR5ZlnHam0lPSRzUsWprazlaVk9yYu/Gzevz0uF04vZ2EAj42L9/F9s3PsM9t0Uj
yzIKUUShVNLU7Oet/7TS1J7I08+8TFbW0PQefFf4ZNUqXv3dHwgi8/Nnn2TGjBldvt+9ezeX//Bm
5rz/Fup+GF1Zltnzx0dIb+/g/Tff7NdEtGbNGn7z69/R1h4iKjIGnUaHIIi0OZoRFCLXLL2aq666
ilAwiEJUdB6zpaUZixGGZfd8zfft3ceLm95GNKhI99i457a7UKlVZ3450K8Dn8IIBINBAlKgU3Vl
oJAlGaWg7PXFbWpqYt26b/B0eDDojdQ31lFQUMx5My7snBk9HjeNjZUsvfayc6KHIBQKUVXbgM5o
QalU4rC3kJoYO6iqRp/Px969B/C4/WjUOkRBgYyMJIUIBv0Eg350ei1WWyRWaxQWi4VVq1bx2fLf
8JObTwSXnB1ByirdVDYoKCj2sKcgxLTz5jFq5GgyUpLISEsjKyurX67x2YDb7WbJ7Hn8JnYYdr+P
N3Dw/mefdntxf/G/v2F1USFTnnocRT9+ixQIsP6mW3j0zru5/PLL+zUWv9/PZ59/jdMl43A4CYVC
DBs2jMzMzC7ZsGAggCiIeL0eOhyNjB83oldvbvfu3Tzx7vPkxmdxz613otVqUWvUZ345MBRQKpUE
fUFkSe4zHdgbpJCEohcBkvb2dj5ZuZrR+WNITwsHeoLBIP9ofoFNm9YxcuSYY+xDXq64ctE5YQAg
vEyKtUVS32RHbzLDAJY734ZGo2Hy5AmdWRJJCsdgjjdc6XS6bsYlNjaW6vpwUZDLHWTrXjdlTQZi
M0YTOzaepKkqznOH2LHXR6NCQZTOyBe79vDB6k+ZOHIE58+de84Zg40bN5IpqkkyRpAoy/iLj1JZ
WUlqaldpukd+/wdqbruVjT+6nfF/eRhjYt/l0KJKRdIVl7Pis8/6bQTUajVz55zH3n2HiIgcicHQ
81JCqVLhdDpoa65l7OjcPrkOxo4dy0OmX5GYlBimLh/Eu3RW/V+NWhPOFDAwQxAKhtCoNL2+IHv3
7CUzNbPTAEDY6Ny47CZeef0lEpPM2Gzp5OcPP+fks3Q6HbE2mcaWNkwG3WkHT41GY7875iZOnEir
XcWRsg62F0Jk9iTmzElHdVKTVxQQGy+xdlM51U0RnL9oMT6fj/2bN/HMiy9xxcWLznhd/kCw+eu1
jFWHswyCIDBMY6CgoKCbEVAqlbzx8iu88OKL/OWGm8m+639IX7wIsY8loiUrkwPvfDCg8RiNRkaP
yqGoqIR2ewuWSBt6/Yk4i8/rpbWlAY1KZuyYXEwmU2ch2fG/45BlGVmWSUlNod3RTlNtPe11LT2d
tk+c1e4ZQRDQqDUg0WcxxMkIBUOnzAgcLSsn7SQDcBwmk4mM9CxmzTqPqVOnnHMG4Dj0ej1pyYnY
BsEhfzpQKpUsuWIZz7/TQfyY88gfN6yLATgOtUpk7nQT1RX72bDhGzRaLRPnziN75mzeXLmKNV9+
9Z2Ouy8U7dlLtvnEdUxESXlZWY/biqLIT+64g+VvvElw+So+W3QZB195jfby8u48Fk1NHH7pFS65
sDvNV084eX+TycTEiWMYnpOEz91MTXUJtTVl1FSX4GivI2dYAhMmjMZisaBQKFCpVSiUCgRRCC/p
ZKlz4nR73Ozfvou6PcVEOAVGJw48XnPWmYWOG4JAIEAwEEQQhW5xAlmWw0ZCAo2qf3UBPc2gPp8P
f8B3Rnuzv+9Iy8yGPWOJiutb206lEpkz3cSa9duxWKIYOWoUCSmp2K65jnUff0hEhInJkyb1eYwz
jWAwSEN9PTE5aZ2fRag1NDQ29bh9Q0MDa9asYdUny7EaNegToyl79z0K//4PBIWC+LFj0FksBBwO
WgsPccM113D/vff2en6Hw0FlVRV7Du5Ho1Bx4fz5nVF+QRCwWq1YrdZwyvxYIZFSqezx2f22FwBh
IdND2/aSYowmMnHw8uRn3QjAMfFFtRqVrCIUChEMBrtYTlEUUSlUKNT9SymmZ6RRWnqE0aO6ikEc
LDxARmZ6j2usjo4OvF4vCqUCg95wzq1tvwuEQiGKSsu4+qbb2LxzLRfNUSEqel+OaDQiMybrWfPN
56SkpGC2WFBrNExfdAmff/ge6Wlp3wlfgyRJtLS00NjYiNPZjM/XgV4fRUeHF50sEJIljisUmVQa
DjU1d9lflmWWr1jOK6+8REychdFjMomynnipQqEQBQeL2bfnEDm2aK67825GjRoVpgoPhfD5vCgU
4SB1KBSiurqagsOHqKirwe33E2Myc960ab2m+QbzrHm9Xg5t30dmZAJG/emlbc8JI3AcQqfi6+kN
a9z4cXz80ceEQhKpKWkEQ0GKSw7j8nZw+ZLuUlmSJNHW3oZGqyHgD9Dh6sBoMBJpiezh6P930dTU
hMpoYtyECVTVVLCvsIKxI/uOJ5gjVORn+1m18kMuunAxHpcLr8eHNiqWV19/i2VLr0Kr1WI0GtFq
e2bUOR00NjayY8eXKFUtxEQriYnRoFYrcbtrqa4uJTPLy5bQYUyuCFLVVowqFc6T2rUlSeK5555j
7brPmT1nPEZT9xdKoVAwanQeecOHsfarrdTW1jJ16lQCAT/CsXJgj8dLZVUVBw4fwi0F8fp9WHQG
Zk2aSvawYUOefq46WoFVaThtAwDnmBE4Ferr61mz5it2bz1AXU0DE6eN5prrruwW3TeZTCy5cgkH
9h9g1/7tKJRKMrMyGDGi51SLKIqYDCY63B3oDWE5LFeHC5VSdcZpqM4lBAIBlCoVCALzL1jI6/96
CZvVQ3JC33X3NlOA/TvL2L5xFyNHj8FkimD4aBsbV35MQ6MLWXbi81UQYdKRlBTfhS//dFBQsJ+S
0rWMHxdJQkL3GJDfb8eeZ2K+1Uqt3U1x2VFq2yT8hhP6Eh988D7frP+Cuef3zjgsyzJSSEKWJSZP
HcV777/NJZcsxmAwYLfbOVhUyNHaWiRlWNRUg8CkUePIy809Ix6l2+2mpaKOkQndhU4Gg++NEfji
izU88ad/YJPGEGccQ542isLV+7ljzc948V9PEhcf3yXlZTQamTptKlOnTe3X8Y8HYRxOB7IQjrqG
QgNXc/k+w2Aw4OkIt7/q9XouW7KUjz54A7VKJDa6ey+8JElUlbWAbGDWjCx2H6xjinFmZyWoLSEJ
KSSTnBwuWGpvt3P4cAU6XQ1ZWadHsV5dXU3Z0a+5YH4aGk3PL68/EEApCChEgeQoA0mRerbFNrC3
vJa6ujqUSiVvvfUGM2eP7dEAHH8GJEkKL0lVSlQqI2aLnh07diAJUFZbg6jTolQpMSAyOj+frMzM
M7qcbG1tJUppGDJWrO+FEXj/3Q959cn/MD3hDiINJxR6rMZE9lWL/PXhp/jz439Ao9OeVkrNZDJh
NBrx+/1hgof/j1iIISyHpRUFHPY2IiyRxMXFsfjSa1i54l1mTKKbIWiosSMSgS02zIFvMrioqKwk
IyOcIlTrdF0IUsxmC2azBbu9jX37ixiel4XFMvCAlizL7Nv3DRMnRPdqACBspE5+GgRBINqsYcZM
A1u3fcDmzRUkJEX1uAQIBUOdvBcnZ0g8Hh9en5fXP3yfSTNmYNDpiNIbGZM/guTk5O9Eu8LV7kSv
Gbql1dkn2DsFioqK+OfT7zAn5c4uBuA4RibOp3hvA0eKiwkMAVmnIAhhpVft6RkUCBctbdy4kYaG
hl63kWWZlpaWM8omNBDkZw/jyIEDnf9HRESQlj6cz9e2crCwCafTSSDgJxAI4rRLRNosyMdYPRLi
FBwtO9y5bygQ6HGGtVgiiYtNpaCgtM9r0xtcLhfBUAsxMX0bEJVSybd9OXfQT3xiNNOn2zhy5HPi
4ro29BwnfZWRUamUKI5lqoLBEBWVtewqKKbVHyDg9zMyNZ1FM+dw2aKLSUtL+87Ea0KBAIoh5MY8
Jz2B5/7+LF+u/4q0xFT27zjM6IhlGDQ9R1ZFQcSqyObgwQJyc/M6XbfvAi6Xi7a2NrRaLVFRUZ3n
LS0t5ZFH/8aKlZ9gsGbQ0XyUObNn8vYbr3RxEzdu3Mjr/3yd+so6/KEAU2ZO4b5f3nfWyE0AZs+c
yTMvvUShxUJhQRGHCg+Ro7GRL8dRsKuRpvoOhg/34XF7kGUDfn8QQQCNRo3ZpKK00gGEZ1JnczPR
MT33t+v1epKTMygtPRoWkemnFDiEMzkm46nvsV6vxyt3pdtqCwZIjI/H7XIwcWIULa0VRFkjUatV
BINBJElGqVR0mQCCwSAFhaU4/H4MGjXRei0LZs1l9oyz03WqMxpxt7YxVGHrc9ITeOOdNyjxH2KP
uJ3Chr28vvN+1h5+HV+wZ86SCHUs5aU1iILwna3jGxoaaGluwaA34HG5cTrDGnB79uxhxpwL2VSd
wIhbN5H7g88Ze9c+dpZ6ueue+zpTnx9+8AHP/eE5Log/n8ev+StPLH0cVbWC22+6HfsZJBs9FXQ6
HY66en7/4ztQFjZwe+REFhiHMdOUwQ3mSegbo9m2OYizRSYYDCEolJxcR3Oci7Di8CHSEuIw9BG9
VqvVJCamUVJSge+Y8Igsy+zcuZOHfv975l1wAdl5eVx/ww1d9tNoNPj8py4u0xsMeKSuz4NDkLFZ
rXR0ODGbNWRlijTU1+E/JkuvUp0wAJIkEQiECIVksjJTmDQyl/Gj8hBl5WmrLp0OoqKtOAL94u/p
F85JI/D3p56neVcb5hQTy1ZeweLX5nDYupqH11zMppIPkb51Y0/F3TbUaG1txef1ER0djVarxWyx
YG9r4+jRo1x82dXEznmM1Fk/R2MM58gVKh2Zl7zAqi+2smLFCgoKCnjrH29z7wU/ZXT66HBNv0LF
1VOvZkREPv984Z/f6e85DlmWufcnd/PfV97lD/6RBLfup6ahuvN7JQJz9FlMCA2j6ICC/Qc8VFa1
4/XJuD0SJeUe4hOSqauopPloCVMnTT7lOTUaDQZjFFu3buPRRx9l/OTJ/PCOOyhsbmLy1VcSnZba
TX3HYDDgdkmnZNc1GY04AwE6rZQs0xLwYbPZ0Gg0BIMSyakRuFw1SFIIUQyn+4LBEIHACa9Aq9Vg
NBrQajXU1jagVGoZOXLkwC/wECEiIgKfQsbtGZxI67dxTi4HJkyYwKN/fIy7772Hhr1tTPnJWC56
ajaNh5rZ8PDrbP7mPa4f+wgJlrCKsMvXRlxiz2QNQw2fz0e7vb1LEYxKpSIYDPGj2+/EMu5OYoZ3
J6dQakzYJt3NK/9+h7G5OSwavpAoU/ey4IVjLuJ3Kx7klh/fMmSptP7iz398mM0ffMq78VdjVmoZ
43Xz2YZtbMgoZ9TwcUToIkCALK2NRHECa+uLKSgKYI1WIIWCxMQkE6k3UXVgH5cuuKhfy5qyo2W8
+fbbrFnzCcOnT2LxXT8hMSMDn8fDqpdeRhsM8co/uxpFtVqN2ZxKdXUzycm9LyOMRiMag452vw+z
Rkurz4PCoCMyMgqDwYDL5UWpFDAZBTxuL6IoIggCCoWixyWlJEkc2HuEX/zitwMOGsuyzMGDB/lk
9Wo2bdlNTW0do0fmMWXSOCZPnsyYMWP6HYMSBIFhY4ZTuu0AOQlpqFWnl4k4Jz0BgIbaFpbk/y/C
lgTevPhjij4pxjYsiiWvL2DET5N4fsst7Kn8AgC/4CAmJhpJls94PKC1tRWTydTtPFu3buHw0QYS
Jt7Sy55gzZrHpo0b2bVlF5Ozey6pNWgNpESmUFIyNNoA/UVZWRlPP/4EL8RcjFkZjjxblXqWqoYx
ttjFjv+u4puNn1FQUUS9vRFfwEecrMTZYmd0/ljy0rMQ7HYigl6WXLzwlAbs0OHD/OZ3v+W+X/6S
gMnI1ffex/lLryEpM5OS/Qd4/r6fk5+czCcrV/ZoTPLzJ3PgoP2Uy7/0nBwqOsI0F8UddvLHjT0W
w9AQFxtHS3MbEREKZDlsXFQqVY/PkCzL7Np5kJyc/AGTdhw5coSp0+cwY+5innr7MLvaptAcdRv/
LYznoefWMnXmheSOnsJ9v/0zq1b/t1/s1zabjcTR2Ryqr6ChpRmX201gkKKl56QnAFBZVkuCZQYT
0hdS2riHVc/+jZ0vFDDhf/LJuiADW46V5T9+hFBIpiVUTkzMxUiyhEpx5vKzXq8Xn9eLJbZrVFqW
ZR574u/ETvsFoqL3S6o2WBHVRhKM8Wh70aMDSDDGU3KkZEilsrxeL7W1tcTFxXVSmJ2M++/8Kbea
x5GoPhGAlWQJEBivT2SsnEBNXTuVVUeoVB3AK4S5CQo8RcwdP5oRObmkTRh/ytm/orKCV157jYOF
hYyeM5vrLr0EpVpNS2M9jrZWvnjzLSr27+fvTz7Zox7lccTHx2Mxj+LAgUOMGZPa63aTpk/j7b37
MHdoKAp5uW3qibqR+fMv5O133sDvM6HsY2IPBIJs37YPizmO3/72gX7P2MFgkL89+RR/evgxDLm3
E3PRPxDEExkEffwUZFlGN8JBw44H+eDjT7BrM1j+1d+ZPSGHyxb37U0lJiUSYY5g985dNJYcxChr
SLENnITmrBiBQC+po5PRWN9EgsaCJEnE6rO5fvhTVLTtY/Mzb/LNH98lZVISllwjnxU8Q07mcBwe
L9v37CUtOZH4+PgzwhJkt9sxGrvflPUb1tPYHmBkfph7T5blcI5ZELvPKoICcy+ZjuMwqo2dgcah
gNvt5t1nX8LmkFmnDjLu4nmMGT+u8/uioiJ2bt7Gk6nHvRgZSQon/o4/8KIgkKy2kKy2ME0OZ2Ba
Am6ebP6K6ZMmkJyc1ufLYbfbeenll9m0ZQujZs3g2p/fj/JYpsTv87Fvwzfs+OpTrlqyhLe++aZf
HZ4TJ05n7dpWdu8uZ+zY1B7Pn5yczLhZM1m3bTsLrlzShacvKSmRBRcu5IEH3yY2zoJer0N7ErWX
y+WhtKSC6qpGZsyYy1133tXv0udAIMDCiy9nT7Ed27x3UJt6ZngSBAGl2oRt2t9o2nAHLfXVTLro
DjYXbmLbn55h2eXnM2nSxF49XIVCQUxuImlTcqg9Wo3RMPBeje/UCEiSRHFJMTWN9UyfMKXXCyrL
Mk1NzUgxChocTcgI6HQ6hqfMID91Fh3eFoobttLmqsVja2PRlVPIGTUGv99PXWMDldW15AzLxGbr
X5xg586dlJaWctVVV/V6sUOhEG6Xm7i4uG7frVr9GRE5lyEc29fn9yMJMsgySlHRZc0mhQJolX0/
SB3+DuIs3WsiBovtGzeT49IwNT0Xp9fNJ+9/jkqjJv9YhHvdunXMNqSjEY9p3cldDcBxHA/EhXPU
AmscR5g1bToWi4bKyjKSkrrnymVZZv2G9Tzz3HOkjxnNtb+4H82xLs6g30/h9h3sXbeOpDgr/121
iry8vH7/Lo1Gw7x5l7Jx45ds3lzClCmpPebq51+0gPkX9UytrtdHc/XVd9FQ7+DLz7/EaNKjUIgE
AkG8ngDnn38B9/50IVlZWb0auZf/+Qob1m9m4cUXsHDhQoxGIzf/6Hb2lnqJmvFPBLHv1yx8XAFT
zi1sWP4npl5yK+lj5tLRNpIXV/6Xjdv3cuuNS3tsQOpwu1AbNGg0GixGM4kJ57gncPjIYSrb60Ho
m2m4paUFh9NJdaCcSL0NlVKB2+ulXZaJtNkwaKMYm3IR7Z5GNrc8z4JLLkYURbRaLUkpqXjcbgoO
lzDiWLtmX/D7/dx+/bWYfB4c9jZuvf3HPW7n8XhQq9U9jvvLtRuInPMscKzOXJYQjwl6BP1BhJM8
H1kO4fT3PcvXddQxO2lOn9sMBBV7C7ksJlxnbtLqWZg4guUffkpiUhIWi4WifQfIFaKOjU9Clns2
AAIcE/gQ6Aj5eMqxlXceXE529jAqKiqpqCghKSm9sxbC6XTyxFNPUXikmHk3XE98ahoQJs44uGUr
BZs2kZeTw6/vv5/MzATy8nIH/NtUKhWzZl3Itm0Gvlizh1EjLSR+K0js8fhoamqnpdFOY20LqJTM
mTeGxsZ2CgslLlm8lIiICG655Vaqqqrw+/0YDAZSUlJO2XYeCoX4+zP/IE49huf2v83zz/6TqedN
ZPWardjmvnNKAwDH1bQktDETsO8RKN27nqyxszBGRpM7+wYqirbxwF/+zl0/urobv6NKocTv9eP3
tBKpNQ/KA/7OjEB9fT3lLbVExVrxNDl7ra2ur6/nzdffJN5qQR3yYTuprNTn99PW3ERkdAxKlYKd
je9y8703IIgCd9x2MxkZmdz3i9+g0+tJSsvg4KFixo8e2WcT0JYtW0hXCjyUkcxNj/2FhRcvJjGx
uzV1uVw9ei4Oh4O6mmpS4ntOGYlqJQFfIFxPHwoQ9HXQ6mvrdTytHW1UOqp6Fd4YKCRJwmN3YIw8
8TCb9UZGtkaya9NW5i1aEK6PRz5GWNGzARCFrqnYZ9u2MnfhhUybNg2A1NQUtFoNZWWl6HRmQpLM
L371K+KGDePKu+9CqVbTXFdP8a7dFO/cycQJE/jbo48SYTLidrcxbFj3BqD+QhRFpk6dSV3dMPbt
28SBg6XEx4kISDjbnPhdHnRKAYfDCxo1yakx7NxZRXu7jRkzLu5cepjN5l7bfU++Fl6vF6/PhygK
qJQqcvNy8VUZSYnOo8lexXN/exXNsIsRFP3PIIiiiCRJqGOmUlu6n6yxYW0DQRBIHj6FNmsCj7zw
HjdfPpsZ503v3C8iIoJAWxClqBh0Nuk7yQ643W4OlBYRFWvF6XCQEpvY44zqcrl4+613yDRHc/H8
GVS59nT5XqNWo0Xk4O49vLfmrxyu3oK9vY133nydGkcd67d/w+qVywHQ6fVExcRxtKKyz7GVlZWR
o4Q4nYYFJg3vvvlmj9v5ff4eDVdlZSXGqCTEYwHJHgkhlCLBQBBn/UHS0jNxyS7qWut6PM+6gnXM
u2jukLXdhkIhRLoTUoyIS6Vy6z4cDgfTZs9kj9B0zN3vSl+FLCOKQhcDsLq9iI88h/nzE3/tcszY
2FgmTBiNQuHj1tv+H3dnHWhFmf//15w53ed2d9DdIYggoYKxWNiJuLq7io3rurqyBmKhGFhYgImi
II0gIR0XLre7+3TN74+DFw43uJTr9/f+784888xz58zzmU+/byY8LZmEHt3YuW4dS1+ez5qPPiYj
IoJX58/j3ntmIhN8CIKLvn17Bj1bv99PTk4Ov/32G8XFxV1m2w0LC6Nnz6EI3nh2bmrk8K9VlGY1
UJjbyK6seiodWqyecIqLTZhMo5k06epTaoonwu12U1ZVQU1LA3bJjdXnotbWxKhxI6iy5QTG2GQk
GS9GrCqgbudL+H1dT2UX8CMJcuoqCtqcs0QmkDj6ZhZ9t5XVa9a1HhdFkYiwcEJCzpzS/g/RBI7k
ZqMwqlAoFfjsHiIz2u9as237DtRuP0P69MPt8bB20wvk1e0mNTTgxKquqqKmppIi6y/INVauSX+U
JfO+4mD5FnpNHojWqGPpss+5ZOrlyGQyQkLDyMk6gPcYz197sFqt6Aiklk4JM/LE0iU88PDDbR6o
2+Nu15nZ3NyMKA8WDnJRxOfzIRyzTwVRxOv10Ji/gckXjmb4kIF8/vkX/HXCvShPuDarOIvtFTt4
a+5bXXyyp4ZCoUBQKnB7PSjlx9evlCvIxMjBffsZMWIEs5vup95oxyLXBswBAqr/yZyRnzXs5WXr
dn5Ys6pd/4hCoSAsLJSy0gLKygo5uCWSoYOHMuMvl5KZ2R1BJiDK3Iiii4yMhDaEGg6Hg//+Zx5F
+Y2Y9JHUN5cRFavnHw/OIiam/eaf9fX1lBQVUFteSKhOQd9ECz1ihlJWZ8UjUxMRm4TBYECj0QRy
B86gMMzpdFLVUItar23zLk254jKWLF5GXXMZ5eUViOp4YhVpVFZvo/bXpwgd+gSisvOSdMnvBcGL
UnSgcNRQnruXmLRgmjeNzkTq6Bl8uuoz/JLExePHnRMWqPMqBBoaGqiuriGvopjYlDhamlsI0Zna
LSG12+1s/2ULkwcOO9ZyTMkDM2/hn8+/TnXZUbAZKG84gl/eQq+UdJIt0xgUN40LU67jpyMf8NHq
OQyZfgHN9mYK8vNITUsPZOIplTidzg5NAq/Xi+zYi55u0CIUl3Dw4MGgjDCPx4Moa+twkiQJq7UF
ZCKOhiI8jkZEuRqVOQGvj1YhACAJ0JyzgssefIYLLriAw4eO8PwPL3DlgCvQqXRszd3G7srdPDPv
WSIjO2/tdbrQmY3YXM4gIQCQGhLF2t2HGDF6FDfefgv3fPI9i6IvxyiqOJk7fretjDetOynUOFn3
6y9kZGR0eL/o6Gjy8/JQq9VBjjqfz9eakNMRVq9eQ0OlluumPIhMJkOSJPYf3sjjjzzLvFeeaf1y
e71eSktLKcnLRua1ERNiICoxnOr6Zg4X1xESFU/GgP6Ehh6ndqusrMTtdp+2EPB6vVQ11KIx6Np1
PBqNRmY9eA/PPPQikicetTEQQYrSD6emeTe1W58mfMS/kCk6K532IMjkCI5ibrxuBtkFGymw1pPY
Z2yQs1ql0ZM2egafr/4MlULB2LFnX79wXoVAfkED2QXFCHojZcUt1FdVMLJP/8DXV6cLehkOHz5M
uFJDZNjxEEdibBwL5v6T9Vt/4aMPPuGywTfQO2owOqWeTXkBwiMJiYtSZlBlL2THlu8ITQpj1287
SE0LZBOeigTS7/UiHluHIAiM0ylZtWJFkBAIMB0FX2ez2Vi2bCnfffopvpIDNH5yBUaJJ28IAAAg
AElEQVSFApffT7HLiab7lYRd8AByTeCHb8zbgEpqYsyYMYiiyD+f/ic//fgTK5evxNpiZdgFw3j/
6g86pJo6G1hio6jLacaiCw5vhulNuAqOYLVamfvSCzzocjHy43e40JTGhYoEZAiUeprY5CulXO7k
gTkPc8utt3apR2N7gr4rVXYtzS2EmRJbX3xBEOjbYyxNtlqWL1/BjBnXUlhQQEneYUI0MlLCDNjs
fkpqm5GpDMQk9WBUbGy7G/3B++7n0KFDLP32m06F2MlobG5Coem8t+XIMaNJSPuQ3VXFxNL/2Npl
hOsGIll3ULv9OcKHP4XQTh6LJPlBEPDYK7HXHuLq6Vfj9XpZ/NnX7N/0BclDp6LSHP+IKTU6UkZc
w8fff0h8fCypqWfXXOS8+gRstjq8ComQsAhEuYaEiAzUmigKCxvIPlpIfX19a8ZXcUEBceFtY5x6
nY5wjZ6Lu41jXNolhOsjEGUiPv+xfPJjZuzl3e6jpqgKQZRxNDdQzup2u5F8vk7ta4VKhesEm7OP
Qc2+bb8GjQl8kY7dTpJYt24d0ydNZP87b3O/XsMX3dNY3LcfC3r24r3effi0bz8Glv1M+Vd34PN4
8fv9lG54hkdn39f6IgmCwJRLpvDa26/x/mfvc9fMu86LAACI65ZKqb2tM1IQBMJFLbW1tYiiyCtv
vsGB3CNcOOd21vf0saEPuK/tz/0L/kNWQQ73zJp13pu09u7Ti9yyX3E4bUHHQwzRHDqQxS+rf6Au
fy9hGrC7vWRXtOAzxdNv5ARGjbuYlJSUDr/0l1w+DXttIzdddTWHDrVhzWsXPp8Pu9t5Su1BEAT6
9u9Ni9hMkyMn6HiEbjDqxibq97yGJPlxNebSUrgSe9Vv+L1OkHwgCNgLvuPqv0xHo9Wg0+m4965b
uHpMKkUbF1GesyfIN6LWGQnvcykLP/6ytfjqTHFeNQGHrwmlyoPN2oKjyUHPbn3RaLRoNFo8Hg8V
VS1UVhYTGWmksbqGbiHt23ylxaVEaU/gEJDJ8UnHhIAASKBTmhiXfD0HS9ZRpikBoLa6ivjY6E7V
z9jYWHKF448h06AjKysriOdQFEUkyY/X6+XVeS+xddlS5iTGMTAiAplMxlGrDb/XgUwRyMQzKpQ8
nN6dm/ftwVOXR3P5QUxKJ3feeWfQvRsbG/no449Y9t1XVFdVIchk9O/Tj3vunMno0aPPWQp0UlIS
O/3Wdsus9cix2Y5vuKioKO655x7uueeec3Lv00Xv3r25aHJ/vvrpOYb0upLoyBSstkbWbV3EuNEJ
eNwufKZQ1NEJJEZFYTKZTmkXOxwOVq1aRUlJMQqTjr6qUP56yx28v/SzU3IkeDwe6AJLluSX0Ol0
qGMGU1NzBKXbhEYZ+KgJgoxI/XBKK9ZR89tzqMxZhPWTYyuXaDgUiSnzUQSFBlfxcu5c8EVgQiEg
QCZdPJ6+vXuyeOl3HN5wgLi+EzGEBMzF0JgUcvLDycrKon///h0t7ZQ4v9EBrUhKRixORwU6QRb0
FVEoFJhNIegNUZRVOKmpqMPv8eLztc1/Li8pI0x3vI+gx+9BFAL27YmOq/6RF+FqcFFdXYXDbsfW
1EhMdOdJN3FxcVR4j0vYUJUChc9LRcVx770gCJjMZj5c9B67vlzGgl7dGRAe3rqhzGYjXntwvrcE
uP1+vE2l1P7yFF99/lHreKfTyd8e/DvJGSnM/3ohjX1lGK5NQz89mV2yPK65awa9B/SluLjzyEZX
YTAYsHRPJre6rM05HXKs5zA78WwhCAI33TSDWf+YToV9Hd9t/De/Hnqb62+9jGvvvJ8Lp1zJqHEX
k9mtG2az+ZQCwO128+GHH1JYkM/wESN5/e2FFHhbuDKyGzNvupXKyspOr/f5fF0ixvF7fURGRqKg
GfOQByh3bMXtbaXmRCbIidaNxF24mthxGmIvSiDjxkSiRtTQnPc+1kOvM3RwH/r179dm7ujoaGbf
dxd3Tx2Edf8yjv6yhOrio7jsLShDEth78Mgp19cZzqsmoDcbkCSJcL2JXqkZNDRWIqHBoDe1qsWi
KGIxh6JUG5CLWgrzC0hKSQmyvzweD0rxuErf7GhEpzhWPXbC7xOpT8RptWO32yjOz6FPj26nVOPi
4uIocwarUxk6DUeOHAnyRhuNRr76+GNeTEvGotUGvXxhYWE0NeXjsdeh0AYcV9trK7HKtdSu+gfv
LXyFHj16UFlZSWl5KbfddTt1ChsZD49GFRpsO+vizESNTaV6Yz4XXDSGnVt/63LmY2cYdOEoNi74
lHQpLmjtAnQ5BPdHQRAEhg4dytChpy5FhoDfp7a2lqamJkwmEyEhIa0efKVSyd133x2kAa2fdBGl
O44w0ZjIPbfcxuIvO2YX7or33e12oxIVTJ8+nQdmP4a+z+Po+99J6Z73iNePQyEG5laIOqIUvSn+
KgtTeigKvZLoMbGU/LwGtcPPhyu3H7+fRJDwkclkDBs2lEGDBrJ//37W/7qbkh2rkFxuhl18TZee
U0c4r0JAo9FQVVpJn+RuREdHExHho7GxkaqqSiRBg05raK3aEuUKoqNjKS0rJT+3gKSUxNaQnMFg
xOY+LlVr7PWY1MfNg9+fm1JU4/V68Xo9JMfHdikGHBUVRYvXj83rQ3esQWaMTKKkpCRoXGlpKaLL
SWY7drtMJiMpKYG8vALcHhv7W+w8m5ONJj6ZBS/MJy4pgQ27tyCoZTzx9JM4MpVE90nA3eJC1CiQ
a4OdRYIgEDk2lZI6Bw8//gjvv7Ooaw+8E8TFxaHpFk9WcRE9o5Naj1vxEPp/uKPyoUOH+PSLz6it
r0Mmyo6R1EiMGDaCS6ZMISwsrI0J9PATj3PlpEuYGZFERVUTcx56hJcXvN6u+SWXy/F7O65U9Pv9
uO1OokMjUCqVXHnlFaw69CXmnnfjdzdTfPAL4nQXoFIE3hudKhFPYwPF3+eRel13vLYqJGcFXy5Z
TcgJjFMnmqMnr2fAgAEMGDCg03Gng/NqDtTX1hFvimrNwBNFkdDQUDIzE4iJUuFy1tDQUIXdbkNU
yHF73MTHJ6BS6MnNzsVmC3S+jYqLpMYW2JQen4eShjoi9CcUZAgCkiRR3HQEndGAXq/rMsWYKIqk
p6WR23K8U0u0TKKkIJiqKjIyEqcgI6ep6eQpAFAolIQnJvBRQy2vNNTw1Csvs3Tpx4ihauxaDwk9
k9l9cC9WpYvoyZno4sxo40w4qq1IPn+7c4aPTeb7H74/Z92Sxk2bwk7qqWgM8NV5fT6KfbZ24/3/
F7BlyxZefm0+foVAcmYqiWnJJGWkEJ+exI59v/Hkv/7Jhg0b8PuDn6/BYOA/81/ijcO/cGV6fyp2
HeTttxa2ew+lUolWrmrX+ebz+bA1Wwk3hbQmOz08++/Ysj+gcvs/aSn/GY9JTY5jOXm25dTa9uCV
qzF40qjdWEvZ6s2UfHeQ6Zde27ZiVKJLPqE/fZ6A1qckM71tKEYUAymOZrMZu91OQ0MLWpOW/OI8
kuNTCAsNQamAlvo6bM1NpKans2zrUgbHTiKnJhezshs6hemYx146lnstUdx4CGOUHkHilOmfJ6JH
//5kr19BX0sghBarVbE6NydojEaj4fHnn+fvjz7CNKOB/hYzeoWCRrebCruDHTY7e6w2rrjhBtbc
cQdZ+UdoEG0k9khBEAScTieLPvqAsEtTW384uVaJqJbjc/uQa9r+4OpQHQqzhm3btjFy5Mg2508X
ZrOZ8bdczaqPlpJSWInD4yJyeI/T6u/3Z0FdXR2LP/+UuNTENtEfURSJS0zA6XSyeMmnlJSWcMOM
G4I2zJAhQ7h25h289sEXPNBvPI+9/T49evVkzJgxbe5lMZmprq/F5rEhP9Z52OvxIvgkoixhQfeP
i4sjvc9ASkMy0HabjNyUhN/rxFmyHWfRAZqObkZ02lHbwqj7vpbHHnuKW2++LaDBHLOA/T4/Cnnn
VbbnEudVCAzqM6DTkmFBENDpdOh0Oi66eAxbf1hJiFmBz+/DYo5Ac6xldWRYCOsjLOwp30Rlk4JB
0RMChIyBWZCLIk6vlzVFnxA3IgoT7Sd1dISeAway/efvW/8OVympKi9vM+6SSy+lZ69efPnFF3yy
8zfsLVZMISFYMiIZOXgw9/YbgM1m58cNPxOSHEm43ojL5UKtVrNx40YU4Ro0UcEaiiCXdagJAKhC
tVRXV3f5fzkV4uPjue7BWRzYtx+jQt5aSfh/Dd98+y2iSuw0/KtWq0nOSGX9LxuJjIjk4osvDjp/
5913sXfnLlbk72d233H884GH+Gz5N62aa0tLCzqdDrlcTnR4JHa7HbfHgyRJqHU61Gp1m6/1hg0b
0HYby0VT/k5Obh6Njbl4XU6UodH4jaFoe1+MVJGNbccnKNx2hkwaR2FdBVpRhVmvD+RXSF3LqThX
OK9C4HQIGOLi4tBFRXCkqJD+J5STqjVq1Bo1k6dN4m9PPs01PV5FrTy5KYbAiqNv41bYUGlVdI8/
vWq0QYMG8YbVFehMJATiDSeny/6OpKQkZj/6KD6fj9raOqoqa/H7BWSiAp/Xz9HiAozxMSiUKmpq
mvH7PGi0Sg5lZSFGt42xS17/cadGO/BZ3ee0zZgkSTQ3NxMTFxvwZp+ir8OfER6Ph992/kZ8RtIp
x4qiSGJ6Ml98tZSIiAj69TvufZfJZDz7wn+ZccVVpNrDuSKqO7PvvZ8Pl3zGa6++xrPPPsuokaP4
5LNPsFgsgQ/WKe6n0+kQhQBnRa+ePYBjuQZ2O3K5nNKyMmq1ctTxz1K/42OefPw/PPPCHGQaFcVN
NZhtNmIjos6Jmt9V/GnaiwmCwIRLJtMgh+3799FisyJJEvVNjezPPkKJ08a1s27jjV2z2FTwJW5f
wEZz+1y8v/cxfipZQFR8GNbyJq6dfnre0vT0dAyR0RxsCvgg/HRua9ntdrKz86isbECvt2A2h2DQ
6ykqL0YRpsVkNqJUqtBptRgMJvw+GcVlpch1wULR7/Xjc3qQa9rfiD6Xl6aSOnr27Hla/09H8Pv9
7NzyKzmrN1G2YRt7t+/400UGuoKqqioQhS5/LZVKJTGJcbyz6F1qao4zEjc1NdHYUsFD/36Id/I3
k2gKQVPZxFNPzOGV+a/w1Vs/YVaH88jDj3R5bXFxcTgrjiKd4IeQyWRotVpkoozI6Egy+mQSk5lI
/9v/TXPMWJ54+N9U1lUgaURsSh/ZFUXU1Nb+Yb/Nn0YIQODHmnjZJWiS4lh/+CDLNq1ne1E+8oRo
LrlmOg8/8jDvf7qQ7f6PufP7Hjy8fiy3fpuGL6GUvYd28cbLr/P0o/88o7ZcU66+hrX1ASHg80ut
VFonw+12k5tTiChTYzKaW9XB2toa6r1NhLbTZ1+pVGE2WvDa3EE/rLvRgVyr7DAOXb0pnwvHXnjO
bPbc7Gykwkr6xCbSPTYBV1E5dXV152TuPxLNzc1dit2fCJ1eh6CU8f2KH1qP6fV6tGoTRpOOy2++
lIWFP3FxRgI/ffc5KQmJ6LV6Zs64j5U/rSInJ6eT2Y+jW7dudI81Ur57FXAseuBx45W8yEQZolyG
QqEgJDwUg8lI3LgbsSVM5JW5CxHUAi7cyI0aqnxWCstL8Z5h38DTwZ+ux6BCoWDYyBEMGzmi3eq/
CRMmMGHCBAoLC6muribpBPrrUaNGnfF9p11xBX95bT73+Pw0eDxYotuGF/1+P4WFxcgVmjb5B0UV
RVhiOg5JDhk4lD1L9sLgY+3HnF7c9XZ0se07ML12N7XrCpi7fvEZ/08nwu12U7L/MP0ijydPmUUV
DfX15yQP4Y+E0+nkTL6R0XGxbN2+jSmTJhMVFUVRURGffPkV6pg45KkjCBtSy5K9OxkQG403Jpyi
uj1kHcyiX8++LF26lEcfffSU2ocgCDz1yD+4buZsGqNSUUckIBPFVotPlIl4fB5kJ8wTM/oa8j8/
wPoVa5l05RTszTZCTGG4nU7yyotIjoo/r9yGZyUEBEEQgZ1AqSRJl52bJR1HZ11SkpKSSEpKOmf3
SkxMZOiFF/He7l9xShJ9h7f1xre0tGC3eTGbgwtxHA47Np8Ds67j6r9evXrjeKMFV60NpUWDvawJ
dbgemaLtS+X3+Cj6YA/XTb/2tNptnYzy8nI2bdzEzs37qSivIBmJtJuux3KsUYtcJsN3Uk///wsw
m80IZ6Aqi6KIXKPgx59+RGcJZWvWEcpKs7n+6hmERkfTd+wEFj3+CAdXrkBlc7JD+oZ4nYrwEImD
R7ZQXJaNQRuG0WjudFOmpKTwrwfu4vEXHyXmqqcxneCjEkURmdeDJPlbezQIgkDUuDtY+ukTTLpy
CqJajt1hw2Q045DLyasoJiUq/rxxY56tOfA3IAu6Lpg3btzI3bPu5aZbbuWrr79uE8P9X+KZl+ax
BjXLG+xccllbmVZdXYtG07ZTr8vlQlR37mBTKJTcdvNdlH+TReORKkSNHIWu7YvkrLWR99pWxvQY
xuuvvHZG/0dxcTFPz/kPt17+Vza/WUZ0/kWk1IxCOmJi6adft46TOPtEk/8FIiIi8HnOLHdCqVby
/uef40nNJKZHDzRKL1UlgfRshVLJTf96BrdKQ2yTxJXRQ1E4dZjNiZSUlGC0KPHK6imvzqGqurwN
KcrvcLlc9Bncmxefvo/qb/9F1YFNQWagSq5ss35tZBItVid2W8CB6PEEmpFoNBrkoQaKqsvOG7vW
GWsCgiDEAVOA/wAPdOWab7/7jkUfLSahWw8s4VF8vGQZLc3N3Hzzzef9ZfR6vVRVVVFSUkJLS0ur
qdG9e3diYwOdjiwWC9+vW4/H4wkiF4GACm+3OTGZ2mbXiaI84OU/BYYOHk7J4Xy+eudzQgbFETo8
HnWEAcnrx1bWSNOWUqw5dcx+cDaPPvTIaT8Tu93Om6+9zc9f/cIg/eXMypiJWh4QWlnuFhS6RDxi
Xut4h9dL+P+Q9/BM4HK5KC0tpaGhgSPZR8hIz+hyoVVVdTW5lTUYYuMwhoRScGAPYRFmGioDNRVO
u53Vb7/JTWPGYd+6jVCtjnKrj979R/H5t9/gsatxum0gCDTbK3E6nSQmtG2L1mhtRK1VM2jIIBa8
9DjPzH2dvKx1xFx0B9qwOGSiDIVfhsfjQf57dEaSEBQqbC1WVGoVshN6E2o0GqweD8WV5STFxJ3z
vXI25sB84CGgS6l5+fn5vL/4EzIHDEZ9rJCoW/+BfLPiRwYOHHjOaZ2am5tZu3Yte/dsZ8+ereTn
56NWSajcbuQtbnQ+AdEro8bpxRAdw3V/vY9p117TYapxZxqLUqlEcvvxerytySQnwuf1Ul9dh7fJ
yX033sddV9/FZ18s5rvFX9PU0IhCoSA+MZ7Hbv8HN8y4odOeiB0hOzubOQ88Q2hTT+7NeAf1SQ0s
JL+PEvtBxvbu0/pVapa8pJlM5yT19HxBkiSKiorYsnUr63Zt51BeDmK4haMH96GSScTFxaHXnfp5
1dbWklNRSWRGBnUl5TTWVONxOwmPCqOxthyX08lPr79KN6ud0YOHsepINrsLs3FoDYRbIrBYLERF
BorYvF5vYAO3Y6663W58ghfVsf6CGd0yWPTuPL775gcWLX4AKTQNTeZYwrsPRy5X4vN58bTUUbH5
S3pkxBAeFYHb7UYhBmuWeqORRk891bU1RLZTcn82OCMhIAjCpUC1JEl7BEEY29G43NxcFAoFCoWC
RR98iCUytlUAQEBFDomO44ulS1s7u56tA6SgoIB33nmdn1d+S89uEt3Tvcy4XEXOIT8Nu12MVqjp
292ARh74eni8Ej9vbkS29Hvmb/+Nu//zb+Lj49vMG3AItW/1qFQqUqOTycnPRxdmRGfQIyDgcjqx
W214Gp0khscT3TOm1a7766y/8dDsB0hMbHuv08XmzZt5dvbLTLDMolda+5mFBY0HUIY0MWRIgPmo
obkJZURIK7nFn00QNDY28v2PK/hm/Roq3XZUQ3sjG5iMOjkU1+Y9TB41BrfD1iUB4Ha7ySkpJTwt
A4VShSRAXWUlfp8XU6iRkoM1bPjkI1KbWhjdO8ANmTlwEK99+zW3/e15jhZm063bcbteLpd36K/y
+XzIToosKZVKpl9zJZdNm8KuHbtYuWYzvy58E5+gxCcIiLgYP3EEV95wb2AOlxe9tq2GZgqxUF1e
jdllOqf+gTPVBEYAUwVBmAKoAaMgCB9LknTTiYP+M/dxJD/Y7Q7yC4voM3QsbpcLpUqF3++nuaEe
OV727d7O7u2bEOVKRLmShORU4uLiT/ul/Oabr3nu2QeYNE7ilWd1WMxyJEni6yV1WPb7uSXKjPyE
0JLT5edIjgezLpxJvQeQ3dzA+3Of59H589p9yAajHqfTgVrdNuknNiYOjVpDbUMtdcdi0XqNngRD
NBG9I9sIN6/Xh7ITFqKuYt26dbzw6JtcHfc0sca0dsdk1/zGAf8vPHPdjcjlIn6/n6LmBjKHtU2R
/V/DarXy/ieLWbpuFfROQTG6F+oWG66dhwgTFFwycgyXzrud8PBwHn70Eew2O1pdWz/NicgvKkIV
FtHKd6DSaKguLUHwezFajBTsX09YWCNjBw9vfeccOi1Ffg/vLXmTkopCnp/33y6t3+vzdvjeqtVq
Rl4wkpEXjMTv99PS3ILdYcfqdiAZVehNxgAxD8p2MyEFQUBl0lHbWE/sCVGeDRs2sGHDhi6trz0I
Z5uQIAjCGGD2ydEBQRCk+qZ9AOzevZu1v2xFrtZTXNiAXBWKTPJh0SsIsZgoLyzg6mmX0rt3HxwO
J0WlZehMkfTo2avLgqCqqoqLLhzIi//SEx97fMMVFLvY8U4990SakAkCLrefhkYfpRUSdfUC6Rk9
6Nt3AKpjm/StkhwufmYOmZmZbe7R3NxMfl4ZZvPZdwBqbKwnJTW2y4VO7WHnzp3MmfU818X/myhD
UrtjDlb9yjrbW8x5YTb2vGJiFVpqnDZMvTLofVLt+p9BE/j888/57+JFyOQiBqWabqlpjBswhKFD
hpCUFMxytHHjRj5Z9jkpGR2316pvqOdwWQUxmd1br60tLaPPoJG4rHVY1PVsXvg9j19/B8ZjWpHD
5eLDnVsxDx9B877dDBw4gBtPokfvCFarFZtkO60vtc/vo6KmmgafA7VKQ3hIZIeahiRJNJVW0SMh
rUNfyLFami7/mOcqT6BTSVJYXIzWoCckPByFQs7hXdkkJKYTHh6wv2UKBbXHklY0GjWZaSkcycmn
piayjYOuI1gsFhKT0nhjURG9u9sw6EGjlrFnm5WBZQp2V3pptkq43QJhYeEkJaczbnwqypPSZuUE
nE+/d6P5ccVq9u45RH19Henp6SSnxpKZ2YMLx44/4w3s9XqpqCxl7doVlBUVIcpFho4cxfjx4zGb
zaeegEC48umHn2da1Ox2BYBf8rOpeBkHhRXMXzSX9LQ0alJSqCwuITUmut3KwT+DSTB9+nT69etH
SEgI4Sc0bmkPw4cP56dVP1FXW0doWPu+nIrqGoyRwd2lvB4PptBQyhtr2P/DZi5NS0N1TIWXJIlV
B/dhHDSEaIWMJ57/72ltaLVaTXNjM5yGti7KRCJDwhDKa3B5/Xh0rg6FgCAIIMpam7aeC5y1EJAk
aSOwsZPzFJeWYo6MweV0Y29qYsSIbpSV1OOw69BotajUGioqqlqvEQSB6MhwigpyuywElEol3/+w
js2bN3PgwAEaG6uptTbj9h0iPFSie2wCJrM50I6qgzmaXU6K5GBdtYoxF4zD51Ij9/TALJuKShZL
dmkR+zfm41Mu4Un/P7n9jtuZOfMeVKquq/Uul4vX5j9PQfZBJg4ayPjUJNweD9t/WsG7b7zB7Cee
YMKECa3j7XY71dXVyGSBzkwWiwW5XM6XS78i3j2YlJA+be5Rayvj+5LXCe0lsOi5NwkPDyQDhYeH
/6EVgx6Ph19//ZWS4mLMFguDBg06Zdny7xGbrkCpVDJr5izmvvBfVGpVG4eqz+ejwWojJiU9+EK/
hCUyil8+/YiLTKFEqo34jmXmHSzKp9JiJkatZMroUadte8vlcnRKHXabDbVWc0qh+juZidwnp1tK
ZuADUVdDQ0sNWoux/fsLwjkNrZ/3jEGr1YrTEfADlBeXERNuwmDUkZgsUpBXjkKZhEajpaq6Kug6
s8lIcVkVdru9XRbd9iAIAr179yYqLlCAodPoOHo4m12vvU1sfBzydtqG/w6Hx8Pft6/nx9xD6Nd+
x8R+kagUMo6WHGVv/hbMwjgixccRhYngBYe/iM/ee52vvpzA2++8TffuPU65Pr/fz2uvvACN1bz7
0IOolMe1kFH9+lJQXsHTc5/DaDTSp08fvl/+LblHszAfC0u63B5cLh+9+vTnl7Xb6W+eETR/nb2C
TeVLKJR2cPsDM7jyqivOO1V7R9izZw8LX38VR2MNBpUcl8fHZx8quOWue5gwYcI50zgSEhK4566Z
vLrgNRLSklGqjpuCNpsNUaNFdsK9nDYbClFBVX4+Mc02+vRPpanRjs/rpa65ifWVFSSNu4h+oUYS
EztmO+4MJqMJoVkgPy8fh9OBx+lGoVKiNWrQaDSYLRZkggyP243kBaPaiM4Y6L4tiiJJMXFYrVYq
6mpoFJqRaRQolEr8fj8elxudoPxTOAa7DKvVilypwOVyI/P7UKuVHNqbTcHRQipKq/B4fYSGR9Ct
nU2kkIunlTtdVV1FeVMFOpMeBIF6VyPGaDOKYQP4YOtuLo9OJFwbHDrz+n3sqKpg7qHf2FuWy8NX
dadnUmgQ406L3c07Kw6x+8itJLIIUdCjkSUS63+Juurl3HDDDfzwww9ER7ffKBUCL2RhUS55Wft5
7+FgAfA7kmOiueuSybz12mv0H9yfyBANV00dF6Qa2u0OjuYWUF2Xz4byJVjdTdg8TRS591Aj5HLN
rdN48eqPMRgMp12Acq425pEjR3jhmadIjTASdkKln9Xu4IM35uPz+Zg8eXLQNf4Sv1cAACAASURB
VAEOh0Ar+tMVXH369GHGNdfzyZLPiE2KQ3us3XmgviD4GdSXVjBswmSKVq1kYvee+H0ORFGGw+Vi
ed5RLAMGkKQQuPAsUtCtVitZu7LwV/pRCSrkcjlev5cmdzMV3kpswkEikiPo1r0boaGh7f6/er2e
dL0el8uF3W7HZncil8lRytWYw7pmMnYV510IuFwuBEFGTWUtRQdzWP/tWjJSYrl4WG8ykiehkIs8
8vxHOOz2Nte2x4zb2X0qG6owR1haH6pSqUTS6xhx+XiyoiN4c/1mDPVlWJChlQQaBYlSvwcpOpzd
Zfm8eNtAwkxaTibeMGiVPPCXbsz/6jCHDs8jRngKjo0Kk09Fstcz4/oZfPrZJxgMJkQxQJrh8XqR
/D4EwY/JbCAv9zDjB/ZDreo4DDqsV0/e+OY7evZKZvDAtj32tFoN/fr04JGHQvjg4y/JE5bTq3dP
Jgy+lMGDB7dqTf+r6kC73c685+eSHKonzBxcF6HXauiVHMPiRe8wdOhQQkJCyMvLY97CBezYv5cW
px1RguTEJMYOHMKVl03rck/9cePGYTAY+GjxR9SJtUTHx6JWqfAf6wjU0thI+dEcuvcbQktpKaMi
ozEpVfgcgaKxHw/sxZaYwPCYSKZNnnTGJdZ+v589v+wh1h9LZHJk0HFJklo5ByvrqsjalEXSwCQS
EhM6fM9VqgDj8LkrJm+LP0ATsLFj20EO7TrK1HH9efofMwixHHeoZWUXoVSpMBqCnWw+nw+3x9fl
PvcNjQ2IWnkbqSoIAmGRYfQe3o/xEy7G7/NTX1+P3W7HYrEQGxvLXbffyvSRcYSZ1JwsAE6c57ZJ
qdxxaBXhwn0ohOMRgjDhZqpqS5k3bx4L3pwf0HpkAnp9oO2UUqlELpfTUFdH5imKdWQyGSF6HZpO
BAVATHQUf/vrbfy0+lduuOX6P00R0M6dO/G21BORltDueZ1GjV7mY+3q1fTu25dr7r8b91XDMNxw
C6EhRvxON2WFFby7L5dFs25hQv9h3H/7XaSnp7c734kYPHgwaWlp/PjTj2za/AuCKNBUWU1Z4Qoc
xUVkmi1U+QREvYneF4yjsaoSt9fPjoIC9jskHrz9ZsaNGXNWJlRDQwNKu5LI2OA6khPnFEWR2IgY
wtyhHN1xlIbqBvoM6vM/M93O611/3bKLW254CF+Tg7/fNpVbr5kYJADsDieLv11PdEJiG7u/rq6e
kLCoLlMt25w2lO2o2L/DFGqmsqkKi8VCnz59GDZsGJmZmUiSxE8rVzK6d1SAK6wTmPUqhnaLoMG3
Kui4IAiE+/7GypUr8fm8JCTEERcXi9lsRqs9zl1nMpupa27u9B6SJNFgtXUki4Kg12lJSYhk3769
px58CpwrU2DNyp8IN3XeeiPMbGDP7p28tugd3NNHEHLJCBShAf4AUaNC1z2J8GvHY1lwP2viJS67
/w4efPJxWrrQGt1isTDj+hnMf+llHpv9KKN79SOzsoKFA/szf/ggjDlHyHC6wO/Habfza9Zhdtvq
uO3Wmxl/4YVnvRFlMhlSF0tpVEoVveJ74S3ycfTQ0bO679ngvAqBe+9+nIfuvJL5T95JbHRYkEfT
4/Wy4KMfiIqPwhJqbs1c+x21DU1Ex7SlCG8PNTU17N2/j9zcPJqb2t9kMpkMnVlHaWVp0PHKykrM
Bg1GrbLTDj+/IylahU9oyygsCgZMsgtZtmxZh9dePGkSP+/ei7eTQpADeflozWacbgmfz4fH4+mU
LSc0zEJVVfB6/lemQHNzM9mHDxIV2rnyGmI0kJdzlN8O7kM/qOMuUDK1kpBpo7G8cR8r5LVceuO1
HDnStR77v39U3NmHmTdiENF+D1lZhwjzeDBWVVK2fw/7jh5mj9vBpOmTiIuLO8WMXYPRaMQu2bvs
yxIEgYyYdGqya2jqoInt+cZ5FQKfv/EIFwwN9LDTadQ0Wx0AOJwuXn9/OaiUjBw3BJfDRkrKcSaY
sopK1PrQU7YM93q9zHlkDhNHTuaNOW/x/CMvccNVNzLn4Tns3bsXTtoMKrUau8+B1Wo9fkylwuX2
dnnjeL1+kNqPMqjcw1j+7eoOr+3Rowcp3bvz7vIf2q0Iq2lo5I1vvmPW3/5OYko3tmzdjSAIfLl0
GT+v+rndOR12J+rTCFG2h3OlBdTU1KASxVN+TeVyEfH3CsYuhLpkKgWht19C3YzhTL//Ln755Zcu
refbjz9mslZBuMlEckI8oiWEYdGxJBv0HG6ow5eZRvdB/VApFedMFRdFkdjuseRV5nU67sTXTRRF
QsXQ/1mDl/MqBEwGHb/rtZFhIdTUt1Bb38TcBUuRG/WMv2wscoUcv9dN/DFJXFNTS2OLm+49Tt1S
a/HiT9i78iDPDJ3PvT1mc3PG3TzQ90kiyxN44dGXePgfj9DQEMzBp9KpqW04/rCjo6PxIVBSY2sj
NNrDloMtaIVB7Z4T0eF0dM4L98xzc6n0Szy88F1Wbt1GYUUF2UXFfLDiR/7+5kKm33IrEyZMYNq0
K9CHxLJy9WbCwiP4dfMWSkuDtZi6ugayjhYxcNCQU677j4DdbkfeyRtV39RCdkEJ2/Zlsf/IEepK
Sih+9n1K5n1Gxfs/0Lh5Hz6bo8PrTcN7I3/sau5+9gl27drV6VrKysoo+20bw6OO55lUWh3Uud18
V5hLtuTh/sceRZIEXO72i4HOFGnd0vBGeMkvz2/347L4g09Z8Opb1NcfZ63SqrW01P5vmKDOf2ch
ARAEdFoV5VUNzH/va0aNHUi/Ib0RBAG3y43X4yU8PJyc/EJ8goq+AwZ3KQ761adfc2ni1ajlanx+
L36vH61WxaDY4fSPHsL64tXMvOUe5jzzBL37BKoUNVoNTVXH1S6FQsGsWX/lm58+5v6pbVOFT0R+
RTPVjW4yZMPaPe+VmlqzICVJapcRWa/X89qCN9m6dSs/Ll/OiuUrUKtU9Bs0mPcferS1061SqWT6
9GvY+dtvVFQ3cGjTb7w6/01uuvUmFAoFtfUNVNVauezya7oUz25sbMThdOL3+/H5fOi0OkJCApGU
3Nxctm/djk6vY9xF4844E1IQBPwnvfROl5vtBw7z29GjWB0OIjLCsSRZiB0UjzZEg8flw2WrpaW8
hLKf15F7oAJtajSGUf2JmDEJVWxwcpM2PR7//dOY+cTDLP/gE6I7oJnbs2sX/cRA45TfMSo+mq1l
lUyMSGR3RARqtZqI8CgqyipQDT13cXdRFOk/vD+HDxxmX85+MiLT0aqP+7wUCgXFB6p4/cW3uOu+
24iOiabJ3oQx88xTyM8G51UIrN68m1EDeyCKIh8s/ZnPlm9k4tSxGMLDqK5uQKVSUFtVg8+noLCs
hvjENBKTkrqsmlVWVBDdNxCbV8vVSE4/kiagZooykfFJk0isS+Kp2U9z/R3X8per/xLIqxakQKHG
sTDQvX+9j4Vvvcmm/RVc0CeW9rxyDVYX//k0izD+SqChUlt4aSQyOgy3283MmTMJDQvlxRdebDNO
FEVGjRrVpXZogwYPpl///hzNymfN6tXoQxL4yzXT6dW/N1ekp3e6Yf1+P3n5+WRtP4S7xoVW1CAT
ZMiQYfPZ8ag86KJ0rF+3gQE9BlBeVc7Lu1/m8ScfP6Nqzri4OOxuX2v6cUNzC29/u4LowdFcuvAS
EofGB1iCjskJUS7i8XgR5DJ+f+Zel5fyfRXsX36YPZc9SMilI4mdfQNy43Fno75vGvVTB3D3Q/9g
ybsftBtB2rt+LZebg59NotFAotFASYuVHe5A046YmASKd+R2OSGtq1AoFPQZ0IeyyDKydmWhr9UT
bgjHrDcz5qILOLgzm0zNUBbMf4eJ14/DmGGkR/ypE87OB86rORAbbqaotJIb/vY8P2zYwd/n3M2I
cUOxxEThU2podPo4cLiIEWMmM3TEGJJTUrosACQpsJFbmYNlcvSCAacnWJ1MD+3Gnd3u4+tF3/Ll
si8BEEQB97GXAAJcgit/XsM7K/N5c/khCquOq2VOt48fthVx3+s7kdunEype2eGaPNp1jBw1hLtm
3oVP8vLAP7rUa+WUkMvl/PflF1AolPz842oSk5IZOHBghwJAEAR8Ph9rf1xL9vdZdPenc2HyBQxN
GMzg+IEMjO/PmKSRjAwZyoEf96P364mPjWfk4JFo5Jou03afDLPZjDkkFJvDidPl5s2vvmfIfYO5
9qO/kDwiEVkru6+EcOx3FsVg3gW5Sk7CkHguffZiHtxxD2HOSvLufQG/O7iLj+WykWSHy1j00Ydt
1tHQ0EBdXi5p5vb7N8oE8B8jvu3Vsy8qhZnIyI5bw50NYmNjGXXJKKJHRFOtrWZX9S6K3UVoe4hs
qVmLXBHKG0vfIrlH8v+s/ft5FQI/rNnGvU+8zuWjwunbP4Li4twAcYNahckSKJv0uZXceOONp50G
KQgC3Xt0p6jxOF2YRWHB4/S0scPMmhBuzLyTpe99ydo1axFkQpsxffv2Zf+hw2TXqXjo7Z3c+N9f
ufXF7Vz/3Ea+WhNCuOcVIsSO6bobfetRGZpYvfZn/H4fz899oUNV9UyQkZHB9TNmoPWrmP3XBzrN
Hff7/Wxcswkp18fQ5MGEGIOrHn/XczQqDekxaejRUpldQXlpOXJRHiQgTxeDh4+grLqOytp6tBFa
Rt7T1nSSoDWVVyaTIROEoBbdv0MbomX6gqmE6b2UvfJF8P8gCBhnTODdLz9vEzo8cuQImXJZULrw
iZAh4DvGL9irVy9mP/hogPTjPEEURSIiIjBEGGjxN3KkdB+hyXoKpb1Uu/IxOkOZdfu9FBYWnrc1
dIbzKgRU/hp+enUSM6/syQOXplJXWkDu0UA8tKG2jl2b9/HgPx49o046AKPHj+Jg/b7Wv5VyFRbJ
gtXR1sFi1oRwXdptvPHiArKPZLfbNTYuLo69+/aQnNoduecCQhxvkCn/mTjhdfRix/zvLb6d1Mjn
0r13oNT1hf++2G6hjNvtpq6ugbLSKspKq2hqaj6tcN6cfz8JOhn5h3L47NPPOhx3OOswzkNW+if1
bcNAfPK26JfWh8qaSqorKtm2aSt5JXlnxXNw+RVX0uQVEWUyGsqaqM0L9nhLkoRMkAUtRBRFBElq
VxDIRBmDr+uNK6eozTllVAiennGsW7cu6HhZcTGxncTqJQgKB5/voiqbzcZXS5ayZ81GQlEwYeBw
rhp3MXMfe4SwcB+Te15Ioi+Sfz3wGF8vXUZtbe15Xc/JOK9C4NqLUzEea6aZFKHnltEx5B7Yw/7t
O9i1ZR/33P0gY8eObR0vSRKFhYWsWrWKhQsXMnfuc8yd+xzbt29vd/6Jkyayt+E3XF5n67EQdSga
txq7u20acpQ+msnR05j/n1c6NDt0Oh3rNvzEoAtFqlX/xOrfiSS1/9X1S26qhdep1c5h4PAehEeE
8+LzL7UrAKxWK5UV9XhcMjRqI2qVgZYmN83NXfcIR0ZGcv/sv6OUKXl2ztM0Nja2O+7oziN0i8o4
gU2p49wji8HC3ZfegVFpIMEUR9/Es8tcCw8P57aZsyhttDO6d08+nv451dk1SNKx/AVBOMEsOA65
KG9XEDgaHWx4Yzuafh3kEwzO4Odfg0OGFTlHidJ2nGna5HJj/oOqKWtra1n26eeESAqG9xtIXFR0
a/l6VFQUYyaM5Ejdb1yYMYlYfzjVh3L4+tMvKCpqK/TOF86rY1Cqt7GlqBGlRo5CLkOUixhcTtxW
Ha/Oe5X4+Hh8Ph/r1q1j2VdfsOmXTYgKgdBoA3ItlBfUUFdhJSf3aLtc9WlpaQy/aBir9//IpWkB
W10QBCLVUZTZS7FJVnSqYC0jyZiGMW87S5Ys5aab2m8UERERwYqfvubHH3/kkYeeIr94HjpFBjhS
kPvi8UoNCNp8mr3b6T+wL+FRI9Bqtbz80vx203ddLhcN9TZ0WmPrl1kQBNRqDXa7DZOp617hmffe
w8fvfYinxsELzz3Pcy/MDTpvs9lwN7owJXWdkDXUGMolw6YAkFVymKOHs+k3sGPN51QYP348UVFR
vDrvRZJtTt6e+CEZ49MYdtcgEgbFtxJvBkEICAKvz4vk9+Pz+jmy8iirX/gF5dABxNzTvi9G1Guw
OoO5GuvLywnRdJw7Ue90EhLbtUS0s4Hf72fl9z+Qag4nIbb9ZKS+fXtTU13DvkPb6B9zAdv3/8yU
v0zk56+/Y8SEcX8IV+R5FQIDki308vpxuLx4fBJen5/RCQZ22Dytffzuu/9evvxmGSFROmK6hYFX
TkOVjaZcG8OGjmD6k9dwySWXdHiPhx6fzdSLLmdk7BgsmkB4TpTJiVXHU+uoocXViKAUEWWBikSl
S8m16bew4KV5TJ16WadNPKZMmcLkyZPJy8sjKyuLAwcOsH/fUWJiwujVexoJCffx4eIPEGVyXp3/
aoecgc3NVpSKtrXl7YUQTwW1Ws3cV15g5vV38OkHi7n1ztuC8up9Ph/iWfysIboQqsprYeAZTwEE
bO3X33qbkpISqqurWbd+HUseXUJx4TIS+sYTMzgSY7wBrUWDqJQf65jTRFNxC9XZNeRtK0SdHE3E
vTcQOmV4hwlNvhY7BnWwZ7+hrhZzeMeCtdLtISq5bZfgc43CwkKwOUnI6CQbURAYN/5Cvq7/hrzq
QyTperBr606mTJ3MljXrsYSEEBPTcXXqucB5zxNQymUo5cfDTQPTQnj/k/2tf19z9XWYjm3EEEso
qSmpZGZmkpGR0SVvaWxsLDfceT3ffrGEW3vNaj0uykQitVGYvWY8Hg8uvxOVqEGnDdRt99L25523
3uXhxx7qdH5BEEhLSyMtLY2pU6e2Ht+3bx/Pz/svClHBa6+83ikVutfjQ6loq546XXYiIrv+xf4d
EydOZNiYEfy2ditPzH6Mpd992XpOr9fjElz4/f4zUuv1Gj1HazvPdusq1Go16enppKenM3LkSJ6c
8yRNTU1s27aN7du3U3yomNr6GpwuFzJBIDEuiVHJaSSOTsR7i5dFXy+hdHMW1qgQ9AMy2wgCn8OF
b8UOLr/jwaDjkt+P2EkWZDkyep7FxsrLzyMrJ4vkuGSSk5I7dCrmZh8lNvTUTXFkMhnTrprKt19+
R3O1j5YyG1VVVfRKSGHDz2u47uYbz2vHpz+chszt86M+IRIwZsyYdjnhTwd3zbyLq76/ik1F67gg
cVzQOZVcjUquRk9wbcKFcRez8Mt5zH7kwdPeLDt27OCVN+ajkqt44/UFp/QsqzVKHDZna4NSr9eL
y+3AbNF2Sq3dGea+/Dxjhoxi7dq1bNmyhZEjA12GZTIZeoueZnszZv3p152LMhke9/ljJTKZTEyc
OJGJEyeecuz06dNZv3498xYtpOiDNdA9Dl9cKDKtCqm4BmH7UW4aN4WLLroo6DqZKMfXgcPV5fVR
5A+YkmeKTTs3EdYjlP31+9h+aDuj+40mIyOjzTi304Whi1EvhULB5X+ZxorlP1Kyv56Dew8x9crL
yC0rprCwkOTk5FNPcob4w4XAwaImuvfsnGPA6Qw4+k7cIA0NDdTUVFNaVkRzSyNKhRqLOYS4uETi
4uJY+OFCpk2YRnVDPpf3uQW5rPN/LdoQi+iSk52dfVpUX1u2bGHB229gMVqY99LLXdrEJpMRSWrC
bgsUNylVcsIjjGcsACBAw/bgYw/xr8ef4unHnmLVxtWtX4v0gZnk/JzHYP3p6/R1zXVEJp6fmHln
kCQJu92O2+1Gq9WiUqkQRZHx48czbtw4CgoK2Lt3L0eL8mmsbaF36gUMuuaBoFbgv0Mmk3WYAX64
voHkfv3PKjlIp9FhMBmITojGlmLjl12bqKiuYNTwUUHmnVavxVVn7WSmYCgUCqZdOZXD3Q63hsyj
LWGUlpT8/yMEXB4fH26qZM5//9nhGI/Hw96D29Co9fTtNQi3282+fbspqyhAp1diMhuIiI7G6/Vi
tzWzZ/9mcvPCSUvN5JarLuGbxV/SrWYQvSL7dXiP35GoS+XAgQNdFgIbNmzg3fffJj42gWf//WyX
kztkMhkhIRYslsCbea5Uu1n33cvXS75i566drFmzprU3YWa3THL25VBaW0pcWNer4/x+P0UtJfTv
0X5txPlATU0NRYUl5OeW4fMKiKICr9dJTEIoI0cORaEIFPekpqZ2ucGIXKnA7W+/UvOA1U7fMWPP
as2RIZHU1daiN+nRGXT0Gt2L7F3ZONY7GD92fGsdgkano6n89IqCBEGgR8/jmYMqpRKH1XZW6z0V
/tAuBq+tyCOt99BOHX1FxfloQ3z4JQ8Oh4NNv6yjobmUjG4JxMVHYzDoEUUx0G0lxEx6RiJylZMP
PlyIRali3GXjeTd3AesL2q+6OxFqQYPD0XHByolYvXo1773/Lj0ye/Lcs8+dUXaXIAidCgCfz3da
eQNyuZy3PngbQSbwt1n3t14riiJjpowhx59PTkVOl+aUJIk9Rfsw9rScs7LaztDQ0MDqVRtYu3In
NWUCqfGD6d1tFD3Sh9IrczR1FX6OZneNDvxkRMbFU91OIZLb5+OgP5AYdibw+/1YrVZCzRGUHCht
TdgSRZHug7tTI6th9frVrWXEScnJlDfWnlVpt1qlxm77/0AIlNc7mP3/2DvPwCrKvO3/Zk6vyUnv
hYSSUARC70gHCyiKddVV164suuta1o5rF9e27qO7ay+LFRUVFRDpkAChJKT33k6vM++HQCCmx6Dy
vM/1CXLm3HPPnJn/ff/bdb1+iG+OBnjq2ee7fBE8Hg8NtgpCwoJQKFRk7duLoHARnxDT7cuj0+kI
+O04BTexg1N59t/P86PwAy9nP4fN03WPdovU3Kty0fXr1/Pm228weeIU7r77nj5H9HuC3++nqbmJ
uoZ6mpqbev7CSUhLS+PB1Q9TU1tDXt6JlyY4OJgll52NLcbFrqI92F1dP0hOj5PMoiwUQ1TMmDvj
lDPcHDx4mC/XbUHwhTNi2GTiY5PbMTaLoohWY+j3y5MwYiRFnayeW6pqGDrzzB5b1DuDz+ejvKKG
+gYPltAEDEIUpXmlbZ8LgsCwjKE0KBvYsHEDgUCA6OhoLDFRFJWVdjNy97A57RjNp1Yv8pT+2mc9
vpexf9rMor/tJnb8MjZu2dEt5XRNTRVBYUp8Xh9up5/aujKiY3qOrjY3NxGkELFYdBTVVDBixEj+
8/7rhE8J57Hsh9lYtIGA1J7kod5RS741h7Fjx/Y4vlarZdGCxdx0000DHqX1er00NDUiC6BUKVEp
+77DuOmWm3jsqcc7VJrp9Xrmnj2PhDOT2G3by7biHRwpz6Gwqoj8inxyy46yq3gP2+p3EjUrllkL
Zg+4gTsZkiSxc8duDmaVk546iajIrnP1dkc9oWH9E3lJHzWKQwG5nRGxeb1s8AQ4+6KL+jye3++n
sqoeUWnCaG6VABs7chyVOZX4fSeeK0EQGDp2CHVCLdt2bANg5pwzyaupoLGLwq6eUFFfS2onQjgD
iZ+tQNTlwIIgZ2VlERcXR2hoaI8vjyRJ7DmwheQ0C/W1TRzeXUN0rBFLSM8R7uzMLNwFJZgtFn4o
qOD2ex5EqWzNPe/atYvXXvgfSg8VMSZkPHrBgEd2s69lNyvvvZVLL7u0x/FPFfx+Pw1NjWi0Gvx+
P4IsYAkO7vdK3J14iCRJ1NXVUVNVg9ftQaFUoFArCQoKIjY2dkD76bvCzh27KSuwMyT1jG6vsayy
CLW+hTnzZvXrPIFAgNV33M6cmjLGR0Xg8vt5pbCMQZdewfKLL+7TWG63m7z8fDw+BWZzKAaDAY1G
g7W5jsqqAkq8JQwd2z4zEAgEyP7xIJNTJjM8fTilpaV88+k60mOSiO1Bd+Fk5JcUUxdws+KyS7r8
Xb1eL39aeSeLz13YlnHpqwLRKTUCfRm7sbGRsob9JKZEcfRQGXkHyxnbDfXUcUiSzI9frmdEkIWS
+kYOO71cfMUNhJ2kSCPLMjmHjpB38CCSJKFUKpk9ezaDBp36gpHu4HA4sDpsrdtftQaT0fSrkU3+
XBzv6vT7/ajVakRRJCcnB7fbjU6nQ5IkDuwtJX3IhG53G2WVRXgCVSxYNLvXJLOdobi4mOfu/BMj
PE4KAjIjl69gxeWX9+n+SpJEbm4WDreN0LBIvF4fDkcAj1skIS6CiPAwPlj3AWGjQgmNaO9iuF1u
Dm8+wjkzziEqKor6+nrWrf2ICK2RIUmDOihfnQxZlsk+moNNIbFk6bnd1qBUVlYyNm06Fr2Jf7z3
HDNnzjx9jUBewREU5mYsIUHs3pKHy+5iyNDOGWtPRkuLlZxNPzAqOpbCqiryRZFJ0xZ1EAMJBAK4
bXaSYuN+My9aIBDA4/G0KTefLggEAhQWFpKbm0tpfhHVZRXUVtci+QO4PW5K6iuQTR4EkwNtkAK/
G2ryHSye8nsuX9G5SxUIBCgqyUFjcjNr9pSfZQCOo76+noMHDxIXF0dKSkqfXTmfz0d+wV6UGi1m
czCSJOFw2PG5m1EpjVgsiXi9Xtb9+BnDZw5Ho21fE9BQ20DdgXpWnL0ClUqF3W5n1/Yd5B88TIQp
iOiwCHRaHRq1CpVShd3ppLahnoqGWoLjolm4ZHGP3bV2u50Zk5czoW4Su83r+W7X11gsll9Fi/Bn
QZIkGq3VpCaEY7c70amN+BTd03QdR1NjI+ZjWu4+EeJjosHjxW61oTPo21YdhUIBgoDP5xtQ9Zaf
A4VCMeBkFqcaX6xbx0dvf4BR0BBrCkOnVBMhaLCExHKkqojdRTuJnOpn2jVRRAw+sTqW5Pj48al/
o/lEzYplf2j7uyzL1NRWUttYROqwaMaOnThgrklYWFi7BrW+QqFQIApKRNmLtaURCBBs1hAc19rz
Ul1VhFYbw4ShE8ncvZcRU0e0W2BCI0KpD21gT+YeJk+cjNFo5Mx5c5kweRL5eXkU5eXjbKzB7Xbj
drkxBZmJT0pkzsxJxMbG9spoNTQ0s2T5Yrb8z9ec4Z7Fmief6/N1/iaMCYSQVQAAIABJREFUgM1m
Q61vvel2q5PoiEQa6mt7/iLQVF1N1LEXyS4FiDSZSU5IwmIy09DSjCQIiKrW+ADHxB/+D/2DLMsU
5rWWFCtNOqx6CXW0mai4WNw+Dwfe+ozJdxg4Y2nHgF5IrI5JfxT57I//Ye7MZQA0t9Rhd9URFRvM
giWT+xW1P5UQRRGzOQpBrMdsbqWOP/78KJVKYuNCqaqsJCYqnvrGRPL25TF0bPsgXsqIQez//gCD
kga1ZaKMRiOjx4xh9Jj+N2kdR21DC7NnTyN762Z0h4z89421PX/pJ/hNGIGm5gYM5tbV3NHiJy05
mqN5BtxuD1pt16u2JMlY6xtIDYukoakRNzKypMBsNmM2mzGZTLjdbjxeDwICWou2T9tuSZKoqqqi
vr7+WMFPazPHr63c+2tBEARuWbWyw9+PHj3KFTefz5R7FCSO6zyibzTqUQ5SEDy8jm82v83cOXNI
Gx1JXNzott2QJEm/qZ0aQFhYJKWljRiNHRcQQRCIig6hvKyMjDMy2LRtE4VHChmUdiLWpFQpSRgV
zw+7fmD5WcsH9Nnxer3Y7D5Cgg38/dVnOX/BCqwVfScr/W0YAWst0SlG3G4PoqTFYDAQE5NAQ2MR
MTFd5/EdDjtauTXAVtHUTItGRCHq2rr5BEFAp9P1yb+UZZl9+/bxyVefsHnPDyiCFGjCNMiSjKfe
g8qjZMroKVx4zoUMGzbs/1uDcBwul4uVd1/PmJsgcVzX+WxBaFVVjhuvIdJnYfac6e0+r6ioIDNz
L36fH6PJSEbGOEJC+pciHEioVCqio1OprMohNlbssIiIokhUtJmqygoWnrmQL7/7kkLaG4Lw6HCq
8qopKysjIaHnOFdv4XQ68XglIsLMxMRE89/17/LqK6+x+rFH+jTOr7439ng8+CQnWq2GlmYbYcGt
3V2DUwdja/Hi8XQdG7BabehkcHk9eAQQ1MGER/W/T7y+vp67H76HO/7xJ/LS85n4yiSmvDSVjIfG
Me6R8Uz9xzRGPDWKI4NzufGpm7j9r3dQV1fX7/P9b8Arr76EIrWSoWf2rlnpWOS63d8aGxvZtWsn
4WGhJCcnotWo2br1x05/e1mWf1YFXn+g1+uJCE+losKG291xTmq1Go3Gi8/n46x5Z6GsV1F4uLDd
MVGpkWQdzhrQebndblQqgeBjXIpJSUk88reH+zzOr24EnE4nWkPrNGyNXkJCWkk5DAYDY0dPpqiw
Cm8XXW3WxkY0CAQEgbzqetLSx6LSavukZHwcJSUlXLXq9+Ql5jHp6cmkLEhFbezIuKsP1TN48WCm
/H0q5WnlXHbrZWRlDeyPe7rAbrfz9kevMfmG3ncrepoEQi3tiVcqKysxGE50VJpMJgRkKisr2x1X
39DAgbwjZOfn8Mc7VjF06BBmzJjO739/Fc8//zybN2/G2Ymw7UDAbDYTEz2Mmmov9fXNbSXDAb+f
2ro6bM6WVh1CtZolc5egbtRwZPeRtmcxPDqc6qaqn8Xf+FM4nR6CjD8/uPyruwNOpxO1TsRud6DE
3I5vMCEhAZ9vAgcPZWIMUhEdHdFu++1obkbh9lJRVoclchBjxo2nqbaWQCDQpwhzc3Mzt/z1FkIu
DyFheu806UWFyNDzh1GXXsftT9zOs395tt816acKsixjs9naRC6Ox0kGKh25ceNGIsaAIaR348my
TNVOgbGPtK/SdLvdHX4vpVKJx+1u993Kxlosca3PQGz6IJyfeAiPDCE03MzezB2sW/cJFRVVZGRk
sGDBQubPnz+g/IF6vZ6kpHTq62spK63GYBRwuR3UuFtwuSTUvkYcRR7iwqI4e8HZ7Ni1g+xNB4kf
GUdoRCgqnQqHw9EnOnefz8fu3bv5/LsNZOYexul0IssyRoORxOgYzj1zHi7X4J+VUv3V6wSO5h9G
E2KjudFBTNDITn80p9PJ4cPZlFUUodEoEESQAhLbNmxhuDYYj0JJ3OJ5DB42jKbaWtISk/vUpnvf
o/dxKOIw6Zf1j2Cz9mANZWtKeeeFd7plKvolEAgE2L9/P19+uYH9+4/gcvlQqVr5DgJ+Nz6/m4SE
GBYunMWMGdNRq9XodLp+peWuvvlStAsPMGRm7665OsfJvsdMfLl2YztjXl5eTube3e385eLiEiZP
mdoWUZckieyCHMISTjA4Hz50mNeee4lDmfvJGD+aCRMzMBj15Obkk3vkKLk5+QwfPpxly87jnHPO
GdB0rM/nw2q1UlNTTpWrmfCoOIJCLPh8PmwNzYSo9cRGRlNVVcWeg3uos9ahU+hYvmQ5CoUCWZa7
DYA2Njby0muv8uWPm/BGh0DGMMzDBqHQaxEEAb/DhbO0Cv+ug4gFlSycOp2rL7mcxMTE069YaP+h
3QRFBagr85Examq3KTyPx4PNZsPr9SIIAps/+JDxwaF8U17MzCsuRW8w0FRTw/BBqb22tjk5Odz4
xI1MWjMFhbr/dfOH3jjIqMZRPPCX+/s9Rm/h9/tbsx52FwGfHwQQlQo2b9nCfz/8ArdbjdmcSnhY
Ilpte8ITWZYpKzvE0ZyvEQJNjB0zEoVSSZAlhNEZ45k2Y0a3/R3HIUkSY6YN43efhaPU9M6r3Pxc
HQsiV3Ldtdd3GGvH9u3U1dWg1WpxudxERccwceLEdsYir6QQMVjXzsDbrFYai6r4/ptv+fiTjzEa
9aSlD2HEyHQsIcHk5uSRlXmA8tJKVqy4iKuvvnpAdwd+v58jJQUYIkPaVULarVZweEmKjMVgMGC3
21Gr1bz++hs8uvoJBAG+/e6rTqtWMzMzWbX6QWwThmKZPQFNaPdG1me107A1E+WGPTx88x9ZMH/+
6VcsVFHSQEpMRo85fI1G02Y9nU4nOpWSupYWtDFR6I+x+8iBvvH2ffzlx4QtiPhZBgBg6IphbLp+
IxUV17RJiZ0K2O12XI021IISvVqNQqfD7Xaz5qkX2b+/lIi4sRiiI1GqNSgUHX/epqZKasu2c+7U
yYQGGZECDcycOQWX18fhvEKeWr2JMxcuYcHChd3eR5vNhkon9NoA1Oa5qN2i44J3L+zwmSiKTJo8
mdraWpqbmggKDiYqKqpD5iUqJJyihkq00SeMgMlsxhPmZNWqVdx1113s3r2bdevW8cZ/3mulhhuc
zMhRw5k4eRzZh7KYN28u9977V5YvX96refcEpVJJXEgEJQ11WCJOxDqMZjNerZe86jKSQqMIDg5m
zZrnePKxlzApJ+Lw5fP1119zww3ttSy2bdvGLU88jP6apUSl9Y4/QWU2ErVoBs6RQ/jzi3/v8zX0
KzAoCEK8IAgbBUE4JAjCQUEQbu3POAAWcziRQam9Wn1+MgcCkkyZ20HM4FaqKI/bjf4YI01v8cPe
LcRN/vn980qNkpA5oaxbv+5nj9UV3G437gYbZp0RnU7Xdp0vv/wqubl2RgxfQmRQHFo/BBx2vJ6O
PfVVFdlMGzWM5NgEzMYQZNlAZWUVYRYLMyZkcMVZ8zmwdRP/+de/uo3C9yU16nUF+OExK3fe8lCX
aT9RFImKimJYWhrR0dGdjm8ymTCKmg7y8xqTnmabFYVCwaRJk1i9ejU7d+ziP/9+nWlTZlFT1chn
H60nK/MATc3N3HXXX7oVb/kprFZrt1kgi8VCiFKPtbF9p6BarcYcGUpRYzVffPEFTz7+PEHqqahV
QciS2OH+lpWVcfsTqzHedCHmXhqAk6GPiyLsjiv6/L3+7gR8wB9lWd4nCIIR2CsIwgZZlo/0daCE
+KR+TUCr1eJTqwhNTiMkJARZlnHY7SSGdKT87gpNTU04fHb04QPjK0aOj2Lba9u4nut7PrgfsNY3
YdYZ2r0ghYWF7NlzhLRh5yAcs+lKhQqF3BpY80gSGl17l+BkZR5RVOFynQjAmY0GLlgwh7c//5pd
u3Z1SvUOrdkbvdpEQ4mb0MSu4y9eZ4DvHq1n5vDzOGvJWd1e38n6kF0hISaO/NIiWuQWgo6lxpQq
FR57+6i7IAikpaW1Y41qbm6mubkZs9ncp8rRex64i507d7L9h51dLjBx0TH4ykuxW60YT5KHUygU
GEOD+cvd96EKpKE8xoys0ro78Bw+8dLz+BdMIGRQfK/n9lP05Dp0hn7tBGRZrpZled+xf9uBI8Cp
5UX+CQRB4KxLL2bWgvlEWUKor6zCpFB2SfvdGRobG9GFd6QC7y8syRaKy4sHNA10HH6/H1ESOjy8
u3ftRa9NRPyJSKogCGhVOlTeAJ6TCEWCQ5I4UlyKJEnIyHi9zURHt9+FKZUKxg0fStae3V3OR6FQ
cPHSqzj0SSuHniRJWK0tVFdXUFZWSGlJAblZBbxzdSGpwpncd9dDPd7n+++/n+3bt3d7jFKpJDUh
Ga0HGqpqsVmtOFpsGDQ9R8eDg4NJSkrqcxFSXnEuLsFGbm5ul8eIokhSbDwqV6A1HnAStny7kYZa
Nxp1NLIs4Q+48QYaycg4wQFZWFjI1qOHCJvdudE9lfjZdQKCICQBY4DOZYJOIQwGA0qlkpjoaEam
DiYlKblPFl6hUCAHBi4wqlArUOgU2O29J5fsLfx+P4pOdITMZiOS1LXR0ai0KL1+/P7jKrxDaPYZ
+TFrD/UN5YSGGgkP77h7Mui0WFuaCQQ6cvUdD0wuP+9Cqn/QsfujMirKi/F6mjCbITRYR0OmwM6H
JRadMZ6YCD9vvfUaTU3dsyZlZu1l4eKFOHqg01IqlQxKSGJQWCzBspY4YxjhnYi+DBRsNhtRo4J7
FGpVKBSkxCeh9YC16YRr8Nrzr6KUklEoFPgDAWzuPM4775x2vRK7du9GGD0YUfXLh+l+1hmPuQJr
gduO7Qja4YEHHmj796xZs35WR1dP6A9zb1hYGK56N7IkI4jdr1IBKUB9XT2hoaHdptNOVbZFkqRW
Db+fIGNcBh99uJ66umLCw5M6/a5GqcHhdKIwKREEkUGpU9m9821Ka/O5esVSvD5/u/72xuYWvt2x
l3Gz5nD4wH4SU1Ixm1sFZA9mH6C5oR6lKCKLInMmLWTdK2+RvzaAMVRAUHhoyJeYMGoILz98Jmlp
sfj9AbZuK2DNmvu4/vq7uxRq/dMdf+acZWez5rk13HP3PT3eE6PR2C8dy9raWqxWK8HBwZ0qRv0U
sixjiNZQVNqzHoNCoSA5LoHKmmrqquvQGHXkHjpCuP4sEMAvufEJxdx+x+vtvrc35xDKlP4FlBt2
7Kdh5/6eD+wC/TYCgiCogA+Bt2RZ/qSzY042Ar9FGI1GokOjaC5txpLUvRuxP2sfLc0tRMVEd8lO
7HV4wSOckloBhUKBuxNNxLDQMKbPzOC1f/0Lv6QkJnIUw9PnoFadMIqCIKLwy5SXH8FuL0OmiZtv
u4LRo0ex6bsN/PD+pwQbDWjVKtxeLza3jzMXLCQhOgJZ9rdlZPLzjqIK+Jg0ZhSCIPDd9xtQy+U8
89BlmMw6vF4/bo+PwalRBAefiLMolQpmzhiCJbiMf/1rDStX3tepVsPMmTNRikoee+Ixbrj+hgHv
HSgpKeG5p58iL+cgZoOeZruDCVOmc+dd93S7iBgMBlQameq6ql6dRxRF4qJjMFutbNqxFbXKiCAo
kOUAdl8W5128tE2B6zhcHg8KzQmD5K6px1VRiyxLaCNC0cd3rXAdOukMQiedKFTLf/7NXs3zOPpl
BIRW5+414LAsy2v6M8ZvBbPHzWbDlu+6NQI1tbV4nG5GJAzjUPnRLo1AU0EjKYkpp6RdWaVS4aej
EXj3/XfYtX8j5185nebmJg7sPcT6r7eRnDgGnb41cOb3uZBkF7HJ0Vx9zflMnDix7aEfPnw4breb
+vp6XC4XarWaiIgICo8eQfb7CI9OQKPREAgEqKmqIGN4GoIgUFxcTFXVfn5/+RTKKhvw+/yMHNl9
QGvUqHgqKg/z2WcfcvHFv+vwuVKpZOUf/8hjT/yNNc+t4aEHH+r3/ZIkiYKCAo4cOcKhQ1nkHDnI
vj37WDZjLHdevgSFKOL1+fl44y4euv8+HvnbY13+bpZgC4FAPS32rklrO4PZbGZYUgpSwIvXa8fh
z2bstMFcecPVeL3edlV+kZZQvE0tuCprcW7bTYjHwdCEMBRKkYLNh2kZM4ag4YO7OVv/0d+dwFTg
MuCAIAjHC+fvkmX5q4GZ1i+Hc5ecy/u3v49vuQ+VrvPIdFlJCdHBkWjVGnw+HzIyQif+edXmaq6Y
2rnI6c+FKIoodWq8Xm9bIZS1xcp3G79iwflj0WjVJBDFqDPSyNyZgzoQwUUXXowkyQRbggkLDcPp
dWOICOpQqabVatvRjDc1NeF1ewiLjiHyWOo2EAggIrRF7/ft20nGmHC0WjWpyVHsP1xMfb2NsLDu
mXHnnDmEF1/aQkXFnE7rKa783ZU89fRTvPjyC9y+6vZuqbU6Q2lpKRs2fM03X38CkpXEeA1xMVpq
yo8yPS2CQdEWFMdedrVKyflzJvLi2m/Jzs7usuw7KiKGQnsVDkffYz2DBw9m2rSJbN26iWXLl3Lz
qlswG4wddh5j0tJ5+42XCKsoYeqkIUQPjmsLpIZEBPNtbjn8loyALMs/8htoPhoIxMTEsHjiYra+
uZ1RfxjV4XO3243NZmdIeDLQGp2XJAmF2D4ab6uy4dxjZ/5180/ZXE3BZpqr6tuMQF19HQazBo32
pOpIAUZlDOaL93YRn9C6iksBiaNHj1JcWoxd8KJSqUhPTycsIhRJllApVKiUavR6PSqVCrPZzODh
I9v52yqVConWNF6L1UpLSxnxCa0ckIIgEBsZSlVlc49GQK1WkpZu5MiRQ50ageTkZObOncNXX3/F
a6+9yqpVt3cySnsEAgG2b9/Oh2vfoiB/P2NGmrh0eSSx0UkIgsDBw9XYm3yMyEgmKbG9ko9SoSAt
PoI9e3Z3aQRGDj2DHd98T3hY319CQRBY++H7+P3+LmNJPp+PqspSRqp8TF46EZ25fZzD7/UjK08d
C/RvomLw18ZN197E9pt3UPZjKfHT2vd7Nzc3Y9YbEQSxrY31p7sAWZI5/PIhbrroJszm3suM9xUq
lQpNkB6X1YVOpyM8LBx7iwtJkhFPCmwqVQrUOiUHsw+yc/t2vvzkU/SySKTRjKgWCRDgsapi4lOS
uXP1PQwZOhiX30ZLQyMGtZngoOAOATdBEIiIiqa2voGjuYcYMtjULlAZGmKkoKyKQEBCoeh+fUhN
CWPrtkzmzu1oMGVZZtVtt/PNhg0898Iabrzxpm799czMTNY8+yiiXMuUiaFctHQ0qmMvjM8XYOee
ct587ygjE5IZMXJ0p3NT9BAUzhibwdP/dBOd1rVf3hO6CyavW/cJQUYP1152NvuOliBnDOfkbOrR
nAqUI3pW1Or33E7ZyKcYJSUlbNi8ib35R1EqFMSFhTNn4mTGjBnTZ+58g8HAM/c9zQ333ogUkEic
mdT2WUtLCwZ1a5DL6/e2MekehxSQ2P/SPkaqR7D03KUDcm3dwWgy0eCoQ+nzYQ4yM3TwcI4cKGT4
6BMVZjXV9WTvO8zdt61kTuIwHpxyFkmhEdg9TlR6JTqNBl8gwMajB7nl0utY8/pLjMkYDUaw2W3U
1nuIDI/q4CPHxSewf/dOCguzOWtJe/9fFEWUCgV+f6BHI5CUGMZ/1+7G5Wo1ZseJS0uKiqmrqUUQ
IDkpicKiQj788EMuvbQjLbzdbmfNs0+QuXcD5yyMZeTwkW3b58YmJ9t2VrA7y0ra8AlcctmZNB7d
3eW8mp1u0i1dByFHjRrFktnncu7i87q9rv5gz5491FbnctEFcwCZks8+pbmgFGNq62JUcrCYMq9I
SErvCoisOYU9H/QTnJZG4KPPPuWVb9ejmj6OoIsXIUsyZdU1bPryQ8xv/purlpzLgnnz+lQElJyc
zMuPvMRdf7uLrP2ZpF2RjjZIi91mJ1zfGjR0ed3o9SeCOdZyK0f+cZhRupE8cu8jvwh/oSiKWCJC
aaptQOeVuebq63hk9QPstB4iaXAUxUWl/PDVbiaaB3PnnKWo2voHZDySH4NKBwioFErmp41Go1Lx
t7sf5oOvPwTAZDThEB3U1FUTFdG+fNdsNhMeG0f+hyVo1O231R6PDxkJlapnA6xUKoiM0FBVVYVW
q2XX1u3g9RMRGsbIQYPx+nwsPnMBL7z2Mk+teZJLLmnPu+/xePjLX1aiVxby51tHo1YraG5xc+hI
DfuybdQ1wPyFy3j5lfOJi4tj48aNvL/7h07n4nR7yC2r544pU7qZr5KnH3+2x+vqK3w+H5s3ref8
pZPadgpnzVvAx+s/x+724LVY2Lq7ANOyxQg9PFuyLNO4NRM+2tznefzqXYR9RUFBATc+9yRxf70V
TVDHrbe9rJKqNz9ihjmMP914c5/rB9xuN6++/ioffv8RpkkmKhQVjJqQTpAliLL6CgIShBBC7ZYa
3Afc3HzJTZxz1jm/OIFpIBCgub4Rpbf1Afj0s095441XsdU0cu2Y2SwZPq7di+PyevAq/FhM7X12
SZI49+01vP3NWmJiTxR9trS0YFQEd3BvmpqaePjBG1g0dxDx0eFYgg34/AFKSmvRh6pITelZMQrg
X//OIiFhDl6bg8ToOIJOOk95VQVKs5Frbriayqoqvvr863by9YWFhfz+yvPJGB2K2y1TUe1CkjWM
HTuJ+QvOZvz48e3Kj51OJ5euWM7SyWkMSTwRh/D7A/z7882Mn7WQG266ucu5NjQ0sGPHdnZmbsPp
sqNSqjAZg0hJHMLgwUMYNGhQv9LCOTk57Ny2jvOXzWr3d4/bzRvvreWd9TvxzJ5K9OKZKI2dl7ZL
Pj8t2bm4ftxHsjXAM/c/RHJy8unXRdgXZGdnI04e06kBADDGx5By5w1se/sj7n3iMR67+94+9cpr
tVpuvu5mLltxGV9/8zXXr7oeMUFCEgNUNNYQHxdPXEYM10+9jlm3zupXscpAQKFQEBIRhs1qxdPi
oCivgHjZxAMXXYHmpBdAlmU8AT9uwU9QJ8QToigSpDfgcLRn5DEYDFgbWzoYAVmWCQkNYujISMpL
myiurEapFAmLMjEoufctuiVFtSh9xViCgimvLEetSkKn09PY1ITV62bhpDnc8cc/s/KO23jxlRfb
GYFBgwbx3PP/obq6GqPRyKBBgzrtOjwOvV7Pg6sf4947VzGuqo6YMAtWh5NdR0oZMX4K191wY5fz
9Hq93HXfHQTFyaSMjiIoJAJJknHZPRRUbmHn519TV24j2BjK9EmzmTx5aocagK7g8Xgw6NtnahwO
F9t3HECWIvnrzXezNWsv39/zAtLQBEiNQ6HXIYgCAZcHubQaeV8eo1OHct6885k3b16/SFpPu53A
C6+9yoZ4M7Gzut6+wTF67Of/xeXxQ7lsRd/1545jUGIyb9zyd7w+L1e9uIp92fv61J/wS+C1V1/l
3ef+weNzL0D0ynhdboKCglCqVfgJoFIp0anViCKdbisveO8F/vHJ6yQmtWdVaqhtIjY8vn2fvN3O
Y3+7jT/dMbHfu5+KikYee3ATkyctwhOkR6VS466qITkmloBKwex5cwkJCcHlcpGUkojD4aQwr5CI
iN7tMrpCSUkJH3+4lurKCoIsFs6cO58JEyZ0aTwaGxvZlZnFM/94nPmXjEMUBURZIjLCRGSspe17
sixTW9nE0QPlFGXXExWSwOL55zJlypRu41PV1dW89cbLjBubjE6nobKygfyiOs4YPZnp02e21RHY
7Xa2bNnCkYJ8mmxWAlIAk87A4MQkZs2c2aHqsa+kIqfdTsCk0xGw9SzVLAgC8Vet4M0H1zApY1yH
jq1en89oxOl2svnQDpYsWfybMwA7duzgX88+zz/OvgI9CprcLehNOuxeO1GWSNQKZRu5Z0Dyd6hu
KGmsw6uA2LjOS1Z/+oIYjUaCLTFUVDQRH98/nYCcI1WYtWYsQUFU40dt0JNrbyHYG8LFyy9pc+F0
Oh0P3f8wK2+/jfc/eJ9bbr6lX+c7jsTERFb2IuUIUFFRSU5xCcHRsaSlj6eyooXhY5OQAhIVtVYE
QSAy9gSrdWRsCJGxIUxdIFF8tIr3v3qFj9e9zyUXXklGRkanhiYqKorzL7iS3JwjNLTYiInL4Mz5
6R1qI4xGI4sWLWLRz7r6rnHa5frHnTEaf9bhXh2rNhnRzJ/Ouu829Pt8o844gw9+XMd/d6zj5tt+
3kM40JBlmSceeoRbx88h3GDCZrURERJOSJAFpSygFIS2h08QBAQE5J+UHn98eA9nXXBuB5epVayl
c96AYcMyKCjsP8tyVbUVfUgUflmiKDubw0cOEREXw8xZszrEcK688krUKg1//etf+32+vsLv95Nf
UkpIZBR6vZ6l5yynJNtKbnYZokLEZDHS0Nh54ZAoigwaFst5105lxFwLr77/DPc9eBdVVZ2XHCcn
J7Nw0WLOP38FkydP7nNx1EDgtNsJpKWlkeCHmh2ZRE5qT1jpdDqpqqyisrIcKSBhNJmIiI/ix6+2
sLIbxd7jCAQCHbZvt61ayapb/8gjjz9Kenp6F9/sO2RZxm634/F48Hq9eL1eJElCo9FgNBoxmXoW
J83KysJWVcusKctoaWlBq9WhPJYNUCgUx67nxE8siorW3YAogyBQ1tTAV4WHePelBzuM7XA6MGhM
nd6zoUOH88Xn3zBrZoeP8Hr9bN12lOy8cnKKq9Fr1cRHhTA8JYbJEwej1aqoqRW4YeUfMZvNnHfp
RdTX16NSqdr4BE+GRqPhrTfe4ndX/A6Px/OLCJPIstxaFXrs2kNDQ7np2pX8581Xqa86yJAR0cRH
dx8LEgSB5KGxJA2JYf+OfO5+cBU3XXM748aNO+Xz7ytOu5gAtPp2Nzy+moi7b0QfEYYsw8HsA+Tk
HCHYpMGsVyKKAm5vgNpaO+Lf32Lrfz/pVoX48OHDVNfWcOas2adkzpIkUVtbS01VNbUl1TTXNKCR
lKgFFRpRhUpUIiLglrw4A258WpnhU8eQmprapTF4+P4H0B0o4ncIONJvAAAgAElEQVTjZlJZUUFo
SHhbJWNjcwNBwUEdVtbjbkFZcwO/++gVos5IIS1tGKtuvLktO2B32PE7JKLCYzr1af1+P48/fg+L
F5lJTYk86e8Bnnj+S2pMThImRBKZEozfK9FYYaP6QAPNB6wMj4smyDyOW265s0/377PPPmPx4sW/
iIQ6QGlpGXll5WiNpjbDY7fbWf/lpxzO3sHEBSmMnz4MtbZ3TMs1FY189VYWt1z9l3Y8AqcCpx3R
6E9RXFzM+nVfsm/7XlqaWhs2BqcPYfi4UUybPq2txv2bb7/lyfWfEnvbVRwoyqe+torUODPqn3AF
OqsaqHjgJcQmH5u3bCMmpiP3yaFDh6isrWFkWnqfac56gs1mozCvgKL9R9F5lISrgwkzh2AxBbWt
2p3B6rCRXZGLfng4U2ZO6/SYm6+9juk+A5PjU7C22AgJPuGjNzQ3YLEEd7py5lSXc9WX/4NlQhJz
z59PxeESLpm2lDHjRuNz+1GjJSw0vNudSG5uLv/94EmuvWYM+mMR7q++OcD60iPMvnl0pzuIuvIW
Nrx6CH1NBH++/i9MGD+hy/F/C2hubqaqugb7MS0Ds9FAZEQEbrebtR+9z+4DW0ibFM2IcYMwmHom
NSkvqmXrh8U8+8SLXVKEV1ZWsnnzZnJzc0hISGTGjBl9jmedtkbA7Xaz5oln2PHlFqaYRpEekkqQ
xoQsyxS3VFBkLyfTlcuCi8/i6uuuQaPR8P3Gjdz9zxc5mhrJ2EUZKDUd/dqa979mQkUe1iYndjGe
z79o3+N08OBBqupqB9wAtLS0kLV9D40FNcRrw0mKiMeo69g+2x2cbhc/1Gax7PcrOv38uiuuYo4Y
wqiQaJSiEv1J49c11hIeEY5K2X6lyqku5w8b/o1pQgLnXLgMSZIo2nmUaxZfyojhI9Fqtb3ecn/+
+ScUFX7FJRePRq1W8vK/v8OZoSB1YkdD6/H4KShoIiZmCLgUbHtxD+dMOI8V5684baXcSktLWf/1
F2zbvYnQOC0pIyNJGhKD3th1bcpH/9zKleet7LAbaGxs5OHVD/HWO2+QmhFJcIIaa5WPvJ3V3HXn
vfzxtlW9ntdpaQSsVit3rbwTUyGsSFmETtX5TbR67Py36Guaor089PRqYmJiGDf2DNA68YaEoJwy
Fm1yLAqdBk9dE56tWcTVVbJ8YgyiIHDPy7vZsnUXycnJSJJEZlYWFXXVpKcMISoqCoPB8LOLfmRZ
5vDBQ+T+eIChxniSoxL7/ZDvKzqEMMzMpOmdp0OfffppWr7fzbmJwwk7yRUAqKmvJiYmpt317Cg6
yk0b3iBp/ggWnLuklaPA4aI5q5on7/9bn0VJJEli7dp3yc3ZyOJFiaz9ei9BZ4UQlx520jEyjY0O
qmtcxMUOIfxYms9td7PxuW1MiZnBtVf+4bQ1BNCqx7hv3z62bNvE4dz9KLUQFmckNMaAwaRDrVbi
cXspya2nscTPM4+/0K7+YseOHZx/4VKGzghn9tWDMYWceP6ba5y8cs1Wvlr3ba/FbU47I+Dz+bjh
d39gUF0oy1J6LvWVZZnvS7ezQ3uUvz3/BBljRvHkbZOx2j0cKm2h0iXhCkCwUmZUjIGEKHNbc81r
n+WQPm4+UfGRHMg+gFvyYzEZMZiMSJJEwBcgyBRMVGQUg5OGMGzoMJKTk/sUjMrak0ndzmLGJ49E
q+4729Hxa8wtL6Bc28zC5Wd1+XKWlJSwdN4C7hu3kImpJ4RTJFmirqG2zXXKq6ti7cFdfFq4nxHn
TmTy/BNioAU7c1g+5SwWzFvQr7kC5OXl8eHaf7MtaxNJl0WSOj4GSZZxu/00N/swGEOIjo7H9JNq
RZ/Hx4YnfuCSSVf8rPP/liDLMlVVVRQUFFBQlE9zSwMerweNWsPYMyYwZsyYdvdh+/btLF1+Nsvu
HcmwKZ03KH32RDbnTb6Om2/uuqrxZJx2RuCD9z5gy0tfclP6JX0a/985HyOPMbJ+/Qfc+buRPR5f
UmVl7bZCos9IY3TGGGRRICE5luAQM1JAQpJkJFnCaXfjaLHRWNuMvc6Bu8VD+uDhzJs9n/T09G6N
VHV1NTs+3MjsQRNQq3ovNXUyGq3NHKjKRZtiYdLMKT3KSz3wwAO8/cprXDByEnOS04kNCsHldVNa
X02px8b6okPYBYm5SxZRaKtk6NxRbddQcbSMJDGSlTfc2uemq58iEAjw7rvv8lnxfxlzSRoCAjqd
kaAgM7pulH+sdTY2PrKdx25/ckAVe08HWK1Who8axpI7h3ZpAAB+eCeXOM8U/r7m+V6Ne1oVC3k8
Ht595Q1uTeh7Rd+KlEXct/F5mqw9Fw5Jkkx2SQPRo6MwBZvwSRAXG4neaMDna02XiaICBWAKUmMK
MhMRH43f60OtVlBVWs3L77xAbFAcN153c5e53JrqGhK0EX02AP6An7LaCkrs1fhMImecNZ7ExN5p
Ihr0Bq66+lacTjsPbd5AU3MTHo8bo0nPmQsXcN/tzzJhwgS+/OpLqo+ckP+qLanCbFVxzS2//9kG
AFpTksuWLePLO9cRFRqLPqh3NO7mcBPDL0nlqX88wbMPPzcgczld8PDqh0ieYOnWAAA0lLiZO6Nz
NquBwK9aLLRlyxZiAqFEG/teDqpXafl96jIkm0BNQ0dDIMsyPn8ApzuAyycREWwiN7MOldZIckoc
4THhqNRqlColSqUSUSEiKkQEUUCSJKRAALVagUanIXlYEjOXT8UX4uLJNU90ySYcFR1FibeW4urS
bglHZVmm2d5CYWUxOwv38U3RdpriZMYsm8bZly7rtQEAKC+rIH3YCK645FpefeUDPnx/A4vPXc7j
zz/Hk88+w6RJkxBFkZqGWrQmPX6fn5IDBWhr4bY/3DKgxSkGg4FzZ5/H9n/v7RPhaurEQTiDbGRm
Zg7YXH7raGlp4bV/vcrc64Z0e5zb4SN3aw1z5849ZXP5VXcCB7OySdcfb0mVsdsdtLQ0txbPeHzI
kgRCq7iEyWTEbA5qtz1OC00hMSiODTvLuGzxsLa/S5KM2yuBKCIqRURRwOn247EJBGoDVJXUoDXo
0Oq0rS+8JCFLMrIsIQqgUIpotJp2/eeCIJA+Lo0fSrdRXl7OsGEnzncckZGRzFyxgH079nI4bwsm
hR6NoEIhiHhlPz7Zj08O4JI8GEJNhKdGkRw7islRUf0ugmlsbCTIfKKDzef3kZN/mHtGt8/Dpw9O
Y+dHe3AVNDN74gzOXnTWz1Ky7QrLly5n/9/2cXDDEUbO731xVdLMWL7duoHx48cP+Jx+i9i6dSuJ
w8Mxh3X/G2z6Tx4L5i1iyJBWYyHLMrt378ZgMPTonvYWv6oRaKptJFUdRGlJCcWFxSDJ6NCglhWI
J7Hse5BoUtTjlN0EBQcxfOQIVCoVgiAwb9A0Xjr0FmcMqWNkamsXmyzLSIAgt0awjxQ38X1WPXfc
ejuLFy1k0w+b2frBdlQGBeZII5Hx4YREWNAb9Sg6oXEK+APUVzdQeKAYizq0W981JCSEMxfPw+Px
YLVacbvd+P2tjL1qtRq1upXGa6CKXhobGwk+yQgcOpJNSsqgDk0lkydNJm1YGlqttl/07L2FQqFg
1fW3s+rhlYQkWIgd1js2nviRcaz/z6ZW5qbTOFPQE1wuF++8+x7792URFNO94S/MqmPfFxVk7VkP
tD7L77z9Plu+2o+g8rH66bvbaRf0F7+qEWhuaMJr1VBU3kg8YWiE4750Jw+CBH4CFDZW09zc3KYs
Ozg4iWULlvHON+sZVdDMkmkJmA0aDKKM3ellc2YFWw41cvGFl3DDdX9AFEVSBg3iqt9dQWlpKblH
c8nOOcC+vYdxuhxo9GoUKsWxnYGM5Jfwuf0kxiWyaOLZzJo5q1cvsEajGVD1284gyzI2mw29/kR9
wJ79OzlzbudVj7+UbHpYWBh333Avj778MO7LPaSMS+rxO6LY2ufwv9kA7N+/n48+/RKNSsHChQvZ
+MjnXR6bt7uGtffv5903P2jTadi6dRtbNxxkVMos8sozKSgoOP2NQFNjExGWkVRVl1IjtaCX1GhQ
ISLSupRDgAB+ArgUPpyym+jYmHYXHm4IQfZLHMg+zKOrH+a+f/yLkGADWrWS8qomho1KZ83TD3LB
BRe0O7dCoSAlJYWUlBQWL1oMnJA+d7vdiKKIQqFAoVBgsVh+kwErQWhl//UH/KhFNXa7jewj+/jz
X1exf/9+3nz/DYrLiwgOsrBo1mIWLVqEvptIfV9wvPfB5XJhsVg6pDGHDRvGw6se5W8vrKappJnR
54xA2Y26jtPqIsj8yzfPdIbS0lKqa+uJi4nqtMK0r5Akib8//wKNTQ7S01K48ILl2O126ksd5O2q
ZvCEE0VqLbVOvvufPPK3N7D2vY+ZPr01nWu321n7zuekRo9HoVAgyhqsP5E76y9+VSMQEhaCp9HL
oKGpePw+nHYHVpujNWUXkFCrlGg0WjQ6PVEhFiwWC8qfVMA5vE4s4a2fPfnUM6x+9DEKCwvZf2A/
BrOJ8WMyOm1M6QwnS5+fLjCbzdhsVkJDwvjq+y+YOXsGjz65mvU7Pkc7AfQZGkpb/Oz67xaef/U5
Xv/Hm30KPP4Usizz3Xff8vFHb9NirUelEnC5AgQHhzJl8pnMnbeg7cVJTEzkyfue5p+vv8IXf/mO
1CWJDJsxuIPLJcsy2V8cISPt148HFBUV8d+t+9FEJODN2cWE5EimT+4/dwLAvn37kCSJP1xzeVvt
htls5oN313LBRecTEltEeLKB5ko3ZTn1XHv1tXz2z3va7dw2bfoBhScEg/54kZE8YAvTL2oEfD5f
2woLkDZ2OAVrCxlvGUFwkIng0BNkjz6vFw0KLMHd9+9bPXYsYSe+p1ariYqKorK6ihHpw382EcVv
HenD0zh4JJvoyGi27fmBKbMn81XuZySsDEWhOunBzYCqzTWsuuePrH3zw35tu2VZ5vnnnyH7wLeM
z4ggJCShjavAanWRm/sx3377IQsWXsiKFZegVCoxmUzcfvMdFBcX8/6n7/HFl98RfoaF4KQg9EE6
GkoaqT/YTGQglstuPzWaDb2Fx+Phmx1ZRKRPwGAORkpMYeeB3egy9zFh3NieB+gCY8eOZezYjt+f
Pn06Rfkl7N27l5ycHBISEpg4cWKHjI3P5+P7r38kNuJEB6IsBAYssPuLGYFAIIAgi0h+GUGQEEWR
8ZMm8Oyb3zI+5Hixj4wsA7KMqBBx2J0YDEaQZaRjKSeFKKJSKjnOyWzz2gmOaF/zHxwczNTJUzqs
6h6PB7Va/b/K7zzn3HN48L6HEUSB+x64l5v+fD2RV5rbG4BjiJpuIefvh8jMzOxXJ1tOTg77933P
gnlJbZkTSZaorKxEEESSEgykpxnZtvVd8vNzuOOOe9rkxpKSkrjztr9QXl7OocOHKDiaT31zPaPi
JjJi8QjS0tLa9BR+LdTU1OBQBxFyLNAqKhTEj8hgy56NDEpK6JVuYV+h0+mYNm0a06Z13iQGrQ1u
Prsaw0maDgHBOWDz+YXdgdbATyAQQBRF0tPTqQ40UGatJkHVuk06Obvsl2U8Xg8qpQpREE7sIk56
ifM95Zw1bDo/xU8NQPb+g+QfKEFjUnHmwhmnNEL+S2LixIn8/cU1qFQqVCoVTtlJZETn9NmCKKCK
FqioqOiXESgoKCAsFBQKkbq6OiqrKhFkaCgoQ6tQ4ZJ8SBolyUMHU1WTxT//+QIrV/65ndGNi4s7
tiX+7ZUJ1zU0ojCe2IL7/QECkoQuYRhb9+7j3AWnLlffHb77ZguhhhO8hbIs45UcvXZze8IvZgRE
UcTn9yMKIqLYKuTh8/lYfMlS3v/nZ9weehUqUXXs/T4WJVarUCtVXfrptY4GSqhtR0LZGQ7sy6b8
YD1jkidTVl1CzuFcRo/tXTPG6YDjraYOhwO/I4DfHUCp7egvyrKMv1ruVPmnNwgLC8PrVSAj88OP
PxIQFKj8PtI1oUToWn1Vu89NWfZRnCr4sdTKggVntyNjkSQJp9P5qxG0dof6ZhsafQSyLJOXn8+W
rdtwOF3ERUcxNlyNzWbr0P8w0JAkicOHD7Nx8ybySwuRAzL5+4tZPOmatmM8Xjd6g2rA7uEvVjEo
CAJKlQJB0RqZFwQBk8nEJRdfhGaYhY0VO1ujnqICURRbjYDQelO6widl37H89xd1G8xrbm6mMLuc
9KQzUCgUxEUmUHKkEo/Hcyou81eFwWBg6cJlVH/b1OnnDfuthCkiGTNmTL/GHzRoEPWNMrU1Dfgl
mbQZc7F7vTR4TlRsGlVa0oyRpGLEUZfLYw8/gs1ma/t8586d3P3XhwYssj2QkGQJQRTZtWs3P2zf
xahJszn74qtw+GQKGpzkFZwQ9pAkCbfbjcPhwGq10tLSQmNjIy0tLW1ZE6/X2+tz+3w+Xn/jdUZO
GcviG1bwxOH3+Cj4MB/o97HVtp8XPnkQv98HQFNLLanDBg2YW/uLugOdRVj1ej1nLlvIRy+/Q2J9
DOnt9N6ELstPN5Rspdbi4MKLLuz2nDkHc4k2JbYFI5VKJVqFkZaWlv+VQcM/rfwze6/aQ+l7ZQRP
0KOP0eJt9tG004Ei18Ar//yffke6IyIiWLLkYj795O8otTpEUUHEoCFU5B8lKRCKTnHCp7doDIwM
DufInoP84aLLefSFZ0lOTiYtLY0lC20DlqocSKiUSoqLi8k6eJRZi5e2NT6NGjeZres/Zkf2EZIS
4rFZ7XhcbgRBbE1nQ1uNgyzLrQuXcNyogDnIjDnI3GUgr7S0lIuv/R2l2ha0q9IJGnzC17fZbIhT
46lbvZvcon0MHzyeFmcdC8Z2v/vtC351olGj0UiwwcQFd17Ne7Zv+arkB/yS/9inMuJPrJ1fCvBh
/tdkmop49p9/73YX4HA4qC5uJCq8fdWaRtThcPTceHQ6Ijw8nM/e/5zrpqxEvzGKsseseN7XcFna
tXy19huGDh36s8ZfvvxCwiPGkH3AhcvhISIpBZfsJ9dRz8kRHVmWqWuQuCBuHPMdIdx6yVXs2rWL
4OBgFiyY/4vRhHUHWZbx+/0n/h8I8MOPPzJ++px2nY8ajRqXzUpxaS0VJZUoUWIJCiHY3CrOYjab
MZlMbdyQJpMJt9dNg7WRhuYmyksrKC4ooaamtsPONjs7m3nnL6F8uoag+6ehHdw+2Of1+FAoVYhq
FaKoaNWRoLGtjHgg8Kv/EoIgMCg2gVJfMzc8czefvvIOj2W+xnTzaKLVoZj1RgJSgBaPjYN1eXzX
tIuEcak8t/qFHsU/q6urCVaFdVj51Eo1TrvrVF7WrwqDwcDNN9zMzTf0rv+8L1AqlSxZspTvdmez
dUsD0ZEBBLUZyagh315PqjEMm9vP/nwbBkcEY2ISUIkKwqwGHrnxDm559F7mzT91ys29QXNzM5mZ
h6iubcTr9WMwaEiMj2LPzu0YTEGEHQu4SYEA1poqZI+XIKMFhSEUv8/fYxajrqEWl8JDaFwokiRh
t9qxOx0IdQKyJBEV3ZrNqq+v5/yrLsZ3dSrmSR1L0Y/3tQh2D4GCJmJGJ9JiayAixjKgmYpf3QgA
JMbGc3R/OaFDkrn8zhvIP5zLoe2ZbNz2Hf4DXyAqRIKCzIyekMGdF9zPmDFjeuUPVZZUE2zqSBkm
dONm/B96RkxMDApB5Kw/v0Dezk1s2fUM1eUSXpeNLc5S4tRhTLaMZs7gNJTH2I5SzRGsVE5gzd0P
YzKbmTRp0q8yd7fbzddf/4hSG0dkdAJKpQqPx0V+cS2ff7mLsLHjcTtsqHUGrDVViAEZjSkYhUqF
rNHT1GLlWL1Pp/D5fNi8dsJiwxGOZbSCQ4KxKWy4HC7EZoGIyAhEUWT1U4/hnhpCUCcGAFrT6vhl
XC9nMXXwXIJMoeQU72bpFVMH9J78JoxAdHQ0+kwFTrsDvdFAavpQElKSmDppEivOPu9EoLAP8Pv9
1Fc1k5DUsZNN7qw34f/QayQmJlJfXoo+KJjRC/5fe2caHFWVBeDvdGftdJLOLk3SSYeQgIGMBhCU
wKgg4oZaU9SU5ajjVmO5gNZoIVOMW9Us/rBGHUenXNgUQUUdZbTGNaiUpegY0RDACHQIgc5G0t3Z
SC93frw2JGSDmE53Ju/79V7nvZfTXfede+4929X4/YrA7i9Ys3oVq++8m/ltSVxk7Z//PsmUzG0Z
pfx55Sr+/MI/mDFjxpjL3tDQQLc/gTPST0wOsbHxtLa2YZs6jy6fmapPPyfLbsUUZybWrAXudHV2
kpSSOmz9im5vN8bYqH7jKzE5kfq2egzHT4zlD3eUE3//DHx+34BFZ72eTjoe/Yrpx6dw8ZLleL3d
eI3HmD17dKsVh31PADRvwblnzabhYF3Pjmp9TR0zCqb1eBKUUhw8eJCP33ufba9t5c2Xt/BpeTkO
h2PAWb25uRmTYeDa/YGAwhgVEV99XJKUlES8KR53Yz0AGbn57Hc4KCgo4O/rn2dnWjdvHt5FQPX3
7NgT07k+6UzW3H4PjY0jb2AyUrQYlf7l2qr27qOguITUpDQSU4qorTqE80C1VqLd58fn7SY+3oTP
7x/y+QYxoAL9x6PfHyBgCBBnjusZz55WN57Odurq6vpcqwIKzw4H7t9vZ1qHnRuW3kNUVDR1DQeY
W3b2qLtXI+ZNsNlsLCwupXFvDYf37Cc3IYMZZ2p187xeL29ueZXyF7fQ8d1eEpzHsDR7aN25i483
bmbL2vX9Ory4XC5MUQP7dJVSiEG3BH4OM2eWULevEoBUaw61h2oArbXWUxuep67IwrM1X9Ll9/a7
tzjFygJ/Go8+8MiYL8uioqJQqq9MPp8PR00t2bZ8rJnpdLW5ycqbRbOznZrKCjo723vSv4dTAjEx
Mfi7T1wTCCja29tp72ojO28yhugTHaFuue5Gmh7YzvHP6+jc00Dbzlpa11bguutD8t7r5N5rbuf8
s67AYDDi83lxeQ+xeMno98WIGCUAMK1oGr+66DKWnbeICxYs7JnFP/noI7oPHGKOvYDcMyaRYUkh
3WLBbp3MHHsBGW3dvLVuYx+N2tLo6lOCuzdef/f/TcRguDin9Czq9mpKIMGSSmdHBx3B+vwWi4XH
n32G7GUL+MvBT6h21fe7/2LrdI7srGTHjh1jKndmZibK7+njFXA6nZiTU4iNiyMrK4uAuwljdDTW
aXNpONrCvoovSE/RIgn9Q8StgGbVxkg0TY1NuD1uPB0ezJYEbLk5JCUla+v8IHfddgfyoxvDc3vJ
3tLMzE8N3Fe0nHf++Qrl296npKSEQNBTdvDIbhZeNGdUshpPZsRKQESWisheEakWkdNrJzMESUlJ
pKen98mQqv6ukkLr4LsxWampTEtK5aO3tvXMLO7WNkxxA/uivRyPSD/1eGJBWRkHvtgO9BS27LP0
io6O5r41q1nx5J9Y7/2Rlw9908cqMIqBReZcPnjrnTGVOzY2lmnTsqmvr+35rKmpGUuaVvvBnJhE
coyBTo+LqOhYrIXnUru/hpQ0My0tDahAN63uVlxuF26PG7dHCxRqdbXS4mqhxXWMRLMZAoq0zFRy
7TZSUlIxGIxaG7VeFah37dpFekIS+SlWtr/9AW9vep0Vd66gpEQrBpufb6fD38yBw7uJz+hk2ZWX
heQ3GZESEBEj8BSwFDgTuEZEQlYJ0ZSQQOcwEX5pyRaOH3PR3NwMQJu7nfhBlECXv6MnsaU327dv
H/T5kehNGEreUDN//nz8bW6O/FBFIBDA5xvYdVZWVsaGt17DfMksHnSU8+TuctzdmnvWnphO5X8r
xlp0SmYWE21swe3WIivb2jzE9RoPdpuN9nqtTqQxKoYWZyNmkxmzJZmSmUXk5GVjtU0i05pBpjWD
M3KymJxrJTffxpTCKRRNL6J4ypl0tHbQ1dkFaEsOd7OLDMsJ115FRQVWk2VQV7fdbqd4to1JRUbu
W71ywDE7GozUEjgH+FEp5VDaAmsLcOXoidWX4jmz2N/oHLZ4ZyCYY+33+1E+Bu2jFzB4B4zeGuql
qq6u5rHHHuOhRx7G4XCM5GuMOuFUAgaDgd9edy1fbt2Aq+EoqWlpg0YiJiYmsurBNTyxdSPVGfDw
0c94sKacp51fMfeChWMsuWYNXHj+XI41/kh393Fcbo+WrRokLSOTSeYY3A11OI/WIcdbcTe20eV0
kJOdTVxcHCaTqScwyGw2YzKZiI2N7RlziYmJ5GXl4nN1U+9w0nKkmUxzRp9NvX2VVSQYo3p6QJ5M
TEwMd9z1O+65d3QLwp7MSF2Ek4HaXueHgbk/X5yBOXvWLI7WHuab3fsozLKSeJIpr5Riz+FDTCoq
ICUlBZ/PhzDwxp+7zUV6VsppuwgLCwtZvnw5z69fxzPr12IQ4epLLqO0tDQiot/Cwa233MLGCxex
+Y93s+QUquHa7XbKzl/IqlWraGpqoqOjg6lTpw57XyhIS0tj/nnFfPZ5JW0eD5mZfQutFBUW0f5t
Bd9X/kCqJQV3s4cyu+W0gnTi4+PJy84b9O/Ve/cRbYjClm8f9JqxYKSjd0xtY6PRyKVXXUnV1N18
+WE50U31JIgBUeBF4VJ+Jk8vZMkVl2vCDVGsssXdTPaskaVg2mw2HnngQZxOJ+te3Mir725j67v/
pmzWHC5avDgk1XsjGYvFwhuvbOGlTZu4+aabTvm++Ph4cnJyhr8wxBQU5BMdbeTTz7bTeiwTppxQ
SDExsaSYE7DFdNHY6mZynGLWL4ZvcnM6OGoc5EcnYy+YMqrPPV1G1IFIROYBDymllgbPVwMBpdSj
va6JvEW0js4EIeRtyEQkCtgHLAKOADuBa5RSe077YTo6OmFlRMsBpZRPRO4E3gOMwAu6AtDRGZ+E
rCGpjo7O+CAkEYOhCiQKBSKSIyLlIrJbRCpFZEW4ZTpVRMQoIhUisi3csgyHiFhEZKuI7BGRquC+
UkQjIquD4+J7EXlZRCKuHr2IrBWRehH5vtdnqSLygYj8IKAF3VMAAAKASURBVCLvi8iQXWdGXQmM
dSDRKOAF7lFKFQPzgDsiXN7erASqGGNvzQh5AnhXKTUdKAEievkoInnArUCpUmom2rL39Ntnh551
aO9ab+4HPlBKFQIfBc8HJRSWwJgGEv1clFJOpdS3weM2tME5+gHao4yIZAOXAs/DIEEREYKIJAML
lFJrQdtTUkq5wizWcLjRJghTcCPcBNQNfcvYo5T6DDi5qOQyYEPweANw1VDPCIUSGCiQaGTlbceY
oPY/G/gyvJKcEn8D7kNr2Bbp2IFGEVknIt+IyHMiEtHJG0qpY8BjwCE0D1irUurD8Ep1ymQppX7K
2qoHhgyMCYUSGA+maT9ExAxsBVYGLYKIRUQuBxqUUhVEuBUQJAooBZ5WSpUC7QxjooYbEZkC3A3k
oVmGZhG5NqxCjQCl7fwP+U6GQgnUAb3DwXLQrIGIRUSigdeBl5RS/wq3PKfAecAyETkIbAYuFJGN
YZZpKA4Dh5VSXwXPt6IphUhmNvC5UqpZKeUD3kD73ccD9SJyBoCITAIahro4FErga2CqiOSJSAzw
a+DtEPyfUUG0+OIXgCql1OPhludUUEr9QSmVo5Syo21WfayUuj7ccg2GUsoJ1IrITyVyFwO7wyjS
qbAXmCci8cExshhtE3Y88DZwQ/D4BmDIiW3UM1/GYSDRfOA3wHci8lNe62ql1H/CKNPpMh6WYHcB
m4ITw37gxjDLMyRKqV1B6+prtH2Xb4BnwytVf0RkM/BLIF1EaoEHgL8Cr4rIzYADGLI5hx4spKMz
wYmo8mI6Ojpjj64EdHQmOLoS0NGZ4OhKQEdngqMrAR2dCY6uBHR0Jji6EtDRmeDoSkBHZ4LzPzxc
i3wQrLY6AAAAAElFTkSuQmCC
)

## 条状图

`bar` 函数：

In [8]:

```py
import numpy as np
import matplotlib.pyplot as plt

n_groups = 5

means_men = (20, 35, 30, 35, 27)
std_men = (2, 3, 4, 1, 2)

means_women = (25, 32, 34, 20, 25)
std_women = (3, 5, 2, 3, 3)

fig, ax = plt.subplots()

index = np.arange(n_groups)
bar_width = 0.35

opacity = 0.4
error_config = {'ecolor': '0.3'}

rects1 = plt.bar(index, means_men, bar_width,
                 alpha=opacity,
                 color='b',
                 yerr=std_men,
                 error_kw=error_config,
                 label='Men')

rects2 = plt.bar(index + bar_width, means_women, bar_width,
                 alpha=opacity,
                 color='r',
                 yerr=std_women,
                 error_kw=error_config,
                 label='Women')

plt.xlabel('Group')
plt.ylabel('Scores')
plt.title('Scores by group and gender')
plt.xticks(index + bar_width, ('A', 'B', 'C', 'D', 'E'))
plt.legend()

plt.tight_layout()
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAakAAAEbCAYAAABgLnslAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 饼状图

`pie` 函数：

In [9]:

```py
import matplotlib.pyplot as plt

# The slices will be ordered and plotted counter-clockwise.
labels = 'Frogs', 'Hogs', 'Dogs', 'Logs'
sizes = [15, 30, 45, 10]
colors = ['yellowgreen', 'gold', 'lightskyblue', 'lightcoral']
explode = (0, 0.1, 0, 0) # only "explode" the 2nd slice (i.e. 'Hogs')

plt.pie(sizes, explode=explode, labels=labels, colors=colors,
        autopct='%1.1f%%', shadow=True, startangle=90)
# Set aspect ratio to be equal so that pie is drawn as a circle.
plt.axis('equal')

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAV0AAAD5CAYAAACEcub7AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 图像中的表格

`table` 函数：

In [10]:

```py
import numpy as np
import matplotlib.pyplot as plt

data = [[  66386,  174296,   75131,  577908,   32015],
        [  58230,  381139,   78045,   99308,  160454],
        [  89135,   80552,  152558,  497981,  603535],
        [  78415,   81858,  150656,  193263,   69638],
        [ 139361,  331509,  343164,  781380,   52269]]

columns = ('Freeze', 'Wind', 'Flood', 'Quake', 'Hail')
rows = ['%d year' % x for x in (100, 50, 20, 10, 5)]

values = np.arange(0, 2500, 500)
value_increment = 1000

# Get some pastel shades for the colors
colors = plt.cm.BuPu(np.linspace(0, 0.5, len(columns)))
n_rows = len(data)

index = np.arange(len(columns)) + 0.3
bar_width = 0.4

# Initialize the vertical-offset for the stacked bar chart.
y_offset = np.array([0.0] * len(columns))

# Plot bars and create text labels for the table
cell_text = []
for row in range(n_rows):
    plt.bar(index, data[row], bar_width, bottom=y_offset, color=colors[row])
    y_offset = y_offset + data[row]
    cell_text.append(['%1.1f' % (x/1000.0) for x in y_offset])
# Reverse colors and text labels to display the last value at the top.
colors = colors[::-1]
cell_text.reverse()

# Add a table at the bottom of the axes
the_table = plt.table(cellText=cell_text,
                      rowLabels=rows,
                      rowColours=colors,
                      colLabels=columns,
                      loc='bottom')

# Adjust layout to make room for the table:
plt.subplots_adjust(left=0.2, bottom=0.2)

plt.ylabel("Loss in ${0}'s".format(value_increment))
plt.yticks(values * value_increment, ['%d' % val for val in values])
plt.xticks([])
plt.title('Loss by Disaster')

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXIAAAEoCAYAAABFMXqYAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 散点图

`scatter` 函数：

In [11]:

```py
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.cbook as cbook

# Load a numpy record array from yahoo csv data with fields date,
# open, close, volume, adj_close from the mpl-data/example directory.
# The record array stores python datetime.date as an object array in
# the date column
datafile = cbook.get_sample_data('goog.npy')
price_data = np.load(datafile).view(np.recarray)
price_data = price_data[-250:] # get the most recent 250 trading days

delta1 = np.diff(price_data.adj_close)/price_data.adj_close[:-1]

# Marker size in units of points^2
volume = (15 * price_data.volume[:-2] / price_data.volume[0])**2
close = 0.003 * price_data.close[:-2] / 0.003 * price_data.open[:-2]

fig, ax = plt.subplots()
ax.scatter(delta1[:-1], delta1[1:], c=close, s=volume, alpha=0.5)

ax.set_xlabel(r'$\Delta_i$', fontsize=20)
ax.set_ylabel(r'$\Delta_{i+1}$', fontsize=20)
ax.set_title('Volume and percent change')

ax.grid(True)
fig.tight_layout()

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAakAAAEbCAYAAABgLnslAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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==
)

## 设置按钮

`matplotlib.widgets` 模块：

In [12]:

```py
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons

fig, ax = plt.subplots()
plt.subplots_adjust(left=0.25, bottom=0.25)
t = np.arange(0.0, 1.0, 0.001)
a0 = 5
f0 = 3
s = a0*np.sin(2*np.pi*f0*t)
l, = plt.plot(t,s, lw=2, color='red')
plt.axis([0, 1, -10, 10])

axcolor = 'lightgoldenrodyellow'
axfreq = plt.axes([0.25, 0.1, 0.65, 0.03], axisbg=axcolor)
axamp  = plt.axes([0.25, 0.15, 0.65, 0.03], axisbg=axcolor)

sfreq = Slider(axfreq, 'Freq', 0.1, 30.0, valinit=f0)
samp = Slider(axamp, 'Amp', 0.1, 10.0, valinit=a0)

def update(val):
    amp = samp.val
    freq = sfreq.val
    l.set_ydata(amp*np.sin(2*np.pi*freq*t))
    fig.canvas.draw_idle()
sfreq.on_changed(update)
samp.on_changed(update)

resetax = plt.axes([0.8, 0.025, 0.1, 0.04])
button = Button(resetax, 'Reset', color=axcolor, hovercolor='0.975')
def reset(event):
    sfreq.reset()
    samp.reset()
button.on_clicked(reset)

rax = plt.axes([0.025, 0.5, 0.15, 0.15], axisbg=axcolor)
radio = RadioButtons(rax, ('red', 'blue', 'green'), active=0)
def colorfunc(label):
    l.set_color(label)
    fig.canvas.draw_idle()
radio.on_clicked(colorfunc)

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAaIAAAEPCAYAAAAAicBfAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 填充曲线

`fill` 函数：

In [13]:

```py
import numpy as np
import matplotlib.pyplot as plt

x = np.linspace(0, 1)
y = np.sin(4 * np.pi * x) * np.exp(-5 * x)

plt.fill(x, y, 'r')
plt.grid(True)
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX4AAAEACAYAAAC08h1NAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 时间刻度

In [14]:

```py
"""
Show how to make date plots in matplotlib using date tick locators and
formatters.  See major_minor_demo1.py for more information on
controlling major and minor ticks

All matplotlib date plotting is done by converting date instances into
days since the 0001-01-01 UTC.  The conversion, tick locating and
formatting is done behind the scenes so this is most transparent to
you.  The dates module provides several converter functions date2num
and num2date

"""
import datetime
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.dates as mdates
import matplotlib.cbook as cbook

years    = mdates.YearLocator()   # every year
months   = mdates.MonthLocator()  # every month
yearsFmt = mdates.DateFormatter('%Y')

# load a numpy record array from yahoo csv data with fields date,
# open, close, volume, adj_close from the mpl-data/example directory.
# The record array stores python datetime.date as an object array in
# the date column
datafile = cbook.get_sample_data('goog.npy')
r = np.load(datafile).view(np.recarray)

fig, ax = plt.subplots()
ax.plot(r.date, r.adj_close)

# format the ticks
ax.xaxis.set_major_locator(years)
ax.xaxis.set_major_formatter(yearsFmt)
ax.xaxis.set_minor_locator(months)

datemin = datetime.date(r.date.min().year, 1, 1)
datemax = datetime.date(r.date.max().year+1, 1, 1)
ax.set_xlim(datemin, datemax)

# format the coords message box
def price(x): return '$%1.2f'%x
ax.format_xdata = mdates.DateFormatter('%Y-%m-%d')
ax.format_ydata = price
ax.grid(True)

# rotates and right aligns the x labels, and moves the bottom of the
# axes up to make room for them
fig.autofmt_xdate()

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXcAAAD1CAYAAACrz7WZAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz
AAALEgAACxIB0t1+/AAAIABJREFUeJztnXmcFNW1+L+HfQk4ILsoIIKKEXHDDXUwbvEpqM9EfHFB
jU9FYzT5RdEsPLMa4xpfzEswCs8nqElUwKCCSrsEBRVRIyAgDDgIA7KI7Nv5/XGqqJ69u6d7uqfm
fD+f+VTdqlu3bp+pPnX73HPPEVXFcRzHiRdN8t0Bx3EcJ/u4cnccx4khrtwdx3FiiCt3x3GcGOLK
3XEcJ4a4cnccx4khaSt3EbldRD4WkY9EZIKItBSRjiIyXUQWisg0ESmqUH+RiCwQkTOz233HcRyn
KiQdP3cR6Q28ChyqqttF5ClgKnAY8IWq3i0itwEdVHW0iAwAJgDHAvsBLwP9VXVPdj+G4ziOk0y6
I/eNwE6gjYg0A9oAnwPDgPFBnfHA+cH+cGCiqu5U1RJgMTC4rp12HMdxaiYt5a6q64B7geWYUt+g
qtOBrqpaFlQrA7oG+z2A0qQmSrERvOM4jpNDmqVTWUT6AjcDvYEvgb+KyKXJdVRVRaQmW0+lc7XU
dxzHcapBVaWq4+maZY4BZqrqWlXdBTwDnACsEpFuACLSHVgd1F8B7J90fc/gWFUdrPQ3ZsyYlI7V
d91c3u+II47I++dzWcRPFoXyOXIli0LpW33LsybSVe4LgONFpLWICHA6MA+YAlwR1LkCeC7YnwyM
EJEWItIH6AfMTvVmxcXFKR2r77q5vF+3bt3q9X4ui+zVzeX96iqLQvkcuZJFofStvuVZI1W9DWr6
A24FPgY+wiZPmwMdMU+YhcA0oCip/h3YROoC4Kxq2lTHGDNmTL67UDC4LCJcFhEui4hAd1apq9Oy
uQda+G7g7gqH12Gj+Krq/xr4dbr3aaxk9IaOKS6LCJdFhMsiNXyFquM4Tgxx5e44jhND0lqhmrNO
iGgh9MNxHKchISJollwhHcdxnAaAK/cCI5FI5LsLBYPLIsJlEeGySA1X7o7jODHEbe6O4zgNFLe5
O47jNDJcuRcYbk+McFlEuCwiXBap4crdcRwnhrjN3XEcp4HiNnfHcQqaZcvy3YP44cq9wHB7YoTL
IiLusujdG1avrrUaEH9ZZAtX7o7j5JU9e2y7cWN++xE33ObuOE5e2bwZvvY1mDULBg/Od28aFm5z
dxynYNmyxbbbtuW3H3HDlXuB4fbECJdFRJxlsXmzbXfuTK1+nGWRTVy5O46TV1autG2qyt1JDbe5
O46TV554Ai69FCZPhvPOK39u0iQ48UTo3Dk/fSt03ObuOE7BsmSJbXftKn/8zTfh/PPhlVfqv09x
IG3lLiIHi8j7SX9fishNItJRRKaLyEIRmSYiRUnX3C4ii0RkgYicmd2PEC/cnhjhsoiIsyxC5V7R
LDNtmm2bNbPtRx/ZCyDOssgmaSt3Vf1EVY9U1SOBo4EtwLPAaGC6qvYHXgnKiMgA4GJgAHA28LCI
+C8Gx3EAc4Hs2LGycg9H8qEXzcCB8PTT9du3hkxdlezpwGJV/QwYBowPjo8Hzg/2hwMTVXWnqpYA
iwH3Zq2G4uLifHehYHBZRMRVFhs2wPz50KlTZbNM6EWzdSuEU3JNm8ZXFtmmrsp9BDAx2O+qqmXB
fhnQNdjvAZQmXVMK7FfH+zqOEwM2bbJt376VR+5btkCLFqbcywLNMmJE/favIdMs0wtFpAVwHnBb
xXOqqiJSk/tLpXMjR46kd+/eABQVFTFo0KC9b+jQxtYYysn2xELoTz7L4bFC6U8+y3PnzuXmm28u
mP5kq7xpE/TsmaBZM9i5Mzq/ZAmsXVtMy5bwP/+T4NNPAYrp1AkeeOCBRq0fxo0bB7BXX1ZHxq6Q
IjIcuF5Vzw7KC4BiVV0lIt2BGap6iIiMBlDVu4J6LwJjVHVWUlvuChmQSCT2/lMbOy6LiLjK4t13
4dprzd2xXz+46SY7LoFz3623wowZUFQEl1wCt9wCzz6bYOjQ4rz1uZDIlSvkJUQmGYDJwBXB/hXA
c0nHR4hICxHpA/QDZtfhvrEmjl/gTHFZRMRVFps2WVyZZs0q29wBDj8cPv0U1q2Dww6Dtm2hT5/i
eu9nQyQj5S4ibbHJ1GeSDt8FnCEiC4HTgjKqOg94GpgHvACM8mG64zgQBQ1r3rzqFaq9e5vNvbQU
OnSAI46ADz6o9242SDJS7qq6WVU7qepXScfWqerpqtpfVc9U1Q1J536tqgep6iGq+lI2Oh5Xku3N
jR2XRURcZbFpk43Gk5V78tCvTRvo2tUmVDt0gO7dYcyYRF762tBwf3PHcfJGaJZJVu47dkTn+/WD
Ll1sv6gIhg2D1q3rv58NEVfuBUZcbauZ4LKIiKMs1q2DqVOhV6/yNvcnnjBlv307tGtno3ewOi1b
wj77FOetzw0JV+6O4+SFq66CZ56BkSPLj9yvvtr2W7SwchjvHexY8sjeqR5X7gVGXG2rmeCyiIij
LObNs22vXtVPqAKsXx/tN28Oa9Ykct63OJDxIibHcZy60L8/LFpk+6FyTx6lhzz6aLRCtUULj/ue
Kq7cC4w42lYzxWUREUdZdO8Of/qT7YfK/YsvbAHT3/8e1RsyJNpv0QJaty6u1342VFy5O46TF3bs
sAlSsInTP//ZAogNHAgXXFD1NW5zTx23uRcYcbStZorLIiKOsti+PZo03Wcf2z7yiLlGVkerVrB2
bSLnfYsDrtwdx8kLySP3oiC1z8aNNfux9+5t9ncROPronHexQePKvcCIo201U1wWEXGUxZo10L69
7Ycj923bIr/2qmjaFKAYgDlzctm7ho8rd8dx6p21a+HDD+Gkk6wcKneofQVqhw6561eccOVeYMTR
tpopLouIuMli1iw47rhIkScr95pG7nY+kbN+xQlX7o7j1CubN8PChbZ4KaRdu2i/tpG7mWac2nDl
XmDE0baaKS6LiDjJ4uijLenG/vtHx5okaaLaRu7t2hUD0K1b9vsWJ1y5O45TryxebNsePao+36pV
zdeHI3vPClEzrtwLjLjZVuuCyyIiTrLo1Mm2Ff3Zb7nFtiUlNV9/660JXn/dkng41ePK3XGceiWM
E1PRtn7ffdCxY82LmAA6d4bBg12510bGCbKz2glPkO04jYYw+fVLL8GZZ5Y/t327TZg2qyUwiqrV
27Gj9rpxJlcJsh3HcdIiOQn25s2Vz7dsmZqyFrGJVx+9V48r9wIjTrbVuuKyiIiLLDZsiBYh9eyZ
WRuhLFq3duVeE2krdxEpEpG/ich8EZknIseJSEcRmS4iC0VkmogUJdW/XUQWicgCETmzprYdx4k3
paWw335mVjn22Lq15cq9ZtK2uYvIeOA1VX1URJoBbYEfA1+o6t0ichvQQVVHi8gAYAJwLLAf8DLQ
X1X3VGjTbe6O0wiYNAnGjoXnn697WwcfbO0dckjd22qoZM3mLiL7ACer6qMAqrpLVb8EhgHjg2rj
gfOD/eHARFXdqaolwGJgcPofwXGcOLBsWfmVqXWhdeuqMzc5RrpmmT7AGhF5TETmiMhYEWkLdFXV
wMGJMqBrsN8DKE26vhQbwTvVEBfbajZwWUTERRbLl8MBB9StjVAWbdvCypV171NcSdeJqBlwFHCj
qr4jIg8Ao5MrqKqKSE02lirPjRw5kt69ewNQVFTEoEGD9i65Dv+ZXm5c5ZBC6U8+y3Pnzi2o/mRa
XrbMAn8lEpm3N3fuXACGDCnm7behbdvC+Xy5LicSCcaNGwewV19WR1o2dxHpBrylqn2C8hDgduBA
YKiqrhKR7sAMVT1EREYDqOpdQf0XgTGqOqtCu25zd5xGwHHHwf33w4kn1r2tiRMt1+rf/lb3thYv
hn79YOZMOOGEurdXX2TN5q6qq4DPRKR/cOh04GNgCnBFcOwK4LlgfzIwQkRaiEgfoB8wO83+O44T
E9avt1Wo2eDQQ2H+/Oy1BbBgQXbaKwQy8XP/HvCEiHwADAR+BdwFnCEiC4HTgjKqOg94GpgHvACM
8iF6zVQ0STRmXBYRcZHF5s1mK68LoSwOPhiWLCm/MCpTwjZUYffu6NgHH2THsycfpL1wV1U/wFwb
K3J6NfV/Dfw63fs4jhMvnnoKPv+87so9pHVrC/u7bBn07ZudNq++Gv73fyGRgHHj4Jpr7HhDHJJ6
bBnHceqFYcNgyhTLkxomxq4rX/86PPmkbeuCVLBaT5pkL42bbrJyoaonjy3jOE7e2bIFjjwSWrTI
XpvNmlnwsLpy/vlw0UVRefhwewk1ZFy5Fxhxsa1mA5dFRBxksWwZTJhQeZScLsmy+OADC/9bV7Zu
NYUOMG2abZMDmy1ZAg89VPf71Ceu3B3HyTmvvGLuhtlanZpMOAFaF7ZssbR/CxbAGWdY2r+NG6Pz
P/iBmWiqimRZqLhyLzDChQuOyyKZhiwLVTg9cLeoLfl1KlQli7oq3a1brW8HH2zlFi1gzZrofJhg
pLS08rWFiit3x3FyyqefWnjfPXtqr5sptWVvqo0tW8q/eFq0gBUrbJHUqafC7GB1TkMKd+DKvcCI
g201W7gsIhqyLN56y1ak1tXWHpILWWzdask/Qpo3h6VLoXt3OPpoezEdcojZ+BsKrtwdx0mLhQth
3rzU669alXlijlyzY4el+1u/HoqKouPNm1ui7oMPhqOOsmO9e8O6dVGdf/2rPnuaPu7n7jhOyqxd
C506WWTHZctSu2b0aGjfHu64I/v9Sf41kIkKef55OO8887vfujVqr2VLU/yqNlofNAguu8xcL3/1
KzseJh3JJ+7n7jhOVnjvPdvuv3/q16xbB/vum5v+1JXQVj9gQPkXRbLvfKdOtu3VCx57zF5s4QRu
Njx1coUr9wKjIdtWs43LIqJQZLF0KQwdapOkqbJ2bfaChUF5WcyfD//4R+Zthcq5f//yx5MnaMO+
Dxpk2127IjfJQnaNTDu2jOM4jZNHH4XrrrPl/qNGpX7d2rW5G7kfcojFqsnUph/mYB0xovzxf/4z
UvytW8M779jEasiHH9p27VozORUibnN3HCclRMwWvXq12Zu/+iq16wYOhMcfhyOOyE2/Pv8cjjnG
tukiAgcdBIsWpVb/T3+yCdgNG2DGDHvRXXxx+vfNFm5zdxynTuzZY66Cq1ebD/jOnalfm8uRO9gk
Zxiyd+xYu186/O53qdft0sVG7TNmWMTIESPgnnvSu1994cq9wCgU22oh4LKIyKcsNm2CyZPN57t9
e3MTTCdY17p1ubO5AzRtGplQ/vM/4b77Um+rc+f0skK1bBnNNxx0kG1//OPUr69PXLk7jlMjN94I
F1wQpZ9r2tTMGTV5inzyicVFv+gii66YvEAo2yQrd4js4amwZ4/FkUmVZF/4ULk3K9CZywLtVuOl
IccQyTYui4h8yWLbNhg/3vYPPzw63qKFjd5bt4aRIy3g1ttvR+dvuimKrphtKsoi2SwDZjpKlXSV
+wknwPXXm9dQv352LJshjLOJK3fHcSqhaqPzL76AHj1MkZ11VnQ+Wbm/+GIUWCsknNzs3j31xU6Z
Eo7cly+3crrKPZ2wCCLw8MO2v2VLdP9CxM0yBYbbmSNcFhH1KYulS200u307fPkl7LOPpZ1L9nbZ
bz+zPS9ZEq3SDE0j27ZZG2CKr3nz7PavOpv73XdbefXq1FeOqqY3ck8mNDWlO4FbX7hydxynHOGo
+xe/sPR18+dXrtO/v/l99+0bLeR54AG46qoot2lxcf2Maps1MyX9/vvwzDP2Mlm/PrVr0zXLVKRJ
k/L+74VERh9LREpE5EMReV9EZgfHOorIdBFZKCLTRKQoqf7tIrJIRBaIyJnZ6nwccTtzRGORhaq5
1tVEfcpi40ZTzo88Un2dyy+P9jdvhm9+02KdP/aYHfv0UzPXzJ2b/f5VlEWTJhYiIEwG0q0bfPxx
am3VVbk/+aQFFEtm505Lrp1vMv1YChSr6pGqGia5Gg1MV9X+wCtBGREZAFwMDADOBh4WEf/F4DgB
paVw2mkWhbAmVHMbEz1kwwY46SSzo7dsCbNmVa5z4YXly6efbvVDz5G777Zrk71LcsmePWaOad/e
lOspp6R+XV2Ue0VPHYCPPoIrr8xObte6UBclW3EaYhgQzKszHjg/2B8OTFTVnapaAiwGspD1MJ64
nTmiscgiNGv87W/V10kkEvzoR6ZMVq3KbX9mzbJE1gCtWlWfo3TXLjPDgIUB+OQTs8///e9w7bW5
619Vz0U4idqhA3TtmnpbuVDuL79s28WLM283G9Rl5P6yiLwrItcEx7qqajhnXgaEIu4BJCenKgX2
y/C+jhM7Fi607YoVNdcLz7/7Lrz2WvaSXySzZw888QScfTbMnAmvvlp93aZNYcwYm2zt3BnmzLFR
/4UX5i/eyr77wv/9n+0nu0dWR7reMhWpSrnfdpttq5qrqE8ydYU8SVVXikhnYLqILEg+qaoqIjXN
V1c6N3LkSHoHxquioiIGDRq017YWvqkbQ7m4uLig+uPl3JeHD7fyypU111+zxiYrL7wwESz/z35/
XnwRvvgiwZdfwmmn1V7/gANgyZJEMEotpn373MsrPJZ8vlUr2LbNysuXJygqgjVriuneveb2VOGN
NxI0bZpZf5o2hTVrEiQSVl6yBCDBKafAokXZ//yJRIJxgUG/d0VjfwXqHDhMRMYAm4BrMDv8KhHp
DsxQ1UNEZDSAqt4V1H8RGKOqs5La8MBhTqNk1SrzBT/oIHMvrMkSdcQRZtOeMyc6lu2vzZNPwrPP
wlNPpXfdpk3Qrp2ZRzp3zm6fUuHZZ20i+IorrJxqsLImTWyE3yRDG8a0aRab5sEHLSb8Y4/BK6+Y
B01JiR3PJVkNHCYibUSkXbDfFjgT+AiYDASi5QrguWB/MjBCRFqISB+gHzA73fs2FhI1fbsbGY1B
Fu+9B2ecYbFbXnvN/MOrSmGXSCRYvbqyEkrF9JAOoV97urRtayaRDh2y25+qqOq5uOCCSLGD2d0r
LqyqiGq0WCtTmjY119HDDjOf/02bTAbdu8Pvf28mtHyRyfuqK/CGiMwFZgHPq+o04C7gDBFZCJwW
lFHVecDTwDzgBWCUD9OdxsquXXDyyVFUxZISG7V362blAw80RVHxG3LhhTbKP/bY6NjXvmYLhrLJ
vHmZRXAMV7MWSpyVVJW7SN2Ue7Nm0ct4xQq4+WbzfgoDpU2dmnnbdcXjuTtOPbJ6tSmef/3LlPid
d9qE3J13lh+VDxhgi3JatLAXQvPmNkrcudPqXX65mSIWLLDwAOkwfbq9GAYOtBF3yNKl5hnz0UfR
y6ahct11ljnpuuuqr7Nrl7lr1iVV3ptv2ssa7CURqrEvvjAPoiFD7P+UKzyeu+MUCKHpYMMG25aU
mK1dxBTFQQfBf/+3jQbDUd+mTeZ9kpzAedkysyfPnJl+Hy64wMLcVgx1W1JiL5yGrtjBlHZtv2rq
EnogJDkdX6jYe/SwXz8vvpj7uDo14cq9wGgMduZUiaMsXnzRtkOGmKIeNy4a+Z10kmUEGjUK+vSJ
wgBs3gzNmiX2xmhZuNDc/Y47jsA7w0wB3/9+7fffvTvyq68YGvfHP7YRZ6GTynPRrBn8+c9Vn9u1
y2S/dm3dlXsY9jeZ116zbZcusHJl9ie9U8WVu1PQvPtu7hft1CdVmVAOPbR8WcQWB5UGq0O2bLHF
RCH9+lnO0AMPhF/+0kb0zz1nE3hhpMKK3Hwz/PGPUWKJsWOjewHccAO89ZbFkokD//qX+Zlv3175
XKh8ly3L3sh9yJBo4deBB9q2Sxd7dh99tG73yBhVzfufdcNxKgOqF1+sun17vnuSHYYPV33mGftc
xx6r+umnVdd77DGr8+mnVn/gwMp1nn7a6lx9tWpRke3PnFl1e6FvSJ8+qscfr/rll9Gxdu2i/a++
ytpHzSuDB9vnmT+/8rlf/crOHXOMaps2db8XqN5yi+qpp9p+xXM33lj3e1R/b1Sr0as+cncKlgkT
bPvUUzYqjQOrVtmE6k03WWCucJRXkU6dbNu3r3nKVFUvjEb4l7+YDf+nP60cwmD9evNdP+oom6Rd
utRMOu3bwznnWJ0w0XVZWXkbckNm0ybbhinxQvbsiX69vPtudlb5zptnE+J9+lQ+16uXhWMoLa18
Lte4ci8w4mhnzpSJExMMHGj74Ze1oVNWZsr9wQfZ+9mqomfP8uWTT05UqnPggVEMczA3yU8+KV/n
/PPhkkvggw9sonbcOHthgL0Ikm3syZ4zhUwq35F77jHvomTlvmGD2cCTqatZBsys1q6dZWiqyKhR
ds8pU+p+n3Rx5e4ULJs2wR13wK9/nX1/7nzxxRepreAcNMjiu4ApoNCeW5F/+zfb3nqrKectW8zr
ZudOM7S8/jqMGGETqf36lV/o07q1eXU89FBUjgvf/KatHE0O3nXUUdFLs0cPOPjg7Cj3kMGDK0ft
vPVWGD068o6qT1y5FxjJ8TMaOy1aFFNUZG5tVU2MNUS2by8/OVoTYY7OhQth6NDiKusMGABvvGET
q23amHI/+WQb1S9fbsd+8xv461/N5bIqbrjBfLGzqehySarfkQMOgM8+i8phdigwRf/JJ7YiN5tU
ZeYpKko9eUg2aSD/TqcxsmGDLYVv1Soeyl3VRtSpruK85x5TPqEZpTqGDLFFTm3aROar0lLzk+/U
yZJJXHRR9fZlETPfxI327aP5hIo8+WT99aOoyEfuDm5zT+bzzxN7R+5xMMvs3m2j41RHyC1aRKFz
U3kuOnaMMhB16WL23myPTAuBVL8j7dpZEK/QVBK6oXbpUr/zCx06RMr9wAOr97/PNq7cnYJl0yYb
9bRqZeaGNWvy3aO6sXNn9pNFJ9OzJ5x6qu2HySviqNxTJczfunKlPUvhSzVcCzB5Mvzv/+a+H6FZ
RtVMQ5Mm5f6e4Mq94HCbu6EKW7aYzX2ffcwdskuXurU5dWp+lV0YIyYTUn0uwknRm2+27UcfZXa/
QiZVWRxzjG379oWhQyNPma1bbXveeXDZZdnvX0U6doR166IXSUlJ9YvNsokrd6cg2bbNbMGtWkU+
33WhpMQ8S15/ve5tZUquR+5gnjjFxXD//ZbuLS4rTjNBxMIDbN9uPu1hgLBhw+q3H506mZfUyJFW
njevfl4qrtwLDLe526h93Tpo0yYBlE/ZlpyoIh3ee8+2dYkAWFfSmUytSKrPxfjxMGOG7X/jG5nd
q9BJ5zsSxt4JWbeu5ly1uaBTJ/NcSqa2lIrZwJW7k1eS/YKXLrWfyk2aWNyPMNFx8mj36KMz+0kb
etvkazHUunX1M3LPRV7VhkzFxCMdOtS/y2dVk7f1sRLYlXuB0Zhs7lOnRpNeYMvnn3/e9i+5BAYO
LAai0W7oHx4mukiHULmvXZtZX+vC5s22WOi223Jvc28MpCOLMFk1WBiAfFDVC7c+UhG6cnfyxuwg
2WIYejZ5kc3y5eafDZFC/N73bLtjR/r32rbNXhLvvJPedb/7nZk3Ro1K/54h4T0nTKifiTQnonv3
aL9QZP/nP2c/PWJVuHIvMBqTzT2Mg7JokW1LSy0UbWg62bEjAUQj965dLZFEpiP3Qw+tbPusiZkz
bfn4q69auNxMmTXLvFe6d8/cnbMxPRe1kY4skpV7Pj2lkkfv++7r3jJOzFm50pT1RReZ6WLGDFs6
H9oo27SxbThy79jR9tNR7qWl8NJLNnI/7jibkK0Y/6M6xo61kXsmJCdomDLFIga+/HL9rox0Ik+r
GTMib5V8kOy1VFRUwMpdRJqKyPsiMiUodxSR6SKyUESmiUhRUt3bRWSRiCwQkTOz1fG40phsq6tW
RYmEZ82yEXv//lbed1+49NJiIBq5d+hgqzbTUe7XXWcBuDZtgv33N7t9qtmGVq2ytHOzZ1ssklTZ
s8cm7UIf83/+05JHDBgAF1+cejvJNKbnojbSkUWYMrC4OL9RLy+8MNpv08bmfsKMWLki05H794F5
QDg+GQ1MV9X+wCtBGREZAFwMDADOBh4WEf+14ACmPFu0sP1vfMMCZYU/X7/4IspQFI7cO3RIb+S+
Zg384x+2v3y5KfeePW00/+67tV+/caO5YXbrZr8yUr3vq69G9w/JVKk7daN79/zmMQ0ZM8bmilRN
uX/0UXoDhkxIW9GKSE/gHOARILQkDQPGB/vjgTAM0XBgoqruVNUSYDEwuC4djjuNxbb6+eeVfb4f
f7x8OZRFWC9ds0xyjtDHH7cogfvvbzG+jz02WqlYFStX2l+7dlEuzIrp8KojTIIRTsQ2bQqnnZba
tdXRWJ6LVEhXFgcckJt+pININEgJzY0LF+b2npmMou8HfgQkWy67qmpZsF8GBB7K9ACSc5CUAtUE
HnUaE3372s/SMHtN27ZmtqiKimaZVL1lFiwo32afPjZyX7DAytVlx9m924JMLV1qL4OWLe14xaw+
1ZH88vnjH6099z93QkLlnmvSUu4ici6wWlXfJxq1lyPM61dDM3nKBd4waCy21W3bzK4+YYLtV7W4
KJRFuOhkn31s8cfGjandY+NGWxQ1ebIF0jrwwPLKvbowrPPn2/b+++2FApb0oX371DLZH3FEtP/t
b5v/fl1pLM9FKjR0WdRXUpR0F0OfCAwTkXOAVkB7EXkcKBORbqq6SkS6A0FMOlYA+ydd3zM4VomR
I0fSO3BsLioqYtCgQXv/ieHPMC83/PLixfDf/23l994rplWr1K7/y1+gXbtievaE6dMTNGlSc/2y
Mli0qJg+faBduwQff2zne/aEn/zE6m/eXPX1M2cm6NQJbr65/Plt24rZvh3efrvm/q5Zk+Cww6BD
h2KeesrOJxKFIX8v57/8zjtWbtIk/esTiQTjxo0D2Ksvq6W6zNm1/QGnAlOC/buB24L90cBdwf4A
YC7QAugDfApIFW3lLj14A2PGjBn57kJOsbGv/e3ZU3PdqmRx442qDz5Y/lhV7eyzj93j3nvLH1+4
ULV3bzs3ZUr5c7fconrrrapPPKF64omV2+zYUfX992vus6pqt26qpaW110uHuD8X6dDQZbFnjz1/
InVvK9DIksN1AAAYGUlEQVSdVeroDMMYRe+GYHsX8LSIXA2UAN8ONPY8EXka86zZBYwKOuQ0Qlat
ivanTs3MDt22bXkXsk2bbNKz4lMVLlgJzSoh/fqZLf1b36rsinb//dF+6KKZzLp1lst0+nQ4/XQ7
tnBheS8f1SiDlONURfKzktP7FIKuFXuF5bsbTo6ZORNOOsn2M/13/+IXtnx78WKb6PzgA0smHWY5
CjnnHDv2j39UHYnxyittwdRVV0XHkl82118PDz9c/poDD4zycH7yifnk9+plcbpPPdXuN2+eJUre
ssUnUZ3qyZaCFxFUtconzX3OnXojnaX/1VFWZl4uoZINQxdUdI/s0AEuv7z6ELvhL4ANG+yLdvLJ
0bnzz6+s2MHCx4YBnz7+2BT8F1/YCtT58+GOO2DgQPPKccXupMKGDTYgyAWu3AuMcPIkjiQS6S3c
qEoWP/iBbcOcqv/zP7atGPFv69aavRLatjWTTphz9M03bTtpUs2p1xYuhDPPhEsvhUMOsRH6vfea
y+Xdd1ud5BdFtojzc5EucZDFD39oYQiuu85WQeeCutrcHSdl5s2zWC2DBmXexoEHwvHHR7E5XnnF
tt/5DvzHf0T1vvqq5pjZ27bZSPuaa8ofry1LT1GR/UoI79+lS5SvdMIEC29w5JGpfx6ncXLPPbZK
OpdpEH3kXmCE7k9xZNkyC+Nb1WRlVVQnizZtotWlyYuUwpjtYAq3ppyrl19u27FjoxWlf/hDav0K
o1mC/Tr47W8tR+cll8AFF0ShirNJnJ+LdImLLHr1isyLucAnVJ16YdcuU8qbNkXxZDJFxJbzd+0K
EydGx+fMsVHzl1/aF2fx4przrz7yCIwbZ6npvvoq9V8Uffua/b1lS7Oxh3HpHScdfvCDyEMrU/Xn
E6oNiDjYE6tixQobSaej2KuTxYgRtro1WbEDzJ1r26eegrPOqj2x9ne/a7b2vn3TMxU98QQ895xN
5tZXwu24PheZEBdZhGEtcoXb3J16YdkyG01ng65d4cEHzf69erX5lA8ZEsWKWbcuN6aRkOOPz13b
TuOhrr9ga8NH7gVGXOyJFVm+PH3lXp0sDjrItmGkvS1bLGb7unV2fMeO3I+K6pu4PheZEBdZhM/o
b36Tm/ZduTv1wmWXwdtvZ6etG280xb5+fXSsY8dIuW/fnvtRkePUlfAZzVWUSFfuBUZc7IlVcf31
6dWvSRb7VQgcve++lsZu5EhT7nEbucf5uUiXuMgifEZduTsNlpIS22YzG1FF5d6xoyUAGT/eFhXF
Tbk78cNH7o2MuNgTk3nrLYv70rNnetfVJIuqlHsycVPucXwuMiUusqiYCD7buLeMk3Pefhvuuqt8
YK+68qMfRROrUFm5V4wG6TiFRvjM+si9kRAXe2Iyn3+emWtiTbI4/nhbGRqSrNx/9SsYPjz9+xUy
cXwuMiUusth3X9v6yN1psOzaFSUHzhXNm1vsmqIiy3jvOIVOrpW7hx9wcs6551r0u3PPzXdPHKdw
WL/efnGWlGS+wM/DDzh5Zdeu6uOqO05jpagIbrsNDjggN+27ci8w4mJPTGbnzszMMnGURaa4LCLi
IgsRczTIVWIXV+5O1lEtH1DLR+6OU/+4zd2pEdX0RhYzZlikxZ/9zIJ6de4MJ55oyQlOPDF3/XSc
xkjWbO4i0kpEZonIXBGZJyK/CY53FJHpIrJQRKaJSFHSNbeLyCIRWSAiZ9btozj1zSmnwLXX1l5v
/nxYtcrirP/sZ3bskkssabSP3B2n/klLuavqNmCoqg4CBgJDRWQIMBqYrqr9gVeCMiIyALgYGACc
DTwsIm4KqoFCsye++aYlpqiNAQPKh8Jt0sRS4D37LLzzTmbKvdBkkU9cFhEui9RIW9GqapA9khZA
U2A9MAwYHxwfD5wf7A8HJqrqTlUtARYDg+vSYSe3lJVVPhb649ZGaakF7gJLhn377fD441besSMb
vXMcJ1XSVu4i0kRE5gJlwAxV/RjoqqqhWigDugb7PYDSpMtLgQpRQZxk8hk3Y+tW6NYNPv7Yyh9+
aNtdu2q+buVK2+7eDUcdZYk5Tj4Z+vWDyZPtXCYLNeISQyQbuCwiXBapkfaPZVXdAwwSkX2Al0Rk
aIXzKiI1zY5WeW7kyJH0DtaoFxUVMWjQoL3/xPBnmJdzW96xw8rPPptg9Wo47TQrz5iR4L774P/+
r5g5cypfP25cgr59YfXqYq68Et59N8GSJdCvn53/5S8TQaz1wvq8XvZyQysnEgnGjRsHsFdfVouq
ZvwH/BT4f8ACoFtwrDuwINgfDYxOqv8icFwV7ahjzJgxI2/3/vnPVUG1Y0fbguqOHdE+qK5cWfm6
H/5Q9bbbKh9fv96uKSvLrD/5lEWh4bKIcFlEBLqzSv2crrdMp9ATRkRaA2cA7wOTgSuCalcAzwX7
k4ERItJCRPoA/QDPFV9AHHqorZIDc12EKKMR2OKjSZOi8p13wp495dt46y0444zKbRcVmUmnS5fs
9tlxnNpJy89dRA7HJkybBH+Pq+rvRKQj8DRwAFACfFtVNwTX3AFcBewCvq+qL1XRrqbTDyc7TJoE
559vMV8mTYLBgy2U7u7dtiS6c2c4+GD47DMr/+lP5hZ51FHw3nv2d8st8MYbsGCB1XUcp/6oyc/d
FzE1YpIXJ02bZop9zpzKcdf37IleBOG5yZMttO6sWTB0KEydCq1a1V/fHcfxwGENinDypL4588zy
yjuZJk3gggvsZfBcYHD7wQ9g9mzYuBFefTU3ij1fsihEXBYRLovUcOXu7HVTrMpuXpHhw2H6dFi8
GG64Adq1y23fHMfJDDfLNFJ27IiSSi9fDocfbsdSjd4oAqNGwR/+kNt+Oo5TPTWZZTziRyNl7lzL
Qdq+PXz96zZpmk5Y3pkzoU+f3PXPcZy64WaZAqO+7IkzZ8IJJ0Tlnj3Tu/6EE2w1ay5x22qEyyLC
ZZEartwbKR98YC6NjuPEE7e5N1JE4Omn4VvfyndPHMfJFHeFdMqxZo1tk0P0Oo4TL1y5Fxj1YU+c
Ph1OPx323z/nt6oTbluNcFlEuCxSw5V7I2ThQh+1O07ccZt7I+TSS23kHibWcBynYeI2d6ccn35q
Pu6O48QXV+4FRq7tievWwdtvN4wIjm5bjXBZRLgsUsOVeyPjzTdh0CAL5+s4Tnxxm3sjYsMG+OMf
oaTEYrM7jtOw8dgyDi+8AP/2b5YsL0xa7ThOfHGzTIGRC3uiKpxzjm1/8hM477ys3yInuG01wmUR
4bJIDR+5x5zvfteyJXXtCq+/Dv365btHjuPUB25zjzlhKr0HH4SbbspvXxzHyS5uc2+k7NljMdr/
+lfLoOQ4TuMhLZu7iOwvIjNE5GMR+ZeI3BQc7ygi00VkoYhME5GipGtuF5FFIrJARM7M9geIG1XZ
EzdvhgUL0m9r0yZo2bLhKna3rUa4LCJcFqmR7oTqTuAWVT0MOB64QUQOBUYD01W1P/BKUEZEBgAX
AwOAs4GHRcQncdPkjjvg0EPTv27jRthnn+z3x3GcwictRauqq1R1brC/CZgP7AcMA8YH1cYD5wf7
w4GJqrpTVUuAxcDgLPQ7thQXFwOwbZsF+IIoRG+6bNxoafQaKqEsHJdFMi6L1Mh4FC0ivYEjgVlA
V1UtC06VAV2D/R5AadJlpdjLwKmCHTtsAnTnTvj2t6MQAfvua9tt29Jrb80aS4LtOE7jI6MJVRH5
GvB34Puq+pVINFmrqioiNbm+VHlu5MiR9O7dG4CioiIGDRq09w0d2tgaYnn3bnj99QQitdf/5z+L
gQTPPANTpgAUowqlpXZ+yJBiBgyAE05IcOihtbf3+efF7LdfYckjnXJ4rFD6k8/y3Llzufnmmwum
P/ksP/DAA7HRD+mWE4kE48aNA9irL6sjbVdIEWkOPA+8oKoPBMcWAMWqukpEugMzVPUQERkNoKp3
BfVeBMao6qwKbcbSFXLHDstT2r8/PPNM7fXtHZkAigFo1w6WLoVOncrXa9sWPvkE9qvmN9Brr9n5
zz+Hr76Ce+/N/DPkk0QisfcBb+y4LCJcFhFZC/krNkT/CzAvVOwBk4Ergv0rgOeSjo8QkRYi0gfo
B8xO554NmUcfhY8/NmVbGy+9FO4VA5YtqVcvawOi2OsXXmjeMzX5rBcXw7XXwp13wgEHZNb3QsC/
wBEuiwiXRWqka3M/CbgUGCoi7wd/ZwN3AWeIyELgtKCMqs4DngbmAS8Ao2I5RK+GsWNt27RpzfV2
7TJl/NJLcOWVcMQRlkzjgAPg1ltt/4HgVfqd75j3zDPP2Ej/qqvKt7VihY3s77nHyoWeSs9xnByh
qnn/s27ED1Dt2lW1WTPV2bNVO3dW3bHDzu3ZE9U7/XSrq6r66qszdPdu2//pT+34nDlWfuUVu/7D
D+04qPbuXf6eTzyhet55qi+8YOfLynL7GXPJjBkz8t2FgsFlEeGyiAh0Z5V61X3Oc0To2XL99dCq
FQwebN4rGzbAz38OTZrAkiVmU3/5ZXjqKasvYucATjzRtqHHy2mn2YrTww831b5pE5SVwZw58O//
Dl//uo3sv/UtOOss87rp0qV+P7fjOIWBx5bJEZ98YiF2Fy+Gbt1sMdHChfDee3DKKWY3P+ccmDrV
6lf18TdsgA4dYO3a6l0ajz0W3n3X9g86CL75Tfjtb6F169x8LsdxCgePLZMHli6F0FOpWbNoQdJT
T8EJJ8CECdGo+oYbqm6jqMgiOtbkqz5mjIXwnTcvs1WsjuPEEzfL5IiyMujRw/ZXrLBtly5w993Q
p09598Zrron2k328wcw5NXHuuTbqj6NiryiLxozLIsJlkRqu3HPEtm1mawd45BHbhjb0Nm3Mtj57
tplpBg7MTx8dx4kvbnPPEb//PSxaBA89ZGVVC8F72WVw3XVmd3ccx6kLbnPPA9u3W7jdEBHzd58w
IX99chyn8eBmmRxRUbmnitsTI1wWES6LCJdFarhyzxGZKnfHcZxs4Db3HLBtm/m233473HZbvnvj
OE5cyVrgMCc1Jk+GL7+0FaSO4zj5wJV7Dnj8cdvu2pX+tW5PjHBZRLgsIlwWqeHKPYt89BGMGAEz
ZtgCplNPzXePHMdprLjNPYscfbQF8WrTxmLHOI7j5BL3c68HXnrJFPtbb1k8dcdxnHziZpkscfbZ
tj3+eAvJmyluT4xwWUS4LCJcFqnhyj1LnHUWPP98vnvhOI5juM09C8yda9EZp0yBI4/Md28cx2ks
uJ97Drn3XlPoK1ZEIX4dx3HyjSv3OvLQQ3DnnTZ679q17u25PTHCZRHhsohwWaRG2spdRB4VkTIR
+SjpWEcRmS4iC0VkmogUJZ27XUQWicgCETkzWx3PB7t3R7lRwWKxb9sGP/4xHHFEdu4xd+7c7DQU
A1wWES6LCJdFamQycn8MOLvCsdHAdFXtD7wSlBGRAcDFwIDgmodFpMH+WujVy3KTrlxp5RdesGTU
TZtm7x4bNmzIXmMNHJdFhMsiwmWRGmkrWlV9A1hf4fAwYHywPx44P9gfDkxU1Z2qWgIsBmpJHBdR
1c+v6n6S5bquapQu7ze/gSlTEtx3H3z3u9m9X0lJSdb6XB91c3k/l0VEXWVRKJ8jV7IolL7Vtzxr
Iluj6K6qWhbslwGh9bkHUJpUrxTYL9VGC+lL/NVXtjhp9myzsw8blqC4uLw5Jhv3q+4nZyHJor7u
57KIqKssCuVz5EoWhdK3QlLuGblCikhvYIqqHh6U16tqh6Tz61S1o4g8BLytqk8Exx8BpqrqMxXa
a7h+kI7jOHkk1+EHykSkm6quEpHuwOrg+Apg/6R6PYNjKXXOcRzHyYxsmWUmA1cE+1cAzyUdHyEi
LUSkD9APmJ2lezqO4zjVkPbIXUQmAqcCnUTkM+BnwF3A0yJyNVACfBtAVeeJyNPAPGAXMKpBL0V1
HMdpIBRE+AHHcRwnu9Sbz7mIdA62jT7McGCicgAROUZEuuS7H4WAiJwuIkfnux+FQPJCyMaOiLTI
5LqcKncx2orIk8AkAFXdJSKNcgJVRI4SkZeBnzf2l5yIHCYibwH/BXSopXqsCZ6LF7G5qoPy3Z98
IiLHicgkYKyIXC0irfLdp3whIieIyBPAf4lIfxFJa7lkTpW7GmFOon1FZFR93LcQEZGfAE8CT6nq
ZaqaQYbVWHEz8Kyqnquqn4ANBvLcp3pFRJqIyFhgLPAnYAJwaHgun33LB8Gvlj8Cfwv+htJIX3Yi
cjjwe+B5zPvwGuDydNrI9ci9WeAaWQZ8F7heRDqo6u5030IxoCXwpqqOhb2jteZ57lNeCEx0e4CH
gvKFIrI/0DooNwolr6p7gGnAyar6LPB3YKiItArONTaOBz5V1ccxubQGlue3S3njJGCBqk4EHgG2
ApemY9LN6oSqiPwHcAjwjqpOSTo+CbgBuA3YAoxV1cVZu3EBkiSLOar6nIi0A/6KeQ6dAqwCNmKj
17/mr6e5J0kW76rqZBFpA7wH/Ai4BOgErAR2quo1+etp7kmSxXuqOinpeBPgG1gspttUdW2eulhv
VJSFiHTDvh9/AK7GFPt84BNVvSt/Pc09VcjiSOAB4GpVXSwiY4AjMIV/RyptZmXkHtjWr8e+rCXA
vSJypYh8LVjNWqKqpcB04HrgryLSMo4j1ypkcbeIXKOqX2Fv4COBH6rqucBrwFkicnDeOpxDqpDF
PSLyn6q6BTNDPAxMU9WzgB8DXxeRc/LW4RxShSx+F3xH2sHeUfx8TMG3Cq6JpWmmGln8p6quwoIM
tgJuVdXjgXHASSJyQr76m0uqkcVIbLDzBjAuGBwfiw0Om4pI61TazsqknqqqiBwP/FZVnxSR5cBV
QQdnAr1EZApwMKbQdqnq9mzcu9CoRhZXi8hnqvo3EXlZVcOwdi8D5wBf5a3DOaS65yLYPgbcCnQO
6q4QkTeB3fnrce6oRhZXAqtFZGowP1UqIm8D/w78Pq6mmRqei1JVnSoip2PRZQHmYDbnHfnqby6p
QhafASOBVar6ExE5DOivqs+KyDHA5aq6NZW2Mx4ZiMjlInKqiHQMDs0H9hORZqr6MvAhcDKm0FcC
S4GjVfU84ACJkctXCrL4ACgWkQOSFDvAmYACm4kJKT4Xp2Ff1u8Bl4vIoGD0cjo2eokFKcjiI2AI
QYiO4JfsYsx0GStSfC6KA9PMWODW4JfLxcDXgdiYqWqRxXTsuRgqIvur6sfBfAzY92ZWqr/o0hq5
BxNd3bFZ/T3Yg/i14ItZiv0TDgIWAE8B9wFPA99X1eQ37zcqKLkGR5qyeBKzn+0LLBeRoZhsPsPs
q1/W/yfIHhk8Fw8Ah6rq38Vc3b4NHAZcFnrONFTq8lyo6k4RaQv0ykffs00Gz8X9QDdVfTgYzT6H
TapeGYQMb7Bk+Fx0Aj4TkcHAb4Prrk31F13KI/fgraJAO2CFqp4GjAI2YF4PT2M/sQeLyD6quhSb
MLxIVXeIuX01AYiBYk9XFiXAl8AFQROlwBhVHaaq8+v9A2SRDJ+LDZjpgSBi6E9Udbiq/isvHyJL
ZOG5APh/qvrT+u159snwufgSuCho4mpsMvEMVZ1X/58ge9ThubgwaGIpcKeqfiMdR5RaR+5iLou/
BJqIyAtBB3fB3gVJ38PMLgOAidiD2hP4NWY/nRXUbfD2wyzIYnZQdxGwqN4/QBbJgizeCttq6M9G
tp6LoH5jl8XbQd2dwJp6/wBZJIu6cw2QSPf+NY7cReRUzGWtCPsZ8QtgJ2YPGhzceDdwJzYh8DLm
BXGSiMzCVh6m3alCxGUR4bKIcFlEuCwiCkIWqlrtH+aPfVlS+Y+YK+OVmD8mQFOgG7airE9wrAOw
X01tN7Q/l4XLwmXhsmhIsqjN5v4O5pMeriZ9EzhAVR/D/C1vUnv79MQWoCwFUNX1qlopKUcDx2UR
4bKIcFlEuCwi8i6LGpW7qm5V1W1BJwDOAL4I9q8CDhWRf2D2ojnZ6FCh4rKIcFlEuCwiXBYRhSCL
lMIPiEUwVCyIzffUlsMehPmeHka0AjX2uCwiXBYRLosIl0VEPmWRkiukWgTD5tibZ2DwxvkpsFtV
32ws/yhwWSTjsohwWUS4LCLyKYt0FjEdCXwH6AM8pqp/yU2XGgQuiwiXRYTLIsJlEZEXWaQcFVJE
emLxhO/R8qtNGx0uiwiXRYTLIsJlEZEvWXgOVcdxnBgSy5CijuM4jR1X7o7jODHElbvjOE4MceXu
OI4TQ1y5O47jxBBX7o7jODHElbvjOE4M+f9EYiNJNukaZgAAAABJRU5ErkJggg==
)

## 金融数据

In [15]:

```py
import datetime
import numpy as np
import matplotlib.colors as colors
import matplotlib.finance as finance
import matplotlib.dates as mdates
import matplotlib.ticker as mticker
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt
import matplotlib.font_manager as font_manager

startdate = datetime.date(2006,1,1)
today = enddate = datetime.date.today()
ticker = 'SPY'

fh = finance.fetch_historical_yahoo(ticker, startdate, enddate)
# a numpy record array with fields: date, open, high, low, close, volume, adj_close)

r = mlab.csv2rec(fh); fh.close()
r.sort()

def moving_average(x, n, type='simple'):
    """
 compute an n period moving average.

 type is 'simple' | 'exponential'

 """
    x = np.asarray(x)
    if type=='simple':
        weights = np.ones(n)
    else:
        weights = np.exp(np.linspace(-1., 0., n))

    weights /= weights.sum()

    a =  np.convolve(x, weights, mode='full')[:len(x)]
    a[:n] = a[n]
    return a

def relative_strength(prices, n=14):
    """
 compute the n period relative strength indicator
 http://stockcharts.com/school/doku.php?id=chart_school:glossary_r#relativestrengthindex
 http://www.investopedia.com/terms/r/rsi.asp
 """

    deltas = np.diff(prices)
    seed = deltas[:n+1]
    up = seed[seed>=0].sum()/n
    down = -seed[seed<0].sum()/n
    rs = up/down
    rsi = np.zeros_like(prices)
    rsi[:n] = 100. - 100./(1.+rs)

    for i in range(n, len(prices)):
        delta = deltas[i-1] # cause the diff is 1 shorter

        if delta>0:
            upval = delta
            downval = 0.
        else:
            upval = 0.
            downval = -delta

        up = (up*(n-1) + upval)/n
        down = (down*(n-1) + downval)/n

        rs = up/down
        rsi[i] = 100. - 100./(1.+rs)

    return rsi

def moving_average_convergence(x, nslow=26, nfast=12):
    """
 compute the MACD (Moving Average Convergence/Divergence) using a fast and slow exponential moving avg'
 return value is emaslow, emafast, macd which are len(x) arrays
 """
    emaslow = moving_average(x, nslow, type='exponential')
    emafast = moving_average(x, nfast, type='exponential')
    return emaslow, emafast, emafast - emaslow

plt.rc('axes', grid=True)
plt.rc('grid', color='0.75', linestyle='-', linewidth=0.5)

textsize = 9
left, width = 0.1, 0.8
rect1 = [left, 0.7, width, 0.2]
rect2 = [left, 0.3, width, 0.4]
rect3 = [left, 0.1, width, 0.2]

fig = plt.figure(facecolor='white')
axescolor  = '#f6f6f6'  # the axes background color

ax1 = fig.add_axes(rect1, axisbg=axescolor)  #left, bottom, width, height
ax2 = fig.add_axes(rect2, axisbg=axescolor, sharex=ax1)
ax2t = ax2.twinx()
ax3  = fig.add_axes(rect3, axisbg=axescolor, sharex=ax1)

### plot the relative strength indicator
prices = r.adj_close
rsi = relative_strength(prices)
fillcolor = 'darkgoldenrod'

ax1.plot(r.date, rsi, color=fillcolor)
ax1.axhline(70, color=fillcolor)
ax1.axhline(30, color=fillcolor)
ax1.fill_between(r.date, rsi, 70, where=(rsi>=70), facecolor=fillcolor, edgecolor=fillcolor)
ax1.fill_between(r.date, rsi, 30, where=(rsi<=30), facecolor=fillcolor, edgecolor=fillcolor)
ax1.text(0.6, 0.9, '>70 = overbought', va='top', transform=ax1.transAxes, fontsize=textsize)
ax1.text(0.6, 0.1, '<30 = oversold', transform=ax1.transAxes, fontsize=textsize)
ax1.set_ylim(0, 100)
ax1.set_yticks([30,70])
ax1.text(0.025, 0.95, 'RSI (14)', va='top', transform=ax1.transAxes, fontsize=textsize)
ax1.set_title('%s daily'%ticker)

### plot the price and volume data
dx = r.adj_close - r.close
low = r.low + dx
high = r.high + dx

deltas = np.zeros_like(prices)
deltas[1:] = np.diff(prices)
up = deltas>0
ax2.vlines(r.date[up], low[up], high[up], color='black', label='_nolegend_')
ax2.vlines(r.date[~up], low[~up], high[~up], color='black', label='_nolegend_')
ma20 = moving_average(prices, 20, type='simple')
ma200 = moving_average(prices, 200, type='simple')

linema20, = ax2.plot(r.date, ma20, color='blue', lw=2, label='MA (20)')
linema200, = ax2.plot(r.date, ma200, color='red', lw=2, label='MA (200)')

last = r[-1]
s = '%s O:%1.2f H:%1.2f L:%1.2f C:%1.2f, V:%1.1fM Chg:%+1.2f' % (
    today.strftime('%d-%b-%Y'),
    last.open, last.high,
    last.low, last.close,
    last.volume*1e-6,
    last.close-last.open )
t4 = ax2.text(0.3, 0.9, s, transform=ax2.transAxes, fontsize=textsize)

props = font_manager.FontProperties(size=10)
leg = ax2.legend(loc='center left', shadow=True, fancybox=True, prop=props)
leg.get_frame().set_alpha(0.5)

volume = (r.close*r.volume)/1e6  # dollar volume in millions
vmax = volume.max()
poly = ax2t.fill_between(r.date, volume, 0, label='Volume', facecolor=fillcolor, edgecolor=fillcolor)
ax2t.set_ylim(0, 5*vmax)
ax2t.set_yticks([])

### compute the MACD indicator
fillcolor = 'darkslategrey'
nslow = 26
nfast = 12
nema = 9
emaslow, emafast, macd = moving_average_convergence(prices, nslow=nslow, nfast=nfast)
ema9 = moving_average(macd, nema, type='exponential')
ax3.plot(r.date, macd, color='black', lw=2)
ax3.plot(r.date, ema9, color='blue', lw=1)
ax3.fill_between(r.date, macd-ema9, 0, alpha=0.5, facecolor=fillcolor, edgecolor=fillcolor)

ax3.text(0.025, 0.95, 'MACD (%d, %d, %d)'%(nfast, nslow, nema), va='top',
         transform=ax3.transAxes, fontsize=textsize)

#ax3.set_yticks([])
# turn off upper axis tick labels, rotate the lower ones, etc
for ax in ax1, ax2, ax2t, ax3:
    if ax!=ax3:
        for label in ax.get_xticklabels():
            label.set_visible(False)
    else:
        for label in ax.get_xticklabels():
            label.set_rotation(30)
            label.set_horizontalalignment('right')

    ax.fmt_xdata = mdates.DateFormatter('%Y-%m-%d')

class MyLocator(mticker.MaxNLocator):
    def __init__(self, *args, **kwargs):
        mticker.MaxNLocator.__init__(self, *args, **kwargs)

    def __call__(self, *args, **kwargs):
        return mticker.MaxNLocator.__call__(self, *args, **kwargs)

# at most 5 ticks, pruning the upper and lower so they don't overlap
# with other ticks
#ax2.yaxis.set_major_locator(mticker.MaxNLocator(5, prune='both'))
#ax3.yaxis.set_major_locator(mticker.MaxNLocator(5, prune='both'))

ax2.yaxis.set_major_locator(MyLocator(5, prune='both'))
ax3.yaxis.set_major_locator(MyLocator(5, prune='both'))

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAdEAAAEcCAYAAACYtY7xAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## basemap 画地图

需要安装 `basemap` 包：

In [16]:

```py
import matplotlib.pyplot as plt
import numpy as np

try:
    from mpl_toolkits.basemap import Basemap
    have_basemap = True
except ImportError:
    have_basemap = False

def plotmap():
    # create figure
    fig = plt.figure(figsize=(8,8))
    # set up orthographic map projection with
    # perspective of satellite looking down at 50N, 100W.
    # use low resolution coastlines.
    map = Basemap(projection='ortho',lat_0=50,lon_0=-100,resolution='l')
    # lat/lon coordinates of five cities.
    lats=[40.02,32.73,38.55,48.25,17.29]
    lons=[-105.16,-117.16,-77.00,-114.21,-88.10]
    cities=['Boulder, CO','San Diego, CA',
            'Washington, DC','Whitefish, MT','Belize City, Belize']
    # compute the native map projection coordinates for cities.
    xc,yc = map(lons,lats)
    # make up some data on a regular lat/lon grid.
    nlats = 73; nlons = 145; delta = 2.*np.pi/(nlons-1)
    lats = (0.5*np.pi-delta*np.indices((nlats,nlons))[0,:,:])
    lons = (delta*np.indices((nlats,nlons))[1,:,:])
    wave = 0.75*(np.sin(2.*lats)**8*np.cos(4.*lons))
    mean = 0.5*np.cos(2.*lats)*((np.sin(2.*lats))**2 + 2.)
    # compute native map projection coordinates of lat/lon grid.
    # (convert lons and lats to degrees first)
    x, y = map(lons*180./np.pi, lats*180./np.pi)
    # draw map boundary
    map.drawmapboundary(color="0.9")
    # draw graticule (latitude and longitude grid lines)
    map.drawmeridians(np.arange(0,360,30),color="0.9")
    map.drawparallels(np.arange(-90,90,30),color="0.9")
    # plot filled circles at the locations of the cities.
    map.plot(xc,yc,'wo')
    # plot the names of five cities.
    for name,xpt,ypt in zip(cities,xc,yc):
        plt.text(xpt+100000,ypt+100000,name,fontsize=9,color='w')
    # contour data over the map.
    cs = map.contour(x,y,wave+mean,15,linewidths=1.5)
    # draw blue marble image in background.
    # (downsample the image by 50% for speed)
    map.bluemarble(scale=0.5)

def plotempty():
    # create figure
    fig = plt.figure(figsize=(8,8))
    fig.text(0.5, 0.5, "Sorry, could not import Basemap",
                                horizontalalignment='center')

if have_basemap:
    plotmap()
else:
    plotempty()
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAcwAAAHMCAYAAABY25iGAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 对数图

`loglog, semilogx, semilogy, errorbar` 函数：

In [17]:

```py
import numpy as np
import matplotlib.pyplot as plt

plt.subplots_adjust(hspace=0.4)
t = np.arange(0.01, 20.0, 0.01)

# log y axis
plt.subplot(221)
plt.semilogy(t, np.exp(-t/5.0))
plt.title('semilogy')
plt.grid(True)

# log x axis
plt.subplot(222)
plt.semilogx(t, np.sin(2*np.pi*t))
plt.title('semilogx')
plt.grid(True)

# log x and y axis
plt.subplot(223)
plt.loglog(t, 20*np.exp(-t/10.0), basex=2)
plt.grid(True)
plt.title('loglog base 4 on x')

# with errorbars: clip non-positive values
ax = plt.subplot(224)
ax.set_xscale("log", nonposx='clip')
ax.set_yscale("log", nonposy='clip')

x = 10.0**np.linspace(0.0, 2.0, 20)
y = x**2.0
plt.errorbar(x, y, xerr=0.1*x, yerr=5.0+0.75*y)
ax.set_ylim(ymin=0.1)
ax.set_title('Errorbars go negative')

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAX8AAAEPCAYAAACqZsSmAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 极坐标

设置 `polar=True`：

In [18]:

```py
import numpy as np
import matplotlib.pyplot as plt

r = np.arange(0, 3.0, 0.01)
theta = 2 * np.pi * r

ax = plt.subplot(111, polar=True)
ax.plot(theta, r, color='r', linewidth=3)
ax.set_rmax(2.0)
ax.grid(True)

ax.set_title("A line plot on a polar axis", va='bottom')
plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAARMAAAEaCAYAAAAyprNwAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 标注

`legend` 函数：

In [19]:

```py
import numpy as np
import matplotlib.pyplot as plt

# Make some fake data.
a = b = np.arange(0,3, .02)
c = np.exp(a)
d = c[::-1]

# Create plots with pre-defined labels.
plt.plot(a, c, 'k--', label='Model length')
plt.plot(a, d, 'k:', label='Data length')
plt.plot(a, c+d, 'k', label='Total message length')

legend = plt.legend(loc='upper center', shadow=True, fontsize='x-large')

# Put a nicer background color on the legend.
legend.get_frame().set_facecolor('#00FFCC')

plt.show()

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAXMAAAEACAYAAABBDJb9AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)

## 数学公式

In [20]:

```py
from __future__ import print_function
import matplotlib.pyplot as plt
import os
import sys
import re
import gc

# Selection of features following "Writing mathematical expressions" tutorial
mathtext_titles = {
    0: "Header demo",
    1: "Subscripts and superscripts",
    2: "Fractions, binomials and stacked numbers",
    3: "Radicals",
    4: "Fonts",
    5: "Accents",
    6: "Greek, Hebrew",
    7: "Delimiters, functions and Symbols"}
n_lines = len(mathtext_titles)

# Randomly picked examples
mathext_demos = {
    0: r"$W^{3\beta}_{\delta_1 \rho_1 \sigma_2} = "
    r"U^{3\beta}_{\delta_1 \rho_1} + \frac{1}{8 \pi 2} "
    r"\int^{\alpha_2}_{\alpha_2} d \alpha^\prime_2 \left[\frac{ "
    r"U^{2\beta}_{\delta_1 \rho_1} - \alpha^\prime_2U^{1\beta}_"
    r"{\rho_1 \sigma_2} }{U^{0\beta}_{\rho_1 \sigma_2}}\right]$",

    1: r"$\alpha_i > \beta_i,\ "
    r"\alpha_{i+1}^j = {\rm sin}(2\pi f_j t_i) e^{-5 t_i/\tau},\ "
    r"\ldots$",

    2: r"$\frac{3}{4},\ \binom{3}{4},\ \stackrel{3}{4},\ "
    r"\left(\frac{5 - \frac{1}{x}}{4}\right),\ \ldots$",

    3: r"$\sqrt{2},\ \sqrt[3]{x},\ \ldots$",

    4: r"$\mathrm{Roman}\ , \ \mathit{Italic}\ , \ \mathtt{Typewriter} \ "
    r"\mathrm{or}\ \mathcal{CALLIGRAPHY}$",

    5: r"$\acute a,\ \bar a,\ \breve a,\ \dot a,\ \ddot a, \ \grave a, \ "
    r"\hat a,\ \tilde a,\ \vec a,\ \widehat{xyz},\ \widetilde{xyz},\ "
    r"\ldots$",

    6: r"$\alpha,\ \beta,\ \chi,\ \delta,\ \lambda,\ \mu,\ "
    r"\Delta,\ \Gamma,\ \Omega,\ \Phi,\ \Pi,\ \Upsilon,\ \nabla,\ "
    r"\aleph,\ \beth,\ \daleth,\ \gimel,\ \ldots$",

    7: r"$\coprod,\ \int,\ \oint,\ \prod,\ \sum,\ "
    r"\log,\ \sin,\ \approx,\ \oplus,\ \star,\ \varpropto,\ "
    r"\infty,\ \partial,\ \Re,\ \leftrightsquigarrow, \ \ldots$"}

def doall():
    # Colors used in mpl online documentation.
    mpl_blue_rvb = (191./255., 209./256., 212./255.)
    mpl_orange_rvb = (202/255., 121/256., 0./255.)
    mpl_grey_rvb = (51./255., 51./255., 51./255.)

    # Creating figure and axis.
    plt.figure(figsize=(6, 7))
    plt.axes([0.01, 0.01, 0.98, 0.90], axisbg="white", frameon=True)
    plt.gca().set_xlim(0., 1.)
    plt.gca().set_ylim(0., 1.)
    plt.gca().set_title("Matplotlib's math rendering engine",
                        color=mpl_grey_rvb, fontsize=14, weight='bold')
    plt.gca().set_xticklabels("", visible=False)
    plt.gca().set_yticklabels("", visible=False)

    # Gap between lines in axes coords
    line_axesfrac = (1. / (n_lines))

    # Plotting header demonstration formula
    full_demo = mathext_demos[0]
    plt.annotate(full_demo,
                 xy=(0.5, 1. - 0.59*line_axesfrac),
                 xycoords='data', color=mpl_orange_rvb, ha='center',
                 fontsize=20)

    # Plotting features demonstration formulae
    for i_line in range(1, n_lines):
        baseline = 1. - (i_line)*line_axesfrac
        baseline_next = baseline - line_axesfrac*1.
        title = mathtext_titles[i_line] + ":"
        fill_color = ['white', mpl_blue_rvb][i_line % 2]
        plt.fill_between([0., 1.], [baseline, baseline],
                         [baseline_next, baseline_next],
                         color=fill_color, alpha=0.5)
        plt.annotate(title,
                     xy=(0.07, baseline - 0.3*line_axesfrac),
                     xycoords='data', color=mpl_grey_rvb, weight='bold')
        demo = mathext_demos[i_line]
        plt.annotate(demo,
                     xy=(0.05, baseline - 0.75*line_axesfrac),
                     xycoords='data', color=mpl_grey_rvb,
                     fontsize=16)

    for i in range(n_lines):
        s = mathext_demos[i]
        print(i, s)
    plt.show()

if '--latex' in sys.argv:
    # Run: python mathtext_examples.py --latex
    # Need amsmath and amssymb packages.
    fd = open("mathtext_examples.ltx", "w")
    fd.write("\\documentclass{article}\n")
    fd.write("\\usepackage{amsmath, amssymb}\n")
    fd.write("\\begin{document}\n")
    fd.write("\\begin{enumerate}\n")

    for i in range(n_lines):
        s = mathext_demos[i]
        s = re.sub(r"(?<!\\)\$", "$$", s)
        fd.write("\\item %s\n" % s)

    fd.write("\\end{enumerate}\n")
    fd.write("\\end{document}\n")
    fd.close()

    os.system("pdflatex mathtext_examples.ltx")
else:
    doall()

```

```py
0 $W^{3\beta}_{\delta_1 \rho_1 \sigma_2} = U^{3\beta}_{\delta_1 \rho_1} + \frac{1}{8 \pi 2} \int^{\alpha_2}_{\alpha_2} d \alpha^\prime_2 \left[\frac{ U^{2\beta}_{\delta_1 \rho_1} - \alpha^\prime_2U^{1\beta}_{\rho_1 \sigma_2} }{U^{0\beta}_{\rho_1 \sigma_2}}\right]$
1 $\alpha_i > \beta_i,\ \alpha_{i+1}^j = {\rm sin}(2\pi f_j t_i) e^{-5 t_i/\tau},\ \ldots$
2 $\frac{3}{4},\ \binom{3}{4},\ \stackrel{3}{4},\ \left(\frac{5 - \frac{1}{x}}{4}\right),\ \ldots$
3 $\sqrt{2},\ \sqrt[3]{x},\ \ldots$
4 $\mathrm{Roman}\ , \ \mathit{Italic}\ , \ \mathtt{Typewriter} \ \mathrm{or}\ \mathcal{CALLIGRAPHY}$
5 $\acute a,\ \bar a,\ \breve a,\ \dot a,\ \ddot a, \ \grave a, \ \hat a,\ \tilde a,\ \vec a,\ \widehat{xyz},\ \widetilde{xyz},\ \ldots$
6 $\alpha,\ \beta,\ \chi,\ \delta,\ \lambda,\ \mu,\ \Delta,\ \Gamma,\ \Omega,\ \Phi,\ \Pi,\ \Upsilon,\ \nabla,\ \aleph,\ \beth,\ \daleth,\ \gimel,\ \ldots$
7 $\coprod,\ \int,\ \oint,\ \prod,\ \sum,\ \log,\ \sin,\ \approx,\ \oplus,\ \star,\ \varpropto,\ \infty,\ \partial,\ \Re,\ \leftrightsquigarrow, \ \ldots$

```

![](data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAbUAAAHlCAYAAAByJGIqAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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)